/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.CustomUninstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.MenuUtilities;
import com.denova.JExpress.Installer.StatusPanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.runtime.Exec;
import com.denova.runtime.UnixCommands;
import com.denova.runtime.UnixMenu;
import com.denova.runtime.WindowsDirs;
import com.denova.ui.Swinger;
import com.denova.util.PropertyList;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.List;
import java.util.Vector;
import javax.swing.JLabel;

public class AutoStartMenusPanel
extends StatusPanel
implements InstallPropertyNames,
JExpressConstants {
    private static final String LogFilename = "autostartup.log";
    private static final String MacAutoStartDirname = "Library/Preferences";
    private static final String MacAutoStartFilename = "loginwindow.plist";
    private static Log autostartLog = null;
    private boolean updated = false;
    private String progressLabel = Localize.strings().getString("Configuring") + " " + Localize.strings().getString("SettingUpAutoStartup");
    private List autoStartList = null;

    public AutoStartMenusPanel(PropertyList propertyList) {
        super(propertyList);
        this.progressBarLabel.setText(this.progressLabel);
        this.autoStartList = new Vector();
    }

    public synchronized void enter() {
        if (this.updated) {
            this.log("startup menus already configured");
            this.showNextPanel();
        } else {
            this.log("starting to add startup menus");
            MenusSwinger menusSwinger = new MenusSwinger();
            menusSwinger.execute();
        }
    }

    public String getName() {
        return "AutoStartMenusPanel";
    }

    public void userCanceled() {
    }

    private void configureAutoStart() throws Exception {
        this.log("configuring auto startup");
        boolean bl = false;
        String string = this.getPropertyList().getProperty("submenu", "").replace('/', File.separatorChar);
        PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
        Enumeration enumeration = propertyList.propertyNames();
        while (enumeration.hasMoreElements()) {
            boolean bl2;
            String string2 = (String)enumeration.nextElement();
            String string3 = propertyList.getProperty(string2);
            PropertyList propertyList2 = new PropertyList();
            propertyList2.fromString(string3);
            if (!MenuUtilities.menuOk(propertyList2, this.getPropertyList()) || !(bl2 = propertyList2.getBooleanProperty("menuAutoStartup", false))) continue;
            this.setupAutoStartup(string, propertyList2);
        }
    }

    private void setupAutoStartup(String string, PropertyList propertyList) {
        String string2 = this.getPropertyList().getProperty("applicationDirectory", ".");
        if (this.isWindows()) {
            this.autoStartWindows(string, propertyList, string2);
        } else if (this.isMacOsX()) {
            this.autoStartMac(propertyList, string2);
        } else if (this.isUnix()) {
            this.autoStartUnix(string, propertyList, string2);
        } else {
            this.log("unable to configure auto start on this OS");
        }
    }

    private void autoStartUnix(String string, PropertyList propertyList, String string2) {
        this.log("configuring unix");
        UnixMenu unixMenu = new UnixMenu();
        String string3 = UnixMenu.getKdeMenuDir();
        String string4 = unixMenu.getKdeAutostartDir();
        if (string3 != null && string3.length() > 0 && string4 != null && string4.length() > 0) {
            String string5 = propertyList.getProperty("longName");
            this.setupKdeAutoStart(string3, string4, string, string5, string2);
        } else {
            this.log("unable to configure the auto startup");
        }
    }

    private void setupKdeAutoStart(String string, String string2, String string3, String string4, String string5) {
        File file = new File(string, string3);
        File file2 = new File(file, string4 + ".desktop");
        String string6 = file2.getPath();
        File file3 = new File(string2, "Autostart " + string4 + ".desktop");
        String string7 = file3.getPath();
        file3.delete();
        this.log("setting up kde autostart");
        UnixCommands.ln(string6, string7);
        UnixCommands.chmod("0744", string7);
        this.log("linked " + string6 + " to " + string7);
        this.autoStartList.add(string7);
        this.configUninstaller(string7, string5);
    }

    private void autoStartWindows(String string, PropertyList propertyList, String string2) {
        String string3 = propertyList.getProperty("longName");
        if (AutoStartMenusPanel.stringHasContent(string3)) {
            boolean bl = propertyList.getBooleanProperty("menuAllUsers", false);
            if (bl) {
                this.log("configuring " + string3 + " for all users");
            } else {
                this.log("configuring " + string3 + " for local user");
            }
            File file = this.getWindowsLink(string, propertyList, bl);
            if (!(file != null && file.exists())) {
                this.log("can't find link in first menus dir");
                file = this.getWindowsLink(string, propertyList, !bl);
            }
            if (!(file != null && file.exists())) {
                this.log("can't create auto startup because can't find corresponding link in any menus dir");
            } else {
                String string4 = this.getWindowsStartupDir(bl);
                if (AutoStartMenusPanel.stringHasContent(string4)) {
                    File file2 = new File(string4, "Autostart " + string3 + ".lnk");
                    this.copyFile(file.getPath(), file2.getPath());
                    this.autoStartList.add(file2.getPath());
                    this.configUninstaller(file2.getPath(), string2);
                }
            }
        }
    }

    private File getWindowsLink(String string, PropertyList propertyList, boolean bl) {
        File file = null;
        String string2 = propertyList.getProperty("longName");
        if (AutoStartMenusPanel.stringHasContent(string2)) {
            String string3 = this.getWindowsMenuDir(bl);
            if (AutoStartMenusPanel.stringHasContent(string3)) {
                File file2 = null;
                file2 = AutoStartMenusPanel.stringHasContent(string) ? new File(string3, string) : new File(string3);
                file = new File(file2, string2 + ".LNK");
                this.log("windows link: " + file.getPath());
            } else {
                this.log("unable to get windows menu dir");
            }
        } else {
            this.log("no long name for menu");
        }
        return file;
    }

    private String getWindowsMenuDir(boolean bl) {
        String string = WindowsDirs.getMenuDir(this.getWindowsUser(bl));
        if (string != null) {
            this.log("menus dir " + string);
        } else {
            this.log("unable to get program menus dir ");
        }
        return string;
    }

    private String getWindowsStartupDir(boolean bl) {
        String string = WindowsDirs.getStartupMenuDir(this.getWindowsUser(bl));
        if (string != null) {
            this.log("startup dir " + string);
        } else {
            this.log("unable to get startup menus dir ");
        }
        return string;
    }

    private String getWindowsUser(boolean bl) {
        String string = "currentUser";
        if (bl) {
            string = "allUsers";
        }
        return string;
    }

    private void autoStartMac(PropertyList propertyList, String string) {
        String string2 = propertyList.getProperty("longName", "");
        String string3 = propertyList.getProperty("shortName", "");
        boolean bl = propertyList.getBooleanProperty("useJavaCommandPrefix");
        boolean bl2 = propertyList.getBooleanProperty("useJavaConsole");
        boolean bl3 = propertyList.getBooleanProperty("menuAutoUpdate");
        this.log("configuring " + string3);
        if (this.getPropertyList().getBooleanProperty("autoupdateEveryStartup") && bl3 && !bl) {
            bl = true;
            bl2 = false;
        }
        if (string2.length() > 0 && bl && !bl2) {
            File file = new File(string, string2 + ".app");
            File file2 = new File(file, "Contents");
            File file3 = new File(file2, "MacOS");
            File file4 = new File(file3, string3);
            String string4 = file4.getPath();
            if (string4.indexOf(" ") >= 0) {
                string4 = "\"" + string4 + "\"";
            }
            File file5 = new File(string, "JExpress");
            File file6 = new File(file5, "autostart." + string3 + ".command");
            String string5 = file6.getPath();
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file6);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                printWriter.println(string4);
                printWriter.close();
                fileOutputStream.close();
                UnixCommands.chmod("0755", string5);
                this.log("created " + string5);
            }
            catch (Exception var16_21) {
                this.log(var16_21);
            }
            this.setupMacAutoStart(string5);
            this.autoStartList.add(string5);
            this.configUninstaller(string5, string);
        } else if (string3.length() > 0) {
            String string6 = string3 + ".command";
            String string7 = "autostart." + string3 + ".command";
            String string8 = string + File.separator + string6;
            String string9 = string + File.separator + string7;
            this.setupMacAutoStart(string9);
            this.reconfigMacAutoStart(string8, string9);
            this.configUninstaller(string9, string);
        }
    }

    private void setupMacAutoStart(String string) {
        String string2 = "$autoStartCommand";
        String string3 = "'<dict><key>Hide</key><false/><key>Path</key><string>" + string2 + "</string></dict>'";
        try {
            int n = string3.indexOf(string2);
            if (n != -1) {
                this.backupPlistFile();
                string3 = string3.substring(0, n) + string + string3.substring(n + string2.length());
                String string4 = System.getProperty("user.home", ".");
                String string5 = "defaults write loginwindow AutoLaunchedApplicationDictionary -array-add " + string3;
                Exec.runCommand(string5, string4);
                this.log("issued command: " + string5);
            }
        }
        catch (Throwable var4_5) {
            this.log(var4_5);
        }
    }

    private void reconfigMacAutoStart(String string, String string2) {
        File file = new File(string);
        File file2 = new File(string2);
        file2.delete();
        if (file.exists()) {
            file.renameTo(file2);
            UnixCommands.ln(string2, string);
            UnixCommands.chmod("0755", string);
            this.log("linked " + string2 + " to " + string);
        } else {
            this.log(string + " not found");
        }
    }

    private void backupPlistFile() {
        try {
            File file = new File(this.getPlistFilename());
            File file2 = new File(this.getPlistFilename() + ".backup");
            file2.delete();
            FileSystem.copyFile(file, file2);
            this.log("backuped plist to: " + file2.getPath());
        }
        catch (Throwable var1_2) {
            this.log(var1_2);
        }
    }

    private String getPlistFilename() {
        String string = null;
        String string2 = System.getProperty("user.home", ".");
        File file = new File(string2, "Library/Preferences");
        File file2 = new File(file, "loginwindow.plist");
        if (file2.exists()) {
            string = file2.getPath();
        } else {
            this.log("unable to find: " + file2.getPath());
        }
        return string;
    }

    private static boolean stringHasContent(String string) {
        return string != null && string.length() > 0;
    }

    private boolean copyFile(String string, String string2) {
        boolean bl = false;
        File file = new File(string2);
        file.delete();
        try {
            FileSystem.copyFile(string, string2);
            this.log("copied " + string + " to " + string2);
            bl = true;
        }
        catch (Exception var5_5) {
            this.log(var5_5);
        }
        return bl;
    }

    private void configUninstaller(String string, String string2) {
        CustomUninstaller customUninstaller = new CustomUninstaller();
        customUninstaller.deleteFile(string);
        customUninstaller.tempSave(string2, "autostartupuinstall");
        this.log("setup to delete file during uninstall: " + string);
    }

    private void log(String string) {
        this.startLog();
        autostartLog.write(string);
    }

    private void log(Throwable throwable) {
        this.startLog();
        autostartLog.write(throwable);
    }

    private void startLog() {
        if (autostartLog == null) {
            autostartLog = new Log("autostartup.log");
        }
    }

    private void stopLogging() {
        if (autostartLog != null) {
            autostartLog.stopLogging();
        }
    }

    private class MenusSwinger
    extends Swinger {
        boolean ok;

        private MenusSwinger() {
            this.ok = false;
        }

        public void swingBefore() {
            CustomInstaller.log("Adding startup menus");
            AutoStartMenusPanel.this.log("adding startup menus");
            AutoStartMenusPanel.this.updateProgressBarLabel(AutoStartMenusPanel.this.progressLabel);
        }

        public void workInBackground() {
            try {
                AutoStartMenusPanel.this.configureAutoStart();
            }
            catch (Exception var1_1) {
                this.ok = false;
                AutoStartMenusPanel.this.log("Unexpected error adding startup menus.");
                CustomInstaller.logException("Unable to set up startup menus.", var1_1);
            }
        }

        public void swingAfter() {
            AutoStartMenusPanel.this.updated = true;
            CustomInstaller.log("Finished adding startup menus");
            AutoStartMenusPanel.this.log("finished adding startup menus");
            AutoStartMenusPanel.this.showNextPanel();
        }
    }

}
