/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.InstallerPopups;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.VerifyDirectory;
import com.denova.JExpress.JExpressConstants;
import com.denova.JExpress.JExpressPropertyStore;
import com.denova.io.FileGroup;
import com.denova.io.Log;
import com.denova.runtime.JRE;
import com.denova.runtime.WindowsUtils;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.FileGroupsListEditor;
import com.denova.ui.Fonts;
import com.denova.ui.GridBagControl;
import com.denova.ui.ListEditor;
import com.denova.ui.Swinger;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.WizardPanel;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Locale;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;

public class DirectoryPanel
extends WizardPanel
implements JExpressConstants,
InstallPropertyNames,
InstallerConstants {
    protected JTextField dirname;
    private JLabel title;
    private JButton browseButton;
    private JButton installButton;
    private JButton cancelButton;
    private String component = null;
    private String lastServletName = null;
    private File defaultDirectory = null;
    private boolean silentInstall = false;
    private boolean clickFreeInstaller = false;
    private boolean showInstall = false;
    private boolean nextButtonEnabled = false;
    private boolean inited = false;
    private static Log log = null;

    public DirectoryPanel(PropertyList propertyList) {
        super(propertyList);
        this.setupPanel(Localize.strings().getString("InstallDir"), Localize.strings().getString("DirToolTip"));
        this.component = "";
    }

    public DirectoryPanel(PropertyList propertyList, String string, String string2) {
        super(propertyList);
        this.setupPanel(string, string2);
        this.component = string;
    }

    public synchronized void enter() {
        if (this.inited) {
            if (this.silentInstall) {
                this.showNextPanel();
            }
        } else {
            this.inited = true;
            this.silentInstall = this.getPropertyList().getBooleanProperty("silentInstall", false);
            DirectoryPanel.logDirMessage("silent install: " + this.silentInstall);
            if (this.silentInstall) {
                String string = this.getPropertyList().getProperty("applicationDirectory", "");
                this.dirname.setText(string);
                DirectoryPanel.logDirMessage("install dir: " + string);
                this.showNextPanel();
            } else {
                this.getDirectory();
            }
        }
    }

    private void getDirectory() {
        DirSwinger dirSwinger = new DirSwinger();
        dirSwinger.execute();
    }

    public boolean isOk() {
        String string = this.dirname.getText();
        boolean bl = VerifyDirectory.isOk(string, this.component, this.getPropertyList());
        if (!bl && this.silentInstall) {
            this.abort();
        }
        return bl;
    }

    public String getNextButtonLabel() {
        String string = this.showInstallNowButton() ? Localize.strings().getString("InstallButton") : Localize.strings().getString("NextButton");
        DirectoryPanel.logDirMessage("next button label: " + string);
        return string;
    }

    public String getNextButtonIconName() {
        String string = this.showInstallNowButton() ? this.getDefaultInstallButtonIconName() : this.getDefaultNextButtonIconName();
        return string;
    }

    public boolean isNextButtonEnabled() {
        DirectoryPanel.logDirMessage("next button enabled: " + this.nextButtonEnabled);
        return this.nextButtonEnabled;
    }

    public void reset() {
        this.inited = false;
        this.nextButtonEnabled = false;
        if (CustomInstaller.multipleDirInstall()) {
            this.getPropertyList().removeProperty("applicationDirectory" + this.component);
        } else {
            this.getPropertyList().removeProperty("applicationDirectory");
        }
        this.getPropertyList().removeProperty("oldApplicationDirectory");
    }

    public String getName() {
        String string = "DirectoryPanel";
        if (this.component != null && CustomInstaller.multipleDirInstall()) {
            string = string + this.component;
        }
        return string;
    }

    public void changeLabels(final String string, final String string2) {
        SwingUtilities.invokeLater(new Runnable(){

            public void run() {
                DirectoryPanel.this.title.setText(string);
                DirectoryPanel.this.dirname.setToolTipText(string2);
                DirectoryPanel.this.browseButton.setToolTipText(string2);
            }
        });
    }

    protected void setSilentOverwrte(boolean bl) {
        VerifyDirectory.setSilentOverwrte(bl);
    }

    protected void setOverwritePrompt(String string) {
        VerifyDirectory.setOverwritePrompt(string);
    }

    protected static void logDirMessage(String string) {
        if (log == null) {
            log = new Log("directory");
        }
        log.write(string);
    }

    private void setupPanel(String string, String string2) {
        this.clickFreeInstaller = this.getPropertyList().getBooleanProperty("clickFreeInstaller", false);
        if (string == null) {
            string = this.getPropertyList().getProperty("safePackageName");
        }
        if (string2 == null) {
            string2 = Localize.strings().getString("DirToolTip");
        }
        this.setLayout(new BorderLayout());
        this.setBorder(UiLayoutUtilities.getMarginBorder());
        GridBagConstraints gridBagConstraints = GridBagControl.getDefaultConstraints();
        gridBagConstraints.anchor = 13;
        GridBagConstraints gridBagConstraints2 = GridBagControl.getDefaultConstraints();
        gridBagConstraints2.anchor = 10;
        GridBagConstraints gridBagConstraints3 = GridBagControl.getDefaultConstraints();
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.fill = 2;
        GridBagConstraints gridBagConstraints4 = GridBagControl.getDefaultConstraints();
        gridBagConstraints4.fill = 2;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        gridBagControl.addVerticalSpace();
        String string3 = null;
        if (CustomInstaller.multipleDirInstall()) {
            string3 = string2;
        }
        if (string3 == null || string3.length() <= 0) {
            string3 = string;
        }
        transparentJPanel.setName(string3);
        this.title = new JLabel(string3);
        Fonts.setFont(this.title, Fonts.Bold);
        gridBagControl.addCentered(this.title);
        gridBagControl.endRow();
        gridBagControl.addVerticalSpace();
        this.dirname = new JTextField();
        this.dirname.setToolTipText(string2);
        this.dirname.setEditable(true);
        gridBagControl.add(gridBagConstraints3, this.dirname);
        String string4 = Localize.strings().getString("BrowseButton");
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        this.browseButton = buttonsIcons.getIconTextButton(string4, "browse-denova.png");
        gridBagControl.endRow(gridBagConstraints4, this.browseButton);
        gridBagControl.addVerticalSpace();
        if (this.clickFreeInstaller) {
            gridBagControl.addCentered(this.getExtraButtons());
        } else {
            this.installButton = new JButton("Install");
            this.cancelButton = new JButton("Cancel");
        }
        this.add(transparentJPanel);
        Action action = new Action();
        this.browseButton.addActionListener(action);
        this.installButton.addActionListener(action);
        this.cancelButton.addActionListener(action);
        WindowsUtils.clearError();
        DirectoryPanel.logDirMessage("setupPanel");
    }

    private TransparentJPanel getExtraButtons() {
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        GridBagConstraints gridBagConstraints = GridBagControl.getDefaultConstraints();
        gridBagConstraints.anchor = 10;
        GridBagConstraints gridBagConstraints2 = GridBagControl.getDefaultConstraints();
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.fill = 2;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        this.installButton = buttonsIcons.getIconTextButton(Localize.strings().getString("Ok"), "yes-denova.png");
        this.cancelButton = buttonsIcons.getIconTextButton(Localize.strings().getString("CancelButton"), "no-denova.png");
        gridBagControl.add(gridBagConstraints2, this.cancelButton);
        gridBagControl.addBlankCell();
        gridBagControl.add(gridBagConstraints2, this.installButton);
        gridBagControl.endRow();
        return transparentJPanel;
    }

    private boolean showInstallNowButton() {
        this.showInstall = Installer.getInstaller().showInstallButtonOnDirectoryPanel();
        if (CustomInstaller.multipleDirInstall() && this.component != null && !this.component.equals(this.getLastServletName())) {
            this.showInstall = false;
        }
        DirectoryPanel.logDirMessage("show install button: " + this.showInstall);
        return this.showInstall;
    }

    private String getLastServletName() {
        if (this.lastServletName == null) {
            FileGroupsListEditor fileGroupsListEditor = new FileGroupsListEditor(new ListEditor());
            fileGroupsListEditor.fromString(this.getPropertyList().getProperty("fileGroupsTypes", ""));
            for (FileGroup fileGroup : fileGroupsListEditor.getItems()) {
                this.lastServletName = fileGroup.getName();
            }
        }
        return this.lastServletName;
    }

    private boolean isOldVersion(String string, String string2) {
        boolean bl = false;
        JExpressPropertyStore jExpressPropertyStore = new JExpressPropertyStore(string);
        this.presetPrevVersion(jExpressPropertyStore);
        this.presetAppDir(jExpressPropertyStore);
        if (this.getPropertyList().getBooleanProperty("checkPreVersion", false)) {
            bl = this.oldVersion(string, string2);
        }
        return bl;
    }

    private boolean oldVersion(String string, String string2) {
        boolean bl = false;
        String string3 = this.getPropertyList().getProperty("previousVersion", "").trim();
        String string4 = this.getPropertyList().getProperty("previousApplicationDir", "");
        if (string3.length() > 0 && string2.length() > 0 && string4.length() > 0) {
            int n = string2.compareToIgnoreCase(string3);
            DirectoryPanel.logDirMessage("new version compared to prev version result: " + n);
            boolean bl2 = bl = n < 0;
        }
        if (bl) {
            DirectoryPanel.logDirMessage("found older version of " + string);
            DirectoryPanel.logDirMessage("  old version: " + string3);
            DirectoryPanel.logDirMessage("  new version: " + string2);
            DirectoryPanel.logDirMessage("      old dir: " + string4);
        }
        return bl;
    }

    private void presetPrevVersion(JExpressPropertyStore jExpressPropertyStore) {
        String string = jExpressPropertyStore.getProperty("packageVersion", "").trim();
        this.getPropertyList().setProperty("previousVersion", string);
    }

    private void presetAppDir(JExpressPropertyStore jExpressPropertyStore) {
        File file;
        String string = jExpressPropertyStore.getProperty("applicationDirectory", "");
        if (string.length() > 0 && (file = new File(string)).exists() && file.isDirectory()) {
            this.getPropertyList().setProperty("previousApplicationDir", string);
            this.getPropertyList().setProperty("applicationDirectory", string);
            DirectoryPanel.logDirMessage("set previous dir: " + string);
        }
    }

    private class DirSwinger
    extends Swinger {
        File dir;
        String titleText;

        private DirSwinger() {
            this.dir = null;
            this.titleText = null;
        }

        public void swingBefore() {
            String string = DirectoryPanel.this.getPropertyList().getProperty("packageName", "").trim();
            String string2 = DirectoryPanel.this.getPropertyList().getProperty("packageVersion", "").trim();
            DirectoryPanel.this.setOpaque(true);
            if (DirectoryPanel.this.isOldVersion(string, string2)) {
                String string3 = Localize.strings().getString("Warning");
                String string4 = Localize.strings().getString("NewLocation");
                String string5 = Localize.strings().getString("Overwrite");
                Vector<String> vector = new Vector<String>();
                vector.add(Localize.strings().getString("FoundOlderVersion", string));
                boolean bl = InstallerPopups.ask(string3, Localize.strings().getString("InstallOlderVersion"), vector, string4, string5, string4);
                DirectoryPanel.logDirMessage("new install location: " + string4);
                if (bl) {
                    String string6 = DirectoryPanel.this.getPropertyList().getProperty("applicationDirectory", "");
                    String string7 = DirectoryPanel.this.getPropertyList().getProperty("packageVersion", "");
                    DirectoryPanel.this.getPropertyList().setProperty("applicationDirectory", string6 + "-" + string7);
                    DirectoryPanel.logDirMessage("new app dir: " + string6 + "-" + string7);
                }
                DirectoryPanel.this.dirname.setEnabled(false);
                DirectoryPanel.this.browseButton.setEnabled(false);
                DirectoryPanel.this.setNextButtonEnabled(false);
                DirectoryPanel.logDirMessage("disabled directory panel");
            }
        }

        public void workInBackground() {
            try {
                Object object;
                if (CustomInstaller.multipleComponents()) {
                    this.titleText = DirectoryPanel.this.getPropertyList().getProperty("installType", "");
                    if (this.titleText != null && this.titleText.length() > 0) {
                        DirectoryPanel.logDirMessage("multiple component title text: " + this.titleText);
                        DirectoryPanel.this.component = this.titleText;
                    }
                }
                boolean bl = true;
                String string = CustomInstaller.getLanguage();
                if (string.equals(Locale.JAPANESE.getLanguage())) {
                    object = new File(JRE.getActiveJavaHome() + "lib", "font.getPropertyList()." + Locale.JAPANESE.getLanguage());
                    bl = object.exists();
                    DirectoryPanel.logDirMessage("japanese font file exists: " + bl);
                }
                if ((object = VerifyDirectory.getDefaultInstallationDirectory(DirectoryPanel.this.component, DirectoryPanel.this.getPropertyList())) == null) {
                    DirectoryPanel.logDirMessage("unable to get default installation directory");
                } else {
                    this.dir = new File((String)object);
                    DirectoryPanel.this.defaultDirectory = this.dir;
                    DirectoryPanel.logDirMessage("set default installation directory: " + this.dir.getPath());
                }
            }
            catch (Exception var1_2) {
                CustomInstaller.logException("Fatal error", var1_2);
                DirectoryPanel.logDirMessage("unexpected error");
            }
        }

        public void swingAfter() {
            if (this.titleText != null && this.titleText.length() > 0) {
                String string = Localize.strings().getString("InstallDir");
                DirectoryPanel.this.title.setText(this.titleText + " " + string);
            }
            if (this.dir != null) {
                DirectoryPanel.this.dirname.setText(this.dir.getPath());
            }
            this.setFocus(DirectoryPanel.this.dirname);
            DirectoryPanel.this.dirname.setEnabled(true);
            DirectoryPanel.this.browseButton.setEnabled(true);
            DirectoryPanel.this.nextButtonEnabled = true;
            if (DirectoryPanel.this.clickFreeInstaller) {
                DirectoryPanel.this.installButton.setEnabled(DirectoryPanel.this.nextButtonEnabled);
                UiLayoutUtilities.setFocus(DirectoryPanel.this.installButton);
            } else {
                DirectoryPanel.this.setNextButtonEnabled(DirectoryPanel.this.nextButtonEnabled);
                DirectoryPanel.this.setDefaultButton(WizardPanel.NextButton);
            }
            DirectoryPanel.logDirMessage("enabled directory buttons");
        }

        private void setFocus(JTextField jTextField) {
            JTextField jTextField2 = jTextField;
            String string = jTextField2.getText();
            int n = 0;
            if (string != null) {
                n = string.length();
            }
            jTextField2.requestFocusInWindow();
            jTextField2.setCaretPosition(n);
        }
    }

    private class Browse
    extends Swinger {
        File newDir;

        private Browse() {
            this.newDir = null;
        }

        public void workInBackground() {
            this.newDir = VerifyDirectory.browse(DirectoryPanel.this, DirectoryPanel.this.defaultDirectory, DirectoryPanel.this.getPropertyList());
        }

        public void swingAfter() {
            if (this.newDir != null) {
                DirectoryPanel.this.defaultDirectory = this.newDir;
                DirectoryPanel.this.dirname.setText(this.newDir.getPath());
                DirectoryPanel.this.dirname.setEnabled(true);
                DirectoryPanel.this.browseButton.setEnabled(true);
                if (DirectoryPanel.this.dirname.getText().length() > 0) {
                    DirectoryPanel.this.nextButtonEnabled = true;
                    DirectoryPanel.this.setNextButtonEnabled(DirectoryPanel.this.nextButtonEnabled);
                    DirectoryPanel.this.setDefaultButton(WizardPanel.NextButton);
                }
            }
        }
    }

    private class Action
    implements ActionListener {
        private Action() {
        }

        public void actionPerformed(ActionEvent actionEvent) {
            Object object = actionEvent.getSource();
            if (object == DirectoryPanel.this.browseButton) {
                DirectoryPanel.logDirMessage("browse button clicked");
                Browse browse = new Browse();
                browse.execute();
            } else if (object == DirectoryPanel.this.installButton) {
                DirectoryPanel.this.showNextPanel();
            } else if (object == DirectoryPanel.this.cancelButton) {
                DirectoryPanel.this.cancel();
            }
        }
    }

}
