/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.StatusPanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.runtime.OS;
import com.denova.util.PropertyList;
import java.util.Enumeration;
import java.util.Timer;
import java.util.TimerTask;

public class FinalPanel
extends StatusPanel
implements JExpressConstants,
InstallPropertyNames,
InstallerConstants {
    protected String fullProgramName = "";
    protected String startProgram = null;
    protected boolean nextButtonEnabled = false;

    public FinalPanel(PropertyList propertyList) {
        super(propertyList);
        this.fullProgramName = propertyList.getProperty("packageName", "");
        String string = propertyList.getProperty("packageVersion", "");
        if (string != null && string.length() > 0) {
            this.fullProgramName = this.fullProgramName + " " + string;
        }
        CustomInstaller.log("full program name: " + this.fullProgramName);
        String string2 = this.getBlankMaxStatus();
        this.updateProgressBarLabel(string2);
    }

    public synchronized void enter() {
        this.maximize();
        if (this.getPropertyList().getBooleanProperty("silentInstall", false)) {
            CustomInstaller.log("exiting final panel silently");
            this.showNextPanel();
        } else {
            boolean bl = this.getPropertyList().getBooleanProperty("installSuccessful", true);
            if (bl && !this.getPropertyList().getBooleanProperty("showFinalPanel", true)) {
                CustomInstaller.log("exiting final panel automatically");
                this.showNextPanel();
            } else {
                this.showFinalStatus(bl);
            }
        }
    }

    public boolean isNextButtonEnabled() {
        return this.nextButtonEnabled;
    }

    public String getNextButtonIconName() {
        return this.getDefaultFinishedButtonIconName();
    }

    public String getName() {
        return "FinalPanel";
    }

    public int getEstimatedTime() {
        return 0;
    }

    private void showFinalStatus(boolean bl) {
        String string = null;
        string = bl ? this.fullProgramName + " " + Localize.strings().getString("InstallationComplete") : this.fullProgramName + " " + Localize.strings().getString("InstallationUnsuccessful");
        if (this.startProgram == null) {
            this.updateProgressBarLabel(string);
        } else {
            CustomInstaller.log("ready to start: " + this.startProgram);
            this.updateProgressBarLabel(string + " " + this.startProgram);
        }
        CustomInstaller.log("final status: " + string);
        if (this.getPropertyList().getBooleanProperty("clickFreeInstaller", false)) {
            this.startExitTimer();
        }
        this.nextButtonEnabled = true;
        this.setNextButtonEnabled(this.nextButtonEnabled);
        CustomInstaller.log("enabled next button");
    }

    private String getMenuName() {
        String string = this.getPropertyList().getProperty("menuToStart");
        if (string == null || string.length() <= 0) {
            String string2 = this.getPropertyList().getProperty("submenu", "").replace('/', '|');
            string = string2 == null || string2.length() <= 0 ? "" : string2 + " | ";
            string = string + this.getPropertyList().getProperty("packageName", "Java applications");
        }
        return string;
    }

    private boolean needMenuStatus() {
        boolean bl = false;
        if (OS.isWindows() && this.getPropertyList().getBooleanProperty("tellUserHowToStart")) {
            PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
            Enumeration enumeration = propertyList.propertyNames();
            bl = enumeration.hasMoreElements();
        }
        return bl;
    }

    private String getBlankMaxStatus() {
        Object object;
        String string = this.fullProgramName + " " + Localize.strings().getString("InstallationUnsuccessful");
        if (this.needMenuStatus() && ((object = this.getMenuName()) == null || object.length() <= 0)) {
            this.startProgram = Localize.strings().getString("ToStartProgram") + " " + Localize.strings().getString("SelectMenu") + " " + (String)object;
            string = string + " ";
            string = string + this.startProgram;
        }
        try {
            object = string.toCharArray();
            for (int i = 0; i < object.length; ++i) {
                object[i] = 32;
            }
            string = String.valueOf((char[])object);
        }
        catch (Exception var2_3) {
            string = "                                         ";
            CustomInstaller.log(var2_3.getMessage());
        }
        CustomInstaller.log("blank status length: " + string.length());
        return string;
    }

    private void startExitTimer() {
        int n = 4000;
        Timer timer = new Timer();
        timer.schedule((TimerTask)new ExitTimer(), n);
        CustomInstaller.log("set timer to exit");
    }

    private class ExitTimer
    extends TimerTask {
        private ExitTimer() {
        }

        public synchronized void run() {
            CustomInstaller.log("exiting final panel");
            FinalPanel.this.showNextPanel();
        }
    }

}
