/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.security.GetCredentials;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.GridBagControl;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.WizardPanel;
import com.denova.util.LocaleTranslator;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import javax.swing.JButton;
import javax.swing.JRootPane;
import javax.swing.border.Border;

public class GetCredentialsPanel
extends WizardPanel
implements InstallPropertyNames,
JExpressConstants {
    private JButton installButton;
    private JButton cancelButton;
    private boolean inited = false;
    private boolean silentInstall = false;
    private boolean clickFreeInstaller = false;
    private GetCredentials credentials = new GetCredentials(Localize.strings());

    public GetCredentialsPanel(PropertyList propertyList) {
        super(propertyList);
        this.addPanel();
    }

    public synchronized void enter() {
        this.setEnabledNamedPanel("GetProxyPanel", false);
        this.silentInstall = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (this.silentInstall) {
            this.showNextPanel();
        } else {
            if (this.inited) {
                this.cancelButton.setVisible(true);
                String string = this.getPropertyList().getProperty("licenseError", "");
                if (string.length() > 0) {
                    String string2 = this.getPropertyList().getProperty("author");
                    CustomInstaller.log("manufacturer: " + string2);
                    if (string2 == null || string2.trim().length() <= 0) {
                        string2 = Localize.strings().getString("Manufacturer", "the manufacturer");
                    }
                    CustomInstaller.log("manufacturer: " + string2);
                    this.credentials.setHeader(this.getLocalizedErrorMessage(string));
                    this.credentials.setSubhead(Localize.strings().getString("CheckInbox"));
                    this.credentials.setWrongLicenseEmail(Localize.strings().getString("WrongLicenseEmail", string2));
                    this.credentials.setSubheadVisible(true);
                } else {
                    this.credentials.setHeader(Localize.strings().getString("CheckInbox"));
                    this.credentials.setSubheadVisible(false);
                }
            } else {
                this.credentials.setHeader(Localize.strings().getString("CheckInbox"));
                this.credentials.setSubheadVisible(false);
                this.cancelButton.setVisible(false);
                this.inited = true;
                this.presetLicenseInfo();
            }
            if (this.clickFreeInstaller) {
                this.getRootPane().setDefaultButton(this.installButton);
            } else {
                this.setNextButtonEnabled(true);
            }
            this.credentials.setPrimaryContactFocus();
        }
    }

    private String getLocalizedErrorMessage(String string) {
        if (string.equals("You do not have a matching license.") || string.equals("Unable to verify your license. Bad email or PIN?")) {
            string = Localize.strings().getString("CheckCredentials");
        } else if (string.startsWith("Your license expired on ")) {
            int n = "Your license expired on ".length();
            String string2 = string.substring(n);
            string = Localize.strings().getString("LicenseExpired", string2);
        } else if (string.equals("Error connecting to license server.")) {
            string = Localize.strings().getString("LicenseConnectionError");
        } else if (string.equals("Invalid format") || string.equals("Data missing.")) {
            string = Localize.strings().getString("BadLicenseData");
        } else if (string.equals("Unknown error.") || string.equals("Unexpected error verifying your license.")) {
            string = Localize.strings().getString("UnknownLicenseError");
        }
        return string;
    }

    public boolean isOk() {
        CustomInstaller.log("Checking if customer info ok");
        boolean bl = false;
        if (this.silentInstall) {
            bl = true;
        } else {
            bl = this.credentials.isOk();
            if (bl) {
                this.getPropertyList().setProperty("licensePrimaryContact", this.credentials.getPrimaryContact());
                this.getPropertyList().setProperty("licenseIdCode", this.credentials.getIdCode());
            } else {
                this.credentials.showError();
            }
        }
        CustomInstaller.log("isOk: " + bl);
        return bl;
    }

    public boolean isNextButtonEnabled() {
        return true;
    }

    public void setNextButtonEnabled(boolean bl) {
        super.setNextButtonEnabled(bl);
        this.setDefaultButton(NextButton);
    }

    public String getNextButtonLabel() {
        return Localize.strings().getString("InstallButton");
    }

    public String getNextButtonIconName() {
        return this.getDefaultInstallButtonIconName();
    }

    public String getName() {
        return "GetCredentialsPanel";
    }

    private void addPanel() {
        this.setLayout(new BorderLayout());
        this.setBorder(UiLayoutUtilities.getMarginBorder());
        GridBagConstraints gridBagConstraints = GridBagControl.getDefaultConstraints();
        gridBagConstraints.anchor = 10;
        GridBagConstraints gridBagConstraints2 = GridBagControl.getDefaultConstraints();
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.fill = 2;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        if (CustomInstaller.isOpaque()) {
            gridBagControl.addVerticalSpace();
        }
        gridBagControl.addCentered(this.getMainPanel());
        gridBagControl.addCentered(this.getExtraButtons());
        ActionListener actionListener = new ActionListener();
        this.installButton.addActionListener(actionListener);
        this.cancelButton.addActionListener(actionListener);
        this.add(transparentJPanel);
    }

    private TransparentJPanel getMainPanel() {
        String string = this.getPropertyList().getProperty("author", "");
        CustomInstaller.log("manufacturer: " + string);
        if (string == null || string.trim().length() <= 0) {
            string = Localize.strings().getString("Manufacturer", "the manufacturer");
        }
        CustomInstaller.log("manufacturer: " + string);
        this.credentials.setHeader(Localize.strings().getString("BadLicenseData"));
        this.credentials.setSubhead(Localize.strings().getString("CheckInbox"));
        this.credentials.setWrongLicenseEmail(Localize.strings().getString("WrongLicenseEmail", string));
        return this.credentials.createMainPanel();
    }

    private TransparentJPanel getExtraButtons() {
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        GridBagConstraints gridBagConstraints = GridBagControl.getDefaultConstraints();
        gridBagConstraints.anchor = 10;
        GridBagConstraints gridBagConstraints2 = GridBagControl.getDefaultConstraints();
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.fill = 2;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        this.clickFreeInstaller = this.getPropertyList().getBooleanProperty("clickFreeInstaller", false);
        this.installButton = buttonsIcons.getIconTextButton(Localize.strings().getString("Ok"), "yes-denova.png");
        this.cancelButton = buttonsIcons.getIconTextButton(Localize.strings().getString("CancelButton"), "no-denova.png");
        if (this.clickFreeInstaller) {
            gridBagControl.add(gridBagConstraints2, this.cancelButton);
            gridBagControl.addBlankCell();
        }
        if (this.clickFreeInstaller) {
            gridBagControl.addBlankCell();
            gridBagControl.add(gridBagConstraints2, this.installButton);
            gridBagControl.endRow();
        } else {
            gridBagControl.endRow();
        }
        return transparentJPanel;
    }

    private void presetLicenseInfo() {
        boolean bl = false;
        if (Installer.getInstaller().isTrialCopyCheqAccount()) {
            String string;
            String string2 = Installer.getInstaller().getLicenseEmail();
            if (string2 != null) {
                this.credentials.setPrimaryContact(string2.trim());
                bl = true;
            }
            if ((string = Installer.getInstaller().getLicenseID()) != null) {
                this.credentials.setIdCode(string.trim());
                bl = true;
            }
        } else if (this.getPropertyList().getBooleanProperty("autoupdateNever", false)) {
            bl = false;
        } else {
            try {
                String string = this.getPropertyList().getProperty("applicationDirectory", "");
                File file = new File(string, "JExpress");
                File file2 = new File(file, "update.control");
                if (file2.exists()) {
                    String string3;
                    PropertyList propertyList = new PropertyList();
                    FileInputStream fileInputStream = new FileInputStream(file2);
                    propertyList.load(fileInputStream);
                    String string4 = propertyList.getProperty("licensePrimaryContact", "").trim();
                    if (string4.length() > 0) {
                        this.getPropertyList().setProperty("licensePrimaryContact", string4);
                        this.credentials.setPrimaryContact(string4);
                        bl = true;
                    }
                    if ((string3 = propertyList.getProperty("licenseIdCode", "").trim()).length() > 0) {
                        this.getPropertyList().setProperty("licenseIdCode", string3);
                        this.credentials.setIdCode(string3);
                        bl = true;
                    }
                }
            }
            catch (Exception var2_4) {
                // empty catch block
            }
        }
        if (!bl) {
            this.credentials.setPrimaryContact("");
            this.credentials.setIdCode("");
        }
    }

    private class ActionListener
    implements java.awt.event.ActionListener {
        private ActionListener() {
        }

        public void actionPerformed(ActionEvent actionEvent) {
            Object object = actionEvent.getSource();
            if (object == GetCredentialsPanel.this.installButton) {
                GetCredentialsPanel.this.showNextPanel();
            } else if (object == GetCredentialsPanel.this.cancelButton) {
                GetCredentialsPanel.this.cancel();
            }
        }
    }

}
