/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.net.GetProxySettings;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.GridBagControl;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.WizardPanel;
import com.denova.util.LocaleTranslator;
import com.denova.util.PropertyList;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import javax.swing.JButton;
import javax.swing.JRootPane;
import javax.swing.border.Border;

public class GetProxyPanel
extends WizardPanel
implements InstallPropertyNames,
JExpressConstants {
    private JButton installButton;
    private JButton cancelButton;
    private boolean inited = false;
    private boolean silentInstall = false;
    private boolean clickFreeInstaller = false;
    private GetProxySettings proxySettings = new GetProxySettings(Localize.strings());

    public GetProxyPanel(PropertyList propertyList) {
        super(propertyList);
        this.addPanel();
    }

    public synchronized void enter() {
        this.setEnabledNamedPanel("GetCredentialsPanel", false);
        this.silentInstall = this.getPropertyList().getBooleanProperty("silentInstall", false);
        if (this.silentInstall) {
            this.showNextPanel();
        } else {
            if (this.inited) {
                this.cancelButton.setVisible(true);
            } else {
                this.cancelButton.setVisible(false);
                this.inited = true;
                this.presetProxyInfo();
            }
            if (this.clickFreeInstaller) {
                this.getRootPane().setDefaultButton(this.installButton);
            } else {
                this.setNextButtonEnabled(true);
            }
            this.proxySettings.setHostAsFocus();
        }
    }

    public boolean isOk() {
        boolean bl = false;
        if (this.silentInstall) {
            bl = true;
        } else {
            bl = this.proxySettings.isOk();
            if (bl) {
                this.getPropertyList().setProperty("proxyHost", this.proxySettings.getHost());
                this.getPropertyList().setProperty("proxyUserName", this.proxySettings.getUserName());
                this.getPropertyList().setProperty("proxyPassword", this.proxySettings.getPassword());
                this.getPropertyList().setIntProperty("proxyPort", this.proxySettings.getPort());
                this.getPropertyList().setProperty("proxyType", this.proxySettings.getType());
            } else {
                this.proxySettings.showError();
            }
        }
        return bl;
    }

    public boolean isNextButtonEnabled() {
        return true;
    }

    public void setNextButtonEnabled(boolean bl) {
        super.setNextButtonEnabled(bl);
        this.setDefaultButton(NextButton);
    }

    public String getNextButtonLabel() {
        return Localize.strings().getString("InstallButton");
    }

    public String getNextButtonIconName() {
        return this.getDefaultInstallButtonIconName();
    }

    public String getName() {
        return "GetProxyPanel";
    }

    private void addPanel() {
        this.setLayout(new BorderLayout());
        this.setBorder(UiLayoutUtilities.getMarginBorder());
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        if (CustomInstaller.isOpaque()) {
            gridBagControl.addVerticalSpace();
        }
        gridBagControl.addCentered(this.getDataFields());
        gridBagControl.addCentered(this.getExtraButtons());
        ActionListener actionListener = new ActionListener();
        this.installButton.addActionListener(actionListener);
        this.cancelButton.addActionListener(actionListener);
        this.add(transparentJPanel);
    }

    private TransparentJPanel getDataFields() {
        this.proxySettings.setHeader(Localize.strings().getString("ConnectionRequired", this.getPropertyList().getProperty("packageName", "this program")));
        this.proxySettings.setSubhead(Localize.strings().getString("MissingProxySettings"));
        return this.proxySettings.createMainPanel();
    }

    private TransparentJPanel getExtraButtons() {
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        GridBagConstraints gridBagConstraints = GridBagControl.getDefaultConstraints();
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.fill = 2;
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        this.clickFreeInstaller = this.getPropertyList().getBooleanProperty("clickFreeInstaller", false);
        this.installButton = buttonsIcons.getIconTextButton(Localize.strings().getString("Ok"), "yes-denova.png");
        this.cancelButton = buttonsIcons.getIconTextButton(Localize.strings().getString("CancelButton"), "no-denova.png");
        if (this.clickFreeInstaller) {
            gridBagControl.add(gridBagConstraints, this.cancelButton);
            gridBagControl.addBlankCell();
        }
        if (this.clickFreeInstaller) {
            gridBagControl.addBlankCell();
            gridBagControl.add(gridBagConstraints, this.installButton);
            gridBagControl.endRow();
        } else {
            gridBagControl.endRow();
        }
        return transparentJPanel;
    }

    private void presetProxyInfo() {
        if (!this.getPropertyList().getBooleanProperty("autoupdateNever", false)) {
            try {
                String string = this.getPropertyList().getProperty("applicationDirectory", "");
                File file = new File(string, "JExpress");
                File file2 = new File(file, "update.control");
                if (file2.exists()) {
                    String string2;
                    int n;
                    String string3;
                    PropertyList propertyList = new PropertyList();
                    FileInputStream fileInputStream = new FileInputStream(file2);
                    propertyList.load(fileInputStream);
                    String string4 = propertyList.getProperty("proxyHost", "");
                    if (string4.length() > 0) {
                        this.getPropertyList().setProperty("proxyHost", string4);
                        this.proxySettings.setHost(string4);
                    }
                    if ((string3 = propertyList.getProperty("proxyUserName", "")).length() > 0) {
                        this.getPropertyList().setProperty("proxyUserName", string3);
                        this.proxySettings.setUserName(string3);
                    }
                    if ((string2 = propertyList.getProperty("proxyPassword", "")).length() > 0) {
                        this.getPropertyList().setProperty("proxyPassword", string2);
                        this.proxySettings.setPassword(string2);
                    }
                    if ((n = propertyList.getIntProperty("proxyPort", -1)) > -1) {
                        this.getPropertyList().setIntProperty("proxyPort", n);
                        this.proxySettings.setPort(n);
                    }
                    String string5 = propertyList.getProperty("proxyType", "");
                    if (string2.length() > 0) {
                        this.getPropertyList().setProperty("proxyType", string5);
                        this.proxySettings.setType(string5);
                    }
                }
            }
            catch (Exception var1_2) {
                // empty catch block
            }
        }
    }

    private class ActionListener
    implements java.awt.event.ActionListener {
        private ActionListener() {
        }

        public void actionPerformed(ActionEvent actionEvent) {
            Object object = actionEvent.getSource();
            if (object == GetProxyPanel.this.installButton) {
                GetProxyPanel.this.showNextPanel();
            } else if (object == GetProxyPanel.this.cancelButton) {
                GetProxyPanel.this.cancel();
            }
        }
    }

}
