/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.InstallerPopups;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.StatusPanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.JExpress.JExpressPropertyStore;
import com.denova.io.FileGroup;
import com.denova.io.FileSystem;
import com.denova.io.GZipper;
import com.denova.io.JarFile;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.io.UnpackJarFile;
import com.denova.lang.TimeSharer;
import com.denova.runtime.ThreadManager;
import com.denova.ui.FileGroupsListEditor;
import com.denova.ui.ListEditor;
import com.denova.ui.Swinger;
import com.denova.ui.TextDisplayable;
import com.denova.util.PropertyList;
import java.io.CharArrayWriter;
import java.io.File;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.swing.JLabel;

public class InstallFilesPanel
extends StatusPanel
implements JExpressConstants,
InstallPropertyNames,
InstallerConstants,
TextDisplayable {
    public static final long Megabyte = 0x100000;
    public static final long MegabytesPerShare = 31457280;
    protected boolean silentInstall = false;
    private static final boolean debugging = false;
    private static final Log filesLog = new Log("installfiles");
    private static boolean gettingFiles = false;
    private static int totalFiles = 0;
    private static long totalBytes = 0;
    private static long bytesWritten = 0;
    private static List newDirectories = null;
    private boolean canceled = false;
    private boolean gotFiles = false;
    private String displayName = null;
    private String progressMessage = Localize.strings().getString("InstallingFiles");

    public InstallFilesPanel(PropertyList propertyList) {
        super(propertyList);
        this.progressBarLabel.setText(this.progressMessage);
        newDirectories = new Vector();
    }

    public synchronized void enter() {
        if (this.gotFiles) {
            this.log("got files so showing next panel");
            this.showNextPanel();
            this.log("showed next panel");
        } else {
            InstallSwinger installSwinger = new InstallSwinger();
            installSwinger.execute();
        }
    }

    public String getName() {
        return "InstallFilesPanel";
    }

    public boolean isOk() {
        return this.gotFiles;
    }

    public void reset() {
        super.reset();
        while (gettingFiles) {
            ThreadManager.sleep(1);
        }
        this.gotFiles = false;
        gettingFiles = false;
    }

    public void userCanceled() {
        this.canceled = true;
        if (newDirectories != null && newDirectories.size() > 0) {
            if (gettingFiles) {
                String string = "User cancelled while installing files into a new directory.";
                CustomInstaller.log(string);
                while (gettingFiles) {
                    Thread.yield();
                }
            }
            this.removeNewDirectories();
        }
    }

    public void displayText(String string) {
    }

    public void displayProgress(int n) {
        if (gettingFiles) {
            try {
                float f = bytesWritten+=(long)n;
                float f2 = totalBytes;
                int n2 = (int)(f / f2 * 100.0f);
                if (n2 < 1) {
                    n2 = 1;
                }
                this.log("progress bar %: " + n2);
                this.updateProgressBar(n2);
            }
            catch (Exception var2_3) {
                this.logException("error trying to update progress bar", var2_3);
                this.log("increment progress bar");
                this.incrementProgressBar();
            }
        }
    }

    public int getPanelProgressShares() {
        long l = this.getPropertyList().getLongProperty("uncompressedTotalSize") + this.getPropertyList().getLongProperty("compressedFileSize");
        int n = 1 + Math.round(l / 31457280);
        return n;
    }

    public boolean isNextButtonEnabled() {
        this.log("next button enabled: " + this.gotFiles);
        return this.gotFiles;
    }

    private String getDisplayName() {
        String string = this.getPropertyList().getProperty("packageName", this.getDistributionBundle());
        if (CustomInstaller.multipleFileGroups() || CustomInstaller.multipleComponents()) {
            string = this.getPropertyList().getProperty("installType", this.getDistributionBundle());
        }
        return string;
    }

    private boolean setupDownload() {
        boolean bl = true;
        if (this.getPropertyList() == null) {
            if (!this.silentInstall) {
                InstallerPopups.noteError(Localize.strings().getString("NoProperties"));
            }
            this.gotError("No properties");
            bl = false;
        }
        if (bl && !CustomInstaller.multipleDirInstall()) {
            File file = null;
            String string = this.getPropertyList().getProperty("applicationDirectory");
            if (string != null) {
                file = new File(string);
            }
            if (file == null) {
                if (!this.silentInstall) {
                    InstallerPopups.noteError(Localize.strings().getString("NoAppDir"));
                }
                bl = false;
                this.gotError("No application directory");
            } else if (!file.exists()) {
                newDirectories.add(file.getPath());
                file.mkdirs();
                this.log("saving new directory name: " + file.getPath());
            }
        }
        return bl;
    }

    private boolean installFromFile() {
        boolean bl = true;
        String string = this.getPropertyList().getProperty("applicationDirectory");
        File file = new File(string);
        if (this.extractDistributionFiles(file)) {
            this.gotFiles = true;
        } else {
            String string2 = Localize.strings().getString("UnableToGetFiles");
            this.gotError(string2);
            bl = false;
        }
        return bl;
    }

    private String getDistributionBundle() {
        return this.getPropertyList().getProperty("safePackageName") + "Jex" + "." + "tar.gz";
    }

    private String getInstallerJarFilename() {
        return "install.jar";
    }

    private boolean extractDistributionFiles(File file) {
        boolean bl = true;
        bl = CustomInstaller.multipleFileGroups() || CustomInstaller.multipleComponents() ? this.extractMultiInstallerFiles(file) : (CustomInstaller.multipleDirInstall() ? this.extractServlet() : this.extractSingleInstallerFiles(file));
        return bl;
    }

    private boolean extractSingleInstallerFiles(File file) {
        boolean bl = true;
        bl = this.extractFiles(this.getDistributionBundle(), file);
        return bl;
    }

    private boolean extractMultiInstallerFiles(File file) {
        String string = this.getPropertyList().getProperty("installType");
        boolean bl = this.extractFileGroup(string, file);
        if (bl) {
            bl = this.extractFiles(this.getDistributionBundle(), file);
        }
        return bl;
    }

    private boolean extractServlet() {
        boolean bl = true;
        try {
            FileGroupsListEditor fileGroupsListEditor = new FileGroupsListEditor(new ListEditor());
            fileGroupsListEditor.fromString(this.getPropertyList().getProperty("fileGroupsTypes", ""));
            Iterator iterator = fileGroupsListEditor.getItems().iterator();
            while (bl && iterator != null && iterator.hasNext()) {
                String string;
                File file;
                FileGroup fileGroup = (FileGroup)iterator.next();
                String string2 = fileGroup.getName();
                bl = this.extractFileGroup(string2, file = new File(string = this.getPropertyList().getProperty("applicationDirectory" + string2)));
                if (bl) {
                    bl = this.extractFiles(this.getDistributionBundle(), file);
                }
                TimeSharer.yield();
            }
        }
        catch (Exception var2_3) {
            String string = "Unable to extract files";
            this.logException(string, var2_3);
            bl = false;
        }
        return bl;
    }

    private boolean extractFileGroup(String string, File file) {
        boolean bl = true;
        this.log("extracting files for " + string + " into " + file.getPath());
        try {
            FileGroupsListEditor fileGroupsListEditor = new FileGroupsListEditor(new ListEditor());
            fileGroupsListEditor.fromString(this.getPropertyList().getProperty("fileGroupsTypes", ""));
            FileGroupsListEditor fileGroupsListEditor2 = new FileGroupsListEditor(new ListEditor());
            fileGroupsListEditor2.fromString(this.getPropertyList().getProperty("fileGroupsFolders", ""));
            FileGroup fileGroup = this.getNamedFileGroup(fileGroupsListEditor, string);
            Runtime.getRuntime().gc();
            Iterator iterator = fileGroup.getElements().iterator();
            while (iterator != null && iterator.hasNext() && bl) {
                String string2 = (String)iterator.next();
                String string3 = this.getSafeFolderName(string2);
                bl = this.extractFiles(string3, file);
            }
            if (iterator == null) {
                bl = false;
                this.log("Unable to get " + string + "'s folders.");
            }
        }
        catch (Exception var4_5) {
            String string4 = "Unable to extract " + string;
            this.logException(string4, var4_5);
            bl = false;
        }
        return bl;
    }

    private boolean extractFiles(String string, File file) {
        boolean bl = true;
        File file2 = new File(file, string);
        try {
            TempFiles.add(file2);
            if (!(file == null || file.exists())) {
                file.mkdirs();
            }
            JarFile jarFile = new JarFile(this.getInstallerJarFilename());
            JarFile.setTextDisplay(this);
            jarFile.unarchiveFileToDirectory(string, file);
            jarFile.close();
            this.log(string + " extracted from " + this.getInstallerJarFilename() + " to " + file);
        }
        catch (Exception var5_6) {
            this.log("Attempting to extract  " + string + " as a resource to " + file.getPath());
            try {
                FileSystem.setTextDisplay(this);
                FileSystem.getResourceAsFile(string, file.getPath());
                this.log(string + " extracted.");
            }
            catch (Exception var6_7) {
                String string2 = "Unable to extract " + string;
                CustomInstaller.logException(string2, var5_6);
                bl = false;
            }
        }
        if (bl) {
            bl = this.unpackFiles(file2, file);
        }
        file2.delete();
        return bl;
    }

    private boolean unpackCompressedJars(File file) {
        boolean bl = true;
        String[] arrstring = file.list();
        if (arrstring.length > 0) {
            for (int i = 0; i < arrstring.length && bl && !this.canceled; ++i) {
                String string = arrstring[i];
                File file2 = new File(file, string);
                if (file2.isDirectory()) {
                    bl = this.unpackCompressedJars(file2);
                } else if (string.endsWith(".jex.gz")) {
                    this.log("unpacking " + file2.getPath());
                    UnpackJarFile unpackJarFile = new UnpackJarFile();
                    bl = unpackJarFile.unpack(file2.getPath());
                    this.log("unpacked ok: " + bl);
                }
                TimeSharer.yield();
            }
        }
        return bl;
    }

    private FileGroup getNamedFileGroup(FileGroupsListEditor fileGroupsListEditor, String string) {
        Iterator iterator = fileGroupsListEditor.getItems().iterator();
        FileGroup fileGroup = null;
        while (iterator.hasNext() && fileGroup == null) {
            FileGroup fileGroup2 = (FileGroup)iterator.next();
            if (fileGroup2.getName().equals(string)) {
                fileGroup = fileGroup2;
            }
            TimeSharer.yield();
        }
        return fileGroup;
    }

    private String getSafeFolderName(String string) {
        String string2 = this.getSafeName(string);
        if (string2.length() <= 0) {
            string2 = "folder";
        }
        return string2 + "Jex" + "." + "tar.gz";
    }

    private String getSafeName(String string) {
        String string2 = "";
        CharArrayWriter charArrayWriter = new CharArrayWriter();
        for (int i = 0; i < string.length(); ++i) {
            int n = Character.getType(string.charAt(i));
            if (n != 1 && n != 2 && n != 9) continue;
            charArrayWriter.write(string.charAt(i));
        }
        charArrayWriter.close();
        if (charArrayWriter.size() > 0) {
            string2 = charArrayWriter.toString();
        }
        return string2;
    }

    protected void getFilesSetup() {
        this.log("entering set up to get files");
        if (!gettingFiles) {
            this.log("setting up to get files");
            this.updateProgressBarLabel(this.progressMessage);
            gettingFiles = true;
            this.setPreviousButtonEnabled(this.gotFiles);
            this.setNextButtonEnabled(this.gotFiles);
            if (CustomInstaller.multipleFileGroups() || CustomInstaller.multipleComponents()) {
                this.displayName = this.getDisplayName();
                this.updateProgressBarLabel(Localize.strings().getString("Installing", "") + " " + this.displayName);
            } else {
                this.displayName = this.getPropertyList().getProperty("packageName", "");
            }
            this.log("started installing files for " + this.displayName);
            totalFiles = this.getPropertyList().getIntProperty("totalCompressedFiles");
            this.log("installing total files: " + totalFiles);
            totalBytes = this.getPropertyList().getLongProperty("uncompressedTotalSize") + this.getPropertyList().getLongProperty("compressedFileSize");
            this.log("installing total bytes: " + new Long(totalBytes).toString());
            this.silentInstall = this.getPropertyList().getBooleanProperty("silentInstall", false);
            CustomInstaller.log("silent install " + String.valueOf(this.silentInstall));
        }
        this.log("exiting set up to get files");
    }

    protected boolean getFiles() {
        boolean bl = this.setupDownload();
        if (bl && !this.canceled) {
            bl = this.installFromFile();
            JarFile.setTextDisplay(null);
            FileSystem.setTextDisplay(null);
        }
        if (bl && !this.canceled) {
            this.storeInstallEnvironment();
        }
        this.getPropertyList().setBooleanProperty("installSuccessful", bl);
        gettingFiles = false;
        this.log("got files: " + bl);
        return bl;
    }

    protected boolean unpackFiles(File file, File file2) {
        boolean bl = true;
        try {
            String string = file.getPath();
            this.log(string + ", exists: " + file.exists());
            GZipper gZipper = new GZipper();
            gZipper.setTextExtensions(this.getPropertyList().getProperty("textFileExtensions"));
            gZipper.setTextDisplay(this);
            gZipper.setModifiedDate(this.getPropertyList().getBooleanProperty("setLastModifiedDate", false));
            gZipper.setModeFlag(this.getPropertyList().getBooleanProperty("saveFilePermissions", false));
            gZipper.unarchiveAllFiles(string, file2);
            this.log("Unpacked " + string + " into " + file2.getPath());
            if (this.getPropertyList().getBooleanProperty("packJarFile", false) && !this.canceled) {
                bl = this.unpackCompressedJars(file2);
            }
        }
        catch (Exception var4_5) {
            bl = false;
            String string = Localize.strings().getString("UnableToGetFiles");
            this.logException(string, var4_5);
        }
        return bl;
    }

    protected void log(String string) {
        filesLog.write(string);
    }

    protected void logException(String string, Exception exception) {
        this.gotError(string);
        CustomInstaller.logException(string, exception);
    }

    protected void gotError(String string) {
        this.log(string);
        CustomInstaller.logError(string);
        CustomInstaller.log(string);
        if (this.silentInstall) {
            CustomInstaller.log("aborting silent install");
            this.abort();
        }
    }

    private void storeInstallEnvironment() {
        boolean bl = this.getPropertyList().getBooleanProperty("saveInstallEnvironment", false);
        if (bl) {
            String string = this.getPropertyList().getProperty("applicationDirectory", "");
            String string2 = this.getPropertyList().getProperty("packageVersion", "").trim();
            String string3 = this.getPropertyList().getProperty("packageName", "").trim();
            JExpressPropertyStore jExpressPropertyStore = new JExpressPropertyStore(string3);
            jExpressPropertyStore.setProperty("applicationDirectory", string);
            jExpressPropertyStore.setProperty("packageVersion", string2);
            if (!this.canceled) {
                jExpressPropertyStore.store();
                CustomInstaller.log("saved install environment");
            }
        }
    }

    private void removeNewDirectories() {
        if (newDirectories != null && newDirectories.size() > 0) {
            CustomInstaller.log("deleting installed files");
            for (String string : newDirectories) {
                FileSystem.removeDirectory(string);
                CustomInstaller.log("deleted " + string);
            }
        }
    }

    private class CancelSwinger
    extends Swinger {
        private CancelSwinger() {
        }

        public void swingBefore() {
            InstallFilesPanel.this.progressMessage = Localize.strings().getString("CancelingInstallation");
            InstallFilesPanel.this.progressBarLabel.setText(InstallFilesPanel.this.progressMessage);
        }

        public void workInBackground() {
            while (gettingFiles) {
                Thread.yield();
            }
            InstallFilesPanel.this.removeNewDirectories();
        }
    }

    private class InstallSwinger
    extends Swinger {
        private InstallSwinger() {
        }

        public void swingBefore() {
            InstallFilesPanel.this.getFilesSetup();
        }

        public void workInBackground() {
            InstallFilesPanel.this.getFiles();
        }

        public void swingAfter() {
            if (InstallFilesPanel.this.gotFiles) {
                InstallFilesPanel.this.log("wrote " + new Long(bytesWritten).toString() + " bytes");
                InstallFilesPanel.this.log("got files; showing next panel");
                InstallFilesPanel.this.showNextPanel();
            } else {
                String string = Localize.strings().getString("UnableToGetFiles");
                CustomInstaller.logError(string);
                if (!InstallFilesPanel.this.silentInstall) {
                    InstallerPopups.noteError(string);
                }
                InstallFilesPanel.this.log("got error; showing the last active panel");
                InstallFilesPanel.this.showLastActivePanel();
            }
        }
    }

}
