/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerGUI;
import com.denova.JExpress.Installer.JExpressInstaller;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.copycheq.CopyCheqAPI;
import com.denova.io.ErrorLog;
import com.denova.io.FileSystem;
import com.denova.io.JarFile;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.lang.TimeSharer;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsCommands;
import com.denova.ui.Marquee;
import com.denova.ui.NoteDialog;
import com.denova.ui.UserNotices;
import com.denova.util.PropertyList;
import java.awt.Color;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.List;
import java.util.Locale;
import java.util.Vector;
import javax.swing.Box;
import javax.swing.JPanel;

public final class Installer
implements InstallPropertyNames,
JExpressConstants {
    private static final String InstallerLog = "installer";
    private static Log log = null;
    private static final boolean debugging = false;
    private static Installer installer;
    private InstallerGUI gui = new InstallerGUI();
    private boolean silentInstall = false;
    private String installedBy = null;
    private PropertyList properties = null;
    private boolean createdTempDir = false;
    private String installImageFilename = null;

    protected boolean setUp(PropertyList propertyList) {
        boolean bl = true;
        try {
            this.properties = propertyList;
            log = new Log("installer");
            this.log("set up Installer");
            this.silentInstall = this.properties.getBooleanProperty("silentInstall", false);
            installer = this;
            this.gui.setUp(installer);
            this.log("Configured the installer");
            this.logInitialSettings();
            this.configCopyCheq();
            bl = true;
        }
        catch (Throwable var3_3) {
            if (var3_3 instanceof NoClassDefFoundError) {
                if (this.silentInstall) {
                    System.out.println("Missing class. See errors.log for more details");
                } else {
                    UserNotices userNotices = new UserNotices();
                    userNotices.awtNoteError("Missing class. See errors.log for more details");
                }
                this.logError(var3_3);
            }
            if (!this.silentInstall) {
                UserNotices userNotices = new UserNotices();
                userNotices.awtNoteError("Unable to start installer. See errors.log for more details");
            }
            this.logError(var3_3);
        }
        return bl;
    }

    protected void configFrame() {
        this.gui.configFrame(this.getBooleanProperty("showFrame", true));
        this.log("installer gui thread launched");
    }

    protected static Installer getInstaller() {
        return installer;
    }

    protected PropertyList getPropertyList() {
        return this.properties;
    }

    protected String getProperty(String string) {
        return this.getProperty(string, "");
    }

    protected String getProperty(String string, String string2) {
        String string3 = string2;
        if (this.properties != null) {
            string3 = this.properties.getProperty(string, string2);
        }
        return string3;
    }

    protected boolean getBooleanProperty(String string, boolean bl) {
        boolean bl2 = bl;
        if (this.properties != null) {
            bl2 = this.properties.getBooleanProperty(string, bl);
        }
        return bl2;
    }

    protected int getIntProperty(String string) {
        int n = -1;
        if (this.properties != null) {
            n = this.properties.getIntProperty(string, -1);
        }
        return n;
    }

    protected void setProperty(String string, String string2) {
        if (this.properties != null) {
            this.properties.setProperty(string, string2);
        } else {
            this.log("unable to set " + string + " to " + string2);
        }
    }

    protected void setBooleanProperty(String string, boolean bl) {
        if (this.properties != null) {
            this.properties.setBooleanProperty(string, bl);
        } else {
            this.log("unable to set " + string + " to " + bl);
        }
    }

    protected JPanel getInstallerPanel() {
        return this.gui.getInstallerPanel();
    }

    protected JPanel getMainPanel() {
        return this.gui.getMainPanel();
    }

    protected JPanel getLogoPanel() {
        return this.gui.getLogoPanel();
    }

    protected JPanel getWizardPanel() {
        return this.gui.getWizardPanel();
    }

    protected Box getWizardBox() {
        return this.gui.getWizardBox();
    }

    protected Marquee getMarquee() {
        return this.gui.getMarquee();
    }

    protected void updateMarquee(Marquee marquee) {
        this.gui.updateMarquee(marquee);
    }

    protected void repackWindow() {
        this.gui.repackWindow();
    }

    protected boolean isOpaque() {
        return this.gui.isOpaque();
    }

    protected void setVisible(boolean bl) {
        this.gui.setVisible(bl);
    }

    protected boolean makeInstallerSilent() {
        boolean bl = false;
        String string = this.getProperty("applicationDirectory");
        if (string != null && string.length() > 0) {
            bl = true;
            this.properties.setBooleanProperty("silentInstall", bl);
            this.log("silent installation to " + string);
        }
        boolean bl2 = this.properties.getBooleanProperty("silentInstall", false);
        this.log("made installer silent: " + String.valueOf(bl2));
        return bl;
    }

    protected boolean savePropertyList() {
        boolean bl;
        try {
            FileOutputStream fileOutputStream = new FileOutputStream("jex.control");
            this.properties.save(fileOutputStream, "JExpress Installation Properties");
            fileOutputStream.close();
            bl = true;
        }
        catch (Exception var2_2) {
            this.logException((Object)this, "Unable to save options to jex.control", var2_2);
            bl = false;
        }
        return bl;
    }

    protected boolean passwordRequired() {
        return this.getProperty("installPasswordDigest", "").length() > 0;
    }

    protected boolean fileSpecified(String string) {
        return this.getProperty(string, "").length() > 0;
    }

    protected boolean multipleFileGroups() {
        Boolean bl = new Boolean(this.getProperty("multipleFileGroups"));
        return bl;
    }

    protected boolean singleInstallType() {
        String string = this.getProperty("singleInstallType", "");
        Boolean bl = string != null && string.length() > 0 ? new Boolean(string) : new Boolean("true");
        return bl;
    }

    protected boolean multipleInstallTypes() {
        String string = this.getProperty("multipleInstallTypes", "");
        Boolean bl = string != null && string.length() > 0 ? new Boolean(string) : new Boolean("false");
        return bl;
    }

    protected boolean multipleComponents() {
        String string = this.getProperty("multipleComponents", "");
        Boolean bl = string != null && string.length() > 0 ? new Boolean(string) : new Boolean("false");
        return bl;
    }

    protected boolean isServlet() {
        Boolean bl = new Boolean(this.getProperty("isServlet"));
        return bl;
    }

    protected String installerCreatedBy() {
        if (this.installedBy == null) {
            this.installedBy = "JExpress";
            if (this.trialCopy()) {
                this.installedBy = this.installedBy + " (Unlicensed Copy)";
            }
            this.installedBy = this.installedBy + " from denova.com";
            this.log("installer created with: " + this.installedBy);
        }
        return this.installedBy;
    }

    protected boolean getResourceAsFile(String string) {
        return this.getResourceAsFile(string, null);
    }

    protected boolean getResourceAsFile(String string, String string2) {
        boolean bl = false;
        try {
            bl = FileSystem.getResourceAsFile(string, string2);
            if (bl) {
                this.log("gotResourceAsFile " + string + " in " + string2);
            } else {
                this.log("unable to getResourceAsFile " + string + " in " + string2);
            }
        }
        catch (Exception var4_4) {
            this.logError(var4_4);
        }
        return bl;
    }

    protected boolean getFile(String string) {
        boolean bl = false;
        this.log("Loading " + string);
        try {
            bl = FileSystem.getFile(string);
        }
        catch (Exception var3_3) {
            this.logException((Object)this, "Unable to get file", var3_3);
        }
        return bl;
    }

    protected boolean getFile(String string, InputStream inputStream) {
        boolean bl = false;
        if (inputStream != null) {
            this.log("Loading " + string);
            try {
                bl = FileSystem.getFile(string, inputStream);
            }
            catch (Exception var4_4) {
                this.logException((Object)this, "Unable to get " + string + " from inputStream", var4_4);
            }
            if (!bl) {
                String string2 = "Unable to load " + string;
                this.log(string2);
                this.logError(string2);
                File file = new File(string);
                try {
                    file.delete();
                }
                catch (Exception var6_7) {
                    this.logError(var6_7.getMessage());
                }
            }
        } else {
            throw new NullPointerException();
        }
        return bl;
    }

    protected InputStream getFileStream(String string) throws Exception {
        InputStream inputStream = null;
        this.log("Getting file stream: " + string);
        inputStream = FileSystem.getFileStream(string);
        this.log("getFileStream: success: " + (inputStream != null));
        return inputStream;
    }

    protected InputStream getResourceAsStream(String string) {
        InputStream inputStream = FileSystem.getResourceAsStream(string);
        return inputStream;
    }

    protected String getUserClasspath() {
        String string = this.getProperty("installUserClasspath", "");
        string = string.replace(':', File.pathSeparatorChar);
        string = string.replace(';', File.pathSeparatorChar);
        string = string.replace('\\', File.separatorChar);
        string = string.replace('/', File.separatorChar);
        string = string.replace('|', ':');
        return string;
    }

    protected boolean extractFile(String string) {
        File file = TempFiles.getFile(string);
        boolean bl = file.exists();
        if (!bl) {
            this.log(string + " does not already exist. Trying to get resource");
            bl = this.getResourceAsFile(string, file.getPath());
        }
        return bl;
    }

    protected boolean showInstallButtonOnDirectoryPanel() {
        return this.gui.showInstallButtonOnDirectoryPanel();
    }

    protected String getStartDirectory() {
        return this.properties.getProperty("startDirectory", ".");
    }

    protected String getTempDirectory() {
        return this.properties.getProperty("tempDirectory", "");
    }

    protected String getLanguage() {
        return Localize.strings().getLanguage();
    }

    protected void setInvisible() {
        this.gui.setInvisible();
    }

    protected void exit() {
        this.log("Exiting");
        this.setInvisible();
        ExitThread exitThread = new ExitThread();
        exitThread.start();
    }

    protected void fatalError(String string) {
        if (this.getBooleanProperty("silentInstall", false)) {
            this.log("fatal error: " + string);
        } else {
            Vector<String> vector = new Vector<String>();
            vector.add(string);
            NoteDialog noteDialog = new NoteDialog();
            noteDialog.setNote(vector);
            noteDialog.setIconName("error-denova.png");
            noteDialog.setOkLabel("OK");
            noteDialog.setColors(this.getTextColor(), this.getBackgroundColor());
            noteDialog.createPanel();
            noteDialog.setVisible(true);
        }
        this.exit();
    }

    protected String getImageFilename() {
        if (this.installImageFilename == null) {
            this.installImageFilename = this.getImageFilename("installImageFilename");
        }
        return this.installImageFilename;
    }

    protected String getImageFilename(String string) {
        String string2 = null;
        String string3 = this.getProperty(string);
        if (string3 != null && string3.length() > 0) {
            string2 = string3;
            string2 = string2.trim();
            string2 = string2.replace('\\', File.separatorChar);
            string2 = string2.replace('/', File.separatorChar);
            File file = new File(string2);
            string2 = file.getName();
            this.log(string + ": " + string2);
        }
        return string2;
    }

    protected Color getTextColor() {
        Color color = null;
        if (this.getPropertyList().getProperty("textColor") != null) {
            color = new Color(this.getPropertyList().getIntProperty("textColor", DefaultTextColor.getRGB()));
        }
        return color;
    }

    protected Color getBackgroundColor() {
        Color color = null;
        if (this.getPropertyList().getProperty("backgroundColor") != null) {
            color = new Color(this.getPropertyList().getIntProperty("backgroundColor", DefaultBackgroundColor.getRGB()));
        }
        return color;
    }

    protected Color getProgressBarColor() {
        Color color = null;
        if (this.getPropertyList().getProperty("progressBarColor") != null) {
            color = new Color(this.getPropertyList().getIntProperty("progressBarColor", DefaultProgressBarColor.getRGB()));
        }
        return color;
    }

    protected void log(String string) {
        if (log != null) {
            log.write(string);
            log.flush();
        }
        this.debug(string);
    }

    protected void logError(Exception exception) {
        if (exception != null) {
            if (log != null) {
                log.write(exception);
                log.flush();
            }
            if (ErrorLog.getLog() != null) {
                ErrorLog.getLog().write(exception);
                ErrorLog.getLog().flush();
            }
            this.debug(exception);
        }
    }

    protected void logError(Throwable throwable) {
        if (throwable != null) {
            if (log != null) {
                log.write(throwable);
                log.flush();
            }
            if (ErrorLog.getLog() != null) {
                ErrorLog.getLog().write(throwable);
                ErrorLog.getLog().flush();
            }
            this.debug(throwable);
        }
    }

    protected void logError(String string) {
        if (ErrorLog.getLog() != null) {
            ErrorLog.getLog().write("Error: " + string);
        }
        this.debug(string);
    }

    protected void logException(Object object, String string, Exception exception) {
        if (ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(exception);
            ErrorLog.getLog().flush();
        }
        if (string != null) {
            this.logError(string);
        }
    }

    protected void logException(Object object, String string, Throwable throwable) {
        if (ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(throwable);
            ErrorLog.getLog().flush();
        }
        if (string != null) {
            this.logError(string);
        }
    }

    protected void debug(String string) {
    }

    protected boolean copyCheqActionOk(String string) {
        boolean bl = false;
        try {
            CopyCheqAPI copyCheqAPI = new CopyCheqAPI();
            copyCheqAPI.setAccountName(this.getPropertyList().getProperty("icenseAccount", ""));
            copyCheqAPI.setProductName(this.getPropertyList().getProperty("licenseProduct", ""));
            copyCheqAPI.setLicenseName(this.getPropertyList().getProperty("licenseName", ""));
            copyCheqAPI.setLicenseRight(this.getPropertyList().getProperty("licenseRight", ""));
            copyCheqAPI.setPrimaryContact(this.getPropertyList().getProperty("licensePrimaryContact", ""));
            copyCheqAPI.setIdCode(this.getPropertyList().getProperty("licenseIdCode", ""));
            copyCheqAPI.setProxyHost(this.getPropertyList().getProperty("proxyHost", ""));
            copyCheqAPI.setProxyPort(this.getPropertyList().getIntProperty("proxyPort"));
            copyCheqAPI.setProxyUsername(this.getPropertyList().getProperty("proxyUserName", ""));
            copyCheqAPI.setProxyPassword(this.getPropertyList().getProperty("proxyPassword", ""));
            String string2 = this.getPropertyList().getProperty("packageVersion");
            if (string2 != null && string2.trim().length() > 0) {
                copyCheqAPI.setProductVersion(string2.trim());
            }
            if (string.equalsIgnoreCase("start")) {
                copyCheqAPI.setExtraData("jvm", JRE.getJavaVersion());
                copyCheqAPI.setExtraData("language", Locale.getDefault().getLanguage());
                this.log("checking if ok to run");
                bl = copyCheqAPI.startRunning();
                this.log("ok to start: " + bl);
                this.setBooleanProperty("installationStarted", bl);
            } else if (string.equalsIgnoreCase("stop")) {
                this.log("stopping installer");
                bl = copyCheqAPI.stopRunning();
                this.log("installer stopped: " + bl);
            } else {
                this.log("unknown action: " + string);
                bl = false;
            }
            if (!bl) {
                this.setLastCopyCheqError(copyCheqAPI.getLastErrorMessage());
            }
        }
        catch (Exception var3_4) {
            bl = false;
            this.logError(var3_4);
        }
        return bl;
    }

    protected boolean isTrialCopyCheqAccount() {
        boolean bl = false;
        try {
            if (this.trialCopy()) {
                String string = "QzxQzxLicenseAccount                                                                                                  ".trim();
                String string2 = "QzxQzxLicenseProduct                                                                                                                                                                                                       ".trim();
                String string3 = "QzxQzxLicenseName                                                                                                                                                                                                             ".trim();
                bl = string.equals("CopyCheq Guest") && string2.equals("CopyCheq Guest Product") && string3.equals("Trial");
            }
        }
        catch (Exception var2_3) {
            bl = false;
            this.log(var2_3.getMessage());
        }
        return bl;
    }

    protected String getLicenseEmail() {
        String string = null;
        try {
            String string2;
            if (this.isTrialCopyCheqAccount() && !(string2 = "QzxQzxLicenseEmail                                                                                                  ".trim()).startsWith("Qzx")) {
                string = string2;
            }
        }
        catch (Exception var2_3) {
            this.log(var2_3.getMessage());
        }
        return string;
    }

    protected String getLicenseID() {
        String string = null;
        try {
            String string2;
            if (this.isTrialCopyCheqAccount() && !(string2 = "QzxQzxLicenseID                                                                                                                                                                                                       ".trim()).startsWith("Qz")) {
                string = string2;
            }
        }
        catch (Exception var2_3) {
            this.log(var2_3.getMessage());
        }
        return string;
    }

    private void configCopyCheq() {
        String string = "QzxQzxLicenseAccount                                                                                                  ".trim();
        String string2 = "QzxQzxLicenseProduct                                                                                                                                                                                                       ".trim();
        String string3 = "QzxQzxLicenseName                                                                                                                                                                                                             ".trim();
        String string4 = "QzxQzxLicenseRight                                                                                                  ".trim();
        String string5 = "QzxQzxLicenseAppRight                                                                                                  ".trim();
        this.setProperty("icenseAccount", string);
        this.setProperty("licenseProduct", string2);
        this.setProperty("licenseName", string3);
        this.setProperty("licenseRight", string4);
        this.setProperty("licenseAppRight", string5);
    }

    private String getCurrentVersion() {
        String string = null;
        try {
            string = this.properties.getProperty("packageVersion");
        }
        catch (Exception var2_2) {
            // empty catch block
        }
        return string;
    }

    private void logInitialSettings() {
        this.log("silentInstall: " + this.silentInstall);
        this.log("os name: " + System.getProperty("os.name", ""));
        this.log("os version: " + System.getProperty("os.version", ""));
        this.log("os arch: " + System.getProperty("os.arch", ""));
        this.log("java version: " + System.getProperty("java.version", ""));
        if (this.properties != null) {
            this.log("created: " + this.properties.getProperty("packageCreated", ""));
        }
        if (OS.isWindows()) {
            this.log("architecture: " + WindowsCommands.getProcessorArchitecture());
            this.log("wow: " + WindowsCommands.isWow64Process());
        }
    }

    private void setLastCopyCheqError(String string) {
        if (string == null || string.length() <= 0) {
            string = "";
            this.log("unknown error");
        } else {
            this.log(string);
        }
        this.setProperty("licenseError", string);
    }

    private void createLogsInTempDir(String string, String string2) {
        if (!(string == null || string.length() <= 0 || string2.equals(string))) {
            File file = new File(string2);
            File file2 = new File(string);
            String[] arrstring = file.list();
            if (arrstring != null && arrstring.length > 0) {
                this.createLogsInTempDir(file2, file, arrstring);
            }
        }
    }

    private void createLogsInTempDir(File file, File file2, String[] arrstring) {
        for (int i = 0; i < arrstring.length; ++i) {
            String string = arrstring[i];
            File file3 = new File(file2, string);
            if (file3.isDirectory() || string.equals("jinstall.log") || !string.endsWith(".log")) continue;
            File file4 = new File(file, string);
            try {
                FileSystem.createEmptyFile(file4);
            }
            catch (Exception var8_8) {
                this.logException((Object)this, "Unable to copy log files", var8_8);
            }
            TimeSharer.yield();
        }
    }

    private void deleteTemporaryFiles() {
        File file;
        if (this.createdTempDir) {
            JarFile.addUnarchiveToTempFiles(this.getTempDirectory());
        }
        TempFiles.delete();
        if (this.createdTempDir && (file = new File(this.getTempDirectory())) != null) {
            file.delete();
        }
    }

    private boolean trialCopy() {
        String string = this.getProperty("customBeforeInstallWizardPanelClass", "");
        boolean bl = string.startsWith("com.denova.JExpress.Installer.JExpressCustomClass");
        this.setBooleanProperty("TrialCopy", bl);
        return bl;
    }

    private boolean theSameFile(File file, File file2) {
        boolean bl = false;
        try {
            bl = file.exists() && file2.exists() && file.getCanonicalPath().equals(file2.getCanonicalPath());
        }
        catch (Exception var4_4) {
            this.logError(var4_4);
        }
        return bl;
    }

    private void debug(Exception exception) {
    }

    private void debug(Throwable throwable) {
    }

    private void debugShowStream(InputStream inputStream) {
    }

    private class ExitThread
    extends Thread {
        private ExitThread() {
        }

        public void run() {
            if (Installer.this.getBooleanProperty("checkLicenseDuringInstall", false) && Installer.this.getBooleanProperty("installationStarted", false)) {
                Installer.this.copyCheqActionOk("stop");
            }
            ErrorLog.getLog().stopLogging();
            Installer.this.log("done");
            log.stopLogging();
            Installer.this.deleteTemporaryFiles();
            JExpressInstaller.copyLogsToStartDir(Installer.this.getTempDirectory(), Installer.this.getStartDirectory());
            if (Installer.this.gui != null) {
                Installer.this.gui.freeResources();
            }
            System.exit(0);
        }
    }

}
