/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallWizard;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.GradientBackgroundPainter;
import com.denova.ui.GridBagControl;
import com.denova.ui.ImagePanel;
import com.denova.ui.LookAndFeel;
import com.denova.ui.Marquee;
import com.denova.ui.ProgressBarPainter;
import com.denova.ui.RepackWindow;
import com.denova.ui.TransparentBackground;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.UserNotices;
import com.denova.util.Sort;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.LayoutManager;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.PrintStream;
import java.util.Locale;
import java.util.Vector;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import org.jdesktop.swingx.plaf.nimbus.RoundedBorder;

final class InstallerGUI
implements InstallPropertyNames,
JExpressConstants {
    private static final boolean debugging = false;
    private Installer installer = null;
    private JFrame jframe = new JFrame();
    private boolean silentInstall = false;
    private boolean decorateFrame = true;
    private InstallWizard installWizard = null;
    private boolean showInstallNowButton = true;
    private boolean createdTempDir = false;
    private String installImageFilename = null;
    private JPanel installerPanel = null;
    private JPanel mainPanel = null;
    private JPanel logoPanel = null;
    private JPanel wizardPanel = null;
    private Box wizardBox = null;
    private Marquee logoMarquee = null;
    private boolean isOpaqueBackground = true;
    private boolean isImageInBackground = false;

    protected void setUp(Installer installer) {
        this.installer = installer;
    }

    public void configFrame(boolean bl) {
        this.decorateFrame = bl;
        this.jframe.setName("Installer JFrame");
        if (!this.decorateFrame) {
            this.jframe.setUndecorated(true);
            this.installer.log("jframe is not decorated");
        }
        this.init();
    }

    protected void freeResources() {
        this.jframe.dispose();
    }

    protected boolean isOpaque() {
        return this.isOpaqueBackground;
    }

    protected JPanel getInstallerPanel() {
        return this.installerPanel;
    }

    protected JPanel getMainPanel() {
        return this.mainPanel;
    }

    protected JPanel getLogoPanel() {
        return this.logoPanel;
    }

    protected Marquee getMarquee() {
        return this.logoMarquee;
    }

    protected JPanel getWizardPanel() {
        return this.wizardPanel;
    }

    protected Box getWizardBox() {
        return this.wizardBox;
    }

    protected void updateMarquee(Marquee marquee) {
        this.installer.log("updating marquee");
        this.logoMarquee = marquee;
        if (this.logoPanel != null) {
            this.logoPanel.remove(0);
            this.logoPanel.add((Component)this.logoMarquee.updatePanel(), "Center");
            UiLayoutUtilities.redraw(this.logoPanel);
        }
    }

    protected void repackWindow() {
        RepackWindow repackWindow = new RepackWindow(this.jframe);
        repackWindow.repack();
        this.installer.log("repacking installer's window");
    }

    protected void setInvisible() {
        this.makeInvisible();
    }

    protected void setVisible(boolean bl) {
        if (bl) {
            this.makeVisible();
        } else {
            this.makeInvisible();
        }
    }

    protected boolean showInstallButtonOnDirectoryPanel() {
        if (this.installWizard != null) {
            this.showInstallNowButton = this.installWizard.showInstallButtonOnDirectoryPanel();
        }
        return this.showInstallNowButton;
    }

    private void init() {
        this.makeInvisible();
        boolean bl = this.setup();
        if (bl) {
            try {
                this.layoutFrame();
                this.setupListeners();
                this.startWizard();
                this.makeVisible();
            }
            catch (Exception var2_2) {
                bl = false;
                this.installer.logError(var2_2);
            }
        }
        if (!bl) {
            this.installer.exit();
        }
    }

    private boolean setup() {
        boolean bl = false;
        this.silentInstall = this.installer.getBooleanProperty("silentInstall", false);
        try {
            this.setLookAndFeel();
            this.setMinimizedIcon();
            this.installer.log("Configured the installer");
            bl = true;
        }
        catch (Throwable var2_2) {
            bl = false;
            if (var2_2 instanceof NoClassDefFoundError) {
                if (this.silentInstall) {
                    System.out.println("Missing class. See errors.log for more details");
                } else {
                    UserNotices userNotices = new UserNotices();
                    userNotices.awtNoteError("Missing class. See errors.log for more details");
                }
                this.installer.logError(var2_2);
            }
            if (!this.silentInstall) {
                UserNotices userNotices = new UserNotices();
                userNotices.awtNoteError("Unable to start installer. See errors.log for more details");
            }
            this.installer.logError(var2_2);
        }
        this.installer.log("set up ok: " + bl);
        return bl;
    }

    private void startWizard() {
        this.installer.log("starting wizard");
        this.installWizard.startWizard();
    }

    private void layoutFrame() {
        Object object;
        this.installer.log("creating frame");
        this.createInstallerPanel();
        if (this.isImageInBackground) {
            object = new TransparentBackground(this.jframe);
            object.setLayout(new BorderLayout());
            object.add("Center", this.getInstallerPanel());
            this.jframe.getContentPane().add("Center", (Component)object);
        } else {
            object = new JPanel();
            object.setLayout(new BorderLayout());
            object.add("Center", this.getInstallerPanel());
            this.jframe.getContentPane().add("Center", (Component)object);
        }
        this.setColors();
        object = this.installer.getLanguage();
        if (object.equals(Locale.JAPANESE.getLanguage()) || object.equals(Locale.KOREAN.getLanguage()) || object.equals(Locale.CHINESE.getLanguage()) || object.equals(Locale.SIMPLIFIED_CHINESE.getLanguage()) || object.equals(Locale.TRADITIONAL_CHINESE.getLanguage())) {
            this.installer.log("no title; non-latin language: " + (String)object);
        } else {
            this.jframe.setTitle(this.getTitle());
        }
        if (this.isImageInBackground || !this.decorateFrame) {
            UiLayoutUtilities.setOpaque(this.wizardBox, false);
            this.jframe.getRootPane().setOpaque(false);
            this.installer.log("set wizard box and its children transparent");
        } else if (!this.isOpaqueBackground) {
            UiLayoutUtilities.setOpaque(this.jframe, false);
            this.jframe.getRootPane().setOpaque(false);
            this.installer.log("set installer panel transparent");
        }
        this.jframe.pack();
        UiLayoutUtilities.adjustBounds(this.jframe);
        this.jframe.setResizable(false);
        SwingUtilities.updateComponentTreeUI(this.jframe);
        UiLayoutUtilities.centerOnScreen(this.jframe);
        this.installWizard.restoreWizardDefaults();
    }

    private void setupListeners() {
        InstallerWindow installerWindow = new InstallerWindow();
        this.jframe.addWindowListener(installerWindow);
    }

    private void makeVisible() {
        if (!this.silentInstall) {
            this.jframe.setVisible(true);
            this.installer.log("Make installer visible");
        }
    }

    private void makeInvisible() {
        this.jframe.setVisible(false);
    }

    private void createInstallerPanel() {
        this.installer.log("Creating panels");
        this.wizardBox = this.createWizardBox();
        String string = this.installer.getProperty("installImagePosition", "West");
        this.isImageInBackground = string.equals("Background") && this.installer.getImageFilename() != null;
        this.isOpaqueBackground = this.decorateFrame || !this.isImageInBackground && this.installer.getImageFilename() != null;
        this.installer.log("Image is in background: " + this.isImageInBackground);
        this.installer.log("Background is opaque: " + this.isOpaqueBackground);
        JPanel jPanel = this.createPanel(string);
        if (this.isImageInBackground || !this.isOpaqueBackground) {
            if (this.decorateFrame) {
                this.installerPanel = jPanel;
            } else {
                this.mainPanel = jPanel;
                this.mainPanel.setName("MainPanel");
                this.installerPanel = this.createInstallerPanelBase();
                if (!LookAndFeel.getActiveLookAndFeel().equals("Synth")) {
                    this.installerPanel.setBorder(new RoundedBorder());
                }
                this.installerPanel.add(this.mainPanel);
                this.installer.log("rounding corners for undecorated frame");
            }
            if (this.installerPanel.getBackground() != null) {
                this.installer.log("installer panel background color: " + this.installerPanel.getBackground().toString());
            }
        } else {
            this.mainPanel = jPanel;
            this.mainPanel.setName("MainPanel");
            this.installerPanel = this.createInstallerPanelBase();
            this.installerPanel.setBorder(UiLayoutUtilities.getMarginBorder());
            this.installerPanel.add(this.mainPanel);
        }
        this.installerPanel.setName("InstallerPanel");
    }

    private JPanel createPanel(String string) {
        JPanel jPanel = new JPanel();
        GridBagControl gridBagControl = new GridBagControl(jPanel);
        GridBagConstraints gridBagConstraints = this.getWizConstraints(gridBagControl);
        if (string.equals("Background")) {
            this.installer.log("background image");
            if (this.installer.getImageFilename() == null) {
                gridBagControl.add(gridBagConstraints, this.wizardBox);
            } else {
                ButtonsIcons buttonsIcons = new ButtonsIcons();
                ImageIcon imageIcon = buttonsIcons.getIcon(this.installer.getImageFilename());
                jPanel = ImagePanel.wrapInBackgroundImage(this.wizardBox, imageIcon, 0, 0);
                this.installer.log("Image width is " + imageIcon.getIconWidth());
                this.installer.log("Image height is " + imageIcon.getIconHeight());
            }
        } else {
            JPanel jPanel2 = this.createLogoPanel();
            if (string.equals("West")) {
                if (jPanel2 != null) {
                    gridBagControl.add(jPanel2);
                    gridBagControl.addBlankCell();
                }
                gridBagControl.add(gridBagConstraints, this.wizardBox);
            } else if (string.equals("North")) {
                if (jPanel2 != null) {
                    gridBagControl.add(jPanel2);
                    gridBagControl.addBlankRow();
                }
                gridBagControl.add(gridBagConstraints, this.wizardBox);
            } else if (string.equals("East")) {
                gridBagControl.add(gridBagConstraints, this.wizardBox);
                if (jPanel2 != null) {
                    gridBagControl.addBlankCell();
                    gridBagControl.add(jPanel2);
                }
            } else if (string.equals("South")) {
                gridBagControl.add(gridBagConstraints, this.wizardBox);
                if (jPanel2 != null) {
                    gridBagControl.addBlankRow();
                    gridBagControl.add(jPanel2);
                }
            } else {
                this.installer.log("image position: " + string);
            }
        }
        return jPanel;
    }

    private JPanel createInstallerPanelBase() {
        JPanel jPanel = new JPanel();
        jPanel.setOpaque(false);
        jPanel.setLayout(new BorderLayout());
        return jPanel;
    }

    private Box createWizardBox() {
        Box box = Box.createVerticalBox();
        box.setName("WizardBox");
        this.wizardPanel = new JPanel();
        this.wizardPanel.setName("WizardPanel");
        this.wizardPanel.setLayout(new BorderLayout());
        this.installer.log("Instantiating wizard panels");
        this.installWizard = new InstallWizard(this.installer);
        this.installWizard.setName("InstallWizard");
        if (this.silentInstall) {
            this.installWizard.setSilent(this.silentInstall);
        }
        this.installWizard.buildWizard();
        this.installer.log("Done instantiating and building wizard panels");
        this.wizardPanel.add((Component)this.installWizard, "Center");
        box.add(this.wizardPanel);
        return box;
    }

    private JPanel createLogoPanel() {
        JPanel jPanel = null;
        String string = this.installer.getImageFilename();
        if (string == null) {
            this.installer.log("logo panel and marquee unavailable because no image");
        } else {
            this.installer.log("imageIconFilename: " + string);
            this.logoPanel = new JPanel();
            this.logoPanel.setName("LogoPanel");
            this.logoPanel.setLayout(new BorderLayout());
            this.installer.log("Creating marquee");
            this.logoMarquee = new Marquee();
            this.logoMarquee.setName("Marquee");
            this.installer.log("Finished creating marquee");
            this.logoMarquee.setBackgroundFilename(string);
            this.logoPanel.add((Component)this.logoMarquee.getPanel(), "Center");
            this.installer.log("Added marquee to logo panel");
            Dimension dimension = new Dimension();
            ButtonsIcons buttonsIcons = new ButtonsIcons();
            ImageIcon imageIcon = buttonsIcons.getIcon(string);
            if (imageIcon != null) {
                this.logoPanel.add(Box.createHorizontalStrut(imageIcon.getIconWidth()), "North");
                this.logoPanel.add(Box.createVerticalStrut(imageIcon.getIconHeight()), "West");
                dimension.height = imageIcon.getIconHeight();
                dimension.width = imageIcon.getIconWidth();
                this.installer.log("Image width is " + imageIcon.getIconWidth());
                this.installer.log("Image height is " + imageIcon.getIconHeight());
            }
            this.logoPanel.setPreferredSize(dimension);
            this.logoPanel.setMinimumSize(dimension);
            this.logoPanel.setMaximumSize(dimension);
            this.installer.log("Added struts to logo panel");
            JPanel jPanel2 = UiLayoutUtilities.addDoubleBevel(this.logoPanel, 1);
            jPanel2.setName("BevelPanel");
            jPanel = new JPanel();
            jPanel.setName("ImagePanel");
            jPanel.setLayout(new BorderLayout());
            jPanel.add((Component)jPanel2, "Center");
            this.installer.log("Added double bevel to logo panel");
        }
        return jPanel;
    }

    private GridBagConstraints getWizConstraints(GridBagControl gridBagControl) {
        GridBagConstraints gridBagConstraints = gridBagControl.getConstraints();
        gridBagConstraints.fill = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        return gridBagConstraints;
    }

    private void setColors() {
        Color color = this.installer.getTextColor();
        Color color2 = this.installer.getBackgroundColor();
        if (this.decorateFrame) {
            UiLayoutUtilities.setColors(this.jframe, color, color2);
        } else {
            UiLayoutUtilities.setColors(this.mainPanel, color, color2);
        }
    }

    private void setMinimizedIcon() {
        try {
            String string = this.installer.getImageFilename("minimizedImageFilename");
            if (string == null) {
                this.installer.log("no image defined so no minimized icon set");
            } else {
                LookAndFeel.setMinimizedIcon(this.jframe, string);
                this.installer.log("set minimized image: " + string);
            }
        }
        catch (Exception var1_2) {
            this.installer.logError(var1_2);
        }
    }

    private void setLookAndFeel() {
        String string = this.installer.getProperty("lookAndFeelInterface");
        String string2 = this.installer.getProperty("lafTheme");
        try {
            this.installer.log("look and feel: " + string);
            if (string.equals("Synth")) {
                LookAndFeel.set(string, InstallerGUI.class);
            } else if (string.equals("Nimbus")) {
                if (string2 == null || string2.equals("Default")) {
                    LookAndFeel.set(string, "Native");
                } else {
                    LookAndFeel.set(string, InstallerGUI.class);
                }
            } else if (!(string2 != null && LookAndFeel.lafSupportsThemes(string))) {
                LookAndFeel.set(string, "Native");
            } else {
                LookAndFeel.set(string, string2, "Native");
            }
        }
        catch (Exception var3_3) {
            this.installer.logError(var3_3);
            LookAndFeel.set();
        }
    }

    private void logOpaqueComponents(Container container) {
        Component[] arrcomponent = container.getComponents();
        for (int i = 0; i < arrcomponent.length; ++i) {
            try {
                Container container2 = (Container)arrcomponent[i];
                if (container2.getComponentCount() <= 0) continue;
                this.logOpaqueComponents((JComponent)container2);
                continue;
            }
            catch (Exception var4_6) {
                // empty catch block
            }
        }
        String string = container.getName();
        if (string == null || string.length() <= 0) {
            string = container.getClass().getName();
        }
        if (string == null) {
            string = "Unnamed component";
        }
        this.installer.log(string + " opaque: " + container.isOpaque());
    }

    private String getTitle() {
        String string = "Installer";
        String string2 = this.installer.getProperty("packageName", "");
        if (string2 != null && string2.length() > 0) {
            string = Localize.strings().getString("InstallerTitle", string2);
        } else {
            Sort.list(new Vector());
        }
        return string;
    }

    private void addPainters() {
        new GradientBackgroundPainter();
        new ProgressBarPainter();
    }

    private class InstallerWindow
    extends WindowAdapter {
        private InstallerWindow() {
        }

        public void windowClosing(WindowEvent windowEvent) {
            Object object = windowEvent.getSource();
            if (object == InstallerGUI.this || InstallerGUI.this.jframe != null && object == InstallerGUI.this.jframe) {
                InstallerGUI.this.installer.log("window closing");
                if (InstallerGUI.this.installWizard.isLastPanel()) {
                    InstallerGUI.this.installer.log("exiting installer");
                    InstallerGUI.this.installer.exit();
                } else {
                    InstallerGUI.this.installer.log("aborting installer");
                    InstallerGUI.this.installWizard.cancel(false);
                }
            }
        }
    }

}
