/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.InstallerPopups;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.ErrorLog;
import com.denova.io.FileSystem;
import com.denova.io.LineEndingInputFilter;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.lang.TimeSharer;
import com.denova.ui.Swinger;
import com.denova.ui.UserNotices;
import com.denova.util.DataFinder;
import com.denova.util.PropertyList;
import com.denova.util.StringConversions;
import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.Reader;
import java.util.Enumeration;
import java.util.Properties;
import java.util.Vector;

public class JExpressInstaller
implements InstallPropertyNames,
JExpressConstants {
    private static final boolean debugging = false;
    private static final String Quote = "\"";
    private static final String Dot = ".";
    private static final String WizardStartedFilename = "__jexwizard.sem";
    private static PropertyList properties = null;
    private static boolean silentInstall = false;
    private static String installDirectory = null;
    private static String propertiesPathname = null;
    private static String extraParameters = "";
    private static String downloadedUrl = "";
    private static String testProperties = "";
    private static Log installerLog = null;
    private String controlFilename = "jex.control";
    private boolean startedByNativeInstaller = false;
    private boolean createdTempDir = false;
    private String tempDirectory = null;
    private String startDirectory = null;

    public static void main(String[] arrstring) {
        try {
            Object object;
            System.getProperties().setProperty("swing.aatext", "true");
            System.setProperty("java.net.useSystemProxies", "true");
            if (arrstring == null) {
                JExpressInstaller.log("no args passed on command line");
            } else {
                object = StringConversions.fromStrings(arrstring);
                JExpressInstaller.log("parsing args: " + (String)object);
                JExpressInstaller.parseArgs(arrstring);
            }
            object = new JExpressInstaller();
            object.startInstaller();
        }
        catch (RuntimeException var1_2) {
            if (silentInstall) {
                System.out.println("Unable to start installer.\n\n(" + var1_2.getMessage() + ")");
            } else {
                UserNotices userNotices = new UserNotices();
                userNotices.awtNoteError("Unable to start installer.\n\n(" + var1_2.getMessage() + ")");
            }
            System.exit(-1);
        }
    }

    public void startInstaller() {
        InstallSwinger installSwinger = new InstallSwinger();
        installSwinger.execute();
    }

    protected static void copyLogsToStartDir(String string, String string2) {
        if (!(string == null || string.length() <= 0 || string2 == null || string2.equals(string))) {
            if (FileSystem.isDirWriteProtected(string2)) {
                string2 = JExpressInstaller.getAltLogDir();
            }
            File file = new File(string2);
            File file2 = new File(string);
            String[] arrstring = file2.list();
            if (arrstring != null && arrstring.length > 0) {
                JExpressInstaller.copyLogsToStartDir(file2, file, arrstring);
            }
        }
    }

    private boolean config() {
        Object object;
        boolean bl = false;
        String string = "";
        try {
            object = new File("__jexshow.sem");
            object.delete();
            this.startDirectory = this.getStartDirectory();
            this.tempDirectory = this.createTempDirectory(this.startDirectory);
            Log.setAlwaysFlush(false);
            Log.setUseTempDirectory(true);
            this.createLogsInTempDir(this.tempDirectory, this.startDirectory);
            ErrorLog.getLog().setLogging(true);
            this.logInitialSettings();
            if (this.tempDirectory != null && this.tempDirectory.length() > 0) {
                DataFinder.addDirectory(this.tempDirectory);
                JExpressInstaller.log("added temp dir: " + this.tempDirectory + " to DataFinder");
            } else {
                DataFinder.addDirectory(this.startDirectory);
                JExpressInstaller.log("added start dir: " + this.startDirectory + " to DataFinder");
            }
            JExpressInstaller.log("classpath " + System.getProperty("java.class.path", ""));
            bl = this.setupProperties();
        }
        catch (Throwable var3_4) {
            bl = false;
            string = var3_4 instanceof NoClassDefFoundError ? "Missing class. See errors.log for more details" : "Unable to instantiate";
            this.logException((Object)this, string, var3_4);
        }
        if (!bl) {
            if (properties.getBooleanProperty("silentInstall", false)) {
                System.out.println(string);
            } else {
                object = new UserNotices();
                object.awtNoteError(string);
            }
        }
        return bl;
    }

    private boolean setupProperties() {
        boolean bl;
        block10 : {
            bl = true;
            try {
                if (this.configureProperties()) {
                    if (this.startedByNativeInstaller) {
                        try {
                            FileOutputStream fileOutputStream = new FileOutputStream("__jexwizard.sem");
                            properties.save(fileOutputStream, "JExpress Wizard started");
                            fileOutputStream.close();
                        }
                        catch (Exception var2_3) {
                            this.logException((Object)this, "Unable to notify native installer that wizard started", var2_3);
                        }
                    }
                } else {
                    bl = false;
                    this.logError("Unable to load properties for installer");
                    JExpressInstaller.copyLogsToStartDir(this.tempDirectory, this.startDirectory);
                    this.fatalError("Unable to load properties for installer. Try restarting installer.");
                }
            }
            catch (Throwable var2_4) {
                if (var2_4 instanceof NoClassDefFoundError) {
                    this.logException((Object)this, "Missing class", var2_4);
                } else {
                    this.logException((Object)this, "Unable to instantiate", var2_4);
                }
                if (silentInstall) break block10;
                UserNotices userNotices = new UserNotices();
                userNotices.awtNoteError("Something unexpected happened, but it probably is not serious so the installer will continue. After the installation finishes, look at the errors.log for more details.");
            }
        }
        return bl;
    }

    private boolean configureProperties() {
        String string;
        boolean bl = false;
        JExpressInstaller.log("about to load properties");
        properties = new PropertyList();
        if (this.loadPropertyList() && (string = properties.getProperty("packageName", "")) != null && string.length() > 0) {
            bl = true;
        }
        if (bl) {
            JExpressInstaller.log("properties loaded");
            properties.setProperty("startDirectory", this.startDirectory);
            properties.setProperty("tempDirectory", this.tempDirectory);
            properties.setBooleanProperty("installSuccessful", bl);
            boolean bl2 = properties.getBooleanProperty("autoDetectLanguage", true);
            Localize.strings().setAutoDetect(bl2);
            String string2 = properties.getProperty("defaultLanguage", "english");
            Localize.strings().setDefaultLanguage(string2);
            this.getNativeJvmSettings();
            this.setInitialUserName();
            this.configureInstaller();
        }
        JExpressInstaller.log("exiting configureProperties");
        return bl;
    }

    private void configureInstaller() {
        this.setNoticesColors();
        this.setTextFileExtensions();
        boolean bl = properties.getBooleanProperty("silentInstall", false);
        JExpressInstaller.log("installer preconfigured silent: " + bl);
        if ((silentInstall || bl) && (installDirectory != null || propertiesPathname != null)) {
            properties.setBooleanProperty("silentInstall", true);
            properties.setBooleanProperty("userRequestedSilentInstall", true);
            JExpressInstaller.log("installer set to silent via command line: " + silentInstall);
            this.configureSilentInstall();
        }
        if (extraParameters != null && extraParameters.length() > 0) {
            properties.setProperty("extraParameters", extraParameters);
        }
        if (downloadedUrl != null && downloadedUrl.length() > 0) {
            properties.setProperty("downloadUrl", downloadedUrl);
            JExpressInstaller.log("installer's download url set via command line: " + downloadedUrl);
        }
    }

    private void setNoticesColors() {
        Color color;
        Color color2 = JExpressInstaller.getTextColor();
        if (color2 != null) {
            UserNotices.setTextColor(color2);
        }
        if ((color = JExpressInstaller.getBackgroundColor()) != null) {
            UserNotices.setBackgroundColor(color);
        }
    }

    private void configureSilentInstall() {
        String string;
        Object object;
        boolean bl = true;
        Properties properties = null;
        if (propertiesPathname != null && propertiesPathname.length() > 0) {
            object = new File(propertiesPathname);
            if (!object.exists()) {
                JExpressInstaller.log("properties file does not exist: " + propertiesPathname);
                string = JExpressInstaller.properties.getProperty("startDirectory", "");
                object = new File(string, propertiesPathname);
            }
            if (!object.isDirectory() && object.exists()) {
                JExpressInstaller.properties.setProperty("silentConfigFilename", object.getPath());
                properties = this.getSilentProperties((File)object);
                if (properties == null) {
                    JExpressInstaller.log("config file empty: " + propertiesPathname);
                } else {
                    JExpressInstaller.log("loaded silent installer's properties");
                }
            } else {
                bl = false;
                JExpressInstaller.log("config file invalid: " + object.getPath());
            }
        }
        if (bl && properties != null) {
            installDirectory = properties.getProperty("applicationDirectory", "");
            JExpressInstaller.log("silent install directory paramenter: " + installDirectory);
            object = properties.propertyNames();
            while (object.hasMoreElements()) {
                string = (String)object.nextElement();
                String string2 = properties.getProperty(string);
                JExpressInstaller.properties.setProperty(string, string2);
                JExpressInstaller.log("  " + string + "=" + string2);
            }
            JExpressInstaller.log("added silent properties to installer");
        }
        if (installDirectory != null && installDirectory.length() > 0 && (object = new File(installDirectory)).exists() && !object.isDirectory()) {
            JExpressInstaller.log(installDirectory + " is not a directory");
            installDirectory = "";
        }
        if (!(installDirectory != null && installDirectory.length() > 0 && bl)) {
            bl = false;
            JExpressInstaller.log("silent install didn't contain correct parameters");
            this.logError("silent install didn't contain correct parameters");
            System.exit(-1);
        } else {
            JExpressInstaller.properties.setProperty("applicationDirectory", installDirectory);
        }
    }

    private PropertyList getSilentProperties(File file) {
        PropertyList propertyList = null;
        boolean bl = false;
        try {
            FileInputStream fileInputStream = new FileInputStream(file);
            if (fileInputStream != null) {
                propertyList = new PropertyList();
                propertyList.load(fileInputStream);
                fileInputStream.close();
            } else {
                bl = false;
            }
        }
        catch (Exception var4_5) {
            bl = false;
        }
        return propertyList;
    }

    private void setTextFileExtensions() {
        String string = properties.getProperty("textFileExtensions");
        if (string != null) {
            LineEndingInputFilter.setTextExtensions(string);
        }
    }

    private void setInitialUserName() {
        String string = null;
        File file = new File("__jex_user_name.txt");
        if (file.exists()) {
            try {
                FileReader fileReader = new FileReader(file);
                BufferedReader bufferedReader = new BufferedReader(fileReader);
                string = bufferedReader.readLine();
                bufferedReader.close();
                fileReader.close();
                JExpressInstaller.log("initial user name: " + string);
                file.delete();
            }
            catch (Exception var4_4) {
                JExpressInstaller.log("unable to read user name from __jex_user_name.txt");
            }
        }
        if (string == null || string.length() <= 0) {
            string = System.getProperty("user.name", "");
            JExpressInstaller.log("system user name: " + string);
        }
        properties.setProperty("initialUserName", string);
    }

    private void getNativeJvmSettings() {
        block6 : {
            File file = new File("native.properties");
            if (file.exists()) {
                this.startedByNativeInstaller = true;
                try {
                    PropertyList propertyList = new PropertyList();
                    FileInputStream fileInputStream = new FileInputStream("native.properties");
                    if (fileInputStream == null) break block6;
                    propertyList.load(fileInputStream);
                    fileInputStream.close();
                    String string = propertyList.getProperty("nativeJvmHomeDir", "");
                    string = string.replace('/', File.separatorChar);
                    File file2 = new File(string);
                    String string2 = null;
                    try {
                        string2 = file2.getCanonicalPath();
                    }
                    catch (Exception var7_8) {
                        string2 = file2.getAbsolutePath();
                    }
                    if (string2 != null && new File(string2).exists()) {
                        string = string2;
                    }
                    properties.setProperty("nativeJvmHomeDir", string);
                    properties.setBooleanProperty("nativeJvmInstalled", propertyList.getBooleanProperty("nativeJvmInstalled", false));
                    properties.setBooleanProperty("nativeJvmInstalledInTemp", propertyList.getBooleanProperty("nativeJvmInstalledInTemp", false));
                    properties.setBooleanProperty("configureWinRegistry", propertyList.getBooleanProperty("configureWinRegistry", true));
                    String string3 = properties.getProperty("predefinedJvmInstallDir", "");
                    string3 = string3.replace('/', File.separatorChar);
                }
                catch (Exception var2_3) {
                    // empty catch block
                }
            }
        }
    }

    private boolean loadPropertyList() {
        boolean bl = true;
        String string = null;
        JExpressInstaller.log("Loading properties");
        try {
            InputStream inputStream = this.getFileStream(this.controlFilename);
            if (inputStream != null) {
                try {
                    String string2;
                    String string3;
                    String string4;
                    JExpressInstaller.log("got properties stream");
                    properties.load(inputStream);
                    JExpressInstaller.log("loaded properties stream");
                    inputStream.close();
                    String string5 = "QzxQzxCheckInstall".trim();
                    if (string5.equals("true")) {
                        properties.setBooleanProperty("checkLicenseDuringInstall", true);
                    }
                    if ((string4 = "QzxQzxCheckUpdate".trim()).equals("true")) {
                        properties.setBooleanProperty("checkLicenseDuringUpdate", true);
                    }
                    if ((string3 = "QzxQzxCheckApp".trim()).equals("true")) {
                        properties.setBooleanProperty("checkLicenseFromYourApp", true);
                    }
                    if ((string2 = "QzxQzxFailIfNoServer".trim()).equals("false")) {
                        properties.setBooleanProperty("failIfNoLicenseServer", false);
                        JExpressInstaller.log("do not fail if no license server");
                    } else {
                        properties.setBooleanProperty("failIfNoLicenseServer", true);
                        JExpressInstaller.log("fail if no license server");
                    }
                    JExpressInstaller.log("fail if no license server: " + properties.getBooleanProperty("failIfNoLicenseServer", true));
                }
                catch (Exception var4_6) {
                    this.logException((Object)this, "Error loading control url", var4_6);
                    bl = false;
                }
            } else {
                this.logError("Unable to load control url");
                bl = false;
            }
            if (string != null) {
                properties.setProperty("oldApplicationDirectory", string);
            }
        }
        catch (Exception var3_4) {
            this.logException((Object)this, "Unable to load property list", var3_4);
            bl = false;
        }
        return bl;
    }

    private String getStartDirectory() {
        String string = System.getProperty("user.dir", ".");
        File file = new File("startdir.txt");
        if (file.exists()) {
            try {
                FileReader fileReader = new FileReader(file);
                BufferedReader bufferedReader = new BufferedReader(fileReader);
                string = bufferedReader.readLine();
                bufferedReader.close();
                fileReader.close();
                if (string == null || string.length() <= 0) {
                    string = System.getProperty("user.dir", ".");
                }
            }
            catch (Exception var3_4) {
                // empty catch block
            }
        }
        return string;
    }

    private InputStream getFileStream(String string) throws Exception {
        InputStream inputStream = null;
        JExpressInstaller.log("Getting file stream: " + string);
        inputStream = FileSystem.getFileStream(string);
        JExpressInstaller.log("getFileStream: success: " + (inputStream != null));
        return inputStream;
    }

    private static void copyLogsToStartDir(File file, File file2, String[] arrstring) {
        for (int i = 0; i < arrstring.length; ++i) {
            block3 : {
                String string = arrstring[i];
                File file3 = new File(file, string);
                if (file3.isDirectory() || string.equals("jinstall.log") || !string.endsWith(".log")) continue;
                File file4 = new File(file2, string);
                try {
                    FileSystem.appendFile(file3, file4);
                    file3.delete();
                }
                catch (Exception var7_7) {
                    if (!string.equalsIgnoreCase("errors.log") || silentInstall) break block3;
                    Vector<String> vector = new Vector<String>();
                    vector.add(Localize.strings().getString("UseWritableDrive"));
                    vector.add(Localize.strings().getString("UnableToSaveLogs"));
                    InstallerPopups.noteError(vector);
                }
            }
            TimeSharer.yield();
        }
    }

    private void createLogsInTempDir(String string, String string2) {
        if (!(string == null || string.length() <= 0 || string2.equals(string))) {
            File file = new File(string2);
            File file2 = new File(string);
            String[] arrstring = file.list();
            if (arrstring != null && arrstring.length > 0) {
                this.createLogsInTempDir(file2, file, arrstring);
            }
        }
    }

    private void createLogsInTempDir(File file, File file2, String[] arrstring) {
        for (int i = 0; i < arrstring.length; ++i) {
            String string = arrstring[i];
            File file3 = new File(file2, string);
            if (file3.isDirectory() || string.equals("jinstall.log") || !string.endsWith(".log")) continue;
            File file4 = new File(file, string);
            try {
                FileSystem.createEmptyFile(file4);
            }
            catch (Exception var8_8) {
                this.logException((Object)this, "Unable to copy log files", var8_8);
            }
            TimeSharer.yield();
        }
    }

    private static String getAltLogDir() {
        String string;
        String string2 = null;
        try {
            string = properties.getProperty("applicationDirectory", "");
            if (!FileSystem.isDirWriteProtected(string)) {
                string2 = string;
            }
        }
        catch (Exception var1_2) {
            // empty catch block
        }
        if (!(string2 != null || (string = System.getProperty("user.home", "")).length() <= 0 || FileSystem.isDirWriteProtected(string))) {
            string2 = string;
        }
        return string2;
    }

    private String createTempDirectory(String string) {
        String string2 = System.getProperty("user.home", ".");
        String string3 = System.getProperty("user.dir", ".");
        string2 = null;
        String string4 = TempFiles.getDefaultTempDirectory();
        if (string4 != null) {
            string2 = this.createTempSubdirectory(string4);
        }
        if (string2 == null) {
            string4 = System.getProperty("user.home");
            string2 = this.createTempSubdirectory(string4);
        }
        if (string2 == null) {
            string4 = System.getProperty("java.home");
            string2 = this.createTempSubdirectory(string4);
        }
        if (string2 == null) {
            File file = new File(string3, "___testjex.txt");
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file);
                fileOutputStream.write(0);
                fileOutputStream.close();
                string2 = string3;
                file.delete();
            }
            catch (Exception var6_7) {
                // empty catch block
            }
        }
        if (!(string2 == null || string2.equals(string3))) {
            TempFiles.add(string2);
        } else {
            string2 = string3;
        }
        TempFiles.setDefaultDirectory(string2);
        return string2;
    }

    private String createTempSubdirectory(String string) {
        String string2 = null;
        boolean bl = false;
        if (string != null) {
            for (int i = 1; !(bl || i >= 50); ++i) {
                File file = new File(string, "tmpjex" + String.valueOf(i));
                file.delete();
                if (!file.exists() && file.mkdir()) {
                    this.createdTempDir = true;
                    bl = true;
                    try {
                        string2 = file.getCanonicalPath();
                    }
                    catch (Exception var6_6) {
                        string2 = file.getPath();
                    }
                }
                Thread.yield();
            }
        }
        return string2;
    }

    private static void parseArgs(String[] arrstring) {
        for (int i = 0; i < arrstring.length; ++i) {
            String string = arrstring[i];
            if (!string.startsWith("-") || string.length() <= 0) continue;
            String string2 = string.substring(1);
            if (string2.equals("q")) {
                ++i;
                silentInstall = true;
                while (!(i >= arrstring.length || arrstring[i].startsWith("-"))) {
                    if (installDirectory == null) {
                        installDirectory = "";
                    }
                    installDirectory = installDirectory + arrstring[i];
                    installDirectory = installDirectory + " ";
                    ++i;
                }
                installDirectory = installDirectory.trim();
                JExpressInstaller.log("silent install to " + installDirectory);
                continue;
            }
            if (string2.equals("d")) {
                ++i;
                while (!(i >= arrstring.length || arrstring[i].startsWith("-"))) {
                    downloadedUrl = downloadedUrl + arrstring[i];
                    downloadedUrl = downloadedUrl + " ";
                    ++i;
                }
                downloadedUrl = downloadedUrl.trim();
                JExpressInstaller.log("downloadedUrl " + downloadedUrl);
                continue;
            }
            if (string2.equals("s")) {
                ++i;
                silentInstall = true;
                while (!(i >= arrstring.length || arrstring[i].startsWith("-"))) {
                    if (propertiesPathname == null) {
                        propertiesPathname = "";
                    }
                    propertiesPathname = propertiesPathname + arrstring[i];
                    propertiesPathname = propertiesPathname + " ";
                    ++i;
                }
                propertiesPathname = propertiesPathname.trim();
                JExpressInstaller.log("silent install using properties: " + propertiesPathname);
                continue;
            }
            if (string2.equals("p")) {
                if (++i >= arrstring.length) continue;
                while (!(i >= arrstring.length || arrstring[i].equalsIgnoreCase("-q") || arrstring[i].equalsIgnoreCase("-s") || arrstring[i].equalsIgnoreCase("-d"))) {
                    extraParameters = extraParameters + arrstring[i];
                    extraParameters = extraParameters + " ";
                    ++i;
                }
                extraParameters = extraParameters.trim();
                JExpressInstaller.log("extra parameters: " + extraParameters);
                continue;
            }
            if (!string2.equals("t")) continue;
            ++i;
            while (!(i >= arrstring.length || arrstring[i].startsWith("-"))) {
                testProperties = testProperties + arrstring[i];
                testProperties = testProperties + " ";
                ++i;
            }
            testProperties = testProperties.trim();
            JExpressInstaller.log("test properties: " + testProperties);
        }
    }

    public void fatalError(String string) {
        if (properties.getBooleanProperty("silentInstall", false)) {
            JExpressInstaller.log("fatal error: " + string);
        } else {
            UserNotices userNotices = new UserNotices();
            userNotices.awtNoteError(string);
        }
        System.exit(-1);
    }

    private static Color getTextColor() {
        Color color = null;
        if (properties.getProperty("textColor") != null) {
            color = new Color(properties.getIntProperty("textColor", DefaultTextColor.getRGB()));
        }
        return color;
    }

    private static Color getBackgroundColor() {
        Color color = null;
        if (properties.getProperty("backgroundColor") != null) {
            color = new Color(properties.getIntProperty("backgroundColor", DefaultBackgroundColor.getRGB()));
        }
        return color;
    }

    private void logInitialSettings() {
        JExpressInstaller.log("silentInstall: " + silentInstall);
        JExpressInstaller.log("installDirectory: " + installDirectory);
        JExpressInstaller.log("propertiesPathname: " + propertiesPathname);
        JExpressInstaller.log("extraParameters: " + extraParameters);
        JExpressInstaller.log("downloadedUrl: " + downloadedUrl);
        JExpressInstaller.log("controlFilename: " + this.controlFilename);
    }

    protected static void startLog() {
        if (installerLog == null) {
            installerLog = new Log("jinstaller");
        }
    }

    protected static void log(String string) {
        JExpressInstaller.startLog();
        installerLog.write(string);
        JExpressInstaller.debug(string);
    }

    protected void logError(String string) {
        JExpressInstaller.log(string);
        ErrorLog.getLog().write(string);
    }

    protected void logError(Exception exception) {
        JExpressInstaller.startLog();
        installerLog.write(exception);
        ErrorLog.getLog().write(exception);
    }

    private void logException(Object object, String string, Exception exception) {
        if (ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(exception);
            ErrorLog.getLog().flush();
        }
        if (string != null) {
            this.logError(string);
        }
    }

    private void logException(Object object, String string, Throwable throwable) {
        if (ErrorLog.getLog() != null) {
            ErrorLog.getLog().write(throwable);
            ErrorLog.getLog().flush();
        }
        if (string != null) {
            this.logError(string);
        }
    }

    private static void debug(String string) {
    }

    private class InstallSwinger
    extends Swinger {
        private Installer installer;
        private boolean ok;
        private String errorMessage;

        private InstallSwinger() {
            this.installer = null;
            this.ok = false;
            this.errorMessage = "Unable to start installer.";
        }

        public void swingBefore() {
            this.installer = new Installer();
        }

        public void workInBackground() {
            try {
                JExpressInstaller.debug("configuring installer");
                this.ok = JExpressInstaller.this.config();
                JExpressInstaller.debug("config ok: " + this.ok);
                if (this.ok) {
                    JExpressInstaller.debug("setting up Installer");
                    this.ok = this.installer.setUp(properties);
                }
            }
            catch (RuntimeException var1_1) {
                this.ok = false;
                JExpressInstaller.this.logException(this, "Unable to start installer", var1_1);
                this.errorMessage = "Unable to start installer.\n\n(" + var1_1.getMessage() + ")";
            }
        }

        public void swingAfter() {
            if (this.ok) {
                this.installer.configFrame();
            } else {
                if (silentInstall) {
                    System.out.println(this.errorMessage);
                } else {
                    UserNotices userNotices = new UserNotices();
                    userNotices.awtNoteError(this.errorMessage);
                }
                System.exit(-1);
            }
        }
    }

}
