/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.MenuUtilities;
import com.denova.JExpress.Installer.StatusPanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.JExpress.JExpressConvertAPI;
import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.io.MakeDirs;
import com.denova.lang.TimeSharer;
import com.denova.runtime.CommandMap;
import com.denova.runtime.Exec;
import com.denova.runtime.JRE;
import com.denova.runtime.LinuxServices;
import com.denova.runtime.MacOS;
import com.denova.runtime.OS;
import com.denova.runtime.UnixCommands;
import com.denova.runtime.UnixMenu;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsMenus;
import com.denova.runtime.WindowsServices;
import com.denova.runtime.WindowsUtils;
import com.denova.ui.Swinger;
import com.denova.util.PropertyList;
import com.denova.util.StringConversions;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.swing.JLabel;

public class MenusPanel
extends StatusPanel
implements InstallPropertyNames,
JExpressConstants,
InstallerConstants {
    private static final String ClassExtension = ".class";
    private static final String Quote = "\"";
    private static final String Space = " ";
    private PropertyList updateControlProperties = null;
    private WindowsMenus windowsMenus = null;
    private boolean updaterInstalled = false;
    private boolean tellUserHowToStart = false;
    private List javaMenus = null;
    private boolean updated;
    private boolean autoUpdate;
    private boolean twoStageAutoUpdate = false;
    private boolean nonJavaAutoMenu = false;
    private boolean nextButtonEnabled = false;
    private String submenu = null;
    private String longName = null;
    private String shortName = null;
    private boolean javaAppMenu = false;
    private boolean useJavaConsole = false;
    private String executableFile = null;
    private String commandLineArguments = null;
    private String iconFilename = null;
    private String splashFile = null;
    private boolean allUsers = false;
    private boolean menuAutoUpdate = true;
    private boolean addDesktopShortcut = true;
    private boolean startAfterInstall = false;
    private boolean installAsService = false;
    private boolean installOnWindows = true;
    private boolean installOnMac = true;
    private boolean installOnUnix = true;
    private boolean installOnGnome = true;
    private boolean installOnKDE = true;
    private boolean installOnXfce = true;
    private String installDir = null;
    private String workingDir = null;
    private String uninstallerIconPath = null;
    private List createdDirs = null;
    private String progressLabel;

    public MenusPanel(PropertyList propertyList) {
        super(propertyList);
        MenuUtilities.setLog();
        this.updated = false;
        this.progressLabel = Localize.strings().getString("Configuring") + " " + Localize.strings().getString("SettingUpMenus");
        this.progressBarLabel.setText(this.progressLabel);
    }

    public synchronized void enter() {
        if (this.updated) {
            this.logMessage("menus already configured");
            this.showNextPanel();
        } else {
            this.logMessage("starting to configure menus");
            MenusSwinger menusSwinger = new MenusSwinger();
            menusSwinger.execute();
        }
    }

    public boolean isOk() {
        return this.updated;
    }

    public void reset() {
        super.reset();
        this.updated = false;
        this.updaterInstalled = false;
    }

    public String getName() {
        return "MenusPanel";
    }

    public int getEstimatedTime() {
        int n = 20;
        try {
            PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
            n = 20 * propertyList.propertyNamesList().size();
        }
        catch (Exception var4_3) {
            this.logMessage("unable to estimate time to create menus");
        }
        if (!this.getPropertyList().getBooleanProperty("autoupdateNever", true)) {
            n+=25;
        }
        this.logMessage("total estimated time: " + n + " seconds");
        return n;
    }

    public boolean isNextButtonEnabled() {
        return this.nextButtonEnabled;
    }

    private void initMenus() {
        this.javaMenus = new Vector();
        this.installDir = this.getApplicationDirectory();
        this.autoUpdate = this.getPropertyList().getBooleanProperty("autoupdateEveryStartup", false);
    }

    private boolean addMenus() {
        boolean bl = this.okToAddMenus();
        if (bl) {
            this.addItems();
        }
        return bl;
    }

    private void addItems() {
        String string;
        String string2;
        Object object;
        if (this.needUpdater()) {
            this.installUpdater();
        }
        this.tellUserHowToStart = this.getPropertyList().getBooleanProperty("tellUserHowToStart");
        this.getPropertyList().setBooleanProperty("tellUserHowToStart", false);
        this.submenu = this.getPropertyList().getProperty("submenu", "").replace('/', File.separatorChar);
        PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
        Iterator iterator = propertyList.propertyNamesList().iterator();
        if (iterator.hasNext() && OS.isWindows() && this.windowsMenus == null) {
            this.windowsMenus = new WindowsMenus(MenuUtilities.getLog());
        }
        while (iterator.hasNext()) {
            string = (String)iterator.next();
            string2 = propertyList.getProperty(string);
            if (string2 != null) {
                this.logMessage("---- start menu ----");
                object = new PropertyList();
                object.fromString(string2);
                if (MenuUtilities.menuOk((PropertyList)object, this.getPropertyList())) {
                    this.logMessage("menu name: " + string);
                    this.installDir = this.getApplicationDirectory();
                    this.workingDir = this.getWorkingDir(object.getProperty("workingDir"));
                    this.addItem(string, (PropertyList)object);
                    this.logMessage("added menu: " + string);
                } else {
                    this.logMessage("not ok to add menu: " + this.submenu);
                }
                this.logMessage("---- end menu ----");
            }
            if (!iterator.hasNext()) continue;
            TimeSharer.yield();
        }
        if (this.needUpdater()) {
            string2 = string = this.getPropertyList().getProperty("packageName", "Applications");
            if (CustomInstaller.multipleComponents()) {
                string2 = this.getPropertyList().getProperty("installType", string);
                this.logMessage("creating updater for " + string2);
                this.configVersionInfo(string2);
            }
            this.createUpdateOnDemandMenu(string2);
            object = this.javaMenus.iterator();
            if (object.hasNext()) {
                this.addJavaMenusToUpdater();
            }
        }
    }

    private void addItem(String string, PropertyList propertyList) {
        this.menuAutoUpdate = propertyList.getBooleanProperty("menuAutoUpdate", this.autoUpdate) && this.autoUpdate;
        this.longName = propertyList.getProperty("longName", "").trim();
        this.shortName = propertyList.getProperty("shortName", "").trim();
        this.addDesktopShortcut = propertyList.getBooleanProperty("menuDesktopShortcut", true);
        this.allUsers = propertyList.getBooleanProperty("menuAllUsers", false);
        this.installAsService = propertyList.getBooleanProperty("menuInstallAsService", false);
        this.installOnWindows = propertyList.getBooleanProperty("windowsMenu", this.longName.length() > 0);
        this.installOnMac = propertyList.getBooleanProperty("macMenu", this.longName.length() > 0);
        this.installOnUnix = propertyList.getBooleanProperty("unixMenu", this.shortName.length() > 0);
        this.installOnGnome = propertyList.getBooleanProperty("gnomeMenu", this.installOnUnix);
        this.installOnKDE = propertyList.getBooleanProperty("kdeMenu", this.installOnUnix);
        this.installOnXfce = propertyList.getBooleanProperty("xfceMenu", this.installOnUnix);
        if (this.longName.length() <= 0) {
            this.longName = this.shortName;
        }
        if (this.shortName.length() <= 0) {
            this.shortName = MenuUtilities.getShortName(this.longName);
        }
        this.javaAppMenu = this.getUseJavaCommandPrefix(propertyList);
        this.useJavaConsole = this.getUseJavaConsole(propertyList);
        if (!(!this.menuAutoUpdate || this.javaAppMenu || this.installAsService)) {
            this.nonJavaAutoMenu = true;
            this.javaAppMenu = true;
            this.useJavaConsole = false;
        } else {
            this.nonJavaAutoMenu = false;
        }
        String string2 = "";
        if (this.javaAppMenu) {
            String string3 = this.getCommandPrefix(this.getClasspath(), false);
            String string4 = this.getCommandPrefix(this.getClasspath(), true);
            string2 = string3;
            string2 = this.useJavaConsole ? string4 : string3;
        }
        this.executableFile = this.getExecutableFile(propertyList);
        this.commandLineArguments = this.getCommandLineArguments(propertyList);
        this.iconFilename = MenuUtilities.getIconFilename(propertyList.getProperty("iconFilename"));
        this.startAfterInstall = propertyList.getBooleanProperty("menuStartAfterInstall", false);
        if (this.needUpdater()) {
            this.saveUpdaterMenuSettings(propertyList);
        }
        this.logMessage("add menu to folder: " + this.submenu);
        this.addMenuItem(string, string2, this.getClasspath(), propertyList.getBooleanProperty("menuRunAsAdmin", false));
    }

    private boolean okToAddMenus() {
        boolean bl = true;
        if (bl && OS.isWindows()) {
            String string = WindowsUtils.getCommandProgramFilename();
            boolean bl2 = bl = string != null && string.length() > 0;
            if (!bl) {
                CustomInstaller.logError("unable to extract windows api file");
            }
        }
        return bl;
    }

    private void addMenuItem(String string, String string2, String string3, boolean bl) {
        String string4;
        if (this.javaAppMenu && this.executableFile != null && this.executableFile.indexOf(".class") != -1) {
            string4 = string2.toLowerCase();
            int n = string4.indexOf("jre");
            if (n < 0) {
                n = string4.indexOf("java");
            }
            if (n >= 0) {
                n = this.executableFile.lastIndexOf(".class");
                this.executableFile = this.executableFile.substring(0, n);
            }
        }
        if (!string2.endsWith(" ")) {
            string2 = string2 + " ";
        }
        this.submenu = this.submenu.trim();
        this.longName = this.longName.trim();
        this.shortName = this.shortName.trim();
        this.iconFilename = this.iconFilename.trim();
        this.iconFilename = this.iconFilename.replace('/', File.separatorChar);
        this.iconFilename = this.iconFilename.replace('\\', File.separatorChar);
        this.logMessage("OS name: " + System.getProperty("os.name"));
        this.logMessage("Submenu: " + this.submenu);
        this.logMessage("Menu item long name: " + this.longName);
        this.logMessage("Menu item short name: " + this.shortName);
        this.logMessage("Auto update menu: " + this.menuAutoUpdate);
        this.logMessage("Path to icon basename: " + this.iconFilename);
        this.logMessage("Product name: " + this.longName);
        this.logMessage("Executable: " + this.executableFile);
        this.logMessage("Cmd args: " + this.commandLineArguments);
        this.logMessage("Working dir: " + this.workingDir);
        this.logMessage("Install dir: " + this.installDir);
        this.logMessage("Add desktop icon: " + this.addDesktopShortcut);
        this.logMessage("All users: " + this.allUsers);
        this.logMessage("Run menu as admin: " + bl);
        if (OS.isWindows() && this.installOnWindows) {
            this.logMessage("Install as a service: " + this.installAsService);
            string4 = MenuUtilities.getWindowsIconFilename(this.iconFilename);
            if (this.uninstallerIconPath == null) {
                this.uninstallerIconPath = string4;
                this.getPropertyList().setProperty("uninstallerIconPath", this.uninstallerIconPath);
            }
            this.addWindowsMenuItem(string2, string4, bl);
            this.getPropertyList().setBooleanProperty("tellUserHowToStart", this.tellUserHowToStart);
            if (this.tellUserHowToStart && this.getPropertyList().getProperty("menuToStart") == null && !this.installAsService) {
                String string5 = this.longName;
                if (this.submenu != null && this.submenu.length() > 0) {
                    string5 = this.submenu + " | " + this.longName;
                    string5 = string5.replace(File.separatorChar, '|');
                }
                this.getPropertyList().setProperty("menuToStart", string5);
            }
            if (!this.installAsService) {
                this.saveMenuArguments(string, string2);
            }
            if (this.twoStageAutoUpdate && this.autoUpdate && this.menuAutoUpdate) {
                this.createSecondStageUpdateLauncher(string2, string3);
            }
        } else if (OS.isMac() && this.installOnMac) {
            if (this.javaAppMenu && this.useJavaConsole) {
                this.buildUnixLaunchScript(string, string2, bl);
                this.saveMenuArguments(string, string2);
            } else {
                this.addMacOsLauncher(string2, string3, bl);
                this.saveMenuArguments(string, string2);
                if (this.twoStageAutoUpdate && this.autoUpdate && this.menuAutoUpdate) {
                    this.createSecondStageUpdateLauncher(string2, string3);
                }
            }
        } else if (OS.isUnix() && this.installOnUnix) {
            this.buildUnixLaunchScript(string, string2, bl);
            if (!(this.installAsService || this.javaAppMenu)) {
                this.saveMenuArguments(string, string2);
            }
        }
    }

    private void buildUnixLaunchScript(String string, String string2, boolean bl) {
        if (this.installAsService && !this.javaAppMenu && this.isLinux()) {
            this.buildUnixScript(string, string2, bl);
            LinuxServices linuxServices = new LinuxServices();
            File file = new File(this.installDir, this.shortName);
            boolean bl2 = linuxServices.installService(string, file.getPath());
            this.logMessage("installed as service ok: " + bl2);
        } else {
            this.buildUnixScript(string, string2, bl);
        }
    }

    private void buildUnixScript(String string, String string2, boolean bl) {
        String string3 = this.shortName;
        if (OS.isMac()) {
            string3 = this.shortName + ".command";
            MacOS macOS = new MacOS(MenuUtilities.getLog());
            macOS.setLaunchDirName(this.installDir);
            macOS.setSubmenu(this.submenu);
            macOS.setInstallDir(this.installDir);
            macOS.setWorkingDir(this.workingDir);
            macOS.setLongName(this.longName);
            macOS.setShortName(string3);
            macOS.setExecutableFile(this.executableFile);
            macOS.setCommandLineArguments(this.commandLineArguments);
            macOS.setRunAsAdmin(bl);
            macOS.setAllUsers(this.allUsers);
            macOS.setIconFilename(this.iconFilename);
            macOS.addLaunchScript(this.javaAppMenu, this.useJavaConsole, string2, this.addDesktopShortcut);
            this.addCreatedDirs(string3, macOS.getCreatedDirs());
        } else {
            this.iconFilename = MenuUtilities.getKdeIconFilename(this.iconFilename);
            UnixMenu unixMenu = new UnixMenu(MenuUtilities.getLog());
            unixMenu.setSubmenu(this.submenu);
            unixMenu.setInstallDir(this.installDir);
            unixMenu.setWorkingDir(this.workingDir);
            unixMenu.setLaunchDirName(this.installDir);
            unixMenu.setLongName(this.longName);
            unixMenu.setShortName(string3);
            unixMenu.setExecutableFile(this.executableFile);
            unixMenu.setCommandLineArguments(this.commandLineArguments);
            unixMenu.setIconFilename(this.iconFilename);
            unixMenu.setRunAsAdmin(bl);
            unixMenu.setAllUsers(this.allUsers);
            unixMenu.setAddDesktopShortcut(this.addDesktopShortcut);
            unixMenu.setInstallOnGnome(this.installOnGnome);
            unixMenu.setInstallOnKDE(this.installOnKDE);
            unixMenu.setInstallOnXfce(this.installOnXfce);
            unixMenu.addLaunchScript(this.javaAppMenu, this.useJavaConsole, string2);
            this.addCreatedDirs(string3, unixMenu.getCreatedDirs());
        }
        if (this.javaAppMenu) {
            this.addJavaMenu(this.shortName);
        }
        this.logMessage("created " + this.shortName + " with launcher named: " + this.executableFile);
        this.saveMenuArguments(string, string2);
    }

    private void saveMenuArguments(String string, String string2) {
        this.logMessage("saving menu arguments for " + string);
        List list = new Vector<String>();
        if (this.javaAppMenu) {
            list = this.addArguments(string2, list);
        }
        list.add(this.executableFile);
        this.logMessage("         arg: " + this.executableFile);
        list = this.addArguments(this.commandLineArguments, list);
        String string3 = string + "menuArguments";
        String string4 = StringConversions.fromList(list);
        this.getPropertyList().setProperty(string3, string4);
        this.logMessage("saved " + string3 + ": " + string4);
    }

    List addArguments(String string, List list) {
        List list2 = list;
        String string2 = string;
        int n = string2.indexOf(" ");
        while (n != -1) {
            String string3;
            int n2;
            int n3 = n;
            int n4 = string2.indexOf("\"");
            if (n4 < n && (n2 = string2.substring(n4 + 1).indexOf("\"") + n4 + 1) != -1) {
                if (n2 + 1 < string2.length()) {
                    if (string2.charAt(n2 + 1) == ' ') {
                        ++n2;
                    }
                } else {
                    string2 = string2 + " ";
                    ++n2;
                }
                n3 = n2;
            }
            if ((string3 = string2.substring(0, n3)).length() > 0) {
                int n5 = 0;
                int n6 = string3.length() - 1;
                if (string3.charAt(n5) == '\"' && string3.charAt(n6) == '\"') {
                    string3 = string3.substring(n5 + 1, n6 - 1);
                }
                list2.add(string3);
                this.logMessage("         arg: " + string3);
            }
            string2 = n3 + 1 < string2.length() ? string2.substring(n3 + 1) : "";
            n = string2.indexOf(" ");
        }
        if (string2.length() > 0) {
            list2.add(string2);
            this.logMessage("         arg: " + string2);
        }
        return list2;
    }

    void createSecondStageUpdateLauncher(String string, String string2) {
        boolean bl = true;
        boolean bl2 = true;
        this.commandLineArguments = "autoUpdateFull";
        this.addDesktopShortcut = false;
        if (OS.isWindows()) {
            this.longName = "Update " + this.longName;
            bl = this.createWindowsLauncher(string, bl2);
            if (bl) {
                WindowsCommands.hideFile(CommandMap.get(this.longName));
            }
        } else if (OS.isMacOsX()) {
            this.longName = ".Update " + this.longName;
            this.addMacOsLauncher(string, string2, bl2);
        } else {
            this.longName = this.shortName = "." + "Update ".trim().toLowerCase() + "-" + this.shortName;
            this.buildUnixLaunchScript(this.shortName, string, bl2);
        }
        if (bl) {
            this.logMessage("created 2nd stage for updater: " + this.longName);
            this.getPropertyList().setProperty("secondaryUpdater", this.longName);
            if (this.loadUpdateControlPropertyList()) {
                String string3 = CommandMap.get(this.longName);
                this.updateControlProperties.setProperty("fullAutoUpdateName", string3);
                this.saveUpdateControlPropertyList();
                this.logMessage("saved full auto update name: " + string3);
            } else {
                this.logMessage("unable to save full auto update name");
            }
        } else {
            this.logMessage("unable to create 2nd stage for updater");
        }
    }

    void addMacOsLauncher(String string, String string2, boolean bl) {
        boolean bl2 = false;
        boolean bl3 = true;
        boolean bl4 = true;
        boolean bl5 = true;
        String string3 = null;
        String string4 = MenuUtilities.getIconFilename(this.iconFilename, "icns");
        String string5 = this.getExtraMacJvmParameters(bl2, bl3, bl4, bl5);
        String string6 = this.getPropertyList().getProperty("packageName", "") + " by " + this.getPropertyList().getProperty("author", "") + " (" + this.getPropertyList().getProperty("packageCopyright", "") + ")";
        String string7 = this.getPropertyList().getProperty("packageVersion", "");
        String string8 = this.getMacJvmVersion();
        String string9 = CustomInstaller.installerCreatedBy();
        string2 = JRE.convertOnlyFileSeparators(string2);
        MacOS macOS = new MacOS(MenuUtilities.getLog());
        macOS.setSubmenu(this.submenu);
        macOS.setInstallDir(this.installDir);
        macOS.setWorkingDir(this.workingDir);
        macOS.setLaunchDirName(this.installDir);
        macOS.setLongName(this.longName);
        macOS.setShortName(this.shortName);
        macOS.setExecutableFile(this.executableFile);
        macOS.setCommandLineArguments(this.commandLineArguments);
        macOS.setRunAsAdmin(bl);
        macOS.setIconFilename(string4);
        if (this.splashFile != null && this.splashFile.length() > 0) {
            macOS.setSplashFile(this.splashFile);
        }
        string3 = macOS.addMacLauncher(this.javaAppMenu, this.useJavaConsole, string, string7, string2, string5, string8, string6, string9, this.addDesktopShortcut);
        this.logMessage("created " + this.longName + " with launcher named: " + string3);
        this.addCreatedDirs(this.longName, macOS.getCreatedDirs());
        if (this.javaAppMenu) {
            this.addJavaMenu(string3);
        }
    }

    private void addJavaMenu(String string) {
        if (this.installDir != null && string != null) {
            String string2 = "JExpress" + File.separator + "Update ".trim();
            if (string.equals("update") || string.startsWith("Update ") || string.startsWith(string2)) {
                this.logMessage("do not add updater (" + string + ") to java menus");
            } else if (this.menuAutoUpdate) {
                this.logMessage("do not add auto update menu (" + string + ") to java menus");
            } else {
                File file = new File(this.installDir, string);
                if (file.exists()) {
                    this.javaMenus.add(file.getName());
                    this.logMessage("added " + file.getName() + " (" + string + ") to java menus");
                } else {
                    this.logMessage("unable to add java menu to list: " + file.getPath());
                }
            }
        } else {
            this.logMessage("unable to add java menu");
            this.logMessage("install dir: " + this.installDir);
            this.logMessage("launch name: " + string);
        }
    }

    private String getMacJvmVersion() {
        String string = this.getPropertyList().getProperty("jvmRequiredVersion", "");
        String string2 = this.getPropertyList().getProperty("jvmMinVersion", "");
        String string3 = this.getPropertyList().getProperty("jvmMaxVersion", "");
        return MacOS.getJvmVersion(string, string2, string3);
    }

    private void addWindowsMenuItem(String string, String string2, boolean bl) {
        String string3 = this.getWindowsUser();
        boolean bl2 = true;
        boolean bl3 = true;
        this.logMessage("    menu name " + this.longName);
        this.logMessage("  install dir " + this.installDir);
        this.logMessage("  working dir " + this.workingDir);
        this.logMessage("     use Java " + String.valueOf(this.javaAppMenu));
        this.logMessage("  use console " + String.valueOf(this.useJavaConsole));
        this.logMessage("   cmd prefix " + string);
        this.logMessage("   executable " + this.executableFile);
        this.logMessage("     cmd args " + this.commandLineArguments);
        this.logMessage("    icon file " + string2);
        this.logMessage(" run as admin " + bl);
        this.logMessage("         user " + string3);
        if (this.javaAppMenu) {
            bl3 = this.installAsService ? this.addWindowsJavaService() : this.addWindowsJavaMenuItem(string, string2, bl);
            boolean bl4 = bl2 = !bl3;
        }
        if (bl2) {
            bl3 = this.addWindowsPlainMenuItem(string, string2, bl);
        }
    }

    private boolean addWindowsJavaService() {
        boolean bl = false;
        String string = this.getPropertyList().getProperty("installJvmParameters", "");
        if (string.length() > 0) {
            boolean bl2 = true;
            boolean bl3 = true;
            boolean bl4 = true;
            boolean bl5 = true;
            String string2 = this.getStandardJvmMemoryParam(string, "-Xmx");
            String string3 = this.getStandardJvmMemoryParam(string, "-Xms");
            String string4 = this.getStandardJvmMemoryParam(string, "-Xss");
            String string5 = this.getExtraJvmParameters(this.getJvmOptionsParam(string, string2, string3, string4), bl2, bl3, bl4, bl5);
            string2 = this.getPrunSrvMemoryParam(string2, "-Xmx", "--JvmMx");
            string3 = this.getPrunSrvMemoryParam(string3, "-Xms", "--JvmMs");
            string4 = this.getPrunSrvMemoryParam(string4, "-Xss", "--JvmSs");
            string = string2 + " " + string3 + " " + string4 + " " + string5;
            this.logMessage("extra jvm line: '" + string + "'");
        }
        try {
            File file = this.getServiceBatchFile(string.trim());
            if (file.exists()) {
                String string6 = this.getQuotedString(file.getPath());
                String string7 = "cmd.exe /c " + string6;
                this.logMessage("about to run command: " + string7);
                Exec.runCommand(string7);
                bl = true;
            } else {
                bl = false;
            }
        }
        catch (Exception var3_5) {
            String string8 = "Unable to install service for " + this.longName;
            CustomInstaller.logException(string8, var3_5);
            this.logMessage(string8);
        }
        return bl;
    }

    private File getServiceBatchFile(String string) {
        String string2 = this.getMenuPrefix();
        String string3 = this.getQuotedString(this.executableFile);
        String string4 = this.getQuotedString(this.installDir);
        String string5 = this.getQuotedString(this.longName);
        String string6 = JRE.changeDotsToCurrentDirectory(this.getClasspath(), this.installDir);
        String string7 = JRE.getJavaHome();
        if (string7.endsWith(File.separator)) {
            string7 = string7.substring(0, string7.length() - 1);
        }
        string7 = this.getQuotedString(string7);
        File file = new File(this.installDir, "JExpress");
        File file2 = new File(file, "services");
        File file3 = new File(file2, "install-service.bat");
        File file4 = new File(file2, "install-" + string2.toLowerCase() + "-service.bat");
        try {
            FileInputStream fileInputStream = new FileInputStream(file3);
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(fileInputStream));
            FileOutputStream fileOutputStream = new FileOutputStream(file4);
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            boolean bl = true;
            String string8 = bufferedReader.readLine();
            while (string8 != null) {
                bl = true;
                if (!this.startAfterInstall && (string8.startsWith("echo Starting %SERVICE_NAME%") || string8.startsWith("%PRUNSRV% start %SERVICE_NAME%") || string8.startsWith("echo %SERVICE_NAME% started."))) {
                    bl = false;
                }
                if (bl) {
                    string8 = this.substitueVariable(string8, "%SERVICE_NAME%", string2);
                    string8 = this.substitueVariable(string8, "%MAIN_CLASS%", string3);
                    string8 = this.substitueVariable(string8, "%START_PATH%", string4);
                    string8 = this.substitueVariable(string8, "%JAVA_HOME%", string7);
                    string8 = this.substitueVariable(string8, "%CLASSPATH%", string6);
                    string8 = this.substitueVariable(string8, "%DESCRIPTION%", string5);
                    string8 = this.substitueVariable(string8, "%EXTRA_PARAMETERS%", string);
                    printWriter.println(string8);
                }
                string8 = bufferedReader.readLine();
            }
            printWriter.close();
            fileOutputStream.close();
            bufferedReader.close();
        }
        catch (Exception var12_18) {
            String string9 = "Unable to create " + file4.getPath();
            CustomInstaller.logException(string9, var12_18);
            this.logMessage(string9);
        }
        return file4;
    }

    private String substitueVariable(String string, String string2, String string3) {
        String string4 = string;
        int n = string4.indexOf(string2);
        if (n > 0) {
            int n2 = n + string2.length();
            string4 = string4.length() > n2 ? string4.substring(0, n) + string3 + string4.substring(n2) : string4.substring(0, n) + string3;
        }
        return string4;
    }

    private String getJvmOptionsParam(String string, String string2, String string3, String string4) {
        String string5 = string;
        if (string5.length() > 0) {
            this.logMessage("original jvm options: " + string5);
            string5 = this.stripStandardJvmMemoryParam(string5, string2);
            string5 = this.stripStandardJvmMemoryParam(string5, string3);
            string5 = this.stripStandardJvmMemoryParam(string5, string4);
            if (string5.length() > 0) {
                try {
                    List list = Exec.getCommandArgs(string5);
                    String string6 = "";
                    for (int i = 0; i < list.size(); ++i) {
                        String string7 = "++JvmOptions=" + (String)list.get(i) + " ";
                        string6 = string6 + string7;
                        this.logMessage("new jvm options: " + string6);
                    }
                    string5 = string6;
                    this.logMessage("final jvm options: " + string5);
                }
                catch (Exception var6_7) {
                    this.logMessage(var6_7.getMessage());
                }
            } else {
                this.logMessage("no jvm options");
            }
        }
        return string5.trim();
    }

    private String stripStandardJvmMemoryParam(String string, String string2) {
        int n;
        if (string.length() > 0 && string2.length() > 0 && (n = string.indexOf(string2)) >= 0) {
            int n2 = n + string2.length();
            string = string.length() > n2 ? string.substring(0, n) + string.substring(n2).trim() : string.substring(0, n);
        }
        return string;
    }

    private String getStandardJvmMemoryParam(String string, String string2) {
        String string3 = "";
        int n = string.toLowerCase().indexOf(string2.toLowerCase());
        if (n >= 0) {
            int n2 = string.substring(n).indexOf(" ") + n;
            string3 = string.length() > n2 && n2 > n ? string.substring(n, n2) : string.substring(n);
            this.logMessage("standard jvm mem param: " + string3);
        }
        return string3;
    }

    private String getPrunSrvMemoryParam(String string, String string2, String string3) {
        int n;
        String string4 = "";
        if (string2.length() > 0 && (n = string.toLowerCase().indexOf(string2.toLowerCase())) >= 0) {
            string4 = string3 + "=" + string.substring(n + string2.length()).trim();
            this.logMessage("new jvm mem param: " + string4);
        }
        return string4;
    }

    private boolean addWindowsJavaMenuItem(String string, String string2, boolean bl) {
        String string3 = this.getWindowsUser();
        boolean bl2 = this.createWindowsLauncher(string, bl);
        if (bl2) {
            String string4 = this.getQuotedString(CommandMap.get(this.longName).trim());
            this.logMessage("menu executable: " + string4);
            bl2 = this.windowsMenus.addMenuItem(this.submenu, this.longName, this.installDir, false, false, "", string4, "", "", string2, string3, this.workingDir);
            this.logMessage("added menu: " + bl2);
            if (bl2 && this.addDesktopShortcut) {
                bl2 = this.windowsMenus.addDesktopShortcut(this.submenu, this.longName, this.installDir, false, false, "", string4, "", "", string2, string3, this.workingDir);
                this.logMessage("added desktop icon: " + bl2);
            }
            this.addCreatedDirs(this.longName, this.windowsMenus.getCreatedDirs());
        } else {
            this.logMessage("unable to create java menu exe");
        }
        return bl2;
    }

    boolean createWindowsLauncher(String string, boolean bl) {
        boolean bl2 = true;
        File file = MenuUtilities.getJavaAppTemplate(bl);
        if (file != null && file.exists()) {
            String string2 = this.getMenuPrefix();
            try {
                File file2 = new File(this.installDir, string2 + ".exe");
                String string3 = file2.getPath();
                CommandMap.put(this.longName, string3);
                this.logMessage("created " + this.longName + " with launcher named: " + string3);
                if (file2.exists()) {
                    file2.delete();
                }
                FileSystem.copyFile(file, file2);
                String string4 = this.createPropertiesFile(string, this.commandLineArguments, string2);
                if (string4 == null) {
                    this.logMessage("    unable to create launcher for " + this.longName);
                    bl2 = false;
                } else {
                    bl2 = true;
                    this.logMessage("    creating the launcher: " + file2.getPath());
                    if (this.getPropertyList().getBooleanProperty("javaAppFilesSigned", false)) {
                        this.logMessage("    launcher signed");
                    }
                    if (this.menuAutoUpdate) {
                        this.logMessage(" don't add " + string4 + " to the java menus");
                    } else {
                        this.addJavaMenu(string4);
                    }
                    this.logMessage("          submenu " + this.submenu);
                    this.logMessage("        menu item " + this.longName);
                    this.logMessage("      install dir " + this.installDir);
                    this.logMessage("       executable " + file2.getName());
                    this.logMessage("property cmd args " + this.commandLineArguments);
                }
            }
            catch (Exception var6_7) {
                bl2 = false;
                this.logMessage(var6_7.getMessage());
                CustomInstaller.logException("Unable to create EXE launcher.", var6_7);
            }
        }
        return bl2;
    }

    private boolean addWindowsPlainMenuItem(String string, String string2, boolean bl) {
        File file;
        Object object;
        String string3 = this.getWindowsUser();
        boolean bl2 = false;
        if (!(this.javaAppMenu || (file = new File(this.installDir, this.executableFile)).exists())) {
            object = new File(this.installDir, this.longName + ".bat");
            try {
                String string4;
                this.logMessage("writing a batch file: " + object);
                FileWriter fileWriter = new FileWriter(object.getPath());
                PrintWriter printWriter = new PrintWriter(fileWriter);
                printWriter.println("@echo off");
                if (!(this.workingDir.length() <= 0 || this.installDir.equalsIgnoreCase(this.workingDir))) {
                    string4 = this.workingDir.toLowerCase();
                    if (string4.startsWith(this.installDir.toLowerCase())) {
                        string4 = this.workingDir.substring(this.installDir.length());
                        if (string4.startsWith(File.separator)) {
                            string4 = string4.substring(1);
                        }
                    } else {
                        string4 = this.workingDir;
                    }
                    printWriter.println("cd " + Exec.quoteArg(string4));
                }
                string4 = this.executableFile;
                if (this.commandLineArguments.length() > 0) {
                    string4 = string4 + this.commandLineArguments;
                }
                printWriter.println(string4);
                printWriter.flush();
                fileWriter.flush();
                printWriter.close();
                fileWriter.close();
                this.logMessage("batch file written");
                this.executableFile = object.getName();
                this.commandLineArguments = "";
            }
            catch (Exception var10_10) {
                this.logMessage(var10_10.getMessage());
            }
        }
        if (this.installAsService) {
            boolean bl3 = true;
            object = new WindowsServices();
            bl2 = object.installService(this.longName, this.longName, this.executableFile, bl3);
            this.logMessage("installed as service: " + bl2);
        } else {
            bl2 = this.windowsMenus.addMenuItem(this.submenu, this.longName, this.installDir, this.javaAppMenu, this.useJavaConsole, string, this.executableFile, this.commandLineArguments, "", string2, string3, this.workingDir);
            this.logMessage("added menu: " + bl2);
            if (bl2 && this.addDesktopShortcut) {
                bl2 = this.windowsMenus.addDesktopShortcut(this.submenu, this.longName, this.installDir, false, false, "", this.executableFile, this.commandLineArguments, "", string2, string3, this.workingDir);
                this.logMessage("added desktop icon: " + bl2);
            }
            this.addCreatedDirs(this.longName, this.windowsMenus.getCreatedDirs());
        }
        if (!bl2) {
            this.logMessage(WindowsUtils.getLastError());
        }
        return bl2;
    }

    private String getMenuPrefix() {
        String string = this.longName;
        int n = string.indexOf(" ");
        while (n > -1) {
            string = string.substring(0, n) + string.substring(n + 1);
            n = string.indexOf(" ");
        }
        return string;
    }

    private String getWindowsUser() {
        String string = "currentUser";
        if (this.allUsers) {
            string = "allUsers";
        }
        return string;
    }

    private boolean installedInProtectedDir() {
        boolean bl = false;
        String string = WindowsDirs.getProgramManagerDirectory().toLowerCase();
        if (this.installDir.toLowerCase().startsWith(string)) {
            bl = true;
        }
        this.logMessage("installed in programs file dir: " + bl);
        if (!bl) {
            String string2 = WindowsDirs.getWindowsDirectory().toLowerCase();
            if (this.installDir.toLowerCase().startsWith(string2)) {
                bl = true;
            }
            this.logMessage("installed in windows system dir: " + bl);
        }
        return bl;
    }

    String createPropertiesFile(String string, String string2, String string3) {
        String string4 = null;
        String string5 = WindowsMenus.getExecutable(this.installDir, this.javaAppMenu, this.useJavaConsole, string, this.executableFile);
        String string6 = WindowsMenus.getArguments(this.installDir, this.javaAppMenu, this.useJavaConsole, string, this.executableFile, string2);
        int n = this.executableFile.indexOf(32);
        if (!(n == -1 || this.executableFile.startsWith("\""))) {
            this.executableFile = "\"" + this.executableFile + "\"";
        }
        this.logMessage("saving properties for menu");
        this.logMessage("programName: " + this.longName);
        this.logMessage("execFilename: " + string5);
        this.logMessage("args: " + string6);
        PropertyList propertyList = new PropertyList();
        propertyList.setProperty("programName", this.longName);
        propertyList.setProperty("execFilename", string5);
        propertyList.setProperty("args", "-Dswing.aatext=true " + string6);
        if (!(this.setJvmVersion(propertyList, "jvmRequiredVersion") || this.setJvmVersion(propertyList, "jvmMinVersion") || this.setJvmVersion(propertyList, "jvmMaxVersion"))) {
            this.getPropertyList().setProperty("jvmMinVersion", "1.5");
            this.setJvmVersion(propertyList, "jvmMinVersion");
        }
        if (!this.workingDir.equals(this.installDir)) {
            this.logMessage("startDir: " + this.workingDir);
            propertyList.setProperty("startDir", this.workingDir);
        }
        File file = new File(this.installDir, "JExpress");
        this.makeJExpressSubdir(string3, file);
        String string7 = "JExpress" + File.separator + string3 + ".properties";
        file = new File(this.installDir, string7);
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            propertyList.save(fileOutputStream, "Menu for " + this.longName);
            fileOutputStream.close();
            string4 = string7;
        }
        catch (Exception var11_12) {
            this.logMessage("unable to create propropertiesFilename: " + string7);
        }
        return string4;
    }

    private boolean setJvmVersion(PropertyList propertyList, String string) {
        boolean bl = false;
        String string2 = this.getPropertyList().getProperty(string);
        if (string2 != null && string2.length() > 0) {
            propertyList.setProperty(string, string2);
            bl = true;
            this.logMessage(string + ": " + string2);
        }
        return bl;
    }

    boolean needUpdater() {
        return !this.getPropertyList().getBooleanProperty("autoupdateNever");
    }

    void createUpdateOnDemandMenu(String string) {
        if (this.getPropertyList().getBooleanProperty("autoupdateOnDemand")) {
            boolean bl = false;
            String string2 = this.getCommandPrefix(this.getUpdaterClasspath(), this.useJavaConsole);
            this.makeJExpressSubdir(string, new File(this.installDir, "JExpress"));
            String string3 = "";
            string3 = OS.isWindows() ? MenuUtilities.getWindowsIconFilename("jexupd") : (OS.isMac() ? MenuUtilities.getIconFilename("jexupd", "icns") : MenuUtilities.getKdeIconFilename("jexupd"));
            this.logMessage("update icon filename: " + string3);
            String string4 = "update";
            this.longName = "Update " + string;
            this.shortName = "update";
            this.javaAppMenu = true;
            this.useJavaConsole = false;
            this.executableFile = "com.denova.JExpress.Updater.JExpressUpdater";
            this.commandLineArguments = "";
            this.iconFilename = string3;
            this.allUsers = false;
            this.menuAutoUpdate = false;
            this.addDesktopShortcut = this.getPropertyList().getBooleanProperty("onDemandDesktopShortcut", true);
            this.logMessage("onDemandDesktopShortcut: " + this.addDesktopShortcut);
            if (OS.isSecureWindows() && this.installedInProtectedDir()) {
                bl = true;
                this.logMessage("update on demand must run as admin on secure Windows");
            } else if (OS.isMacOsX() && this.installDir.startsWith("/Applications")) {
                bl = true;
                this.logMessage("update on demand must run as admin on Mac when installer dir /Applications");
            }
            this.installAsService = false;
            this.addMenuItem(this.longName, string2, this.getUpdaterClasspath(), bl);
        }
    }

    void saveUpdaterMenuSettings(PropertyList propertyList) {
        File file = this.getUpdaterDir();
        if (this.updateControlProperties == null) {
            this.updateControlProperties = new PropertyList();
        }
        if (this.loadUpdateControlPropertyList(file)) {
            Object object;
            Object object2;
            if (this.menuAutoUpdate) {
                object2 = this.getMenuExecutable(propertyList);
                if (this.nonJavaAutoMenu) {
                    this.updateControlProperties.setBooleanProperty("startNonJavaApp", true);
                    this.updateControlProperties.setProperty("autoUpdateExec", (String)object2);
                    if (OS.isUnix()) {
                        UnixCommands.chmod("0754", (String)object2);
                        this.logMessage("set executable permissions for " + (String)object2);
                    }
                } else if (this.autoUpdate) {
                    this.updateControlProperties.setProperty("programClass", (String)object2);
                }
                object = this.getMenuCommandLineArguments(propertyList);
                this.updateControlProperties.setProperty("commandLineArgs", (String)object);
            }
            this.updateControlProperties.setProperty("author", this.getPropertyList().getProperty("author", ""));
            this.updateControlProperties.setBooleanProperty("useJavaConsole", this.useJavaConsole);
            if (this.iconFilename == null || this.iconFilename.length() <= 0) {
                this.logMessage("no icon filename defined");
            } else {
                object2 = new File(this.iconFilename);
                if (object2.getParent() == null) {
                    this.logMessage("icon file doesn't have a parent");
                } else {
                    object = new File(object2.getParent());
                    if (object.getName() == null || object2.getName() == null) {
                        this.logMessage("icon filename not defined properly");
                    } else {
                        File file2 = new File(object.getName(), object2.getName());
                        String string = file2.getPath();
                        this.updateControlProperties.setProperty("programIcon", string);
                        this.logMessage("relative program icon name: " + string);
                    }
                }
            }
            this.saveUpdateControlPropertyList(file);
        }
    }

    void installUpdater() {
        if (!this.updaterInstalled) {
            try {
                File file = this.getUpdaterDir();
                this.updateControlProperties = new PropertyList();
                if (!this.loadUpdateControlPropertyList(file)) {
                    this.updateControlProperties.setProperty("maxMinsToDownloadFile", 15);
                    this.updateControlProperties.setProperty("userName", "");
                    this.updateControlProperties.setProperty("password", "");
                }
                this.updateControlProperties.setIntProperty("totalFileSize", this.getPropertyList().getIntProperty("uncompressedTotalSize"));
                this.updateControlProperties.setLongProperty("totalFileCount", this.getPropertyList().getIntProperty("totalCompressedFiles"));
                this.updateControlProperties.setProperty("licensePrimaryContact", this.getPropertyList().getProperty("licensePrimaryContact", ""));
                this.updateControlProperties.setProperty("licenseIdCode", this.getPropertyList().getProperty("licenseIdCode", ""));
                this.updateControlProperties.setProperty("licenseEndUser", this.getPropertyList().getProperty("licenseEndUser", ""));
                if (this.getPropertyList().getProperty("proxyHost") != null) {
                    this.updateControlProperties.setProperty("proxyHost", this.getPropertyList().getProperty("proxyHost", ""));
                    this.updateControlProperties.setProperty("proxyPort", this.getPropertyList().getProperty("proxyPort", ""));
                    this.updateControlProperties.setProperty("proxyUserName", this.getPropertyList().getProperty("proxyUserName", ""));
                    this.updateControlProperties.setProperty("proxyPassword", this.getPropertyList().getProperty("proxyPassword", ""));
                }
                boolean bl = true;
                boolean bl2 = true;
                boolean bl3 = true;
                boolean bl4 = true;
                String string = this.getExtraJvmParameters(bl, bl2, bl3, bl4);
                this.updateControlProperties.setProperty("jvmParameters", string);
                String string2 = CustomInstaller.getUserClasspath();
                this.updateControlProperties.setProperty("userClasspath", string2);
                String string3 = this.getPropertyList().getProperty("packageName");
                this.updateControlProperties.setProperty("programName", string3);
                this.updateControlProperties.setProperty("minimizedImageFilename", this.getPropertyList().getProperty("minimizedImageFilename", ""));
                this.saveUpdateControlPropertyList(file);
            }
            catch (Exception var1_2) {
                CustomInstaller.logException("Unable to install auto-update.", var1_2);
            }
            this.updaterInstalled = true;
        }
    }

    private boolean loadUpdateControlPropertyList() {
        boolean bl = this.loadUpdateControlPropertyList(this.getUpdaterDir());
        return bl;
    }

    private boolean loadUpdateControlPropertyList(File file) {
        boolean bl = false;
        try {
            FileInputStream fileInputStream = new FileInputStream(this.updateControlPropertiesFilename(file));
            if (fileInputStream != null) {
                this.updateControlProperties.load(fileInputStream);
                fileInputStream.close();
                bl = true;
            }
        }
        catch (Exception var3_4) {
            bl = false;
        }
        return bl;
    }

    public boolean saveUpdateControlPropertyList() {
        boolean bl = this.saveUpdateControlPropertyList(this.getUpdaterDir());
        return bl;
    }

    public boolean saveUpdateControlPropertyList(File file) {
        boolean bl = false;
        String string = this.updateControlPropertiesFilename(file);
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(string);
            this.updateControlProperties.save(fileOutputStream, "JExpress Update Properties");
            fileOutputStream.close();
            bl = true;
        }
        catch (Exception var4_5) {
            bl = false;
            this.logMessage("unable to save update properties " + string);
        }
        return bl;
    }

    private File getUpdaterDir() {
        File file = null;
        try {
            file = new File(this.getApplicationDirectory(), "JExpress");
        }
        catch (Exception var2_2) {
            CustomInstaller.logException("Unable to install auto-update.", var2_2);
        }
        return file;
    }

    private String updateControlPropertiesFilename(File file) {
        File file2 = new File(file, "update.control");
        return file2.getPath();
    }

    private void addJavaMenusToUpdater() {
        String string = "";
        Iterator iterator = this.javaMenus.iterator();
        while (iterator.hasNext()) {
            if (string.length() > 0) {
                string = string + ",";
            }
            String string2 = (String)iterator.next();
            string = string + string2;
        }
        if (this.loadUpdateControlPropertyList()) {
            this.updateControlProperties.setProperty("javaMenus", string);
            this.saveUpdateControlPropertyList();
        }
    }

    private String getCommandPrefix(String string) {
        return this.getCommandPrefix(string, false);
    }

    private String getCommandPrefix(String string, boolean bl) {
        String string2 = this.getPropertyList().getProperty("jvmCommandName", "");
        this.logMessage("jvm command name: " + string2);
        String string3 = JRE.getNativeExecutable(string2, bl);
        this.logMessage("executable: " + string3);
        boolean bl2 = true;
        boolean bl3 = true;
        boolean bl4 = true;
        boolean bl5 = true;
        String string4 = this.getExtraJvmParameters(bl2, bl3, bl4, bl5);
        if (string.indexOf(" ") != -1 && string.indexOf("\"") == -1) {
            string = "\"" + string + "\"";
        }
        this.logMessage("classpath: " + string);
        return this.getQuotedString(string3) + " " + string4 + JRE.getClasspathSwitch() + " " + string + " ";
    }

    private String getExtraJvmParameters(boolean bl, boolean bl2, boolean bl3, boolean bl4) {
        String string = this.getPropertyList().getProperty("installJvmParameters", "");
        return this.getExtraJvmParameters(string, bl, bl2, bl3, bl4);
    }

    private String getExtraJvmParameters(String string, boolean bl, boolean bl2, boolean bl3, boolean bl4) {
        String string2 = string;
        if (string2.length() > 0) {
            if (!string2.endsWith(" ")) {
                string2 = string2 + " ";
            }
            string2 = this.convertVariables(string2, bl, bl2, bl3, bl4);
            string2 = JRE.convertOnlyFileSeparators(string2);
        }
        this.logMessage("jvmParameters: " + string2);
        return string2;
    }

    private String getExtraMacJvmParameters(boolean bl, boolean bl2, boolean bl3, boolean bl4) {
        String string = this.getExtraJvmParameters(bl, bl2, bl3, bl4);
        if (string.length() > 0) {
            this.logMessage("extra jvm parameters: " + string);
            if (string.startsWith("-splash:") || string.startsWith("-splash\\:")) {
                this.logMessage("splash file param found");
                int n = "-splash:".length();
                if (string.startsWith("-splash\\:")) {
                    n = "-splash\\:".length();
                }
                int n2 = string.trim().indexOf(" ");
                this.logMessage("index: " + n2);
                if (n2 > 0) {
                    this.logMessage("extra jvm params have a space");
                    this.splashFile = string.substring(n, n2).trim();
                    this.logMessage("splash file: " + this.splashFile);
                    if (string.length() > n2 + 1) {
                        string = string.substring(n2 + 1);
                        this.logMessage("extraJvmParameters: " + string);
                    } else {
                        this.logMessage("no more extra jvm params");
                        string = "";
                    }
                } else {
                    this.logMessage("no space in extra jvm params");
                    this.splashFile = string.substring(n).trim();
                    this.logMessage("splash file: " + this.splashFile);
                    string = "";
                }
                n2 = this.splashFile.indexOf("[$AppDir]");
                if (n2 >= 0) {
                    String string2;
                    this.logMessage("app dir found in splash file");
                    this.splashFile = string2 = this.splashFile.substring(0, n2) + "$APP_PACKAGE/.." + this.splashFile.substring(n2 + "[$AppDir]".length());
                } else if (!this.splashFile.startsWith(File.separator)) {
                    this.splashFile = "$APP_PACKAGE/.." + File.separator + this.splashFile;
                }
                this.logMessage("mac splashFile: " + this.splashFile);
            }
        }
        if (string.length() > 0) {
            if (!string.endsWith(" ")) {
                string = string + " ";
            }
            while (string.indexOf("[$AppDir]") != -1) {
                String string3;
                int n = string.indexOf("[$AppDir]");
                string = string3 = string.substring(0, n) + "$APP_PACKAGE/.." + string.substring(n + "[$AppDir]".length());
            }
        }
        this.logMessage("mac jvmParameters: " + string);
        return string;
    }

    private String convertVariables(String string) {
        return this.convertVariables(string, true, true, true, true);
    }

    private String convertVariables(String string, boolean bl, boolean bl2, boolean bl3, boolean bl4) {
        return this.convertVariables(string, bl, bl2, bl3, bl4, true);
    }

    private String convertVariables(String string, boolean bl, boolean bl2, boolean bl3, boolean bl4, boolean bl5) {
        String string2 = string;
        this.logMessage("escape separators: " + bl5);
        if (string2 != null) {
            String string3;
            String string4;
            String string5;
            if (bl) {
                while (string2.indexOf("[$AppDir]") != -1) {
                    string3 = this.installDir;
                    if (bl5) {
                        string3 = this.escapeOSSeparators(this.installDir);
                    }
                    int n = string2.indexOf("[$AppDir]");
                    string2 = string5 = string2.substring(0, n) + string3 + string2.substring(n + "[$AppDir]".length());
                }
                this.logMessage("args after AppDir changed: " + string2);
            }
            if (bl2) {
                string3 = this.getJavaHome();
                while (string2.indexOf("[$JavaHomeDir]") != -1) {
                    String string6 = string3;
                    if (bl5) {
                        string6 = this.escapeOSSeparators(string3);
                    }
                    int n = string2.indexOf("[$JavaHomeDir]");
                    string2 = string4 = string2.substring(0, n) + string6 + string2.substring(n + "[$JavaHomeDir]".length());
                }
                this.logMessage("args after JavaHome changed: " + string2);
            }
            if (bl3) {
                String string7 = string3 = this.getUserHome();
                if (bl5) {
                    string7 = this.escapeOSSeparators(string3);
                }
                while (string2.indexOf("[$UserHomeDir]") != -1) {
                    int n = string2.indexOf("[$UserHomeDir]");
                    string2 = string4 = string2.substring(0, n) + string7 + string2.substring(n + "[$UserHomeDir]".length());
                }
                this.logMessage("args after UserHome changed: " + string2);
            }
            if (bl4) {
                while (string2.indexOf("[$WorkingDir]") != -1) {
                    string3 = this.workingDir;
                    if (bl5) {
                        string3 = this.escapeOSSeparators(this.workingDir);
                    }
                    int n = string2.indexOf("[$WorkingDir]");
                    string2 = string5 = string2.substring(0, n) + string3 + string2.substring(n + "[$WorkingDir]".length());
                }
                this.logMessage("args after WorkingDir changed: " + string2);
            }
        }
        return string2;
    }

    private String escapeOSSeparators(String string) {
        String string2 = string;
        StringBuffer stringBuffer = new StringBuffer();
        for (int i = 0; i < string2.length(); ++i) {
            if (string2.charAt(i) == ':') {
                stringBuffer.append('\\');
            }
            stringBuffer.append(string2.charAt(i));
        }
        if (stringBuffer.length() > 0) {
            string2 = stringBuffer.toString();
        }
        return string2;
    }

    private String getWorkingDir(String string) {
        this.logMessage("install dir: " + this.installDir);
        if (string == null || string.trim().length() <= 0) {
            string = this.installDir;
        } else {
            File file;
            string = string.trim();
            string = string.replace('\\', File.separatorChar);
            string = string.replace('/', File.separatorChar);
            string = this.convertVariables(string, true, true, true, false);
            if (OS.isWindows()) {
                if (!(string.indexOf(58) == 1 || string.startsWith(File.separator))) {
                    string = this.installDir + File.separator + string;
                }
            } else if (!string.startsWith(File.separator)) {
                string = this.installDir + File.separator + string;
            }
            if (!(file = new File(string)).exists()) {
                file.mkdirs();
            }
        }
        this.logMessage("final working dir: " + string);
        return string;
    }

    private String getClasspath() {
        String string;
        if (this.getPropertyList().getBooleanProperty("autoupdateEveryStartup") && this.menuAutoUpdate) {
            string = this.getUpdaterClasspath();
            this.logMessage("classpath with auto-update: " + string);
        } else {
            string = CustomInstaller.getUserClasspath();
            this.logMessage("basic classpath: " + string);
            if (!(this.workingDir.length() <= 0 || this.installDir.equalsIgnoreCase(this.workingDir))) {
                String string2 = this.workingDir;
                if (this.workingDir.startsWith(this.installDir) && (string2 = this.workingDir.substring(this.installDir.length())).startsWith(File.separator)) {
                    string2 = string2.substring(1);
                }
                string = string + File.pathSeparator;
                string = string + string2;
                this.logMessage("final classpath: " + string);
            }
        }
        return string;
    }

    private String getUpdaterClasspath() {
        String string = "." + File.separator + "JExpress" + File.separator + this.getUpdaterJarFilename();
        return string;
    }

    private String getCurrentDir() {
        String string = this.getApplicationDirectory();
        if (string.indexOf(" ") != -1) {
            string = "\"" + string + "\"";
        }
        return string;
    }

    private boolean getUseJavaCommandPrefix(PropertyList propertyList) {
        return propertyList.getBooleanProperty("useJavaCommandPrefix", false);
    }

    private boolean getUseJavaConsole(PropertyList propertyList) {
        boolean bl = propertyList.getBooleanProperty("useJavaCommandPrefix", false) ? propertyList.getBooleanProperty("useJavaConsole", false) : false;
        return bl;
    }

    private boolean autoupdateEveryStartup(PropertyList propertyList) {
        return this.getPropertyList().getBooleanProperty("autoupdateEveryStartup");
    }

    private String getExecutableFile(PropertyList propertyList) {
        String string = this.autoupdateEveryStartup(propertyList) && this.menuAutoUpdate ? "com.denova.JExpress.Updater.JExpressUpdater" : this.getMenuExecutable(propertyList);
        return string;
    }

    private String getMenuExecutable(PropertyList propertyList) {
        String string = propertyList.getProperty("executableFile");
        if (!(string == null || this.javaAppMenu)) {
            string = string.replace('/', File.separatorChar);
            if ((string = string.replace('\\', File.separatorChar)).startsWith(File.separator) || OS.isWindows() && string.indexOf(58) > 0) {
                File file = new File(string);
                if (OS.isUnix() && file.exists()) {
                    this.setUnixExecPermissions(file);
                }
                this.logMessage("executableFile contains the full path");
            } else if (this.installDir.equals(this.workingDir)) {
                this.logMessage("install and working dirs the same");
            } else {
                File file = new File(this.workingDir, string);
                File file2 = new File(this.installDir, string);
                if (file2.exists() && !file.exists()) {
                    if (OS.isUnix()) {
                        this.setUnixExecPermissions(file2);
                    }
                    string = this.getExecRelativeToWorkingDir(string);
                } else if (OS.isUnix()) {
                    this.setUnixExecPermissions(file2);
                    this.setUnixExecPermissions(file);
                }
            }
        }
        return string;
    }

    private String getExecRelativeToWorkingDir(String string) {
        String string2 = string;
        String string3 = this.workingDir;
        if (this.workingDir.startsWith(this.installDir)) {
            string3 = this.workingDir.substring(this.installDir.length() + 1);
            this.logMessage("working dir is subdir of install dir: " + string3);
        }
        if (OS.isWindows() && string3.indexOf(58) > 0 || string3.indexOf(File.separatorChar) == 0) {
            File file = new File(this.installDir, string2);
            string2 = file.getPath();
            this.logMessage("exec must include full path because working dir is not relative to install");
        } else {
            String string4 = ".." + File.separator;
            if (string3.endsWith(File.separator)) {
                string3 = string3.substring(0, string3.length() - 1);
            }
            String string5 = string4;
            int n = string3.indexOf(File.separator);
            while (n >= 0) {
                string5 = string5 + string4;
                string3 = string3.substring(n + 1);
                n = string3.indexOf(File.separator);
            }
            string2 = string5 + string2;
            this.logMessage("add prefix to reach install dir from working dir: " + string5);
        }
        return string2;
    }

    private void setUnixExecPermissions(File file) {
        if (file.exists()) {
            String string = "0754";
            if (OS.isMacOsX() && file.isDirectory()) {
                string = "-R 0755";
            }
            UnixCommands.chmod(string, file.getPath());
        }
    }

    private String getCommandLineArguments(PropertyList propertyList) {
        String string = this.autoupdateEveryStartup(propertyList) && this.menuAutoUpdate ? this.getUpdateEveryStartupCommandLineArguments(propertyList) : this.getMenuCommandLineArguments(propertyList);
        this.logMessage("command line args: " + string);
        return string;
    }

    private String getMenuCommandLineArguments(PropertyList propertyList) {
        String string = propertyList.getProperty("commandLineArguments", "");
        if (string != null) {
            string = string.trim();
            string = OS.isWindows() && !this.javaAppMenu || this.autoupdateEveryStartup(propertyList) && this.menuAutoUpdate ? this.convertVariables(string, true, true, true, true, false) : this.convertVariables(string);
            string = string.replace('\\', File.separatorChar);
        }
        return string;
    }

    private String getUpdateEveryStartupCommandLineArguments(PropertyList propertyList) {
        this.twoStageAutoUpdate = !propertyList.getBooleanProperty("menuRunAsAdmin", false) && (OS.isSecureWindows() && this.installedInProtectedDir() || OS.isMacOsX() && this.installDir.startsWith("/Applications"));
        String string = this.twoStageAutoUpdate ? "autoUpdateCheck" : "autoUpdateFull";
        return string;
    }

    private String getUpdaterJarFilename() {
        return "JExpressUpdater.jar";
    }

    private String getApplicationDirectory() {
        return this.getPropertyList().getProperty("applicationDirectory", "");
    }

    private String getJavaHome() {
        String string = JRE.getJavaHome();
        if (string.endsWith(File.separator)) {
            int n = string.lastIndexOf(File.separator);
            string = string.substring(0, n);
        }
        return string;
    }

    private String getUserHome() {
        String string = System.getProperty("user.home", "");
        if (string.endsWith(File.separator)) {
            int n = string.lastIndexOf(File.separator);
            string = string.substring(0, n);
        }
        return string;
    }

    private void configVersionInfo(String string) {
        this.logMessage("updating version info for " + string);
        try {
            File file = new File(this.installDir, "JExpress");
            File file2 = new File(file, "version.txt");
            PropertyList propertyList = new PropertyList();
            FileInputStream fileInputStream = new FileInputStream(file2);
            propertyList.load(fileInputStream);
            fileInputStream.close();
            propertyList.setProperty("packageName", string);
            this.removeBlankValues(propertyList);
            propertyList.save(file2.getPath());
            this.logMessage("new package name: " + propertyList.getProperty("packageName", ""));
            this.logMessage("saved version info in " + file2.getPath());
        }
        catch (Exception var2_3) {
            this.logMessage("unable to update version info for " + string);
        }
    }

    private void removeBlankValues(PropertyList propertyList) {
        String string;
        String string2 = propertyList.getProperty("packageCopyright");
        if (string2 == null || string2.length() <= 0) {
            propertyList.removeProperty("packageCopyright");
        }
        if ((string = propertyList.getProperty("webSite")) == null || string.length() <= 0) {
            propertyList.removeProperty("webSite");
        }
    }

    private void addCreatedDirs(String string, List list) {
        if (list == null || list.isEmpty()) {
            this.logMessage("no created subdirectories for " + string);
        } else {
            if (this.createdDirs == null) {
                this.createdDirs = new Vector();
            }
            this.logMessage("created dirs for " + string + ": " + list.size());
            int n = list.size() - 1;
            while (n >= 0) {
                String string2;
                if (this.createdDirs.contains(string2 = (String)list.get(n--))) continue;
                this.createdDirs.add(string2);
                this.logMessage("created dir: " + string2);
            }
        }
    }

    private void saveCreatedDirs() {
        if (this.createdDirs == null || this.createdDirs.size() <= 0) {
            this.logMessage("didn't create any dirs for menus");
        } else {
            String string = StringConversions.fromList(this.createdDirs);
            this.getPropertyList().setProperty("createdMenuDirs", string);
            this.logMessage("created dirs for menus: " + string);
        }
    }

    private void trackInstall() {
        if (this.getPropertyList().getBooleanProperty("trackConversions", false)) {
            String string = this.getPropertyList().getProperty("packageName", "");
            String string2 = CustomInstaller.getProductUrl();
            new JExpressConvertAPI(string, string2, "install");
        }
    }

    private void makeJExpressSubdir(String string, File file) {
        MakeDirs makeDirs = new MakeDirs();
        makeDirs.mkdirs(file);
        if (OS.isWindows()) {
            WindowsCommands.hideFile(file.getPath());
        }
        this.addCreatedDirs(string, makeDirs.getCreatedDirs());
    }

    private String getQuotedString(String string) {
        if (!(string.indexOf(" ") < 0 || string.startsWith("\""))) {
            string = "\"" + string + "\"";
        }
        return string;
    }

    private void logMessage(String string) {
        MenuUtilities.logMessage(string);
    }

    private class MenusSwinger
    extends Swinger {
        boolean ok;

        private MenusSwinger() {
            this.ok = false;
        }

        public void swingBefore() {
            CustomInstaller.log("Creating menus");
            MenusPanel.this.logMessage("creating menus");
            MenusPanel.this.updateProgressBarLabel(MenusPanel.this.progressLabel);
        }

        public void workInBackground() {
            try {
                MenusPanel.this.initMenus();
                if (MenusPanel.this.addMenus()) {
                    this.ok = true;
                    MenusPanel.this.saveCreatedDirs();
                    MenusPanel.this.logMessage("finished configuring menus");
                } else {
                    this.ok = false;
                    MenusPanel.this.logMessage("Unable to add menus.");
                }
            }
            catch (Exception var1_1) {
                this.ok = false;
                MenusPanel.this.logMessage("Unexpected error adding menus.");
                CustomInstaller.logException("Unable to set up menus.", var1_1);
            }
            MenusPanel.this.trackInstall();
        }

        public void swingAfter() {
            MenusPanel.this.updated = true;
            if (this.ok) {
                CustomInstaller.log("Finished creating menus");
                MenusPanel.this.logMessage("finished creating menus");
                MenusPanel.this.showNextPanel();
            } else {
                MenusPanel.this.updateProgressBarLabel("Unable to add menus. See errors.log.");
                MenusPanel.this.logMessage("unable to add menus");
                MenusPanel.this.nextButtonEnabled = true;
                MenusPanel.this.setNextButtonEnabled(true);
                MenusPanel.this.logMessage("enabled next button");
            }
        }
    }

}
