/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.CustomUninstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.Installer;
import com.denova.JExpress.Installer.InstallerConstants;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.Installer.MenuUtilities;
import com.denova.JExpress.Installer.StatusPanel;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.FileSystem;
import com.denova.io.JarFile;
import com.denova.io.Log;
import com.denova.io.TempFiles;
import com.denova.io.Zipper;
import com.denova.runtime.CommandMap;
import com.denova.runtime.Exec;
import com.denova.runtime.JRE;
import com.denova.runtime.MacOS;
import com.denova.runtime.OS;
import com.denova.runtime.UnixMenu;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsConstants;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsJavaApp;
import com.denova.runtime.WindowsRegistry;
import com.denova.runtime.WindowsUtils;
import com.denova.ui.Swinger;
import com.denova.util.PropertyList;
import com.denova.util.StringConversions;
import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.charset.CharacterCodingException;
import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;
import java.util.Enumeration;
import java.util.List;
import java.util.Vector;
import javax.swing.JLabel;

public class UninstallPanel
extends StatusPanel
implements JExpressConstants,
WindowsConstants,
InstallerConstants,
InstallPropertyNames {
    public static final String WinUninstallKeyPrefix = "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall";
    private static final String Quote = "\"";
    private static final String UninstallSpecFilename = "uninstall";
    private static Log log;
    private String programName;
    private String programID;
    private String appDir;
    private String javaHomeDir;
    private File jExpressDir;
    private File uninstallerDir;
    private File commandFile;
    private String progressLabel;
    private String winAppDataDir = null;
    private String winUninstallerExeFilename = null;
    private boolean uninstallDone = false;
    private String uninstallerCommand = null;

    public UninstallPanel(PropertyList propertyList) {
        super(propertyList);
        this.programName = this.getPropertyList().getProperty("packageName");
        this.programID = this.programName.trim();
        this.progressLabel = Localize.strings().getString("Configuring") + " " + Localize.strings().getString("SettingUpUninstaller");
        this.progressBarLabel.setText(this.progressLabel);
        log = new Log("uninstall");
    }

    public synchronized void enter() {
        if (this.uninstallDone) {
            this.showNextPanel();
        } else {
            UninstallSwinger uninstallSwinger = new UninstallSwinger();
            uninstallSwinger.execute();
        }
    }

    public boolean isOk() {
        this.logMessage("isOk: " + this.uninstallDone);
        return this.uninstallDone;
    }

    public void reset() {
        this.uninstallDone = false;
    }

    public String getName() {
        return "UninstallPanel";
    }

    public int getEstimatedTime() {
        return 15;
    }

    private void saveUninstallProperties(File file) {
        try {
            Color color;
            PropertyList propertyList = new PropertyList();
            File file2 = new File(file, "uninstall.control");
            propertyList.setBooleanProperty("silentUninstall", this.getPropertyList().getBooleanProperty("silentUninstaller", false));
            propertyList.setBooleanProperty("showFrame", this.getPropertyList().getBooleanProperty("showFrame", true));
            propertyList.setBooleanProperty("clickFreeUninstaller", this.getPropertyList().getBooleanProperty("clickFreeUninstaller", false));
            propertyList.setBooleanProperty("promptUserBeforeUninstalling", this.getPropertyList().getBooleanProperty("promptUserBeforeUninstalling", true));
            String string = this.getPropertyList().getProperty("lookAndFeelInterface", "Native");
            propertyList.setProperty("lookAndFeelInterface", string);
            if (string.equals("Metal") || string.equals("NimROD") || string.equals("Synth")) {
                propertyList.setProperty("lafTheme", this.getPropertyList().getProperty("lafTheme", ""));
            }
            if ((color = CustomInstaller.getBackgroundColor()) != null) {
                propertyList.setIntProperty("backgroundColor", color.getRGB());
            }
            if ((color = CustomInstaller.getTextColor()) != null) {
                propertyList.setIntProperty("textColor", color.getRGB());
            }
            if ((color = CustomInstaller.getProgressBarColor()) != null) {
                propertyList.setIntProperty("progressBarColor", color.getRGB());
            }
            FileOutputStream fileOutputStream = new FileOutputStream(file2);
            propertyList.save(fileOutputStream, "Uninstaller Properties");
            fileOutputStream.close();
        }
        catch (Exception var2_3) {
            String string = "Unable to create uninstaller properties.";
            CustomInstaller.logException(string, var2_3);
        }
    }

    private void copyCustomUninstallFiles() {
        boolean bl = true;
        File file = new File(this.jExpressDir, "CustomUninstaller.zip");
        try {
            JarFile jarFile = new JarFile(this.getInstallerJarFilename());
            jarFile.unarchiveFileToDirectory("CustomUninstaller.zip", this.jExpressDir);
            jarFile.close();
            TempFiles.add(file);
            this.logMessage("CustomUninstaller.zip extracted from " + this.getInstallerJarFilename() + " to " + this.jExpressDir);
        }
        catch (Exception var4_4) {
            if (CustomInstaller.getResourceAsFile("CustomUninstaller.zip", this.jExpressDir.getPath())) {
                this.logMessage("CustomUninstaller.zip extracted.");
            }
            bl = false;
        }
        if (bl) {
            bl = this.unpackFiles(file, this.uninstallerDir);
        }
        file.delete();
    }

    private boolean unpackFiles(File file, File file2) {
        boolean bl = true;
        try {
            this.logMessage("starting to unpack custom uninstaller");
            Zipper.unzipFilesToDirectory(file.getPath(), file2);
            this.logMessage("finished unpacking custom uninstaller");
        }
        catch (Exception var4_4) {
            String string = "Unable to unzip " + file.getParent() + " to " + file2.getPath();
            CustomInstaller.logException(string, var4_4);
        }
        return bl;
    }

    private String getInstallerJarFilename() {
        return "install.jar";
    }

    private String getUninstallerJarFilename() {
        return "JExpressUninstaller.jar";
    }

    private File getUninstallerJarFile() {
        File file = new File("JExpress", "uninstaller");
        return new File(file, this.getUninstallerJarFilename());
    }

    private String getApplicationDirectory() {
        return this.getPropertyList().getProperty("applicationDirectory");
    }

    private void createWindowsUninstaller() {
        CustomUninstaller customUninstaller;
        this.logMessage("creating Windows uninstaller");
        this.setUpUninstallerJar();
        boolean bl = true;
        String string = this.createWinUninstallExe(this.commandFile);
        if (string == null) {
            string = this.createUninstallBatchFile(this.commandFile);
            bl = false;
        }
        if ((customUninstaller = new CustomUninstaller()) != null) {
            String string2 = this.getPropertyList().getProperty("customUninstallerClass", "");
            customUninstaller.setCustomClasses(string2);
            this.trackUninstall(customUninstaller);
            this.deletePropertyStorage(customUninstaller);
            this.createWindowsRegistryDeleteInfo(customUninstaller);
            this.createWindowsMenusDeleteInfo(customUninstaller, this.appDir);
            this.addAutoStartupDeleteInfo(customUninstaller);
            this.writeWindowsCommandFile(customUninstaller);
            this.registerWindowsUninstaller(string, bl);
            this.deleteCreatedMenuDirs(customUninstaller);
            customUninstaller.deleteFile(string);
            customUninstaller.deleteDirIfEmpty(this.appDir);
            customUninstaller.save(this.appDir, this.programID);
            this.copyWinApiApp();
        } else {
            this.logMessage("Unable to configure JExpressUninstaller.");
        }
    }

    private void copyWinApiApp() {
        String string = WindowsUtils.getCommandProgramFilename();
        if (string == null) {
            this.logMessage("unable to get Windows api program");
        } else {
            try {
                File file = new File(string);
                File file2 = new File(this.jExpressDir, WindowsUtils.getWindowsCommandsFilename());
                FileSystem.copyFile(file, file2);
                this.logMessage("copied " + file.getName() + " to " + file2.getPath());
            }
            catch (Exception var2_3) {
                this.logMessage(var2_3.getMessage());
            }
        }
    }

    private void createUnixUninstaller() {
        this.logMessage("creating unix uninstaller");
        this.writeUnixCommandFile(this.commandFile);
        if (this.setUpUninstallerJar()) {
            this.writeUnixUninstallScript(this.commandFile);
        } else {
            this.logMessage("unable to set up uninstallJarFile");
        }
        this.logMessage("finished creating unix uninstaller");
    }

    private void createWindowsRegistryDeleteInfo(CustomUninstaller customUninstaller) {
        this.logMessage("creating windows registry delete info");
        customUninstaller.deleteSubkeyEntry("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall", this.programID);
        File file = new File(CustomInstaller.getTempDirectory(), "program.txt");
        if (file.exists()) {
            try {
                FileReader fileReader = new FileReader(file);
                BufferedReader bufferedReader = new BufferedReader(fileReader);
                String string = bufferedReader.readLine();
                bufferedReader.close();
                if (string != null) {
                    String string2 = string.trim();
                    this.logMessage("set up to remove appcompatflags for " + string2);
                    customUninstaller.deleteAttribute("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows NT\\CurrentVersion\\AppCompatFlags\\Compatibility\\Assistant\\Persisted", string2);
                    customUninstaller.deleteAttribute("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\AppCompatFlags\\Layers", string2);
                }
            }
            catch (Exception var5_4) {
                this.logMessage(var5_4.getMessage());
            }
        }
    }

    private void createWindowsMenusDeleteInfo(CustomUninstaller customUninstaller, String string) {
        String string2;
        String string3;
        this.logMessage("creating windows menus delete info");
        String string4 = this.getPropertyList().getProperty("submenu", "").replace('/', File.separatorChar);
        PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
        Enumeration enumeration = propertyList.propertyNames();
        while (enumeration.hasMoreElements()) {
            string2 = (String)enumeration.nextElement();
            string3 = propertyList.getProperty(string2);
            if (string3 == null) continue;
            PropertyList propertyList2 = new PropertyList();
            propertyList2.fromString(string3);
            if (!MenuUtilities.menuOk(propertyList2, this.getPropertyList())) continue;
            String string5 = propertyList2.getProperty("longName");
            if (string5 == null || string5.length() <= 0) {
                string5 = propertyList2.getProperty("shortName");
            }
            boolean bl = propertyList2.getBooleanProperty("menuAllUsers", false);
            String string6 = this.getWindowsUser(bl);
            customUninstaller.deleteWindowsMenuItem(string4, string5, string6);
            if (propertyList2.getBooleanProperty("menuDesktopShortcut", true)) {
                customUninstaller.deleteWindowsDesktopIcon(string4, string5, string6);
            }
            if (!propertyList2.getBooleanProperty("menuInstallAsService")) continue;
            if (propertyList2.getBooleanProperty("useJavaCommandPrefix", false)) {
                customUninstaller.removeWindowsJavaService(string5);
                continue;
            }
            String string7 = this.getWindowsExecutable(string5, propertyList2, string);
            customUninstaller.removeWindowsService(string5, string7);
        }
        if (this.getPropertyList().getBooleanProperty("autoupdateOnDemand", false)) {
            string2 = "Update " + this.programName;
            if (CustomInstaller.multipleComponents()) {
                string2 = "Update " + this.getPropertyList().getProperty("installType", this.programName);
            }
            customUninstaller.deleteWindowsMenuItem(string4, string2, "currentUser");
            this.logMessage("deleting on demand menu");
            if (this.getPropertyList().getBooleanProperty("onDemandDesktopShortcut")) {
                customUninstaller.deleteWindowsDesktopIcon(string4, string2, "currentUser");
                this.logMessage("deleting on demand desktop icon");
            }
        }
        if (this.getPropertyList().getBooleanProperty("autoupdateEveryStartup", false) && (string2 = this.getPropertyList().getProperty("secondaryUpdater")) != null) {
            string3 = CommandMap.get(string2);
            customUninstaller.deleteFile(string3);
            this.logMessage("deleting " + string2 + " secondary updater: " + string3);
        }
        this.logMessage("finished creating windows menus delete info");
    }

    private String getWindowsExecutable(String string, PropertyList propertyList, String string2) {
        String string3 = propertyList.getProperty("executableFile");
        boolean bl = propertyList.getBooleanProperty("useJavaCommandPrefix");
        File file = bl ? new File(string2, string + ".exe") : new File(string2, string3);
        return file.getPath();
    }

    private String getWindowsUser(boolean bl) {
        String string = "currentUser";
        if (bl) {
            string = "allUsers";
        }
        this.logMessage("menu for all users: " + bl);
        return string;
    }

    String getLauncherName(String string) {
        String string2 = string;
        int n = string2.indexOf(" ");
        while (n > -1) {
            string2 = string2.substring(0, n) + string2.substring(n + 1);
            n = string2.indexOf(" ");
        }
        return string2;
    }

    void writeWindowsCommandFile(CustomUninstaller customUninstaller) {
        String string;
        Object object;
        this.logMessage("writing windows command file");
        File file = new File(this.uninstallerDir, "specreg");
        String[] arrstring = new String[]{file.getPath()};
        customUninstaller.runThirdPartyApp("registry", arrstring);
        File file2 = new File(this.uninstallerDir, "specmenu");
        String[] arrstring2 = new String[]{file2.getPath()};
        customUninstaller.runThirdPartyApp("programsMenu", arrstring2);
        boolean bl = false;
        String string2 = "";
        if (CustomInstaller.multipleFileGroups() || CustomInstaller.multipleComponents() || CustomInstaller.multipleDirInstall()) {
            bl = true;
            string2 = this.getPropertyList().getProperty("installType", "").trim();
        }
        PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
        Enumeration enumeration = propertyList.propertyNames();
        while (enumeration.hasMoreElements()) {
            object = (String)enumeration.nextElement();
            string = propertyList.getProperty((String)object);
            if (string == null) continue;
            PropertyList propertyList2 = new PropertyList();
            propertyList2.fromString(string);
            String string3 = propertyList2.getProperty("longName");
            String string4 = propertyList2.getProperty("associatedInstallType", "").trim();
            if (string3 == null || string3.length() <= 0) {
                string3 = propertyList2.getProperty("shortName");
            }
            if (!MenuUtilities.menuOk(propertyList2, this.getPropertyList())) continue;
            String string5 = this.getLauncherName(string3);
            customUninstaller.deleteFile(this.appDir + File.separator + string5 + ".exe");
            customUninstaller.deleteFile(this.jExpressDir + File.separator + string5 + ".properties");
        }
        if (this.getPropertyList().getBooleanProperty("autoupdateOnDemand")) {
            object = "Update " + this.programName;
            if (CustomInstaller.multipleComponents()) {
                object = "Update " + this.getPropertyList().getProperty("installType", this.programName);
            }
            string = this.getLauncherName((String)object);
            customUninstaller.deleteFile(this.appDir + File.separator + string + ".exe");
            customUninstaller.deleteFile(this.jExpressDir + File.separator + string + ".properties");
        }
        if (!this.getPropertyList().getBooleanProperty("autoupdateNever")) {
            object = new File(this.jExpressDir, "update.control");
            customUninstaller.deleteFile(object.getPath());
        }
        customUninstaller.deleteManifest(this.appDir);
        customUninstaller.deleteDirIfEmpty(this.appDir);
        this.logMessage("finished writing windows command file");
    }

    void registerWindowsUninstaller(String string, boolean bl) {
        String string2 = string;
        if (bl) {
            File file;
            String string3;
            File file2 = new File(string);
            string2 = file2.exists() ? ((file = new File(string3 = this.getWindowsDataDir(), this.winUninstallerExeFilename)).exists() ? this.getWindowsShortName(file) + " " + this.getWindowsShortName(file2.getParent()) : this.getWindowsShortName(string)) : "";
        }
        if (string2.length() > 0) {
            this.uninstallerCommand = string2;
            if (this.okToRegister(string2)) {
                if (bl) {
                    WindowsCommands.hideFile(string);
                    this.logMessage("hid " + string);
                }
                this.logMessage("registering windows uninstaller");
                this.registerWindowsUninstaller(string2);
            }
        } else {
            this.logMessage("uninstaller doesn't exist: " + string);
        }
    }

    void registerWindowsUninstaller(String string) {
        String string2;
        Object object;
        String string3;
        this.logMessage("registering windows uninstaller");
        String string4 = "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall" + File.separator + this.programID;
        boolean bl = WindowsRegistry.exists(string4);
        this.logMessage("key exists: " + bl + " (" + string4 + ")");
        bl = WindowsRegistry.deleteKey("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall", this.programID);
        this.logMessage("deleted old key: " + bl + " (" + string4 + ")");
        bl = WindowsRegistry.exists(string4);
        this.logMessage("key exists: " + bl + " (" + string4 + ")");
        bl = WindowsRegistry.addKey("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall", this.programID);
        this.logMessage("added key to registry: " + bl + " (" + string4 + ")");
        bl = WindowsRegistry.replaceData(string4, "DisplayName", this.programID);
        this.logMessage("added DisplayName attribute: " + bl + " (" + this.programID + " to " + string4 + ")");
        Integer n = this.getEstimatedSize();
        if (n > 0) {
            if (OS.isWindowsXP()) {
                n = n * 100;
            }
            bl = WindowsRegistry.replaceData(string4, "EstimatedSize", n);
            this.logMessage("added EstimatedSize attribute: " + bl + " " + n);
        } else {
            this.logMessage("unable to add EstimatedSize");
        }
        String string5 = this.getPropertyList().getProperty("webSite");
        if (string5 != null && string5.trim().length() > 0 && string5.startsWith("http")) {
            bl = WindowsRegistry.replaceData(string4, "URLInfoAbout", string5);
            this.logMessage("added URLInfoAbout attribute: " + bl + " (" + string5 + ")");
        }
        if ((string2 = this.getPropertyList().getProperty("uninstallerIconPath")) == null && (object = new File(this.jExpressDir, "jexuninstall.ico")).exists()) {
            string2 = object.getPath();
            this.logMessage("using default uninstaller icon");
        }
        if (string2 == null || string2.length() <= 0) {
            this.logMessage("no uninstaller icon predefined");
        } else {
            bl = WindowsRegistry.replaceData(string4, "DisplayIcon", string2);
            this.logMessage("added DisplayIcon attribute: " + bl + " (" + string2 + ")");
        }
        object = this.getPropertyList().getProperty("packageVersion", "");
        if (object != null && object.length() > 0) {
            bl = WindowsRegistry.replaceData(string4, "DisplayVersion", (String)object);
            this.logMessage("added DisplayVersion attribute: " + bl + " (" + (String)object + ")");
        }
        if ((string3 = this.getPropertyList().getProperty("author", "")) != null && string3.length() > 0) {
            bl = WindowsRegistry.replaceData(string4, "Publisher", string3);
            this.logMessage("added Publisher attribute: " + bl + " (" + string3 + ")");
        }
        bl = WindowsRegistry.replaceData(string4, "UninstallString", string);
        this.logMessage("added UninstallString attribute: " + bl + " (" + string + ")");
        this.logMessage("finished registering windows uninstaller");
    }

    private boolean okToRegister(String string) {
        boolean bl = true;
        if (OS.isSecureWindows() || this.getPropertyList().getBooleanProperty("configureWinRegistry", true)) {
            byte[] arrby = string.getBytes();
            CharsetDecoder charsetDecoder = Charset.forName("US-ASCII").newDecoder();
            try {
                CharBuffer charBuffer = charsetDecoder.decode(ByteBuffer.wrap(arrby));
                charBuffer.toString();
                bl = true;
                this.logMessage("user wants registry configured");
            }
            catch (CharacterCodingException var5_6) {
                bl = false;
                this.logMessage("didn't add uninstaller to registery; non-US ASCII characters in uninstall command");
            }
        } else {
            bl = false;
            this.logMessage("user doesn't want registry configured");
        }
        return bl;
    }

    private String createWinUninstallExe(File file) {
        this.logMessage("creating windows uninstaller exe");
        String string = null;
        File file2 = this.getWinUninstallExeFile();
        if (file2 != null && file2.exists()) {
            try {
                boolean bl = true;
                File file3 = new File(this.appDir, "Uninstall.exe");
                String string2 = file3.getPath();
                if (file3.exists()) {
                    file3.delete();
                }
                FileSystem.copyFile(file2, file3);
                String string3 = this.createWindowsPropertiesFile(file);
                if (string3 != null) {
                    this.logMessage("    creating the launcher: " + file3.getPath());
                    if (this.getPropertyList().getBooleanProperty("javaAppFilesSigned", false)) {
                        this.logMessage("    launcher signed");
                    }
                } else {
                    this.logMessage("    unable to create launcher");
                    bl = false;
                }
                if (bl) {
                    string = file3.getPath();
                    this.logMessage("uninstaller filename: " + string);
                }
            }
            catch (Exception var4_5) {
                // empty catch block
            }
        }
        this.logMessage("finished creating windows uninstaller exe");
        return string;
    }

    private File getWinUninstallExeFile() {
        File file = null;
        boolean bl = this.getPropertyList().getBooleanProperty("installAsAdmin", false);
        file = OS.isSecureWindows() || bl ? WindowsJavaApp.getAdminFile() : WindowsJavaApp.getRegularFile();
        if (file == null) {
            this.logMessage("unable to extract uninstaller exe template");
        } else {
            this.logMessage("uninstaller exe template: " + file.getPath());
        }
        return file;
    }

    String createWindowsPropertiesFile(File file) {
        String string;
        this.logMessage("creating windows properties file");
        String string2 = this.getPropertyList().getProperty("jvmCommandName", "");
        String string3 = string = JRE.getNativeExecutable(string2);
        if (string3 == null || string3.length() <= 0) {
            string3 = string;
            this.logMessage("jvm exe: " + string3);
        }
        this.logMessage("jvm command name: " + string2);
        this.logMessage("jvm executable: " + string);
        int n = string3.indexOf(32);
        if (!(n == -1 || string3.startsWith("\""))) {
            string3 = "\"" + string3 + "\"";
        }
        String string4 = this.getWinFilenameCommand(this.getUninstallerJarFile());
        String string5 = this.getWinFilenameCommand(file);
        String string6 = this.getWinFilenameCommand(this.appDir);
        String string7 = JRE.getClasspathSwitch() + " " + string4 + " " + "com.denova.JExpress.Uninstaller.JExpressUninstaller";
        this.logMessage("uninstaller args: " + string7);
        PropertyList propertyList = new PropertyList();
        propertyList.setProperty("programName", "Uninstall");
        propertyList.setProperty("execFilename", string3);
        propertyList.setProperty("args", string7);
        propertyList.setProperty("startDir", string6);
        propertyList.setProperty("jvmRequiredVersion", this.getPropertyList().getProperty("jvmRequiredVersion", ""));
        propertyList.setProperty("jvmMinVersion", this.getPropertyList().getProperty("jvmMinVersion", ""));
        propertyList.setProperty("jvmMaxVersion", this.getPropertyList().getProperty("jvmMaxVersion", ""));
        File file2 = new File(this.appDir, "JExpress");
        file2.mkdirs();
        String string8 = "JExpress" + File.separator + "Uninstall.properties";
        file2 = new File(this.appDir, string8);
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file2);
            propertyList.save(fileOutputStream, "Menu for Uninstaller");
            fileOutputStream.close();
        }
        catch (Exception var13_14) {
            this.logMessage("unable to create propropertiesFilename: " + string8);
            string8 = null;
        }
        this.logMessage("finished creating windows properties file");
        return string8;
    }

    private String createUninstallBatchFile(File file) {
        this.logMessage("creating uninstall batch file");
        String string = "";
        File file2 = new File(this.appDir, "Uninstall.bat");
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file2);
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            printWriter.println("echo off");
            printWriter.println("echo Uninstalling " + this.programName);
            String string2 = this.getWinUninstallCommand(file);
            File file3 = new File(this.appDir);
            String string3 = this.getWinFilenameCommand(file3);
            printWriter.println("cd " + string3);
            printWriter.println(string2);
            printWriter.close();
            fileOutputStream.close();
            String string4 = this.getWinFilenameCommand(file2);
            string = "cmd.exe /c " + string4;
        }
        catch (Exception var4_5) {
            CustomInstaller.logException("Unable to write to " + file2.getPath(), var4_5);
        }
        this.logMessage("finished creating uninstall batch file");
        return string;
    }

    private Integer getEstimatedSize() {
        Integer n = new Integer(0);
        long l = this.getPropertyList().getLongProperty("uncompressedTotalSize");
        if (l > 0) {
            try {
                this.logMessage("total uncompressed size: " + new Long(l).toString());
                n = new Integer(new Long(l / 1024).intValue());
            }
            catch (Exception var4_3) {
                this.logMessage(var4_3.getMessage());
            }
        }
        return n;
    }

    private String getWindowsShortName(String string) {
        return this.getWindowsShortName(new File(string));
    }

    private String getWindowsShortName(File file) {
        String string;
        try {
            string = file.getCanonicalPath();
        }
        catch (Exception var3_3) {
            string = file.getAbsolutePath();
        }
        String string2 = string;
        if (string2 != null && string2.length() > 0) {
            string = string2;
        }
        string = Exec.quoteArg(string);
        return string;
    }

    private String getWinFilenameCommand(String string) {
        File file = new File(string);
        return this.getWinFilenameCommand(file);
    }

    private String getWinFilenameCommand(File file) {
        String string = file.getPath();
        if (!(string.indexOf(" ") == -1 || string.startsWith("\""))) {
            string = "\"" + string + "\"";
        }
        return string;
    }

    private String getWinUninstallCommand(File file) {
        String string = this.getPropertyList().getProperty("jvmCommandName", "");
        String string2 = JRE.getNativeExecutable(string);
        String string3 = string2;
        if (string3 == null || string3.length() <= 0) {
            string3 = string2;
        }
        this.logMessage("jvm command name: " + string);
        this.logMessage("jvm executable: " + string2);
        this.logMessage("jvm exe: " + string3);
        String string4 = this.getWinFilenameCommand(this.getUninstallerJarFile());
        String string5 = this.getWinFilenameCommand(file);
        String string6 = string3 + " " + JRE.getClasspathSwitch() + " " + string4 + " " + "com.denova.JExpress.Uninstaller.JExpressUninstaller";
        this.logMessage("uninstaller command: " + string6);
        return string6;
    }

    void writeUnixCommandFile(File file) {
        CustomUninstaller customUninstaller;
        this.logMessage("creating unix command file");
        File file2 = null;
        String string = this.getPropertyList().getProperty("submenu", "").replace('/', File.separatorChar);
        File file3 = new File(string + "kde");
        File file4 = new File(string + "gnome");
        String string2 = UnixMenu.getKdeMenuDir();
        file3 = new File(UnixMenu.getSubmenuDir(string2, string));
        file4 = new File(UnixMenu.getGnomeMenuDir());
        if (OS.isMac()) {
            file2 = new File(MacOS.getDesktopDirectory());
        }
        if ((customUninstaller = new CustomUninstaller()) != null) {
            String string3 = this.getPropertyList().getProperty("customUninstallerClass", "");
            customUninstaller.setCustomClasses(string3);
            this.trackUninstall(customUninstaller);
            this.deletePropertyStorage(customUninstaller);
            this.deleteUnixMenu(customUninstaller, file2, file3, file4);
            this.addAutoStartupDeleteInfo(customUninstaller);
            this.deleteUnixUpdateCommand(customUninstaller, file2, file3, file4, this.programName);
            this.deleteCreatedMenuDirs(customUninstaller);
            File file5 = new File(this.appDir, "uninstall");
            customUninstaller.deleteFile(file5.getPath());
            if (OS.isMac()) {
                String string4;
                file5 = new File(this.appDir, "uninstall.command");
                if (file5.exists()) {
                    customUninstaller.deleteFile(file5.getPath());
                }
                String string5 = "uninstall".toLowerCase();
                String string6 = "uninstall".toUpperCase();
                String string7 = string6.substring(0, 1) + string5.substring(1) + ".app";
                file5 = new File(this.appDir, string7);
                customUninstaller.deleteDirTree(file5.getPath());
                file5 = new File(this.appDir, ".DS_Store");
                customUninstaller.deleteFile(file5.getPath());
                if (this.getPropertyList().getBooleanProperty("autoupdateEveryStartup", false) && (string4 = this.getPropertyList().getProperty("secondaryUpdater")) != null) {
                    if (!string4.endsWith(".app")) {
                        string4 = string4 + ".app";
                    }
                    if ((file5 = new File(string4)).exists() && file5.isDirectory()) {
                        customUninstaller.deleteDirTree(string4);
                    }
                }
            }
            customUninstaller.deleteManifest(this.appDir);
            customUninstaller.deleteDirIfEmpty(this.appDir);
            customUninstaller.save(this.appDir, this.programID);
        } else {
            this.logMessage("Unable to configure JExpressUninstaller.");
        }
        this.logMessage("finished creating unix command file");
    }

    void trackUninstall(CustomUninstaller customUninstaller) {
        if (this.getPropertyList().getBooleanProperty("trackConversions", false)) {
            String string = this.getPropertyList().getProperty("packageName", "");
            String string2 = CustomInstaller.getProductUrl();
            customUninstaller.trackUninstall(string, string2);
        }
    }

    void deletePropertyStorage(CustomUninstaller customUninstaller) {
        String string = this.getPropertyList().getProperty("packageName", "");
        customUninstaller.deletePropertyStorage(string);
    }

    void deleteUnixMenu(CustomUninstaller customUninstaller, File file, File file2, File file3) {
        this.logMessage("creating unix delete menus file");
        PropertyList propertyList = this.getPropertyList().getPropertyListProperty("menus");
        Enumeration enumeration = propertyList.propertyNames();
        while (enumeration.hasMoreElements()) {
            String string = (String)enumeration.nextElement();
            String string2 = propertyList.getProperty(string);
            if (string2 == null) continue;
            PropertyList propertyList2 = new PropertyList();
            propertyList2.fromString(string2);
            if (!MenuUtilities.menuOk(propertyList2, this.getPropertyList())) continue;
            this.deleteUnixScript(customUninstaller, file, file2, file3, propertyList2);
        }
        this.logMessage("finished creating unix delete menus file");
    }

    void deleteUnixScript(CustomUninstaller customUninstaller, File file, File file2, File file3, PropertyList propertyList) {
        this.logMessage("creating unix delete script file");
        String string = propertyList.getProperty("shortName");
        String string2 = propertyList.getProperty("longName", "");
        if (string2.length() <= 0) {
            string2 = string;
        }
        if (string == null || string.length() <= 0) {
            string = MenuUtilities.getShortName(string2);
        }
        File file4 = new File(this.appDir, string);
        customUninstaller.deleteFile(file4.getPath());
        if (OS.isMac()) {
            File file5 = new File(this.appDir, string + ".command");
            customUninstaller.deleteFile(file5.getPath());
            if (propertyList.getBooleanProperty("useJavaCommandPrefix", false)) {
                this.deleteMacLink(file, string2 + ".app", customUninstaller);
            } else {
                String string3 = propertyList.getProperty("executableFile", "");
                if (string3.length() > 0) {
                    int n;
                    if (string3.lastIndexOf(File.separator) >= 0) {
                        n = string3.lastIndexOf(File.separator);
                        string3 = string3.substring(n + 1);
                    } else if (string3.lastIndexOf("\\") >= 0) {
                        n = string3.lastIndexOf("\\");
                        string3 = string3.substring(n + 1);
                    }
                    this.deleteMacLink(file, string3, customUninstaller);
                }
            }
            file4 = new File(this.appDir, string2 + ".app");
            if (file4.exists()) {
                customUninstaller.deleteDirTree(file4.getPath());
            } else {
                this.logMessage("no app bundle: " + file4.getPath());
            }
        } else if (propertyList.getBooleanProperty("menuInstallAsService")) {
            customUninstaller.removeLinuxService(file4.getPath());
            this.logMessage("removing service: " + file4.getPath());
        }
        boolean bl = propertyList.getBooleanProperty("gnomeMenu", true);
        boolean bl2 = propertyList.getBooleanProperty("kdeMenu", true);
        if ((bl || bl2) && (file3.exists() || file2.exists())) {
            String string4 = UnixMenu.getKdeMenuName(string2, string) + ".desktop";
            if (bl2 && file2.exists() && (file4 = new File(file2, string4)).exists()) {
                customUninstaller.deleteFile(file4.getPath());
            }
            if (bl && file3.exists() && (file4 = new File(file3, string4)).exists()) {
                customUninstaller.deleteFile(file4.getPath());
            }
            if (propertyList.getBooleanProperty("menuDesktopShortcut") && (file4 = new File(UnixMenu.getDesktopDir(), string4)).exists()) {
                customUninstaller.deleteFile(file4.getPath());
            }
        }
        this.logMessage("finished creating unix delete script file");
    }

    private void deleteMacLink(File file, String string, CustomUninstaller customUninstaller) {
        File file2 = new File(file, string);
        if (file2.exists()) {
            customUninstaller.deleteFile(file2.getPath());
        } else {
            this.logMessage("no link in desktop link: " + file2.getPath());
        }
        file2 = new File("/Applications", string);
        if (file2.exists()) {
            customUninstaller.deleteFile(file2.getPath());
        } else {
            this.logMessage("no link in /Applications: " + file2.getPath());
        }
    }

    void deleteUnixUpdateCommand(CustomUninstaller customUninstaller, File file, File file2, File file3, String string) {
        String string2;
        File file4;
        this.logMessage("creating unix delete update command");
        if (this.getPropertyList().getBooleanProperty("autoupdateOnDemand")) {
            string2 = "Update " + string;
            if (CustomInstaller.multipleComponents()) {
                string2 = "Update " + this.getPropertyList().getProperty("installType", string);
            }
            if (OS.isMac()) {
                File file5;
                String string3 = string2 + ".app";
                if (CustomInstaller.multipleComponents()) {
                    string3 = "Update " + this.getPropertyList().getProperty("installType", string2) + ".app";
                }
                if ((file4 = new File(this.appDir, "update.command")).exists()) {
                    customUninstaller.deleteFile(file4.getPath());
                }
                if (file != null && (file4 = new File(file, string3)).exists()) {
                    customUninstaller.deleteFile(file4.getPath());
                }
                if ((file4 = new File(file5 = new File("/Applications", file.getName()), string3)).exists()) {
                    customUninstaller.deleteFile(file4.getPath());
                }
                if ((file4 = new File(this.appDir, string3)).exists()) {
                    customUninstaller.deleteDirTree(file4.getPath());
                }
                this.logMessage("deleting on demand app bundle");
            } else {
                String string4 = UnixMenu.getKdeMenuName(string2 + ".desktop", "update");
                if (file2.exists()) {
                    file4 = new File(file2, string4);
                    customUninstaller.deleteFile(file4.getPath());
                    this.logMessage("kde on demand menu: " + file4.getPath());
                }
                if (file3.exists()) {
                    file4 = new File(file3, string4);
                    customUninstaller.deleteFile(file4.getPath());
                    this.logMessage("gmome on demand menu: " + file4.getPath());
                }
                if (this.getPropertyList().getBooleanProperty("onDemandDesktopShortcut")) {
                    File file6 = new File(System.getProperty("user.home", "~"), "Desktop");
                    String string5 = this.getPropertyList().getProperty("submenu", "").replace('/', File.separatorChar);
                    if (string5.length() > 0) {
                        file6 = new File(file6, string5);
                    }
                    file4 = new File(file6, string4);
                    customUninstaller.deleteFile(file4.getPath());
                    this.logMessage("desktop on demand menu: " + file4.getPath());
                }
            }
            file4 = new File(this.appDir, "update");
            customUninstaller.deleteFile(file4.getPath());
            file4 = new File(this.jExpressDir, "update.control");
            customUninstaller.deleteFile(file4.getPath());
        }
        if (this.getPropertyList().getBooleanProperty("autoupdateEveryStartup", false) && (string2 = this.getPropertyList().getProperty("secondaryUpdater")) != null && (file4 = new File(string2)).exists() && file4.isFile()) {
            customUninstaller.deleteFile(string2);
        }
        this.logMessage("finished creating unix delete update command");
    }

    void writeUnixUninstallScript(File file) {
        this.logMessage("writing unix uninstall script");
        boolean bl = true;
        boolean bl2 = false;
        String string = this.getUninstallerJarFile().getPath();
        String string2 = JRE.getCommandPrefix("", string, "", bl2);
        String string3 = file.getPath();
        this.logMessage("commandPrefix: " + string2);
        this.logMessage("commandFilePath: " + string3);
        this.logMessage("classpath: " + string);
        if (OS.isMac()) {
            this.addMacUninstaller(this.appDir, "uninstall", bl, bl2, string2, "com.denova.JExpress.Uninstaller.JExpressUninstaller", "", string);
        } else {
            String string4 = MenuUtilities.getKdeIconFilename("jexuninstall");
            String string5 = Localize.strings().getString("StartingUninstaller");
            UnixMenu unixMenu = new UnixMenu(log);
            unixMenu.setInstallDir(this.appDir);
            unixMenu.setWorkingDir(this.appDir);
            unixMenu.setLaunchDirName(this.appDir);
            unixMenu.setLongName("uninstall");
            unixMenu.setShortName("uninstall");
            unixMenu.setExecutableFile("com.denova.JExpress.Uninstaller.JExpressUninstaller");
            unixMenu.setIconFilename(string4);
            unixMenu.addLaunchScript(bl, bl2, string2, false, false, false, string5);
            File file2 = new File(this.appDir, "uninstall");
            this.uninstallerCommand = file2.getPath();
        }
        this.logMessage("finished writing unix uninstall script");
    }

    void addMacUninstaller(String string, String string2, boolean bl, boolean bl2, String string3, String string4, String string5, String string6) {
        this.logMessage("adding mac uninstaller");
        String string7 = string2.toLowerCase();
        String string8 = string2.toUpperCase();
        String string9 = string8.substring(0, 1) + string7.substring(1);
        String string10 = MenuUtilities.getIconFilename("jexuninstall", "icns");
        String string11 = this.getPropertyList().getProperty("packageName", "") + " " + this.getPropertyList().getProperty("packageCopyright", "") + " " + this.getPropertyList().getProperty("author", "");
        String string12 = this.getPropertyList().getProperty("packageVersion", "");
        String string13 = Installer.getInstaller().installerCreatedBy();
        boolean bl3 = this.getPropertyList().getBooleanProperty("installAsAdmin", false);
        MacOS macOS = new MacOS(log);
        macOS.setSubmenu("");
        macOS.setInstallDir(string);
        macOS.setWorkingDir(string);
        macOS.setLaunchDirName(string);
        macOS.setLongName(string9);
        macOS.setShortName(string2);
        macOS.setExecutableFile(string4);
        macOS.setCommandLineArguments(string5);
        macOS.setRunAsAdmin(bl3);
        macOS.setIconFilename(string10);
        macOS.addMacLauncher(bl, bl2, string3, string12, string6, "", "1.5+", string11, string13, false);
        File file = new File(string, "uninstall");
        if (file.exists()) {
            this.uninstallerCommand = file.getPath();
        } else {
            File file2 = new File(string, "Contents");
            File file3 = new File(file2, "MacOS");
            file = new File(file3, "uninstall");
            this.uninstallerCommand = file.getPath();
        }
        this.logMessage("finished adding mac uninstaller");
    }

    private void deleteCreatedMenuDirs(CustomUninstaller customUninstaller) {
        this.logMessage("deleting created menu dirs");
        String string = this.getPropertyList().getProperty("createdMenuDirs");
        if (string == null) {
            this.logMessage("No directories created for menus");
        } else {
            List list = StringConversions.toList(string);
            if (list == null || list.isEmpty()) {
                this.logMessage("No new directories created for menus");
            } else {
                for (String string2 : list) {
                    customUninstaller.deleteDirIfEmpty(string2);
                    this.logMessage("Setup to delete new dir: " + string2);
                }
            }
        }
        this.logMessage("finished deleting created menu dirs");
    }

    boolean setUpUninstallerJar() {
        this.logMessage("setting uninstall jar");
        boolean bl = true;
        File file = new File(this.appDir, "JExpress");
        this.getPropertyList().setProperty("uninstallerPathname", file.getPath());
        if (OS.isWindows()) {
            bl = this.copyUninstallerToWindows();
        }
        this.logMessage("finished setting uninstall jar: " + bl);
        return bl;
    }

    boolean copyUninstallerToWindows() {
        boolean bl = false;
        String string = this.getWindowsDataDir();
        if (string == null) {
            bl = false;
            this.logMessage("unable to create jexpress data dir");
        } else {
            bl = true;
            this.copyUninstallerExe(string);
            Vector<String> vector = new Vector<String>();
            vector.add("+h");
            vector.add("/s");
            vector.add("/d");
            WindowsCommands.changePermissions(string, vector);
        }
        if (!bl) {
            CustomInstaller.logError("Unable to create jexpress data dir");
        }
        return bl;
    }

    void copyUninstallerExe(String string) {
        boolean bl = false;
        boolean bl2 = WindowsCommands.is64BitProcessorArchitecture() && !WindowsCommands.isWow64Process();
        WindowsUtils.log("64 bit: " + bl2);
        if (bl2) {
            this.winUninstallerExeFilename = "JExpressUninstaller-x64.exe";
            bl = this.getUninstallerExe(string, this.winUninstallerExeFilename);
        }
        if (!bl) {
            this.winUninstallerExeFilename = "JExpressUninstaller-x32.exe";
            bl = this.getUninstallerExe(string, this.winUninstallerExeFilename);
        }
    }

    boolean getUninstallerExe(String string, String string2) {
        boolean bl;
        if (CustomInstaller.extractFile(string2)) {
            try {
                File file = TempFiles.getFile(string2);
                FileSystem.copyFile(file.getPath(), string);
                this.logMessage("copied " + string2 + " to " + string);
                bl = true;
            }
            catch (Exception var4_4) {
                bl = false;
                this.logMessage("unable to copy " + string2 + " to " + string);
            }
        } else {
            bl = false;
            this.logMessage("unable to extract " + string2);
        }
        return bl;
    }

    String getWindowsDataDir() {
        if (this.winAppDataDir == null) {
            String string = this.getWindowsDataDir(WindowsDirs.getAppDataDirectory("allUsers"));
            if (string == null) {
                string = this.getWindowsDataDir(WindowsDirs.getAppDataDirectory());
            }
            if (string == null) {
                this.logMessage("unable to get windows app data dir");
            } else {
                this.winAppDataDir = string;
                this.logMessage("windows app data dir: " + this.winAppDataDir);
            }
        }
        return this.winAppDataDir;
    }

    String getWindowsDataDir(String string) {
        String string2 = null;
        try {
            File file = new File(string, "JExpress");
            if (!file.exists()) {
                file.mkdirs();
            }
            if (file.exists() && file.isDirectory() && !FileSystem.isDirWriteProtected(file.getPath())) {
                string2 = file.getPath();
            }
        }
        catch (Exception var3_4) {
            this.logMessage(var3_4.getMessage());
        }
        return string2;
    }

    private void addAutoStartupDeleteInfo(CustomUninstaller customUninstaller) {
        File file = new File(this.uninstallerDir, "autostartupuinstall");
        if (file.exists()) {
            try {
                FileReader fileReader = new FileReader(file);
                BufferedReader bufferedReader = new BufferedReader(fileReader);
                String string = bufferedReader.readLine();
                while (string != null) {
                    int n = string.indexOf("\t");
                    if (n > 0) {
                        String string2 = string.substring(0, n);
                        String string3 = string.substring(n + 1);
                        if (string2.equals("delfile")) {
                            customUninstaller.deleteFile(string3);
                        } else {
                            this.logMessage("unknown uninstall command: " + string);
                        }
                    }
                    string = bufferedReader.readLine();
                }
                bufferedReader.close();
                fileReader.close();
            }
            catch (IOException var3_4) {
                this.logMessage("unable to add auto startup uninstall commands");
            }
            file.delete();
        } else {
            this.logMessage("no autostart for this menu: " + file.getPath());
        }
    }

    private void logMessage(String string) {
        log.write(string);
    }

    private class UninstallSwinger
    extends Swinger {
        private UninstallSwinger() {
        }

        public void swingBefore() {
            CustomInstaller.log("Installing uninstaller");
            UninstallPanel.this.updateProgressBarLabel(UninstallPanel.this.progressLabel);
        }

        public void workInBackground() {
            UninstallPanel.this.programName = UninstallPanel.this.getPropertyList().getProperty("packageName");
            UninstallPanel.this.programID = UninstallPanel.this.programName.trim();
            if (CustomInstaller.multipleComponents()) {
                UninstallPanel.this.programID = UninstallPanel.this.getPropertyList().getProperty("installType").trim();
            }
            UninstallPanel.this.appDir = UninstallPanel.this.getPropertyList().getProperty("applicationDirectory", "");
            UninstallPanel.this.jExpressDir = new File(UninstallPanel.this.appDir, "JExpress");
            UninstallPanel.this.uninstallerDir = new File(UninstallPanel.this.jExpressDir, "uninstaller");
            UninstallPanel.this.uninstallerDir.mkdirs();
            UninstallPanel.this.commandFile = new File(UninstallPanel.this.uninstallerDir, "uninstall");
            UninstallPanel.this.javaHomeDir = JRE.getJavaHome();
            if (UninstallPanel.this.javaHomeDir.length() <= 0) {
                UninstallPanel.this.javaHomeDir = UninstallPanel.this.jExpressDir.getPath();
            }
            try {
                UninstallPanel.this.saveUninstallProperties(UninstallPanel.this.uninstallerDir);
                if (OS.isWindows()) {
                    UninstallPanel.this.createWindowsUninstaller();
                } else {
                    UninstallPanel.this.createUnixUninstaller();
                }
            }
            catch (Exception var1_1) {
                CustomInstaller.logException(Localize.strings().getString("NoUninstaller"), var1_1);
            }
            UninstallPanel.this.uninstallDone = true;
            UninstallPanel.this.logMessage("uninstall done: " + UninstallPanel.this.uninstallDone);
            UninstallPanel.this.logMessage("uninstall command: " + UninstallPanel.this.uninstallerCommand);
        }

        public void swingAfter() {
            UninstallPanel.this.showNextPanel();
        }
    }

}
