/*
 * Decompiled with CFR 0_101.
 */
package com.denova.JExpress.Installer;

import com.denova.JExpress.Installer.CustomInstaller;
import com.denova.JExpress.Installer.InstallPropertyNames;
import com.denova.JExpress.Installer.InstallerPopups;
import com.denova.JExpress.Installer.Localize;
import com.denova.JExpress.JExpressConstants;
import com.denova.io.Log;
import com.denova.io.TempDirs;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsDirs;
import com.denova.ui.DirectorySelectionDialog;
import com.denova.util.PropertyList;
import java.awt.Container;
import java.io.File;
import java.io.FileOutputStream;

public class VerifyDirectory
implements InstallPropertyNames,
JExpressConstants {
    private static final String MacAppDirName = "Applications";
    private static final String TestFilename = "deleteMe.JexTest";
    private static boolean warnedUser = false;
    private static boolean forceOverwrite = false;
    private static String overwritePrompt = "";
    private static Log log = null;
    private static String windowsDir = null;
    private static String windowsDocsDir = null;
    private static String windowsProgramManagerDir = null;

    public static boolean isOk(String string, String string2, PropertyList propertyList) {
        boolean bl;
        warnedUser = false;
        File file = VerifyDirectory.dirNameTestOk(string, propertyList);
        boolean bl2 = bl = file != null;
        if (bl) {
            propertyList.setProperty("applicationDirectory", file.getPath());
            if (CustomInstaller.multipleDirInstall() || CustomInstaller.multipleComponents()) {
                propertyList.setProperty("applicationDirectory" + string2, file.getPath());
                VerifyDirectory.logMessage(string2 + ": " + file.getPath());
            } else {
                VerifyDirectory.logMessage("got a good install dir: " + file.getPath());
            }
            VerifyDirectory.setJvmInstallDir(string2, file, propertyList);
        } else {
            boolean bl3 = propertyList.getBooleanProperty("silentInstall", false);
            if (bl3) {
                String string3 = Localize.strings().getString("WriteProtected");
                CustomInstaller.logError(string3);
                VerifyDirectory.logMessage(string3);
            } else if (!warnedUser) {
                if (!propertyList.getBooleanProperty("silentInstall", false)) {
                    InstallerPopups.noteError(Localize.strings().getString("WriteProtected"));
                }
                VerifyDirectory.logMessage("unable to create a file in " + string);
            }
        }
        return bl;
    }

    public static String getDefaultInstallationDirectory(String string, PropertyList propertyList) {
        String string2;
        String string3 = null;
        boolean bl = false;
        VerifyDirectory.logMessage("getting initial install dir");
        VerifyDirectory.logMessage("for component: " + string);
        if (CustomInstaller.multipleDirInstall()) {
            string3 = propertyList.getProperty("applicationDirectory" + string);
            VerifyDirectory.logMessage("trying applicationDirectory with component " + string + ": " + string3);
        } else {
            string3 = propertyList.getProperty("applicationDirectory");
            VerifyDirectory.logMessage("trying applicationDirectory: " + string3);
        }
        VerifyDirectory.logMessage("dirPath: " + string3);
        bl = VerifyDirectory.testDir(string3);
        if (!bl) {
            string3 = propertyList.getProperty("oldApplicationDirectory");
            VerifyDirectory.logMessage("trying oldApplicationDirectory: " + string3);
            bl = VerifyDirectory.testDir(string3);
        }
        if (!bl) {
            string2 = VerifyDirectory.getDefaultDir(propertyList);
            VerifyDirectory.logMessage("defaultDir: " + string2);
            string3 = VerifyDirectory.getDirPath(string2, string, propertyList);
            VerifyDirectory.logMessage("trying defaultDir: " + string3);
            bl = VerifyDirectory.testDir(string3);
        }
        if (!bl) {
            string2 = propertyList.getProperty("safePackageName");
            string3 = VerifyDirectory.getDirPath(string2, string, propertyList);
            VerifyDirectory.logMessage("trying safe package name: " + string3);
            bl = VerifyDirectory.testDir(string3);
        }
        if (!bl) {
            string3 = VerifyDirectory.getDirPath(System.getProperty("user.home"), string, propertyList);
            VerifyDirectory.logMessage("trying home directory: " + string3);
            bl = VerifyDirectory.testDir(string3);
        }
        if (!bl) {
            string3 = VerifyDirectory.getDirPath(propertyList.getProperty("startDirectory"), string, propertyList);
            VerifyDirectory.logMessage("trying start directory: " + string3);
            bl = VerifyDirectory.testDir(string3);
        }
        if (!bl) {
            string3 = VerifyDirectory.getDirPath(System.getProperty("user.dir"), string, propertyList);
            VerifyDirectory.logMessage("trying current directory: " + string3);
            bl = VerifyDirectory.testDir(string3);
        }
        if (bl) {
            VerifyDirectory.logMessage("initial dir: " + string3);
        } else {
            VerifyDirectory.logMessage("unknown initial dir");
        }
        return string3;
    }

    public static File browse(Container container, File file, PropertyList propertyList) {
        VerifyDirectory.logMessage("browsing for directory");
        DirectorySelectionDialog directorySelectionDialog = new DirectorySelectionDialog(container);
        DirectorySelectionDialog.setDefaultDirectory(file);
        directorySelectionDialog.setPrompt(Localize.strings().getString("SelectDir"));
        DirectorySelectionDialog.setTextColor(CustomInstaller.getTextColor());
        DirectorySelectionDialog.setBackgroundColor(CustomInstaller.getBackgroundColor());
        File file2 = directorySelectionDialog.getSelection();
        if (file2 != null) {
            String string = VerifyDirectory.getDefaultSubdir(propertyList);
            String string2 = file2.getPath().toLowerCase();
            VerifyDirectory.logMessage("defaultDirName: " + string);
            VerifyDirectory.logMessage("newDirName: " + string2);
            if (!(string == null || string2.endsWith(string.toLowerCase()))) {
                VerifyDirectory.logMessage("newDirName doesn't end with defaultDirName");
                string2 = VerifyDirectory.parentDirOk(file2, string);
                if (string2 != null && string2.length() > 0) {
                    file2 = new File(file2, string);
                    VerifyDirectory.logMessage("added defaultDirName to newDirName: " + file2.getPath());
                } else {
                    VerifyDirectory.logMessage("new directory name is not ok");
                }
            }
        }
        return file2;
    }

    public static void setSilentOverwrte(boolean bl) {
        forceOverwrite = bl;
    }

    public static void setOverwritePrompt(String string) {
        overwritePrompt = string;
    }

    public static String getOverwritePrompt(String string, PropertyList propertyList) {
        String string2;
        String string3 = overwritePrompt.length() > 0 ? overwritePrompt : ((string2 = propertyList.getProperty("previousApplicationDir", "")).equals(string) ? Localize.strings().getString("InstallInSameDir") : Localize.strings().getString("DirectoryExists"));
        return string3;
    }

    public static File dirNameTestOk(String string, PropertyList propertyList) {
        return VerifyDirectory.dirNameTestOk(string, forceOverwrite, propertyList);
    }

    public static File dirNameTestOk(String string, boolean bl, PropertyList propertyList) {
        boolean bl2 = false;
        File file = null;
        File file2 = null;
        if (string != null) {
            int n = 255;
            if (OS.isWindows()) {
                n = 260;
            }
            boolean bl3 = bl2 = string.length() < n;
        }
        if (bl2) {
            if (OS.isWindows()) {
                if (string.startsWith(File.separator) || string.indexOf(":") >= 0) {
                    bl2 = true;
                } else {
                    bl2 = false;
                    VerifyDirectory.logMessage(string + " doesn't include a drive spec or leading file separator");
                }
            } else if (OS.isUnix() && !string.startsWith(File.separator)) {
                bl2 = false;
                VerifyDirectory.logMessage(string + " doesn't start with a " + File.separator);
            }
        }
        if (bl2) {
            file2 = new File(string.trim());
            bl2 = VerifyDirectory.testDir(file2);
        }
        if (bl2) {
            bl2 = VerifyDirectory.dirOk(file2, bl, propertyList);
        }
        if (bl2) {
            file = file2;
            VerifyDirectory.logMessage(file.getPath() + " ok: " + bl2);
        }
        return file;
    }

    private static boolean dirOk(File file, boolean bl, PropertyList propertyList) {
        boolean bl2 = false;
        boolean bl3 = file.exists();
        TempDirs tempDirs = new TempDirs(file);
        if (bl3) {
            bl2 = VerifyDirectory.existingDirOk(file, bl, propertyList);
        } else {
            try {
                boolean bl4 = bl2 = file.exists() && file.isDirectory();
                if (bl2) {
                    VerifyDirectory.logMessage("created " + file.getPath());
                } else {
                    VerifyDirectory.logMessage("unable to create " + file.getPath());
                }
            }
            catch (Exception var6_6) {
                bl2 = false;
                if (file == null) {
                    VerifyDirectory.logMessage("invalid directory name");
                } else {
                    VerifyDirectory.logMessage("invalid directory name " + file.getPath());
                }
                CustomInstaller.logException("invalid directory name", var6_6);
            }
            tempDirs.delete();
        }
        return bl2;
    }

    private static boolean existingDirOk(File file, boolean bl, PropertyList propertyList) {
        boolean bl2 = false;
        if (file.isDirectory()) {
            VerifyDirectory.logMessage(file.getPath() + " already exists");
            if (bl) {
                bl2 = true;
                VerifyDirectory.logMessage("silently overwriting it");
            } else {
                boolean bl3 = propertyList.getBooleanProperty("silentInstall", false);
                if (bl3) {
                    bl2 = true;
                } else {
                    String string = Localize.strings().getString("Warning");
                    String string2 = Localize.strings().getString("Overwrite");
                    String string3 = Localize.strings().getString("TryAgain");
                    String string4 = VerifyDirectory.getOverwritePrompt(file.getPath(), propertyList);
                    bl2 = InstallerPopups.ask(string, string4, null, string2, string3, string2, string3);
                    VerifyDirectory.logMessage("overwrite: " + bl2);
                    warnedUser = true;
                }
            }
        } else {
            bl2 = false;
            VerifyDirectory.logMessage(file.getPath() + " exists, but it's not a directory");
        }
        return bl2;
    }

    private static String getDirPath(String object, String string, PropertyList propertyList) {
        String string2 = null;
        if (object != null && object.length() > 0) {
            Object object2;
            boolean bl = false;
            File file = null;
            object = object.replace('/', File.separatorChar);
            if ((object = object.replace('\\', File.separatorChar)).length() >= 2 && ":".equals(object.substring(1, 2))) {
                if (OS.isWindows()) {
                    if (!(object.length() < 3 || File.separator.equals(object.substring(2, 3)))) {
                        object = object2 = object.substring(0, 2) + File.separator + object.substring(2);
                    } else if (object.length() == 2) {
                        object = (String)object + File.separator;
                    }
                    object2 = VerifyDirectory.getNewTestDir((String)object, string);
                    if (VerifyDirectory.testDir((File)object2)) {
                        bl = true;
                        file = object2;
                    }
                } else {
                    object = object.length() > 3 ? object.substring(2) : "";
                }
            }
            if (!bl) {
                if (object.startsWith(File.separator)) {
                    if (OS.isWindows()) {
                        File file2;
                        String string3;
                        object2 = new File(System.getProperty("user.dir"));
                        try {
                            string3 = object2.getPath();
                        }
                        catch (Exception var9_8) {
                            string3 = object2.getAbsolutePath();
                        }
                        if (string3.length() >= 2 && ":".equals(string3.substring(1, 2))) {
                            object = string3.substring(0, 2) + (String)object;
                        }
                        if (VerifyDirectory.testDir(file2 = VerifyDirectory.getNewTestDir((String)object, string))) {
                            bl = true;
                            file = file2;
                        }
                    } else {
                        object2 = VerifyDirectory.getNewTestDir((String)object, string);
                        if (VerifyDirectory.testDir((File)object2)) {
                            bl = true;
                            file = object2;
                        }
                    }
                } else {
                    file = VerifyDirectory.addParentDir((String)object, string, propertyList);
                }
            }
            if (file != null) {
                string2 = file.getPath();
                VerifyDirectory.logMessage("possible new directory: " + string2);
            } else {
                VerifyDirectory.logMessage("unable to get a possible directory name for defaultDir: " + (String)object);
            }
        } else {
            VerifyDirectory.logMessage("bad defaultDir name");
        }
        return string2;
    }

    private static File getNewTestDir(String string, String string2) {
        File file = null;
        if (string != null) {
            file = string2 != null && string2.length() > 0 ? new File(string, string2) : new File(string);
        }
        return file;
    }

    private static File addParentDir(String string, String string2, PropertyList propertyList) {
        File file = null;
        if (string2 != null && string2.length() > 0) {
            VerifyDirectory.logMessage("adding " + string2 + " to " + string);
            string = string + File.separator + string2;
        }
        VerifyDirectory.logMessage("adding a parent directory to " + string);
        String string3 = VerifyDirectory.getDefaultParentDir(propertyList);
        if (string3 != null) {
            string3 = VerifyDirectory.parentDirOk(string3, string);
        }
        file = string3 == null ? VerifyDirectory.addParentDir(string, propertyList) : new File(string3, string);
        return file;
    }

    private static File addParentDir(String string, PropertyList propertyList) {
        File file = null;
        VerifyDirectory.logMessage("trying to find a parent directory for " + string);
        if (OS.isWindows()) {
            File file2;
            String string2 = null;
            try {
                string2 = VerifyDirectory.getWindowsProgramManagerDir();
                VerifyDirectory.logMessage("windows dir: " + string2);
            }
            catch (Exception var4_6) {
                VerifyDirectory.logMessage("unable to get program manager dir from registry");
            }
            if (string2 == null || string2.length() <= 0) {
                string2 = VerifyDirectory.getWindowsDocsDir();
            }
            if (string2 == null || string2.length() <= 0) {
                string2 = "C:\\Program Files";
                VerifyDirectory.logMessage("trying standard program files directory " + string2);
            }
            if (string2 != null) {
                string2 = VerifyDirectory.parentDirOk(string2, string);
            }
            if (string2 == null) {
                file2 = new File(System.getProperty("user.home", File.separator));
                string2 = VerifyDirectory.parentDirOk(file2, string);
            }
            if (string2 == null) {
                file2 = new File(System.getProperty("user.dir", File.separator));
                string2 = VerifyDirectory.parentDirOk(file2, string);
            }
            file = new File(string2);
        } else if (OS.isUnix()) {
            String string3 = null;
            String string4 = System.getProperty("user.home", File.separator);
            if (OS.isMacOsX()) {
                File file3 = null;
                if (propertyList.getBooleanProperty("installAsAdmin", false) || OS.getVersion().startsWith("10.2") || OS.getVersion().startsWith("10.1") || OS.getVersion().startsWith("10.0")) {
                    file3 = new File("/Applications");
                    string3 = VerifyDirectory.parentDirOk(file3, string);
                }
                if (string3 == null) {
                    file3 = new File(string4, "Applications");
                    string3 = VerifyDirectory.parentDirOk(file3, string);
                }
            }
            if (string3 == null) {
                string3 = VerifyDirectory.getUnixInstallRootDir(string);
            }
            if (string3 == null) {
                string3 = VerifyDirectory.parentDirOk(System.getProperty("user.home", File.separator), string);
            }
            if (string3 == null) {
                string3 = VerifyDirectory.parentDirOk(System.getProperty("user.dir", File.separator), string);
            }
            file = new File(string3);
        } else {
            String string5 = System.getProperty("user.dir", File.separator);
            file = new File(string5);
        }
        return new File(file, string);
    }

    private static String getUnixInstallRootDir(String string) {
        Object object;
        String string2 = null;
        if (string2 == null) {
            string2 = VerifyDirectory.parentDirOk("/usr/local/bin", string);
        }
        if (string2 == null) {
            string2 = VerifyDirectory.parentDirOk("/opt", string);
        }
        if (string2 == null && (object = new File("/usr/local")).exists()) {
            string2 = VerifyDirectory.parentDirOk((File)object, string);
        }
        if (string2 == null && (object = System.getProperty("user.home")) != null && object.length() > 0) {
            string2 = VerifyDirectory.parentDirOk((String)object, string);
        }
        return string2;
    }

    private static String parentDirOk(File file, String string) {
        String string2;
        try {
            string2 = file.getPath();
        }
        catch (Exception var3_3) {
            string2 = file.getAbsolutePath();
        }
        return VerifyDirectory.parentDirOk(string2, string);
    }

    private static String parentDirOk(String string, String string2) {
        String string3 = null;
        VerifyDirectory.logMessage("testing parent dir: " + string);
        File file = new File(string, string2);
        boolean bl = VerifyDirectory.testDir(file);
        if (bl) {
            string3 = string;
        }
        VerifyDirectory.logMessage("parentDir " + string + " ok: " + bl);
        return string3;
    }

    private static boolean testDir(String string) {
        boolean bl;
        boolean bl2 = bl = string != null && string.trim().length() > 0;
        if (bl) {
            File file = new File(string);
            bl = VerifyDirectory.testDir(file);
        }
        VerifyDirectory.logMessage("testDir " + string + ": " + bl);
        return bl;
    }

    private static boolean testDir(File file) {
        boolean bl = false;
        boolean bl2 = false;
        try {
            bl2 = file.exists();
            VerifyDirectory.logMessage("testing dir: " + file.getPath());
            VerifyDirectory.logMessage("dir exists: " + bl2);
            File file2 = new File(file, "deleteMe.JexTest");
            TempDirs tempDirs = new TempDirs(file2);
            if (file2.exists() && file2.isDirectory()) {
                file2.delete();
                VerifyDirectory.logMessage("created/deleted subdirectory");
                bl = VerifyDirectory.testFile(file);
            } else {
                bl = false;
                VerifyDirectory.logMessage("tested creating new directory ok: " + bl);
            }
            if (!bl2 && file.exists()) {
                tempDirs.delete();
                VerifyDirectory.logMessage("deleted " + file.getPath());
            }
            VerifyDirectory.logMessage(file.getPath() + " ok: " + bl);
        }
        catch (Exception var3_4) {
            // empty catch block
        }
        return bl;
    }

    private static boolean testFile(File file) {
        boolean bl = false;
        VerifyDirectory.logMessage("test creating a file in: " + file.getPath());
        File file2 = new File(file, "deleteMe.JexTest");
        try {
            file2.delete();
            if (file2.exists()) {
                bl = false;
                VerifyDirectory.logMessage("unable to delete test file");
            } else {
                FileOutputStream fileOutputStream = new FileOutputStream(file2);
                fileOutputStream.write(999);
                fileOutputStream.close();
                bl = file2.exists() && file2.length() > 0;
                VerifyDirectory.logMessage("wrote file: " + bl);
                if (bl) {
                    file2.delete();
                    bl = !file2.exists();
                    VerifyDirectory.logMessage("deleted file: " + bl);
                }
            }
        }
        catch (Exception var3_4) {
            bl = false;
            VerifyDirectory.logMessage("unexpected error testing file");
        }
        return bl;
    }

    private static String getDefaultDir(PropertyList propertyList) {
        String string = propertyList.getProperty("defaultApplicationDirectory");
        String string2 = null;
        if (string != null && string.length() > 0) {
            string = string.replace('/', File.separatorChar);
            if ((string = string.replace('\\', File.separatorChar)).startsWith("[$UserHomeDir]")) {
                String string3 = System.getProperty("user.home", "");
                string2 = string3 + string2.substring("[$UserHomeDir]".length());
            } else if (string.startsWith("[$JavaHomeDir]")) {
                String string4 = System.getProperty("java.home", "");
                string2 = string4 + string2.substring("[$JavaHomeDir]".length());
            } else if (string.startsWith(File.separator)) {
                string2 = string;
                VerifyDirectory.logMessage("default directory name starts with file separator");
            } else if (OS.isWindows() && string.length() >= 2 && ":".equals(string.substring(1, 2))) {
                string2 = string;
                VerifyDirectory.logMessage("default directory name starts with drive spec");
            } else {
                VerifyDirectory.logMessage("default directory name: " + string);
                string2 = string;
            }
        } else {
            VerifyDirectory.logMessage("no default directory name defined");
        }
        return string2;
    }

    private static String getDefaultParentDir(PropertyList propertyList) {
        String string;
        String string2 = null;
        if (OS.isWindows()) {
            VerifyDirectory.logMessage("trying default windows dir");
            string2 = propertyList.getProperty("defaultWindowsParentAppDir", VerifyDirectory.getWindowsProgramManagerDir());
            if (string2 == null || string2.length() <= 0) {
                VerifyDirectory.logMessage("no default windows parent dir set");
                string2 = VerifyDirectory.getWindowsProgramManagerDir();
            } else if (string2.startsWith("[$ProgFilesDir]")) {
                string = VerifyDirectory.getWindowsProgramManagerDir();
                string2 = string + string2.substring("[$ProgFilesDir]".length());
            } else if (string2.startsWith("[$WinDir]")) {
                string = VerifyDirectory.getWindowsDir();
                string2 = string + string2.substring("[$WinDir]".length());
            }
        } else if (OS.isMacOsX()) {
            VerifyDirectory.logMessage("trying default mac dir");
            string2 = propertyList.getProperty("defaultMacParentAppDir");
            if (string2 == null || string2.length() <= 0) {
                VerifyDirectory.logMessage("no default mac parent dir set");
                string2 = "[$UserHomeDir]/Applications";
                if (propertyList.getBooleanProperty("installAsAdmin", false)) {
                    string2 = "/Applications";
                }
            }
        } else if (OS.isLinux()) {
            VerifyDirectory.logMessage("trying default linux dir");
            string2 = propertyList.getProperty("defaultLinuxParentAppDir", "/usr/local/bin");
            if (string2 == null || string2.length() <= 0) {
                VerifyDirectory.logMessage("no default linux parent dir set");
                string2 = "/usr/local/bin";
            }
        } else if (OS.isSolaris()) {
            VerifyDirectory.logMessage("trying default solaris dir");
            string2 = propertyList.getProperty("defaultSolarisParentAppDir", "/usr/local/bin");
            if (string2 == null || string2.length() <= 0) {
                VerifyDirectory.logMessage("no default solari parent dir set");
                string2 = "/usr/local/bin";
            }
        } else {
            VerifyDirectory.logMessage("trying default unknown os dir");
            string2 = propertyList.getProperty("defaultOtherParentAppDir", "/usr/local/bin");
            if (string2 == null || string2.length() <= 0) {
                string2 = "/usr/local/bin";
            }
        }
        VerifyDirectory.logMessage("initial parent default dir: " + string2);
        string2 = string2.replace('/', File.separatorChar);
        string2 = string2.replace('\\', File.separatorChar);
        if (string2.startsWith("[$UserHomeDir]")) {
            VerifyDirectory.logMessage("converting user home variable");
            string = System.getProperty("user.home", "");
            string2 = string + string2.substring("[$UserHomeDir]".length());
        } else if (string2.startsWith("[$JavaHomeDir]")) {
            VerifyDirectory.logMessage("converting java home variable");
            string = System.getProperty("java.home", "");
            string2 = string + string2.substring("[$JavaHomeDir]".length());
        }
        if (string2.endsWith(File.separator)) {
            string2 = string2.substring(0, string2.length() - 1);
        }
        VerifyDirectory.logMessage("default parent directory: " + string2);
        return string2;
    }

    private static String getDefaultSubdir(PropertyList propertyList) {
        String string = propertyList.getProperty("defaultApplicationDirectory");
        String string2 = null;
        if (string != null && string.length() > 0) {
            string = string.replace('/', File.separatorChar);
            if ((string = string.replace('\\', File.separatorChar)).startsWith("[$UserHomeDir]")) {
                string2 = null;
                VerifyDirectory.logMessage("default directory starts with the user's home dir");
            } else if (OS.isWindows() && string.length() >= 2 && ":".equals(string.substring(1, 2))) {
                string2 = null;
                VerifyDirectory.logMessage("default directory name starts with drive spec");
            } else if (string.startsWith(File.separator)) {
                string2 = null;
                VerifyDirectory.logMessage("default directory name starts with file separator");
            } else {
                string2 = string;
                VerifyDirectory.logMessage("default directory name: " + string2);
            }
        } else {
            VerifyDirectory.logMessage("no default directory name defined");
        }
        return string2;
    }

    private static void setJvmInstallDir(String string, File file, PropertyList propertyList) {
        int n;
        String string2;
        boolean bl = propertyList.getBooleanProperty("nativeJvmInstalledInTemp", false);
        if (bl && CustomInstaller.multipleComponents() && (n = (string2 = file.getPath()).lastIndexOf(File.separator + string)) != -1) {
            string2 = string2.substring(0, n);
            String string3 = propertyList.getProperty("predefinedJvmInstallDir", "");
            n = string3.indexOf("[$AppDir]");
            if (n >= 0) {
                String string4 = string3.substring(n+="[$AppDir]".length());
                File file2 = new File(string2, string4);
                propertyList.setProperty("predefinedJvmInstallDir", file2.getPath());
            }
        }
    }

    private static String getWindowsDir() {
        if (windowsDir == null && (VerifyDirectory.windowsDir = WindowsDirs.getWindowsDirectory()) == null) {
            VerifyDirectory.logMessage("Unable to get windows dir");
            windowsDir = "";
        }
        return windowsDir;
    }

    private static String getWindowsProgramManagerDir() {
        if (windowsProgramManagerDir == null && (VerifyDirectory.windowsProgramManagerDir = WindowsDirs.getProgramManagerDirectory()) == null) {
            VerifyDirectory.logMessage("Unable to get windows program manager dir");
            windowsProgramManagerDir = "";
        }
        return windowsProgramManagerDir;
    }

    private static String getWindowsDocsDir() {
        if (windowsDocsDir == null && (VerifyDirectory.windowsDocsDir = WindowsDirs.getDocumentsDirectory()) == null) {
            VerifyDirectory.logMessage("Unable to get windows documents dir for current user");
            windowsDocsDir = "";
        }
        return windowsDocsDir;
    }

    private static void logMessage(String string) {
        if (log == null) {
            log = new Log("verifydirectory");
        }
        log.write(string);
        log.flush();
    }
}
