/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.JarException;
import com.denova.io.Log;
import com.denova.io.ZipEntryInputStream;
import com.denova.lang.TimeSharer;
import com.denova.util.Base64;
import com.denova.util.Cancelable;
import com.denova.util.PropertyList;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.security.DigestInputStream;
import java.security.MessageDigest;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Vector;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

public class JarManifest
implements Cancelable {
    public static final String Name = "Name";
    public static final String DigestAlgorithms = "Digest-Algorithms";
    public static final String SHADigest = "SHA-Digest";
    public static final String MD5Digest = "MD5-Digest";
    public static final String ManifestVersion = "Manifest-Version";
    public static final String ManifestVersionNumber = "1.0";
    public static final String MetaInformationPathname = "META-INF";
    static final String ManifestFilename = "MANIFEST.MF";
    static final char Space = ' ';
    static final char Colon = ':';
    static final int CarriageReturn = 13;
    static final int EOL = 10;
    static final int EOF = -1;
    static final String JarManifestLogFilename = "jarmanifest";
    private static Log jarManifestLog;
    boolean isJar;
    InputStream in;
    Vector manifest = new Vector();
    Properties headerSection;
    boolean isPushedBack;
    int pushedBackToken;
    boolean isPushedBackRaw;
    int pushedBackTokenRaw;
    int lineNumber;
    boolean canceled = false;

    JarManifest(ZipFile zipFile) throws Exception {
        ZipEntry zipEntry;
        jarManifestLog = new Log("jarmanifest");
        if (zipFile != null && (zipEntry = zipFile.getEntry(JarManifest.getManifestPathname())) != null) {
            ZipEntryInputStream zipEntryInputStream = new ZipEntryInputStream(zipFile, zipEntry);
            this.parseManifest(zipEntryInputStream);
            zipEntryInputStream.close();
        }
    }

    public JarManifest(File file) throws Exception {
        jarManifestLog = new Log("jarmanifest");
        FileInputStream fileInputStream = new FileInputStream(file);
        this.parseManifest(fileInputStream);
        fileInputStream.close();
    }

    public JarManifest(InputStream inputStream) throws JarException {
        jarManifestLog = new Log("jarmanifest");
        this.parseManifest(inputStream);
    }

    public JarManifest() {
        jarManifestLog = new Log("jarmanifest");
    }

    public boolean isJar() {
        return this.isJar;
    }

    public Properties getHeader() {
        return this.headerSection;
    }

    void addHeader(String string, String string2) {
        if (this.headerSection == null) {
            this.headerSection = new Properties();
        }
        this.headerSection.put(string, string2);
    }

    public List getItems() {
        return (Vector)this.manifest.clone();
    }

    public void clear() {
        this.manifest = new Vector();
    }

    public void addSection(Properties properties) {
        if (!this.canceled) {
            this.manifest.add(properties);
        }
    }

    public void write(ZipOutputStream zipOutputStream) throws Exception {
        this.isJar = true;
        if (!this.canceled) {
            ZipEntry zipEntry = new ZipEntry(JarManifest.getManifestPathname());
            zipOutputStream.putNextEntry(zipEntry);
            PrintWriter printWriter = new PrintWriter(zipOutputStream);
            this.write(printWriter);
            String string = System.getProperty("java.version");
            if (string.compareTo("1.2") < 0) {
                printWriter.close();
            } else {
                printWriter.flush();
            }
            zipOutputStream.closeEntry();
        }
    }

    public void write(OutputStream outputStream) throws Exception {
        if (!this.canceled) {
            PrintWriter printWriter = new PrintWriter(outputStream);
            this.write(printWriter);
            String string = System.getProperty("java.version");
            if (string.compareTo("1.2") < 0) {
                printWriter.close();
            } else {
                printWriter.flush();
            }
        }
    }

    public void write(PrintWriter printWriter) throws Exception {
        if (!(this.manifest == null || this.canceled)) {
            Object object;
            printWriter.println("Manifest-Version: 1.0");
            if (this.headerSection != null && (object = new PropertyList(this.headerSection)) != null) {
                for (String string : object.propertyNamesList()) {
                    String string2 = this.headerSection.getProperty(string, "");
                    printWriter.println(string + ':' + ' ' + string2);
                }
            }
            printWriter.println();
            object = this.manifest.iterator();
            while (object.hasNext() && !this.canceled) {
                Object object2 = (Properties)object.next();
                this.writeAVPair((Properties)object2, "Name", printWriter);
                this.writeAVPair((Properties)object2, "Digest-Algorithms", printWriter);
                this.writeAVPair((Properties)object2, "SHA-Digest", printWriter);
                this.writeAVPair((Properties)object2, "MD5-Digest", printWriter);
                printWriter.println();
                TimeSharer.yield();
            }
        }
    }

    public void writeAVPair(Properties properties, String string, PrintWriter printWriter) throws Exception {
        String string2 = properties.getProperty(string);
        printWriter.println(string + ':' + ' ' + string2);
    }

    public static Properties createSection(String string, String string2) {
        Properties properties = null;
        try {
            File file = new File(string);
            FileInputStream fileInputStream = new FileInputStream(file.getPath());
            MessageDigest messageDigest = MessageDigest.getInstance("SHA");
            MessageDigest messageDigest2 = MessageDigest.getInstance("MD5");
            DigestInputStream digestInputStream = new DigestInputStream(fileInputStream, messageDigest);
            DigestInputStream digestInputStream2 = new DigestInputStream(digestInputStream, messageDigest2);
            byte[] arrby = new byte[30000];
            int n = digestInputStream2.read(arrby);
            long l = n;
            while (n > 0) {
                TimeSharer.yield();
                n = digestInputStream2.read(arrby);
                l+=(long)n;
            }
            JarManifest.log("totalBytesRead: " + String.valueOf(l));
            string2 = string2.replace(File.separatorChar, '/');
            string2 = string2.replace(':', '|');
            properties = new Properties();
            properties.put("Name", string2);
            properties.put("Digest-Algorithms", "SHA MD5");
            properties.put("SHA-Digest", JarManifest.base64(digestInputStream));
            properties.put("MD5-Digest", JarManifest.base64(digestInputStream2));
            JarManifest.log("created section for " + string2 + " (" + string + ")");
            digestInputStream2.close();
            digestInputStream.close();
            fileInputStream.close();
        }
        catch (Exception var3_4) {
            JarManifest.log("Error adding entry to manifest " + string2);
            JarManifest.log(var3_4);
        }
        return properties;
    }

    public void parseManifest(InputStream inputStream) throws JarException {
        this.isJar = true;
        this.lineNumber = 1;
        JarManifest.log("started to parse manifest");
        try {
            this.in = inputStream;
            try {
                if (this.moreTokens()) {
                    this.headerSection = this.parseSection();
                }
                JarManifest.log("starting to add sections");
                while (this.moreTokens() && !this.canceled) {
                    this.addSection(this.parseSection());
                    TimeSharer.yield();
                }
                JarManifest.log("finished adding sections");
            }
            catch (IOException var2_2) {
                var2_2.printStackTrace();
                throw new JarException("Unable to parse manifest at line " + this.lineNumber + ": " + var2_2);
            }
            this.in.close();
        }
        catch (Exception var2_3) {
            var2_3.printStackTrace();
            throw new JarException("Manifest stream not readable: " + var2_3);
        }
        JarManifest.log("finished parsing manifest");
    }

    public static String getManifestPathname() {
        return "META-INF/MANIFEST.MF";
    }

    public static String getManifestDirname() {
        return "META-INF";
    }

    public static String getManifestFilename() {
        return "MANIFEST.MF";
    }

    Properties parseSection() throws JarException, IOException {
        JarManifest.log("starting to parseSection");
        Properties properties = new Properties();
        boolean bl = false;
        int n = this.nextToken();
        while (!(n == 10 || n == -1 || this.canceled)) {
            this.pushBack(n);
            this.parseAvPair(properties);
            n = this.nextToken();
            TimeSharer.yield();
        }
        while (!(n != 10 || n == -1 || this.canceled)) {
            n = this.nextToken();
            TimeSharer.yield();
        }
        this.pushBack(n);
        JarManifest.log("finished parseSection");
        return properties;
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    void parseAvPair(Properties properties) throws JarException, IOException {
        JarManifest.log("starting to parseAvPair");
        StringBuffer stringBuffer = new StringBuffer();
        int n = this.nextToken();
        while (!(n == 58 || n == 10 || n == -1 || this.canceled)) {
            stringBuffer.append((char)n);
            n = this.nextToken();
            TimeSharer.yield();
        }
        if (!this.canceled) {
            if (n != 58) throw new JarException("Colon expected in manifest at line " + this.lineNumber);
            n = this.nextToken();
            if (n != 32) throw new JarException("Space expected in manifest at line " + this.lineNumber);
            StringBuffer stringBuffer2 = new StringBuffer();
            boolean bl = true;
            n = this.nextToken();
            while (bl) {
                if (n == 10) {
                    n = this.nextToken();
                    if (n != 32) {
                        this.pushBack(n);
                        bl = false;
                        properties.put(stringBuffer.toString(), stringBuffer2.toString());
                        JarManifest.log("   attribute: " + stringBuffer.toString() + " value: " + stringBuffer2.toString());
                    }
                } else if (n == -1) {
                    bl = false;
                } else {
                    stringBuffer2.append((char)n);
                }
                if (bl) {
                    n = this.nextToken();
                }
                TimeSharer.yield();
            }
        }
        JarManifest.log("finished parseAvPair");
    }

    boolean moreTokens() {
        boolean bl;
        try {
            int n = this.nextToken();
            this.pushBack(n);
            bl = n != -1;
        }
        catch (Exception var2_2) {
            bl = false;
        }
        return bl;
    }

    int nextToken() throws IOException {
        int n;
        if (this.isPushedBack) {
            n = this.pushedBackToken;
            if (n != -1) {
                this.isPushedBack = false;
            }
        } else if (this.isPushedBackRaw) {
            n = this.pushedBackTokenRaw;
            this.isPushedBackRaw = false;
        } else {
            n = this.in.read();
            if (n == 13 && (n = this.in.read()) != 10) {
                this.pushBackRaw(n);
                n = 10;
            }
            if (n == 10) {
                ++this.lineNumber;
            }
            if (n == -1) {
                this.pushBack(n);
            }
        }
        return n;
    }

    private static String base64(DigestInputStream digestInputStream) {
        return Base64.toString(digestInputStream.getMessageDigest().digest());
    }

    void pushBack(int n) {
        this.isPushedBack = true;
        this.pushedBackToken = n;
    }

    void pushBackRaw(int n) {
        this.isPushedBackRaw = true;
        this.pushedBackTokenRaw = n;
    }

    public void setCancel(boolean bl) {
        this.canceled = bl;
    }

    public boolean isCanceled() {
        return this.canceled;
    }

    private static void log(String string) {
        if (jarManifestLog != null) {
            jarManifestLog.write(string);
        }
    }

    private static void log(Exception exception) {
        if (jarManifestLog != null) {
            jarManifestLog.write(exception);
        }
    }
}
