/*
 * Decompiled with CFR 0_101.
 */
package com.denova.io;

import com.denova.io.Log;
import com.denova.runtime.OS;
import java.io.File;
import java.io.FileOutputStream;
import java.util.List;
import java.util.Vector;

public class TempFiles {
    static Log log;
    static List files;
    static boolean cleanupEnabled;
    static File defaultDirectory;
    static String tempDirname;

    public static void makeDirs(String string) {
        TempFiles.makeDirs(new File(string));
    }

    public static void makeDirs(File file) {
        if (!file.exists()) {
            TempFiles.add(file);
            String string = file.getParent();
            if (string != null) {
                TempFiles.makeDirs(string);
            }
            file.mkdir();
        }
    }

    public static void add(String string) {
        TempFiles.add(new File(string));
    }

    public static void add(List list) {
        for (File file : list) {
            files.add(file);
            TempFiles.debug("Added " + file.getPath());
        }
    }

    public static void add(String[] arrstring) {
        if (arrstring != null) {
            int n = arrstring.length;
            TempFiles.debug("Adding " + String.valueOf(n) + " files");
            for (int i = 0; i < n; ++i) {
                TempFiles.add(arrstring[i]);
            }
        }
    }

    public static void add(String string, String[] arrstring) {
        if (arrstring != null) {
            int n = arrstring.length;
            TempFiles.debug("Adding " + String.valueOf(n) + " files");
            for (int i = 0; i < n; ++i) {
                TempFiles.add(new File(string, arrstring[i]));
            }
        }
    }

    public static void add(File file) {
        if (cleanupEnabled) {
            TempFiles.debug("Added " + file.getPath());
            files.add(file);
        } else {
            TempFiles.debug("Unable to add " + file.getPath());
        }
    }

    public static void delete() {
        Vector<File> vector = new Vector<File>();
        for (File file2 : files) {
            if (!file2.exists() || file2.isDirectory()) continue;
            if (file2.delete()) {
                TempFiles.debug("Deleted " + file2.getPath());
                continue;
            }
            TempFiles.debug("Unable to delete " + file2.getPath());
            vector.add(file2);
        }
        for (File file2 : files) {
            if (!file2.exists() || !file2.isDirectory()) continue;
            TempFiles.deleteEmptySubdirs(file2, vector);
            if (file2.delete()) {
                TempFiles.debug("Deleted directory " + file2.getPath());
                continue;
            }
            TempFiles.debug("Unable to delete directory " + file2.getPath());
            vector.add(file2);
        }
        files = vector;
    }

    public static File getFile(File file) {
        return TempFiles.getFile(file.getPath());
    }

    public static File getFile(String string) {
        String string2 = ":" + File.separator;
        File file = string.startsWith(File.separator) || OS.isWindows() && string.indexOf(string2) > 0 ? new File(string) : new File(TempFiles.getDefaultDirectory(), string);
        TempFiles.add(file);
        return file;
    }

    public static void setDefaultDirectory(String string) {
        TempFiles.setDefaultDirectory(new File(string));
    }

    public static void setDefaultDirectory(File file) {
        defaultDirectory = file;
    }

    public static File getDefaultDirectory() {
        if (defaultDirectory == null) {
            defaultDirectory = new File(TempFiles.getDefaultTempDirectory());
        }
        return defaultDirectory;
    }

    public static String getTempDirectory(String string) {
        if (tempDirname == null || tempDirname.length() <= 0) {
            String string2 = TempFiles.getDefaultTempDirectory();
            if (string2 != null) {
                tempDirname = TempFiles.createTempSubdirectory(string2, string);
            }
            if (tempDirname == null) {
                string2 = System.getProperty("user.home", "");
                tempDirname = TempFiles.createTempSubdirectory(string2, string);
            }
            if (tempDirname == null) {
                string2 = System.getProperty("user.dir", "");
                tempDirname = TempFiles.createTempSubdirectory(string2, string);
            }
            if (tempDirname != null && tempDirname.length() > 0) {
                TempFiles.add(tempDirname);
                TempFiles.setDefaultDirectory(tempDirname);
            } else {
                tempDirname = "";
            }
        }
        return tempDirname;
    }

    private static String createTempSubdirectory(String string, String string2) {
        String string3 = null;
        if (string != null) {
            File file = new File(string, string2);
            boolean bl = TempFiles.tempDirOk(file);
            for (int i = 1; !(bl || i >= 50); ++i) {
                file = new File(string, string2 + String.valueOf(i));
                bl = TempFiles.tempDirOk(file);
                Thread.yield();
            }
            if (bl) {
                try {
                    string3 = file.getCanonicalPath();
                }
                catch (Exception var6_6) {
                    string3 = file.getPath();
                }
            }
        }
        TempFiles.debug("tempDir: " + string3);
        return string3;
    }

    private static boolean dirOk(String string) {
        boolean bl;
        if (string == null) {
            bl = false;
        } else {
            File file = new File(string);
            if (!file.exists()) {
                file.mkdirs();
            }
            bl = file.exists() && TempFiles.dirWritable(file);
        }
        return bl;
    }

    private static boolean tempDirOk(String string) {
        boolean bl = string == null ? false : TempFiles.tempDirOk(new File(string));
        return bl;
    }

    private static boolean tempDirOk(File file) {
        boolean bl = false;
        file.delete();
        if (!file.exists()) {
            bl = file.mkdir() && TempFiles.dirWritable(file);
        }
        return bl;
    }

    private static boolean dirWritable(File file) {
        boolean bl;
        if (!(file != null && file.exists())) {
            bl = false;
        } else {
            File file2 = new File(file, "test.txt");
            try {
                FileOutputStream fileOutputStream = new FileOutputStream(file2);
                fileOutputStream.write(0);
                fileOutputStream.close();
                file2.delete();
                bl = true;
            }
            catch (Exception var3_4) {
                bl = false;
            }
        }
        return bl;
    }

    public static String getDefaultTempDirectory() {
        String string = null;
        String string2 = null;
        try {
            string2 = System.getProperty("java.io.tmpdir");
        }
        catch (Exception var2_2) {
            // empty catch block
        }
        if (TempFiles.dirOk(string2)) {
            string = string2;
        } else if (OS.isUnix()) {
            string2 = "/tmp";
            if (!TempFiles.tempDirOk(string2)) {
                string2 = "/temp";
            }
            if (!TempFiles.tempDirOk(string2)) {
                string2 = "/usr/tmp";
            }
            if (!TempFiles.tempDirOk(string2)) {
                string2 = "/usr/temp";
            }
            if (!TempFiles.tempDirOk(string2) && OS.isMacOsX()) {
                string2 = "/private/tmp";
            }
            if (TempFiles.tempDirOk(string2)) {
                string = string2;
            }
        } else if (OS.isWindows()) {
            File file = new File(System.getProperty("user.home"), "temp");
            if (TempFiles.tempDirOk(file)) {
                string = file.getPath();
            }
            if (string == null && TempFiles.tempDirOk(file = new File(System.getProperty("user.home"), "tmp"))) {
                string = file.getPath();
            }
            if (string == null && TempFiles.tempDirOk(file = new File("/Temp"))) {
                string = file.getPath();
            }
            if (string == null && TempFiles.tempDirOk(file = new File("/Tmp"))) {
                string = file.getPath();
            }
        }
        if (string == null && TempFiles.tempDirOk(string2 = System.getProperty("user.dir", "tmp"))) {
            string = string2;
        }
        return string;
    }

    static void deleteEmptySubdirs(File file, List list) {
        String[] arrstring = file.list();
        for (int i = 0; i < arrstring.length; ++i) {
            File file2 = new File(file, arrstring[i]);
            if (!file2.exists() || !file2.isDirectory()) continue;
            TempFiles.deleteEmptySubdirs(file2, list);
            if (file2.delete()) {
                TempFiles.debug("Deleted directory " + file2.getPath());
                continue;
            }
            TempFiles.debug("Unable to delete directory " + file2.getPath());
            list.add(file2);
        }
    }

    public static void setCleanupEnabled(boolean bl) {
        cleanupEnabled = bl;
    }

    public static boolean getCleanupEnabled() {
        return cleanupEnabled;
    }

    static void debug(String string) {
        if (log == null) {
            log = new Log("tempFiles");
        }
        if (log != null) {
            log.write("TempFiles: " + string);
        }
    }

    static {
        files = new Vector();
        cleanupEnabled = true;
        defaultDirectory = null;
        tempDirname = null;
    }
}
