/*
 * Decompiled with CFR 0_101.
 */
package com.denova.net;

import com.denova.io.Log;
import com.denova.ui.GridBagControl;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.UserNotices;
import com.denova.util.LocaleTranslator;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import javax.swing.AbstractButton;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

public class GetProxySettings {
    public static final String HttpProxyType = "http";
    public static final String SocksProxyType = "socks";
    private static final boolean debugging = false;
    private static final Log log = new Log("getproxy.log");
    private boolean userOk;
    private JTextField host;
    private JTextField port;
    private JTextField userName;
    private JPasswordField password;
    private JRadioButton httpProxy;
    private JRadioButton socksProxy;
    private String header = null;
    private String subhead = null;
    private LocaleTranslator localized;

    public GetProxySettings(LocaleTranslator localeTranslator) {
        this.localized = localeTranslator;
    }

    public void setHostAsFocus() {
        UiLayoutUtilities.setFocus(this.host);
    }

    public void setHost(String string) {
        UiLayoutUtilities.update((Component)this.host, (Object)string);
        log.write("initial host: " + this.host.getText());
    }

    public String getHost() {
        log.write("final host: " + this.host.getText().trim());
        return this.host.getText().trim();
    }

    public void setPort(int n) {
        if (n != -1 && n != 0) {
            UiLayoutUtilities.update((Component)this.port, (Object)String.valueOf(n));
        }
        log.write("initial port: " + this.port.getText().trim());
    }

    public int getPort() {
        int n = -1;
        try {
            n = new Integer(this.port.getText().trim());
        }
        catch (Exception var2_2) {
            // empty catch block
        }
        log.write("final port: " + n);
        return n;
    }

    public void setType(String string) {
        if ("socks".equalsIgnoreCase(string)) {
            UiLayoutUtilities.update((Component)this.socksProxy, true);
            UiLayoutUtilities.update((Component)this.httpProxy, false);
            log.write("initial type: socks");
        } else {
            UiLayoutUtilities.update((Component)this.httpProxy, true);
            UiLayoutUtilities.update((Component)this.socksProxy, false);
            log.write("initial type: http");
        }
    }

    public String getType() {
        String string = "http";
        if (this.socksProxy.isSelected()) {
            string = "socks";
        }
        return string;
    }

    public void setUserName(String string) {
        UiLayoutUtilities.update((Component)this.userName, (Object)string);
        log.write("initial user name length: " + this.userName.getText().trim().length());
    }

    public String getUserName() {
        log.write("final user name length: " + this.userName.getText().trim().length());
        return this.userName.getText().trim();
    }

    public void setPassword(String string) {
        UiLayoutUtilities.update((Component)this.password, (Object)string);
        log.write("initial password length: " + this.password.getText().trim().length());
    }

    public String getPassword() {
        log.write("final password length: " + this.password.getText().trim().length());
        return this.password.getText().trim();
    }

    public boolean isOk() {
        boolean bl = true;
        try {
            String string = this.port.getText();
            if (string.trim().length() > 0) {
                new Integer(string.trim()).intValue();
            }
        }
        catch (Exception var2_3) {
            bl = false;
            log.write(var2_3);
        }
        return bl;
    }

    public void showError() {
        UserNotices userNotices = new UserNotices();
        userNotices.noteError(this.getLocalizedString("ProxyPortError", "The port must only contain digits."));
    }

    public void showHelp() {
        UserNotices userNotices = new UserNotices();
        userNotices.note(this.getLocalizedString("ProxyHelp", "If your computer uses a proxy to connect to the internet, then enter the appropriate data."));
    }

    public void setHeader(String string) {
        this.header = string;
        log.write("header: " + this.header);
    }

    public void setSubhead(String string) {
        this.subhead = string;
        log.write("subhead: " + this.subhead);
    }

    public String getTitle() {
        return this.getLocalizedString("LicenseError", "Unable to Verify Your License");
    }

    public TransparentJPanel createMainPanel() {
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        GridBagConstraints gridBagConstraints = GridBagControl.getLabelForTextConstraints();
        GridBagConstraints gridBagConstraints2 = GridBagControl.getTextConstraints();
        GridBagConstraints gridBagConstraints3 = GridBagControl.getDefaultConstraints();
        gridBagConstraints3.anchor = 17;
        gridBagControl.endRow(this.getHeaderPanel());
        this.host = new JTextField(15);
        this.host.setToolTipText(this.getLocalizedString("ProxyHostHelp", "Name of the proxy's host."));
        gridBagControl.add(gridBagConstraints, new JLabel(this.getLocalizedString("ProxyHost", "Proxy host:")));
        gridBagControl.endRow(gridBagConstraints2, this.host);
        this.port = new JTextField(15);
        this.port.setToolTipText(this.getLocalizedString("ProxyPortHelp", "Port number for the proxy."));
        gridBagControl.add(gridBagConstraints, new JLabel(this.getLocalizedString("ProxyPort", "Port:")));
        gridBagControl.endRow(gridBagConstraints2, this.port);
        gridBagControl.add(gridBagConstraints, new JLabel(this.getLocalizedString("Type", "Type:")));
        ButtonGroup buttonGroup = new ButtonGroup();
        Box box = Box.createHorizontalBox();
        this.httpProxy = new JRadioButton("<html>" + this.getLocalizedString("HTTPProxy", "HTTP") + "</html>", true);
        this.httpProxy.setToolTipText(this.getLocalizedString("HttpProxyTypeHelp", "This is the most common type of proxy and if you're unsure select this type."));
        buttonGroup.add(this.httpProxy);
        box.add(this.httpProxy);
        box.add(new JLabel("   "));
        this.socksProxy = new JRadioButton("<html>" + this.getLocalizedString("SOCKSProxy", "SOCKS") + "</html>", false);
        this.socksProxy.setToolTipText(this.getLocalizedString("SocksProxyTypeHelp", "You're more likely to find a SOCKS proxy in very large corporations."));
        buttonGroup.add(this.socksProxy);
        box.add(this.socksProxy);
        gridBagControl.add(gridBagConstraints3, box);
        gridBagControl.endRow();
        gridBagControl.addBlankRow();
        gridBagControl.addCentered(new JLabel(this.getLocalizedString("Credentials", "Credentials")));
        this.userName = new JTextField(15);
        this.userName.setToolTipText(this.getLocalizedString("ProxyUserNameHelp", "User's name for the proxy, if required by proxy."));
        gridBagControl.add(gridBagConstraints, new JLabel(this.getLocalizedString("ProxyUserName", "User name:")));
        gridBagControl.endRow(gridBagConstraints2, this.userName);
        this.password = new JPasswordField(15);
        this.password.setToolTipText(this.getLocalizedString("ProxyPasswordHelp", "Password for the proxy, if required by proxy."));
        gridBagControl.add(gridBagConstraints, new JLabel(this.getLocalizedString("ProxyPassword", "Password:")));
        gridBagControl.endRow(gridBagConstraints2, this.password);
        return transparentJPanel;
    }

    private TransparentJPanel getHeaderPanel() {
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        GridBagConstraints gridBagConstraints = GridBagControl.getTextConstraints();
        if (this.header != null) {
            String string = this.header;
            String string2 = "";
            if (this.header.length() > 75) {
                int n = this.header.substring(75).indexOf(" ") + 75;
                string = this.header.substring(0, n).trim();
                string2 = this.header.substring(n).trim();
                JLabel jLabel = new JLabel(string.trim());
                gridBagControl.endRow(gridBagConstraints, jLabel);
                log.write("added header1: " + jLabel.getText());
                JLabel jLabel2 = new JLabel(string2.trim());
                gridBagControl.endRow(gridBagConstraints, jLabel2);
                log.write("added header2: " + jLabel2.getText());
            } else {
                JLabel jLabel = new JLabel(this.header.trim());
                gridBagControl.endRow(gridBagConstraints, jLabel);
                log.write("added header: " + jLabel.getText());
            }
        }
        if (this.subhead != null) {
            gridBagControl.endRow(gridBagConstraints, new JLabel(this.subhead));
            log.write("added subhead: " + this.subhead);
        }
        return transparentJPanel;
    }

    private String getLocalizedString(String string, String string2) {
        String string3 = string2;
        string3 = this.localized == null ? string2 : this.localized.getString(string, string2);
        return string3;
    }

    void debug(String string) {
    }
}
