/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.io.RedirectStderr;
import com.denova.io.RedirectStdin;
import com.denova.io.RedirectStdout;
import com.denova.io.TempFiles;
import com.denova.runtime.OS;
import com.denova.util.StringArray;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.List;
import java.util.Vector;

public class Exec {
    private static final boolean debugging = false;
    public static final String CommandLauncher = "cmd.exe";
    public static final String WindowsCommandFilename = "_tempcmd.bat";
    public static final String UnixCommandFilename = ".tmpjcmd";
    private static final String EndOfStreamToken = "qzEOSqz";
    private static final String ErrorExecutingMsg = "Error executing ";
    private static final String ColonSpaceString = ": ";
    private static final String ChmodCommand = "chmod 0744";
    private static final char DoubleQuote = '\"';
    private static final char SingleQuote = '\'';
    private static Log execLog = null;
    private static boolean launchBatchCommand = false;

    public static int execCommand(String string) throws Exception {
        Exec.log("execCommand: " + string);
        String[] arrstring = Exec.getCommandAsStringArray(string);
        return Exec.execCommand(arrstring);
    }

    public static int execCommand(String[] arrstring) throws Exception {
        int n = arrstring.length;
        for (int i = 0; i < n; ++i) {
            Exec.log("command[" + i + "]: " + arrstring[i]);
        }
        Runtime runtime = Runtime.getRuntime();
        Process process = runtime.exec(arrstring);
        RedirectStderr redirectStderr = new RedirectStderr(process.getErrorStream());
        RedirectStdout redirectStdout = new RedirectStdout(process.getInputStream());
        RedirectStdin redirectStdin = new RedirectStdin(process.getOutputStream());
        redirectStderr.start();
        redirectStdout.start();
        redirectStdin.start();
        int n2 = process.waitFor();
        return n2;
    }

    public static void runCommand(String string, String string2) throws Exception {
        Exec.runCommand(string, new File(string2));
    }

    public static void runCommand(String string, File file) throws Exception {
        String string2 = string;
        Exec.log("runCommand: " + string2);
        Exec.log("      from: " + file.getPath());
        if (OS.isWindows()) {
            string2 = Exec.getWindowsCommand(string, file.getPath());
        } else if (OS.isUnix()) {
            string2 = Exec.getUnixCommand(string, file.getPath());
        }
        Exec.log("batchCommand: " + string2);
        Exec.runCommand(string2);
        Exec.removeCommandFile();
    }

    public static void runCommand(String string) throws Exception {
        String[] arrstring = Exec.getCommandAsStringArray(string);
        if (arrstring != null && arrstring.length > 0) {
            Exec.runCommand(arrstring);
        }
    }

    public static void runCommand(String[] arrstring) throws Exception {
        Process process = Exec.runExec(arrstring);
        Exec.log("about to waitFor process");
        process.waitFor();
        Exec.log("finished waiting for process");
        Exec.log("Custom command process result: " + process.exitValue());
    }

    public static String getCommandOutput(String string) throws Exception {
        String[] arrstring = Exec.getCommandAsStringArray(string);
        String string2 = null;
        if (arrstring != null && arrstring.length > 0) {
            string2 = Exec.getCommandOutput(arrstring);
        }
        return string2;
    }

    public static String getCommandOutput(String[] arrstring) throws Exception {
        Process process = Exec.runExec(arrstring);
        Exec.log("about to waitFor process");
        process.waitFor();
        Exec.log("finished waiting for process");
        char[] arrc = new char[50000];
        StringBuffer stringBuffer = new StringBuffer(50000);
        InputStreamReader inputStreamReader = new InputStreamReader(process.getInputStream());
        int n = inputStreamReader.read(arrc);
        for (int i = 0; n >= 0 && i < 50000; i+=n) {
            stringBuffer.append(arrc, 0, n);
        }
        inputStreamReader.close();
        Exec.log("Custom command process result: " + process.exitValue());
        Exec.log("results: " + stringBuffer.toString());
        return stringBuffer.toString();
    }

    public static void launchCommand(String string, String string2) throws Exception {
        String string3 = string;
        File file = new File(string2);
        Exec.log("launchCommand: " + string3);
        Exec.log("         from: " + file.getPath());
        launchBatchCommand = true;
        if (OS.isWindows()) {
            string3 = Exec.getWindowsCommand(string, file.getPath());
        } else if (OS.isUnix()) {
            string3 = Exec.getUnixCommand(string, file.getPath());
        }
        Exec.launchCommand(string3);
        launchBatchCommand = false;
        Exec.removeCommandFile();
    }

    public static void launchCommand(String string) throws Exception {
        String[] arrstring = Exec.getCommandAsStringArray(string);
        if (arrstring != null && arrstring.length > 0) {
            Process process = Exec.runExec(arrstring);
            if (launchBatchCommand && OS.isWindows()) {
                Exec.log("finished getRuntime. exec; waiting for process output");
                while (process.getErrorStream().available() <= 0 && process.getInputStream().available() <= 0) {
                    Thread.sleep(1000);
                    Thread.yield();
                }
                Thread.sleep(1000);
                Thread.yield();
                Exec.log("about to get process output");
                Exec.logProcessOutput(process, arrstring[0]);
            } else {
                Exec.log("about to waitFor process");
                process.waitFor();
                Exec.log("Custom command process result: " + process.exitValue());
            }
        }
    }

    public static void startAppWithoutWaiting(String string) throws Exception {
        String[] arrstring = Exec.getCommandAsStringArray(string);
        if (arrstring == null || arrstring.length <= 0) {
            Exec.log("unable to start command without waiting because command is empty");
        } else {
            Exec.log("starting app without waiting");
            int n = 0;
            while (n < arrstring.length) {
                Exec.log("arg: " + arrstring[n++]);
            }
            Runtime runtime = Runtime.getRuntime();
            Process process = runtime.exec(arrstring);
            RedirectStderr redirectStderr = new RedirectStderr(process.getErrorStream());
            RedirectStdout redirectStdout = new RedirectStdout(process.getInputStream());
            RedirectStdin redirectStdin = new RedirectStdin(process.getOutputStream());
            redirectStderr.start();
            redirectStdout.start();
            redirectStdin.start();
        }
    }

    public static String[] getCommandAsStringArray(String string) throws Exception {
        Exec.log("getting command line args from: " + string);
        List list = Exec.getCommandArgs(string);
        String[] arrstring = Exec.getCommandAsStringArray(list);
        return arrstring;
    }

    public static String[] getCommandAsStringArray(List list) throws Exception {
        Exec.log("getting command line args from: " + list);
        StringArray stringArray = new StringArray();
        stringArray.setList(list);
        String[] arrstring = stringArray.getStrings();
        if (arrstring.length > 0) {
            String string = arrstring[0];
            if (string.length() >= 3 && string.startsWith("\"") && string.endsWith("\"")) {
                string = string.substring(1);
                string = string.substring(0, string.length() - 1);
            }
            Exec.log("program: " + string);
            if (OS.isUnix()) {
                arrstring[0] = Exec.getUnixCommandArray(string);
                Exec.log("cmdArray[0]: " + arrstring[0]);
            }
        }
        return arrstring;
    }

    public static List getCommandArgs(String string) throws Exception {
        Vector<Object> vector = new Vector<Object>();
        int n = 0;
        while (n < string.length()) {
            Object object;
            StringBuffer stringBuffer = new StringBuffer();
            Object object2 = 32;
            Object object3 = 32;
            boolean bl = false;
            boolean bl2 = false;
            boolean bl3 = false;
            int n2 = n;
            while (!(n >= string.length() || bl2)) {
                object = string.charAt(n);
                if (bl) {
                    if (object == object2) {
                        bl = false;
                        object2 = 32;
                        Exec.log("found end of inside quote");
                    }
                    stringBuffer.append((char)object);
                } else if (bl3) {
                    if (object == object3 && (n + 1 < string.length() && Exec.isWhiteSpace(string.charAt(n + 1)) || n + 1 == string.length())) {
                        bl3 = false;
                        object3 = 32;
                        Exec.log("found end of arg quote");
                    } else {
                        stringBuffer.append((char)object);
                    }
                } else if (Exec.isWhiteSpace((char)object)) {
                    bl2 = true;
                } else if (object == 34 || object == 39) {
                    if (n2 == n) {
                        bl3 = true;
                        object3 = object;
                        Exec.log("found start of arg quote");
                    } else {
                        bl = true;
                        object2 = object;
                        Exec.log("found start of inside quote");
                    }
                    if (bl) {
                        stringBuffer.append((char)object);
                        Exec.log("saving inside quote");
                    } else {
                        Exec.log("not saving arg quote");
                    }
                } else {
                    stringBuffer.append((char)object);
                }
                ++n;
            }
            object = stringBuffer.toString().trim();
            if (!bl3 && object.length() <= 0) continue;
            vector.add(object);
            Exec.log("cmdArray[" + n + "]: " + (String)object);
        }
        return vector;
    }

    private static String getUnixCommandArray(String string) {
        String string2 = string;
        if (string2.indexOf(File.separator) < 0) {
            File file = new File(string2);
            if (file.exists()) {
                string2 = "." + File.separator + string2;
            } else {
                String string3 = File.separator + "bin";
                file = new File(string3, string2);
                if (!(file.exists() || (file = new File(string3 = File.separator + "usr" + File.separator + "bin", string2)).exists() || (file = new File(string3 = File.separator + "sbin", string2)).exists())) {
                    string3 = File.separator + "usr" + File.separator + "sbin";
                    file = new File(string3, string2);
                }
                if (file.exists()) {
                    string2 = file.getPath();
                }
            }
        }
        return string2;
    }

    private static Process runExec(String[] arrstring) throws Exception {
        String[] arrstring2 = arrstring;
        for (int i = 0; i < arrstring2.length; ++i) {
            Exec.log("Command arg [" + i + "]: " + arrstring2[i]);
        }
        Exec.log("about to getRuntime.exec ");
        Process process = Runtime.getRuntime().exec(arrstring2);
        Exec.log("returned from getRuntime.exec ");
        return process;
    }

    public static String getWindowsCommand(String string, String string2) {
        String string3 = string;
        String string4 = string2;
        File file = new File(TempFiles.getDefaultDirectory(), Exec.getCommandFilename());
        try {
            int n;
            Exec.log("begin batch file");
            FileWriter fileWriter = new FileWriter(file.getPath());
            PrintWriter printWriter = new PrintWriter(fileWriter);
            printWriter.println("@echo off");
            if (string4 != null && string4.length() > 0) {
                String string5 = ":" + File.separator;
                if (string4.indexOf(string5) > 0) {
                    int n2 = string4.indexOf(string5) + string5.length();
                    printWriter.println(Exec.quoteArg(string4.substring(0, n2)));
                    string4 = string4.substring(n2);
                }
                printWriter.println("cd " + Exec.quoteArg(string4));
                Exec.log("cd " + Exec.quoteArg(string4));
            }
            if ((n = string3.indexOf(".bat")) < 0) {
                n = string3.indexOf(".cmd");
            }
            if (n > 0) {
                string3 = "call " + string3;
            }
            printWriter.println(string3);
            Exec.log(string3);
            if (launchBatchCommand) {
                printWriter.println("echo qzEOSqz");
                Exec.log("echo qzEOSqz");
            }
            printWriter.flush();
            fileWriter.flush();
            printWriter.close();
            fileWriter.close();
            Exec.log("end batch file");
            TempFiles.add(file.getPath());
            string3 = "cmd.exe /c " + Exec.quoteArg(file.getPath());
        }
        catch (Exception var5_6) {
            Exec.log(var5_6);
            file.delete();
        }
        return string3;
    }

    private static String getUnixCommand(String string, String string2) {
        String string3;
        block7 : {
            string3 = string;
            String string4 = Exec.getProgramName(string3);
            File file = new File(string2, string4);
            if (string4.length() > 0 && file.exists()) {
                string3 = "./" + string3;
            }
            File file2 = new File(TempFiles.getDefaultDirectory(), Exec.getCommandFilename());
            try {
                Exec.log("begin shell script");
                FileOutputStream fileOutputStream = new FileOutputStream(file2);
                PrintWriter printWriter = new PrintWriter(fileOutputStream);
                if (string2 != null && string2.length() > 0) {
                    printWriter.println("cd " + Exec.quoteArg(string2));
                    Exec.log("cd " + string2);
                }
                printWriter.println(string3);
                Exec.log(string3);
                printWriter.flush();
                fileOutputStream.flush();
                printWriter.close();
                fileOutputStream.close();
                Exec.log("end shell script");
                TempFiles.add(file2.getPath());
                boolean bl = launchBatchCommand;
                launchBatchCommand = false;
                Exec.runCommand("chmod 0744 " + Exec.quoteArg(file2.getPath()));
                Exec.log("chmod 0744 " + file2.getPath());
                if (file.exists()) {
                    Exec.runCommand("chmod 0744 " + Exec.quoteArg(file.getPath()));
                    Exec.log("chmod 0744 " + file.getPath());
                }
                launchBatchCommand = bl;
                Thread.sleep(1000);
                Thread.yield();
                string3 = "sh " + Exec.quoteArg(file2.getPath());
            }
            catch (Exception var6_7) {
                Exec.log(var6_7);
                file2.delete();
                if (string4.length() <= 0 || !file.exists()) break block7;
                try {
                    Exec.runCommand("chmod 0744 " + Exec.quoteArg(file.getPath()));
                    Exec.log("chmod 0744 " + file.getPath());
                }
                catch (Exception var7_9) {
                    Exec.log(var7_9);
                }
            }
        }
        return string3;
    }

    private static String getProgramName(String string) {
        String string2 = "";
        int n = 0;
        if (n < string.length()) {
            StringBuffer stringBuffer = new StringBuffer();
            char c = string.charAt(n);
            if (c == '\"' || c == '\'') {
                ++n;
                while (n < string.length() && string.charAt(n) != c) {
                    stringBuffer.append(string.charAt(n));
                    ++n;
                }
                ++n;
            } else {
                while (n < string.length() && string.charAt(n) != ' ' && string.charAt(n) != '\t') {
                    stringBuffer.append(string.charAt(n));
                    ++n;
                }
                ++n;
            }
            if (stringBuffer != null && stringBuffer.toString().length() > 0) {
                string2 = stringBuffer.toString();
            }
        }
        return string2;
    }

    private static boolean removeCommandFile() {
        boolean bl;
        try {
            File file = new File(TempFiles.getDefaultDirectory(), Exec.getCommandFilename());
            file.delete();
            bl = true;
        }
        catch (Exception var1_1) {
            bl = false;
        }
        return bl;
    }

    private static String getCommandFilename() {
        String string = OS.isWindows() ? "_tempcmd.bat" : ".tmpjcmd";
        return string;
    }

    private static void logProcessOutput(Process process, String string) throws Exception {
        int n;
        InputStreamReader inputStreamReader;
        byte[] arrby = new byte[50000];
        boolean bl = false;
        boolean bl2 = false;
        Exec.log("entered logProcessOutput");
        while (!(process.getErrorStream().available() <= 0 || bl2)) {
            Exec.log("Error executing " + string + ": ");
            bl = true;
            n = process.getInputStream().read(arrby);
            inputStreamReader = new ByteArrayInputStream(arrby, 0, n);
            bl2 = Exec.logStream((InputStream)inputStreamReader);
            try {
                inputStreamReader.close();
            }
            catch (Exception var8_8) {}
        }
        if (!((process.getInputStream().available() <= 0 || bl2) && bl)) {
            Exec.log("Output from " + string + ": ");
            try {
                n = 0;
                inputStreamReader = new InputStreamReader(process.getInputStream());
                BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
                while (n == 0) {
                    String string2 = bufferedReader.readLine();
                    if (string2 == null) {
                        n = 1;
                    } else if (string2.endsWith("qzEOSqz")) {
                        n = 1;
                    } else {
                        Exec.log(string2);
                    }
                    Thread.yield();
                }
                bufferedReader.close();
                inputStreamReader.close();
            }
            catch (Exception var6_6) {
                Exec.log(var6_6);
            }
        }
        Exec.log("exiting logProcessOutput");
    }

    private static void log(String string) {
        Exec.startLogging();
        execLog.write(string);
    }

    private static void log(Exception exception) {
        Exec.startLogging();
        execLog.write(exception);
    }

    private static boolean logStream(InputStream inputStream) {
        boolean bl = false;
        try {
            InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
            String string = bufferedReader.readLine();
            while (string != null) {
                Exec.log(string);
                if ("qzEOSqz".equals(string)) {
                    bl = true;
                    Exec.log("end of stream found");
                }
                Thread.yield();
                string = bufferedReader.readLine();
            }
            bufferedReader.close();
            inputStreamReader.close();
        }
        catch (Exception var2_3) {
            Exec.log(var2_3);
        }
        return bl;
    }

    private static void startLogging() {
        if (execLog == null) {
            execLog = new Log("exec");
        }
    }

    public static void main(String[] arrstring) {
        try {
            Exec.runCommand("ls -l /usr/src");
        }
        catch (Exception var1_1) {
            var1_1.printStackTrace();
        }
    }

    public static String quoteArg(String string) {
        String string2;
        if (string.startsWith("\"") && string.endsWith("\"") || string.startsWith("'") && string.endsWith("'")) {
            string2 = string;
        } else if (Exec.hasWhiteSpace(string)) {
            string2 = !string.startsWith("\"") ? "" + '\"' + string : string;
            if (!string.endsWith("\"")) {
                string2 = string2 + '\"';
            }
        } else {
            string2 = string;
        }
        return string2;
    }

    public static String unquoteArg(String string) {
        String string2 = string;
        if (string.startsWith("\"") && string.endsWith("\"") || string.startsWith("'") && string.endsWith("'")) {
            string2 = string.substring(1, string.length() - 1);
        }
        return string2;
    }

    public static boolean hasWhiteSpace(String string) {
        return string.indexOf(32) >= 0 || string.indexOf(9) >= 0 || string.indexOf(13) >= 0 || string.indexOf(10) >= 0;
    }

    public static boolean isWhiteSpace(char c) {
        return c == ' ' || c == '\t' || c == '\r' || c == '\n';
    }
}
