/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.Log;
import com.denova.runtime.LinuxServices;
import com.denova.runtime.UnixCommands;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsRegistry;
import com.denova.runtime.WindowsServices;
import java.io.File;

public class OS {
    public static final String X32Architecture = "-x32";
    public static final String X64Architecture = "-x64";
    private static final Log log = new Log("os");
    private static String osName = null;

    public static boolean isWindows() {
        String string = OS.getOsName();
        return string.startsWith("win") || string.startsWith("microsoft windows");
    }

    public static boolean isSecureWindows() {
        boolean bl = false;
        if (OS.isWindows()) {
            String string = System.getProperty("os.version", "");
            bl = string.startsWith("6");
        }
        return bl;
    }

    public static boolean isWindowsVista() {
        boolean bl = false;
        String string = OS.getOsName();
        if (OS.isWindows()) {
            bl = string.indexOf("vista") > 0;
        }
        return bl;
    }

    public static boolean isWindows7() {
        boolean bl = false;
        String string = OS.getOsName();
        if (OS.isWindows()) {
            boolean bl2 = bl = string.indexOf("7") > 0;
            if (!bl && OS.isWindowsVista()) {
                String string2 = OS.getVersion();
                bl = "6.1".equals(string2);
            }
        }
        return bl;
    }

    public static boolean isWindows8() {
        boolean bl = false;
        String string = OS.getOsName();
        if (OS.isWindows()) {
            boolean bl2 = bl = string.indexOf("8") > 0;
            if (!bl && OS.isWindowsVista()) {
                String string2 = OS.getVersion();
                bl = "6.2".equals(string2);
            }
        }
        return bl;
    }

    public static boolean isWindows2000() {
        boolean bl = false;
        if (OS.isWindows()) {
            String string = OS.getOsName();
            String string2 = null;
            if (string.indexOf("2000") > 0) {
                string2 = WindowsDirs.getWindowsDirectory();
                string2 = string2.toLowerCase();
            }
            if (string2 != null && string2.indexOf("winnt") > 0) {
                bl = true;
            }
        }
        return bl;
    }

    public static boolean isWindowsNT() {
        String string = OS.getOsName();
        return OS.isWindows() && string.indexOf("nt") > 0;
    }

    public static boolean isWindowsXP() {
        boolean bl = false;
        String string = OS.getOsName();
        if (OS.isWindows()) {
            if ((string = string.toLowerCase()).indexOf("xp") > 0) {
                bl = true;
            } else if (string.indexOf("2000") > 0) {
                String string2 = WindowsDirs.getWindowsDirectory();
                if ((string2 = string2.toLowerCase()) != null && string2.indexOf("windows") > 0) {
                    bl = true;
                }
            }
        }
        return bl;
    }

    public static boolean isWindowsServer2003() {
        boolean bl = false;
        String string = OS.getOsName();
        if (OS.isWindows()) {
            Object var2_2 = null;
            if ((string = string.toLowerCase()).indexOf("server") > 0 && string.indexOf("2003") > 0) {
                bl = true;
            }
        }
        return bl;
    }

    public static boolean isWindowsServer2008() {
        boolean bl = false;
        String string = OS.getOsName();
        if (OS.isWindows()) {
            Object var2_2 = null;
            if ((string = string.toLowerCase()).indexOf("server") > 0 && string.indexOf("2008") > 0) {
                bl = true;
            }
        }
        return bl;
    }

    public static boolean isWindows98() {
        String string = OS.getOsName();
        return OS.isWindows() && string.indexOf("98") > 0;
    }

    public static boolean isWindows95() {
        String string = OS.getOsName();
        return OS.isWindows() && string.indexOf("95") > 0;
    }

    public static boolean isUnix() {
        String string = OS.getOsName();
        return string.indexOf("unix") >= 0 || OS.isLinux() || OS.isAix() || OS.isHpUnix() || OS.isSolaris() || OS.isMpeUnix() || OS.isMacOsX();
    }

    public static boolean isLinux() {
        String string = OS.getOsName();
        return string.indexOf("linux") >= 0;
    }

    public static boolean isAix() {
        String string = OS.getOsName();
        return string.indexOf("aix") >= 0;
    }

    public static boolean isHpUnix() {
        String string = OS.getOsName();
        return string.indexOf("hp-ux") >= 0 || string.indexOf("hpux") >= 0 || string.indexOf("irix") >= 0;
    }

    public static boolean isSolaris() {
        String string = OS.getOsName();
        return string.indexOf("solaris") >= 0 || string.indexOf("sunos") >= 0;
    }

    public static boolean isMacOsX() {
        String string = OS.getOsName();
        String string2 = System.getProperty("mrj.version");
        return string2 != null || string.indexOf("mac os x") >= 0;
    }

    public static boolean isMac() {
        String string = OS.getOsName();
        return string.indexOf("mac os") >= 0 || string.indexOf("macos") >= 0;
    }

    public static boolean isOs2() {
        String string = OS.getOsName();
        return string.indexOf("os/2") >= 0;
    }

    public static boolean isNetware() {
        String string = OS.getOsName();
        return string.indexOf("netware") >= 0;
    }

    public static boolean isMpeUnix() {
        String string = OS.getOsName();
        return string.indexOf("mpe/ix") >= 0;
    }

    public static String getOsName() {
        if (osName == null) {
            osName = System.getProperty("os.name", "").toLowerCase();
            OS.logMessage("os name: " + osName);
            if (osName.startsWith("win")) {
                String string = WindowsRegistry.getStringData("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion", "ProductName");
                if (string == null || string.length() <= 0) {
                    OS.logMessage("no product name defined in registry");
                } else {
                    osName = string.toLowerCase();
                    OS.logMessage("windows os name: " + osName);
                }
            }
        } else {
            OS.logMessage("os name: " + osName);
        }
        return osName;
    }

    public static String getVersion() {
        return System.getProperty("os.version", "");
    }

    public static void sleep(long l) {
        try {
            Thread.sleep(l);
        }
        catch (Exception var2_1) {
            // empty catch block
        }
    }

    public static void yield() {
        Thread.yield();
    }

    public static String getSystemPath() {
        String string = null;
        try {
            if (OS.isUnix()) {
                string = UnixCommands.getSystemPath();
            } else if (OS.isWindows()) {
                string = WindowsCommands.getSystemPath();
            }
        }
        catch (Exception var1_1) {
            string = "";
        }
        return string;
    }

    public static boolean ln(String string, String string2) {
        boolean bl = false;
        try {
            if (OS.isUnix()) {
                UnixCommands.ln(string, string2);
                File file = new File(string2);
                bl = file.exists();
            } else if (OS.isWindows()) {
                bl = WindowsCommands.createLink(string, string2);
            }
        }
        catch (Exception var3_4) {
            bl = false;
        }
        return bl;
    }

    public static String[] getEnvironment() {
        String[] arrstring = null;
        try {
            if (OS.isUnix()) {
                arrstring = UnixCommands.getEnvironment();
            } else if (OS.isWindows()) {
                arrstring = WindowsCommands.getEnvironment();
            }
        }
        catch (Exception var1_1) {
            // empty catch block
        }
        return arrstring;
    }

    public static String[] addArg(String[] arrstring, String string) {
        String[] arrstring2 = new String[arrstring.length + 1];
        System.arraycopy(arrstring, 0, arrstring2, 0, arrstring.length);
        arrstring2[arrstring.length] = string;
        return arrstring2;
    }

    public static boolean installService(String string, String string2) {
        boolean bl = false;
        if (OS.isWindows()) {
            WindowsServices windowsServices = new WindowsServices();
            bl = windowsServices.installService(string, string2);
        } else if (OS.isLinux()) {
            LinuxServices linuxServices = new LinuxServices();
            bl = linuxServices.installService(string, string2);
        }
        return bl;
    }

    public static boolean removeService(String string, String string2) {
        boolean bl = false;
        if (OS.isWindows()) {
            WindowsServices windowsServices = new WindowsServices();
            bl = windowsServices.removeService(string2);
        } else if (OS.isLinux()) {
            LinuxServices linuxServices = new LinuxServices();
            bl = linuxServices.removeService(string2);
        }
        return bl;
    }

    public static boolean supportServices() {
        boolean bl = false;
        if (OS.isWindows()) {
            WindowsServices windowsServices = new WindowsServices();
            bl = windowsServices.supportServices();
        } else if (OS.isLinux()) {
            LinuxServices linuxServices = new LinuxServices();
            bl = linuxServices.supportServices();
        }
        return bl;
    }

    private static void logMessage(String string) {
        log.write(string);
    }
}
