/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.runtime.Exec;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsConstants;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsRegistry;
import com.denova.runtime.WindowsUtils;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.Reader;
import java.util.List;
import java.util.Vector;

public class WindowsCommands
implements WindowsConstants {
    private static final String PathCommand = "path";
    private static final String EnvVariableCommand = "envvar";
    private static final String SetCommand = "set";

    public static boolean createLink(String string, String string2) {
        boolean bl = false;
        if (string != null && string2 != null) {
            String[] arrstring = new String[]{WindowsUtils.getCommandProgramFilename(), "link", Exec.quoteArg(string), Exec.quoteArg(string2)};
            try {
                File file = new File(string2);
                file.delete();
                WindowsUtils.runCommand(arrstring);
                bl = file.exists();
            }
            catch (Exception var5_5) {
                WindowsUtils.log("Unable to create link from " + string + " to " + string2);
                WindowsUtils.log(var5_5);
            }
        }
        WindowsUtils.log("created link: " + bl);
        return bl;
    }

    public static String getSystemPath() {
        String string = WindowsCommands.getEnvVariable("PATH");
        if (string.length() <= 0) {
            string = WindowsCommands.getEnvVariable("Path");
        }
        if (string.length() <= 0) {
            string = WindowsCommands.getEnvVariable("path");
        }
        return string;
    }

    public static String getEnvVariable(String string) {
        String string2 = null;
        if (string != null) {
            try {
                String[] arrstring = new String[]{WindowsUtils.getCommandProgramFilename(), "envvar", Exec.quoteArg(string), Exec.quoteArg(WindowsUtils.getTempDir())};
                string2 = WindowsUtils.runCommand(arrstring, "winenv.txt");
            }
            catch (Exception var4_3) {
                WindowsUtils.log("Unable to get environment variable: " + string);
                WindowsUtils.log(var4_3);
            }
        }
        return string2;
    }

    public static String[] getEnvironment() {
        String[] arrstring = new String[]{};
        try {
            List list = WindowsRegistry.enumerateData("HKEY_LOCAL_MACHINE\\SYSTEM\\CurrentControlSet\\Control\\Session Manager", "Environment");
            if (list == null || list.isEmpty()) {
                WindowsUtils.log("no environment variables defined in registry");
            } else {
                for (String string : list) {
                    arrstring = WindowsCommands.addEnvItem(string, arrstring);
                }
            }
            arrstring = WindowsCommands.addStandardVariables(list, arrstring);
            if (arrstring.length > 0) {
                WindowsUtils.log("got environment");
            } else {
                WindowsUtils.log("Unable to get environment");
            }
        }
        catch (Exception var3_2) {
            WindowsUtils.log("Unable to get the environment");
            WindowsUtils.log(var3_2);
        }
        return arrstring;
    }

    public static String getProcessorArchitecture() {
        String string = System.getProperty("os.arch", "unknown").toLowerCase();
        WindowsUtils.log("processor architecture: " + string);
        return string;
    }

    public static boolean is64BitProcessorArchitecture() {
        boolean bl = false;
        String string = WindowsCommands.getEnvVariable("PROCESSOR_ARCHITECTURE");
        if (string == null) {
            string = WindowsCommands.getProcessorArchitecture();
        }
        if (string != null) {
            WindowsUtils.log("processor architecture: " + string);
            bl = string.toLowerCase().indexOf("64") >= 0;
        }
        WindowsUtils.log("64 bit process: " + bl);
        return bl;
    }

    public static boolean isWow64Process() {
        boolean bl = WindowsCommands.is64BitProcessorArchitecture() && !WindowsRegistry.exists("HKEY_LOCAL_MACHINE\\SOFTWARE\\Wow6432Node");
        WindowsUtils.log("Wow 64 bit process: " + bl);
        return bl;
    }

    public static boolean changePermissions(String string, List list) {
        boolean bl = true;
        try {
            WindowsUtils.log("changing permissions for: " + string);
            WindowsUtils.log("         new permissions: " + list);
            int n = 0;
            int n2 = 0;
            String[] arrstring = new String[list.size() + 2];
            String[] arrstring2 = new String[list.size()];
            String string2 = WindowsDirs.getWindowsDirectory();
            arrstring[n++] = string2 + File.separator + "System32" + File.separator + "attrib.exe";
            for (String string3 : list) {
                if (string3.startsWith("/")) {
                    arrstring2[n2++] = string3;
                    continue;
                }
                arrstring[n++] = string3;
            }
            arrstring[n++] = string;
            if (n2 > 0) {
                int n3 = 0;
                while (n3 < n2) {
                    arrstring[n++] = arrstring2[n3++];
                }
            }
            WindowsUtils.runCommand(arrstring);
        }
        catch (Exception var3_4) {
            bl = false;
            WindowsUtils.rememberError("Unable to change permissioons", var3_4);
        }
        return bl;
    }

    public static boolean hideFile(String string) {
        File file = new File(string);
        Vector<String> vector = new Vector<String>();
        vector.add("+h");
        if (file.isDirectory()) {
            vector.add("/s");
            vector.add("/d");
        }
        return WindowsCommands.changePermissions(string, vector);
    }

    public static boolean normalFile(String string) {
        File file = new File(string);
        Vector<String> vector = new Vector<String>();
        vector.add("-h");
        vector.add("-r");
        if (file.isDirectory()) {
            vector.add("/s");
            vector.add("/d");
        }
        return WindowsCommands.changePermissions(string, vector);
    }

    public static Long getFreeDiskSpace(String string) {
        Long l = new Long(-1);
        if (OS.isWindows()) {
            try {
                String[] arrstring = new String[]{WindowsUtils.getCommandProgramFilename(), "freespace", Exec.quoteArg(string), Exec.quoteArg(WindowsUtils.getTempDir())};
                WindowsUtils.runCommand(arrstring);
                String string2 = WindowsUtils.tempFilename("winspace.txt");
                try {
                    File file = new File(string2);
                    FileReader fileReader = new FileReader(file);
                    BufferedReader bufferedReader = new BufferedReader(fileReader);
                    String string3 = bufferedReader.readLine();
                    if (string3 != null) {
                        l = new Long(Long.parseLong(string3.trim()));
                    }
                    fileReader.close();
                    bufferedReader.close();
                    file.delete();
                }
                catch (Exception var6_6) {
                    WindowsUtils.rememberError("Unable to read " + string2, var6_6);
                }
            }
            catch (Exception var4_3) {
                WindowsUtils.rememberError("Unable to get free disk space", var4_3);
            }
        }
        WindowsUtils.log("free disk space: " + l.toString());
        WindowsUtils.log("free disk space: " + Long.toHexString(l));
        return l;
    }

    public static String getAncientShortPath(String string) {
        String string2 = string;
        File file = new File(string);
        if (file.exists() && OS.isWindows()) {
            String[] arrstring;
            boolean bl = false;
            String string3 = WindowsUtils.getCommandProgramFilename();
            if (string3 != null && string3.length() > 0) {
                arrstring = new String[]{string3, "shortname", Exec.quoteArg(string), Exec.quoteArg(WindowsUtils.getTempDir())};
                try {
                    WindowsUtils.runCommand(arrstring);
                    bl = true;
                }
                catch (Exception var8_7) {
                    WindowsUtils.rememberError("Unable to execute command " + arrstring.toString(), var8_7);
                    bl = false;
                }
            }
            if (bl) {
                try {
                    arrstring = new String[](WindowsUtils.tempFilename("winsname.txt"));
                    FileReader fileReader = new FileReader((File)arrstring);
                    BufferedReader bufferedReader = new BufferedReader(fileReader);
                    String string4 = bufferedReader.readLine();
                    if (string4 != null) {
                        string2 = string4.trim();
                    }
                    bufferedReader.close();
                    fileReader.close();
                    arrstring.delete();
                }
                catch (Exception var7_6) {
                    WindowsUtils.rememberError("Unable to read " + WindowsUtils.getCommandProgramFilename(), var7_6);
                }
            }
            if (string2 == null || string2.length() <= 0 || string2.indexOf(" ") > -1) {
                string2 = string;
            } else {
                file = new File(string2);
                if (!file.exists()) {
                    string2 = string;
                }
            }
        } else {
            string2 = string;
        }
        WindowsUtils.log("short name: " + string2);
        return string2;
    }

    private static String[] addEnvItem(String string, String[] arrstring) {
        String[] arrstring2 = arrstring;
        if (string == null || string.length() <= 0) {
            WindowsUtils.log("no variable defined");
        } else {
            String string2 = WindowsCommands.getEnvVariable(string);
            if (string2 == null) {
                WindowsUtils.log("no value defined for " + string);
                string2 = "";
            }
            arrstring2 = OS.addArg(arrstring2, string + "=" + string2);
            WindowsUtils.log("env item: " + string + "=" + string2);
        }
        return arrstring2;
    }

    private static String[] addStandardVariables(List list, String[] arrstring) {
        String[] arrstring2 = arrstring;
        if (list != null) {
            arrstring2 = WindowsCommands.addStandardVariable("PATH", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("ALLUSERSPROFILE", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("USERPROFILE", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("USERNAME", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("SYSTEMROOT", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("APPDATA", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("HOMEDRIVE", list, arrstring2);
            arrstring2 = WindowsCommands.addStandardVariable("HOMEPATH", list, arrstring2);
            if (OS.isSecureWindows()) {
                arrstring2 = WindowsCommands.addStandardVariable("PUBLIC", list, arrstring2);
                arrstring2 = WindowsCommands.addStandardVariable("PROGRAMDATA", list, arrstring2);
            } else {
                arrstring2 = WindowsCommands.addStandardVariable("WINDIR", list, arrstring2);
            }
        }
        return arrstring2;
    }

    private static String[] addStandardVariable(String string, List list, String[] arrstring) {
        String[] arrstring2 = arrstring;
        if (!list.contains(string)) {
            arrstring2 = WindowsCommands.addEnvItem(string, arrstring2);
        }
        return arrstring2;
    }
}
