/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.FileSystem;
import com.denova.io.Log;
import com.denova.lang.LangUtilities;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsConstants;
import java.io.File;

public class WindowsJavaApp
implements WindowsConstants {
    private static final Log log = new Log("javaapp.log");
    private static final String RegularJavaAppName = "JavaApp";
    private static final String AdminJavaAppName = "JavaAdminApp";

    public static File getRegularFile() {
        File file = null;
        try {
            String string = WindowsJavaApp.getRegularName();
            File file2 = WindowsJavaApp.getJavaAppFile(string);
            if (!file2.exists() && string.equals(WindowsJavaApp.getX64RegularName())) {
                file2 = WindowsJavaApp.getJavaAppFile(WindowsJavaApp.getX32RegularName());
            }
            if (!file2.exists()) {
                file2 = WindowsJavaApp.getJavaAppFile("JavaApp.exe");
            }
            if (file2.exists()) {
                file = file2;
            }
        }
        catch (Exception var1_2) {
            log.write(var1_2);
        }
        return file;
    }

    public static File getAdminFile() {
        File file = null;
        try {
            String string = WindowsJavaApp.getAdminName();
            File file2 = WindowsJavaApp.getJavaAppFile(string);
            if (!file2.exists() && string.equals(WindowsJavaApp.getX64AdminName())) {
                file2 = WindowsJavaApp.getJavaAppFile(WindowsJavaApp.getX32AdminName());
            }
            if (!file2.exists()) {
                file2 = WindowsJavaApp.getJavaAppFile("JavaAdminApp.exe");
            }
            if (file2.exists()) {
                file = file2;
            }
        }
        catch (Exception var1_2) {
            log.write(var1_2);
        }
        return file;
    }

    public static String getRegularName() {
        String string = WindowsJavaApp.getX32RegularName();
        if (OS.isWindows() && WindowsCommands.is64BitProcessorArchitecture() && !WindowsCommands.isWow64Process()) {
            string = WindowsJavaApp.getX64RegularName();
        }
        log.write("regular name: " + string);
        return string;
    }

    public static String getAdminName() {
        String string = WindowsJavaApp.getX32AdminName();
        if (OS.isWindows() && WindowsCommands.is64BitProcessorArchitecture() && !WindowsCommands.isWow64Process()) {
            string = WindowsJavaApp.getX64AdminName();
        }
        log.write("admin name: " + string);
        return string;
    }

    public static String getX32RegularName() {
        return "JavaApp-x32.exe";
    }

    public static String getX64RegularName() {
        return "JavaApp-x64.exe";
    }

    public static String getX32AdminName() {
        return "JavaAdminApp-x32.exe";
    }

    public static String getX64AdminName() {
        return "JavaAdminApp-x64.exe";
    }

    private static File getJavaAppFile(String string) {
        File file = null;
        try {
            File file2 = new File(string);
            if (!file2.exists()) {
                LangUtilities.getResourceAsFile(file2.getPath());
                if (!file2.exists()) {
                    log.write("unable to use lang utilities to get " + string);
                    if (!FileSystem.getResourceAsFile(string, null)) {
                        log.write("unable to use file system to get " + string);
                    }
                }
            }
            if (file2.exists()) {
                file = file2;
            }
        }
        catch (Exception var2_3) {
            log.write(var2_3);
        }
        return file;
    }
}
