/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.runtime.Exec;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsUtils;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;

public class WindowsRegistry {
    public static final String HKeyClassesRoot = "HKEY_CLASSES_ROOT";
    public static final String HKeyCurrentUser = "HKEY_CURRENT_USER";
    public static final String HKeyLocalMachine = "HKEY_LOCAL_MACHINE";
    public static final String HKeyUsers = "HKEY_USERS";
    public static final String HKeyCurrentConfig = "HKEY_CURRENT_CONFIG";
    public static final String HKeyDynData = "HKEY_DYN_DATA";
    private static final String AddKey = "add";
    private static final String ReplaceRegistryEntry = "replace";
    private static final String AppendRegistryEntry = "append";
    private static final String PrependRegistryEntry = "prepend";
    private static final String DeleteRegistryEntry = "delete";
    private static final String DeleteAttribute = "delattrib";
    private static final String ExistsRegistryEntry = "exists";
    private static final String ExistsAttribute = "existsattrib";
    private static final String QueryRegistryEntry = "query";
    private static final String EnumKeyRegistryEntry = "enumkey";
    private static final String EnumValueRegistryEntry = "enumvalue";
    private static final String WindowsRegistryEditorCommand = "registry";
    private static final String RegistryResultsFilename = "regstats.txt";
    private static final String RegistrySpecFilename = "specreg";
    private static final String StringType = "String";
    private static final String ExpandedStringType = "ExString";
    private static final String DWordType = "DWord";
    private static final String BinaryType = "Binary";
    private static boolean debugging = false;

    public static String getData(String string, String string2) {
        String string3 = WindowsRegistry.getStringData(string, string2);
        if (string3 == null && (string3 = WindowsRegistry.getExpandedData(string, string2)) == null) {
            int n = WindowsRegistry.getIntData(string, string2);
            if (n == -1) {
                byte[] arrby = WindowsRegistry.getBinaryData(string, string2, 10000);
                if (arrby == null) {
                    WindowsUtils.log("Error getting data from " + string + " attribute: " + string2);
                } else {
                    string3 = WindowsRegistry.toHex(arrby);
                }
            } else {
                string3 = new Integer(n).toString();
            }
        }
        return string3;
    }

    public static String getStringData(String string, String string2) {
        boolean bl;
        String string3 = null;
        WindowsUtils.log("getting data from: " + string + File.separator + string2);
        if (WindowsRegistry.runCommand("query", string, string2)) {
            string3 = WindowsRegistry.getQueryResults();
        }
        boolean bl2 = bl = string3 != null;
        if (bl) {
            WindowsRegistry.debug("results: " + string3);
        }
        WindowsUtils.log("got good results: " + bl);
        return string3;
    }

    public static String getExpandedData(String string, String string2) {
        WindowsUtils.log("getting expanded data from: " + string + File.separator + string2);
        return WindowsRegistry.getStringData(string, string2);
    }

    public static int getIntData(String string, String string2) {
        int n = -1;
        try {
            WindowsUtils.log("getting int data from: " + string + File.separator + string2);
            String string3 = WindowsRegistry.getStringData(string, string2);
            if (string3 != null) {
                n = Integer.valueOf(string3);
            }
        }
        catch (Exception var3_4) {
            n = -1;
            WindowsUtils.log("Error getting integer data from " + string + " attribute: " + string2);
            WindowsUtils.log(var3_4);
        }
        return n;
    }

    public static byte[] getBinaryData(String string, String string2, int n) {
        Object object = null;
        try {
            WindowsUtils.log("getting binary data from: " + string + File.separator + string2);
            String string3 = WindowsRegistry.getStringData(string, string2);
            if (string3 != null) {
                object = string3.getBytes();
            }
        }
        catch (Exception var4_5) {
            WindowsUtils.log("Error getting binary data from " + string + " attribute: " + string2);
            WindowsUtils.log(var4_5);
        }
        return object;
    }

    public static boolean exists(String string) {
        boolean bl = false;
        WindowsUtils.log("key exists: " + string);
        if (WindowsRegistry.runCommand("exists", string, null)) {
            bl = WindowsRegistry.resultsOk("exists");
        }
        return bl;
    }

    public static boolean attributeExists(String string, String string2) {
        boolean bl = false;
        WindowsUtils.log("attribute exists: " + string);
        if (WindowsRegistry.runCommand("existsattrib", string, string2)) {
            bl = WindowsRegistry.resultsOk("existsattrib");
        }
        return bl;
    }

    public static boolean addKey(String string, String string2) {
        return WindowsRegistry.runSimpleCommand("add", string, string2);
    }

    public static boolean addSubkey(String string, String string2, String string3) {
        boolean bl = false;
        if (string3 == null || string3.length() <= 0) {
            bl = WindowsRegistry.addKey(string, string2);
        } else if (!WindowsRegistry.exists(WindowsRegistry.getFullKey(string, string2))) {
            bl = WindowsRegistry.replaceData(string, string2, string3);
        } else {
            WindowsUtils.log("Unable to add subkey because it already exists: " + string);
        }
        return bl;
    }

    public static boolean replaceData(String string, String string2, String string3) {
        boolean bl = false;
        try {
            if (string3 == null || string3.length() <= 0) {
                String string4 = WindowsRegistry.getFullKey(string, string2);
                if (WindowsRegistry.exists(string4)) {
                    bl = true;
                } else {
                    WindowsUtils.log("Creating key (" + string + "\\" + string2 + ")");
                    bl = WindowsRegistry.addKey(string, string2);
                }
                WindowsUtils.log("Key (" + string + "\\" + string2 + ") exists: " + bl);
            } else if (WindowsRegistry.exists(string)) {
                bl = WindowsRegistry.isExpandingString(string3) ? WindowsRegistry.runSimpleCommand("replace", string, string2, "ExString", string3) : WindowsRegistry.runSimpleCommand("replace", string, string2, "String", string3);
            } else {
                bl = false;
                WindowsUtils.log("Unable to replace data because key doesn't exist (" + string + ")");
            }
            WindowsUtils.log("Replaced data (" + string + "\\" + string2 + ") ok: " + bl);
        }
        catch (Exception var4_5) {
            bl = false;
            WindowsUtils.rememberError("Unable to replace data for " + string, var4_5);
        }
        return bl;
    }

    public static boolean replaceData(String string, String string2, Integer n) {
        boolean bl = false;
        try {
            if (WindowsRegistry.exists(string)) {
                bl = WindowsRegistry.runSimpleCommand("replace", string, string2, "DWord", n);
            } else {
                bl = false;
                WindowsUtils.log("Unable to replace integer data because key doesn't exist (" + string + ")");
            }
            WindowsUtils.log("Replaced integer data (" + string + "\\" + string2 + ") ok: " + bl);
        }
        catch (Exception var4_4) {
            bl = false;
            WindowsUtils.log(var4_4);
        }
        WindowsUtils.log("Replaced integer data (" + string + "\\" + string2 + ") ok: " + bl);
        return bl;
    }

    public static boolean replaceBinaryData(String string, String string2, String string3) {
        return WindowsRegistry.replaceBinaryData(string, string2, string3.getBytes());
    }

    public static boolean replaceBinaryData(String string, String string2, byte[] arrby) {
        boolean bl = false;
        String string3 = WindowsRegistry.getFullKey(string, string2);
        try {
            if (arrby == null || arrby.length <= 0) {
                if (WindowsRegistry.exists(string3)) {
                    bl = true;
                } else {
                    WindowsUtils.log("Creating key (" + string + "\\" + string2 + ")");
                    bl = WindowsRegistry.addKey(string, string2);
                }
                WindowsUtils.log("Key (" + string + "\\" + string2 + ") exists: " + bl);
            } else if (WindowsRegistry.exists(string)) {
                bl = WindowsRegistry.runSimpleCommand("replace", string, string2, "Binary", arrby);
            } else {
                bl = false;
                WindowsUtils.log("Unable to replace binary data because key doesn't exist (" + string + ")");
            }
            WindowsUtils.log("Replaced binary data (" + string + "\\" + string2 + ") ok: " + bl);
        }
        catch (Exception var5_5) {
            bl = false;
            WindowsUtils.log(var5_5);
        }
        WindowsUtils.log("Replaced binary data (" + string3 + ") ok: " + bl);
        return bl;
    }

    public static boolean appendData(String string, String string2, String string3) {
        String string4 = WindowsRegistry.getStringData(string, string2);
        if (string4 == null) {
            string4 = "";
        }
        boolean bl = WindowsRegistry.replaceData(string, string2, string4 + string3);
        WindowsUtils.log("Append new data (" + string + "\\" + string2 + ") ok: " + bl);
        return bl;
    }

    public static boolean prependData(String string, String string2, String string3) {
        String string4 = WindowsRegistry.getStringData(string, string2);
        if (string4 == null) {
            string4 = "";
        }
        boolean bl = WindowsRegistry.replaceData(string, string2, string3 + string4);
        WindowsUtils.log("Prepended new data (" + string + "\\" + string2 + ") ok: " + bl);
        return bl;
    }

    public static boolean deleteSubkey(String string, String string2) {
        boolean bl = false;
        String string3 = WindowsRegistry.getFullKey(string, string2);
        try {
            bl = WindowsRegistry.exists(string3) ? WindowsRegistry.deleteKey(string, string2) : WindowsRegistry.deleteAttribute(string, string2);
        }
        catch (Exception var4_4) {
            WindowsUtils.log(var4_4);
        }
        WindowsUtils.log("Deleted subkey (" + string3 + ") ok: " + bl);
        return bl;
    }

    public static boolean deleteKey(String string, String string2) {
        boolean bl = false;
        try {
            bl = WindowsRegistry.runSimpleCommand("delete", string, string2);
        }
        catch (Exception var3_3) {
            WindowsUtils.log(var3_3);
        }
        WindowsUtils.log("Key deleted (" + string + "\\" + string2 + ") ok: " + bl);
        return bl;
    }

    public static boolean deleteAttribute(String string, String string2) {
        boolean bl = false;
        try {
            bl = WindowsRegistry.runSimpleCommand("delattrib", string, string2);
            WindowsUtils.log("Deleted attribute (" + string + "\\" + string2 + ") ok: " + bl);
        }
        catch (Exception var3_3) {
            WindowsUtils.log(var3_3);
        }
        return bl;
    }

    public static List enumerate(String string, String string2) {
        List list = null;
        if (WindowsRegistry.runCommand("enumkey", string, string2)) {
            list = WindowsRegistry.getEnumerateResults();
        }
        return list;
    }

    public static List enumerateData(String string, String string2) {
        List list = null;
        if (WindowsRegistry.runCommand("enumvalue", string, string2)) {
            list = WindowsRegistry.getEnumerateResults();
        }
        return list;
    }

    public static boolean importEntries(String string) {
        File file;
        boolean bl = false;
        if (OS.isWindows() && (file = new File(string)).exists()) {
            String[] arrstring;
            String string2 = WindowsDirs.getWindowsDirectory();
            file = new File(string2, "Regedit.exe");
            if (!file.exists()) {
                file = new File(string2, "Regedit32.exe");
            }
            if (!file.exists()) {
                arrstring = new String[](string2, "System32");
                file = new File((File)arrstring, "Regedit32.exe");
            }
            if (file.exists()) {
                try {
                    arrstring = new String[]{file.getPath(), "/s", string};
                    WindowsUtils.log("starting to import: " + string);
                    Exec.runCommand(arrstring);
                    WindowsUtils.log("finished importing");
                    bl = true;
                }
                catch (Exception var4_5) {
                    WindowsUtils.rememberError("Unable to import registry entries", var4_5);
                }
            }
        }
        return bl;
    }

    public static boolean exportEntries(String string, String string2) {
        boolean bl = false;
        if (OS.isWindows()) {
            File file = new File(string);
            if (file.exists()) {
                file.delete();
            }
            try {
                file = WindowsRegistry.getRegEditFile();
                if (file.exists()) {
                    if (!(string2.indexOf(" ") == -1 || string2.startsWith("\"") || string2.endsWith("\""))) {
                        string2 = "\"" + string2 + "\"";
                    }
                    WindowsUtils.log("exporting: " + string2 + " to " + string);
                    String[] arrstring = new String[]{file.getPath(), "/e", string, string2};
                    Exec.runCommand(arrstring);
                    WindowsUtils.log("finished exporting");
                    bl = true;
                }
            }
            catch (Exception var4_5) {
                WindowsUtils.rememberError("Unable to export registry entries", var4_5);
            }
        }
        return bl;
    }

    public static String toUnicode(String string) {
        String string2 = string;
        if (string2 != null && string2.length() > 0) {
            WindowsUtils.log("input: \"" + string2 + "\"");
            try {
                byte[] arrby = string2.getBytes();
                StringBuffer stringBuffer = new StringBuffer();
                for (int i = 0; i < arrby.length; ++i) {
                    String string3 = Integer.toHexString(arrby[i]);
                    while (string3.length() < 2) {
                        string3 = "0" + string3;
                    }
                    stringBuffer.append(string3);
                    stringBuffer.append("00");
                }
                stringBuffer.append("0000");
                string2 = stringBuffer.toString();
            }
            catch (Exception var2_3) {
                WindowsUtils.log(var2_3);
            }
            WindowsUtils.log("output: \"" + string2 + "\"");
        }
        return string2;
    }

    public static String toHex(byte[] arrby) {
        String string = "";
        if (arrby != null && arrby.length > 0) {
            try {
                StringBuffer stringBuffer = new StringBuffer();
                for (int i = 0; i < arrby.length; ++i) {
                    String string2 = Integer.toHexString(arrby[i]);
                    while (string2.length() < 2) {
                        string2 = "0" + string2;
                    }
                    stringBuffer.append(string2);
                }
                string = stringBuffer.toString();
            }
            catch (Exception var2_3) {
                WindowsUtils.log(var2_3);
            }
        }
        return string;
    }

    private static String getFullKey(String string, String string2) {
        String string3 = string;
        if (string2 != null && string2.length() > 0) {
            if (!string3.endsWith("\\")) {
                string3 = string3 + "\\";
            }
            string3 = string3 + string2;
        }
        return string3;
    }

    private static boolean isExpandingString(String string) {
        boolean bl = false;
        int n = string.indexOf("%");
        if (n >= 0) {
            bl = string.substring(n + 1).indexOf("%") >= 0;
        }
        return bl;
    }

    private static String getQueryResults() {
        String string = null;
        String string2 = WindowsUtils.tempFilename("regstats.txt");
        File file = new File(string2);
        WindowsUtils.log("  query results filename: " + string2);
        try {
            FileReader fileReader = new FileReader(file);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            String string3 = bufferedReader.readLine();
            int n = 0;
            String string4 = "";
            String string5 = "";
            String string6 = "";
            StringTokenizer stringTokenizer = new StringTokenizer(string3, "\t");
            while (stringTokenizer.hasMoreTokens()) {
                string4 = string5;
                string5 = stringTokenizer.nextToken();
                if (n == 1) {
                    string6 = string5;
                }
                ++n;
            }
            if (string6.equalsIgnoreCase("ok")) {
                string = string4.equalsIgnoreCase("String") || string4.equalsIgnoreCase("DWord") || string4.equalsIgnoreCase("Binary") ? string5 : "";
            }
            bufferedReader.close();
            fileReader.close();
        }
        catch (Exception var3_4) {
            WindowsUtils.rememberError("Unable to query registry entries", var3_4);
        }
        file.delete();
        return string;
    }

    private static List getEnumerateResults() {
        Vector<String> vector = null;
        String string = WindowsUtils.tempFilename("regstats.txt");
        File file = new File(string);
        WindowsUtils.log("  enumerate results filename: " + string);
        try {
            FileReader fileReader = new FileReader(file);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            String string2 = bufferedReader.readLine();
            Vector vector2 = new Vector();
            int n = 0;
            String string3 = "";
            String string4 = "";
            StringTokenizer stringTokenizer = new StringTokenizer(string2, "\t");
            while (stringTokenizer.hasMoreTokens()) {
                string3 = stringTokenizer.nextToken();
                if (n != 0 && n == 1) {
                    string4 = string3;
                }
                ++n;
            }
            if (string4.equalsIgnoreCase("ok")) {
                vector = new Vector<String>();
                String string5 = bufferedReader.readLine();
                while (string5 != null) {
                    vector.add(string5);
                    string5 = bufferedReader.readLine();
                }
            }
            bufferedReader.close();
            fileReader.close();
        }
        catch (Exception var3_4) {
            WindowsUtils.log("Unable to enumerate registry entries");
            WindowsUtils.log(var3_4);
        }
        file.delete();
        return vector;
    }

    private static boolean runSimpleCommand(String string, String string2) {
        return WindowsRegistry.runSimpleCommand(string, string2, null, null, null);
    }

    private static boolean runSimpleCommand(String string, String string2, String string3) {
        return WindowsRegistry.runSimpleCommand(string, string2, string3, null, null);
    }

    private static boolean runSimpleCommand(String string, String string2, String string3, String string4, Object object) {
        boolean bl = WindowsRegistry.runCommand(string, string2, string3, string4, object);
        if (bl) {
            bl = WindowsRegistry.resultsOk(string);
        }
        return bl;
    }

    private static boolean runCommand(String string, String string2, String string3) {
        return WindowsRegistry.runCommand(string, string2, string3, null, null);
    }

    private static boolean runCommand(String string, String string2, String string3, String string4, Object object) {
        boolean bl = true;
        WindowsUtils.log(string + ": " + string2);
        WindowsUtils.log("  subkey: " + string3);
        WindowsUtils.log("  type: " + string4);
        WindowsUtils.log("  data: " + String.valueOf(object));
        String string5 = WindowsUtils.tempFilename("regstats.txt");
        File file = new File(string5);
        file.delete();
        WindowsUtils.log("  command results filename: " + string5);
        String string6 = WindowsUtils.tempFilename("specreg");
        File file2 = new File(string6);
        try {
            FileOutputStream fileOutputStream = new FileOutputStream(file2);
            PrintWriter printWriter = new PrintWriter(fileOutputStream);
            String string7 = string + "\t" + string2;
            if (string3 != null) {
                string7 = string7 + "\t";
                string7 = string7 + string3;
            }
            if (string4 != null) {
                string7 = string7 + "\t";
                string7 = string7 + string4;
                if (object != null) {
                    string7 = string7 + "\t";
                    string7 = string7 + String.valueOf(object);
                }
            }
            printWriter.println(string7);
            printWriter.close();
            fileOutputStream.close();
            String string8 = WindowsUtils.getCommandProgramFilename();
            String[] arrstring = new String[]{string8, "registry", string6};
            WindowsUtils.log("Command program name: " + string8);
            WindowsUtils.log("Command filename: " + string6);
            WindowsUtils.runCommand(arrstring);
            file2.delete();
        }
        catch (Exception var10_11) {
            bl = false;
            WindowsUtils.log("Unable to " + string);
            WindowsUtils.log(var10_11);
        }
        WindowsUtils.log(string + " started ok: " + bl);
        WindowsUtils.log("  results file exists: " + String.valueOf(file.exists()));
        return bl;
    }

    private static boolean resultsOk(String string) {
        boolean bl = false;
        String string2 = WindowsUtils.tempFilename("regstats.txt");
        File file = new File(string2);
        WindowsUtils.log("  results ok filename: " + string2);
        try {
            FileReader fileReader = new FileReader(file);
            BufferedReader bufferedReader = new BufferedReader(fileReader);
            String string3 = bufferedReader.readLine();
            WindowsRegistry.debug("results: " + string3);
            String string4 = "";
            StringTokenizer stringTokenizer = new StringTokenizer(string3, "\t");
            for (int i = 0; stringTokenizer.hasMoreTokens() && i < 2; ++i) {
                string4 = stringTokenizer.nextToken();
            }
            if (string4.equalsIgnoreCase("ok")) {
                bl = true;
            }
            bufferedReader.close();
            fileReader.close();
        }
        catch (Exception var4_5) {
            WindowsUtils.log(var4_5);
        }
        file.delete();
        WindowsUtils.log(string + " finished ok: " + bl);
        return bl;
    }

    private static File getRegEditFile() {
        File file = null;
        String string = WindowsDirs.getWindowsDirectory();
        if (!(string == null || (file = WindowsRegistry.getRegEditFile(new File(string))).exists())) {
            file = WindowsRegistry.getRegEditFile(new File(string, "System32"));
        }
        return file;
    }

    private static File getRegEditFile(File file) {
        File file2 = new File(file, "Regedit.exe");
        if (!file2.exists()) {
            file2 = new File(file, "Regedit32.exe");
        }
        return file2;
    }

    private static void debug(String string) {
        if (debugging) {
            WindowsUtils.log(string);
        }
    }
}
