/*
 * Decompiled with CFR 0_101.
 */
package com.denova.runtime;

import com.denova.io.TempFiles;
import com.denova.lang.LangUtilities;
import com.denova.runtime.JRE;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsConstants;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsRegistry;
import com.denova.runtime.WindowsUtils;
import java.io.File;

public class WindowsServices
implements WindowsConstants {
    private static File invokerProgram = null;

    public boolean installService(String string) {
        boolean bl = false;
        if (this.supportServices()) {
            bl = this.installWithNet(string);
        }
        return bl;
    }

    public boolean installService(String string, String string2) {
        return this.installService(string, string, string2, true);
    }

    public boolean installService(String string, String string2, String string3, boolean bl) {
        boolean bl2 = false;
        if (this.supportServices() && !(bl2 = this.installWithNet(string3))) {
            String string4 = bl ? "automatic" : "manual";
            bl2 = this.installWithInvoker(string, string2, string3, string4);
        }
        return bl2;
    }

    public boolean removeService(String string) {
        boolean bl = false;
        if (this.supportServices()) {
            bl = this.removeWithInvoker(string);
        }
        return bl;
    }

    public boolean removeService(String string, String string2) {
        boolean bl = false;
        if (this.supportServices() && !(bl = this.removeWithNet(string2))) {
            bl = this.removeWithInvoker(string);
        }
        return bl;
    }

    public boolean supportServices() {
        return OS.isWindows();
    }

    private boolean installWithNet(String string) {
        boolean bl = false;
        String string2 = this.getNetUtilFilename();
        if (string2 != null) {
            String[] arrstring = new String[]{string2, string};
            try {
                this.removeWithNet(string);
                WindowsUtils.runCommand(arrstring);
                WindowsUtils.log("installed with microsoft net framework");
                bl = true;
            }
            catch (Exception var5_5) {
                WindowsUtils.rememberError("Unable to register service with '" + arrstring + "'", var5_5);
            }
        }
        return bl;
    }

    private boolean removeWithNet(String string) {
        boolean bl = false;
        String string2 = this.getNetUtilFilename();
        if (string2 != null) {
            String[] arrstring = new String[]{string2, "/u", string};
            try {
                WindowsUtils.runCommand(arrstring);
                WindowsUtils.log("removed service with microsoft.net framework");
                bl = true;
            }
            catch (Exception var5_5) {
                WindowsUtils.rememberError("Unable to remove service with '" + arrstring + "'", var5_5);
            }
        }
        return bl;
    }

    private boolean installWithInvoker(String string, String string2, String string3, String string4) {
        boolean bl = false;
        String[] arrstring = new String[]{this.getInvokerFilename(), "install", string, string2, string3, string4};
        try {
            WindowsUtils.runCommand(arrstring);
            bl = this.serviceInstalled(string);
            WindowsUtils.log("service installed: " + bl);
        }
        catch (Exception var7_7) {
            WindowsUtils.rememberError("Unable to register service with '" + arrstring + "'", var7_7);
        }
        return bl;
    }

    private boolean removeWithInvoker(String string) {
        boolean bl = false;
        String[] arrstring = new String[]{this.getInvokerFilename(), "remove", string};
        try {
            WindowsUtils.runCommand(arrstring);
            WindowsUtils.log("removed service with invoker");
            bl = true;
        }
        catch (Exception var4_4) {
            WindowsUtils.rememberError("Unable to remove service" + arrstring, var4_4);
        }
        return bl;
    }

    private boolean serviceInstalled(String string) {
        String string2 = WindowsRegistry.getStringData("HKEY_LOCAL_MACHINE\\System\\CurrentControlSet\\Services\\" + string + "\\Parameters", "Application");
        return string2 != null && string2.length() > 0;
    }

    private String getNetUtilFilename() {
        String string;
        String string2;
        String string3 = null;
        String string4 = "Microsoft.NET\\Framework";
        if (JRE.is64Bit()) {
            string4 = "Microsoft.NET\\Framework64";
        }
        if ((string2 = this.getNetUtilFilename(string = WindowsDirs.getWindowsDirectory(), string4)) == null) {
            string2 = this.getNetUtilFilename("C:\\Windows", string4);
        }
        if (string2 == null) {
            WindowsUtils.log("unable to find microsoft.net framework");
        } else {
            string3 = string2;
        }
        return string3;
    }

    private String getNetUtilFilename(String string, String string2) {
        String string3 = null;
        File file = new File(string, string2);
        String[] arrstring = file.list();
        for (int i = 0; i < arrstring.length && string3 == null; ++i) {
            String string4 = arrstring[i];
            File file2 = new File(file, string4);
            if (!file2.isDirectory()) continue;
            File file3 = new File(file2, "InstallUtil.exe");
            if (file3.exists()) {
                string3 = file3.getPath();
                continue;
            }
            file3 = new File(file2, "AddInUtil.exe");
            if (!file3.exists()) continue;
            string3 = file3.getPath();
        }
        return string3;
    }

    private String getInvokerFilename() {
        String string = "";
        if (invokerProgram == null) {
            this.getInvokerProgram();
        }
        try {
            string = invokerProgram.getCanonicalPath();
        }
        catch (Exception var2_2) {
            string = invokerProgram.getAbsolutePath();
        }
        return string;
    }

    File getInvokerProgram() {
        if (OS.isWindows() && invokerProgram == null) {
            invokerProgram = this.getCommandFile();
        }
        return invokerProgram;
    }

    private File getCommandFile() {
        File file = null;
        File file2 = TempFiles.getFile("invoker.exe");
        if (file2 != null && !file2.exists() && LangUtilities.getResourceAsFile(file2.getPath())) {
            file = file2;
        }
        return file;
    }
}
