/*
 * Decompiled with CFR 0_101.
 */
package com.denova.security;

import com.denova.io.Log;
import com.denova.ui.GridBagControl;
import com.denova.ui.TransparentJPanel;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.UserNotices;
import com.denova.util.LocaleTranslator;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.util.List;
import java.util.Vector;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

public class GetCredentials {
    private static final boolean debugging = false;
    private static final Log log = new Log("getlicense.log");
    private JTextField primaryContactEmail;
    private JPasswordField idCode;
    private JLabel header = null;
    private JLabel subhead = null;
    private JLabel wrongLicenseEmail1 = null;
    private JLabel wrongLicenseEmail2 = null;
    private String headerLabel = null;
    private String subheadLabel = null;
    private String wrongLicenseLabel = "If you haven't received your credentials, contact the manufacturer.";
    private LocaleTranslator localized = null;

    public GetCredentials(LocaleTranslator localeTranslator) {
        this.localized = localeTranslator;
    }

    public boolean isOk() {
        return this.primaryContactOk() && this.idCodeOk();
    }

    public String getTitle() {
        return this.getLocalizedString("LicenseDetails", "License Details");
    }

    public void setPrimaryContact(String string) {
        UiLayoutUtilities.update((Component)this.primaryContactEmail, (Object)string);
        String string2 = this.primaryContactEmail.getText();
        int n = 0;
        if (string2 != null && string2.length() <= 0) {
            this.primaryContactEmail.requestFocusInWindow();
            this.primaryContactEmail.setCaretPosition(n);
        }
    }

    public String getPrimaryContact() {
        return this.primaryContactEmail.getText().trim();
    }

    public void setIdCode(String string) {
        UiLayoutUtilities.update((Component)this.idCode, (Object)string);
        int n = 0;
        String string2 = this.primaryContactEmail.getText();
        String string3 = this.idCode.getText();
        if (string2 != null && string2.length() > 0 && string3 != null && string3.length() <= 0) {
            this.idCode.requestFocusInWindow();
            this.idCode.setCaretPosition(n);
        } else {
            n = string2.length();
            this.primaryContactEmail.requestFocusInWindow();
            this.primaryContactEmail.setCaretPosition(n);
        }
    }

    public String getIdCode() {
        return this.idCode.getText().trim();
    }

    public void setHeader(String string) {
        this.headerLabel = string;
        if (this.header != null) {
            UiLayoutUtilities.update((Component)this.header, (Object)string);
        }
        this.logMessage("header: " + string);
    }

    public void setSubhead(String string) {
        this.subheadLabel = string;
        if (this.subhead != null) {
            UiLayoutUtilities.update((Component)this.subhead, (Object)string);
        }
        this.logMessage("subhead: " + string);
    }

    public void setWrongLicenseEmail(String string) {
        this.wrongLicenseLabel = string;
        if (this.wrongLicenseEmail1 != null && this.wrongLicenseEmail2 != null) {
            this.logMessage("wrong license email help: " + this.wrongLicenseLabel);
            if (this.wrongLicenseLabel.length() > 40) {
                int n = this.wrongLicenseLabel.substring(40).indexOf(" ") + 40;
                String string2 = string.substring(0, n).trim();
                String string3 = string.substring(n).trim();
                UiLayoutUtilities.update((Component)this.wrongLicenseEmail1, (Object)string2);
                UiLayoutUtilities.update((Component)this.wrongLicenseEmail2, (Object)string3);
                this.logMessage("wrong license email help1: " + string2);
                this.logMessage("wrong license email help2: " + string3);
            } else {
                UiLayoutUtilities.update((Component)this.wrongLicenseEmail1, (Object)string.trim());
                UiLayoutUtilities.update((Component)this.wrongLicenseEmail2, (Object)"");
            }
        }
    }

    public void setSubheadVisible(boolean bl) {
        this.subhead.setVisible(bl);
    }

    public void setPrimaryContactFocus() {
        UiLayoutUtilities.setFocus(this.primaryContactEmail);
    }

    public void setIdCodeFocus() {
        UiLayoutUtilities.setFocus(this.idCode);
    }

    public TransparentJPanel createMainPanel() {
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        GridBagConstraints gridBagConstraints = GridBagControl.getTextConstraints();
        GridBagConstraints gridBagConstraints2 = GridBagControl.getLabelForTextConstraints();
        gridBagControl.endRow(this.getHeaderPanel());
        this.primaryContactEmail = new JTextField(15);
        this.primaryContactEmail.setToolTipText(this.getLocalizedString("PrimaryContactEmailHelp", "Email you supplied when you obtained the license."));
        gridBagControl.add(gridBagConstraints2, new JLabel(this.getLocalizedString("PrimaryContactEmail", "Email")));
        gridBagControl.endRow(gridBagConstraints, this.primaryContactEmail);
        this.idCode = new JPasswordField(15);
        this.idCode.setToolTipText(this.getLocalizedString("IdCodeHelp", "PIN supplied to you when you obtained the license."));
        gridBagControl.add(gridBagConstraints2, new JLabel(this.getLocalizedString("IdCode", "PIN")));
        gridBagControl.endRow(gridBagConstraints, this.idCode);
        gridBagControl.addVerticalSpace();
        gridBagControl.addCentered(new JLabel(this.getLocalizedString("LicenseWarning", "All settings are case sensitive.")));
        return transparentJPanel;
    }

    public void showError() {
        if (this.primaryContactOk()) {
            Vector<String> vector = new Vector<String>();
            vector.add(this.getLocalizedString("LicenseDetailsHelp", "Enter the email and PIN for this license."));
            UserNotices userNotices = new UserNotices();
            userNotices.note(vector, this.getLocalizedString("Ok", "OK"));
            this.setIdCodeFocus();
        } else {
            UiLayoutUtilities.setFocus(this.primaryContactEmail);
            UserNotices userNotices = new UserNotices();
            userNotices.note(this.getLocalizedString("InvalidUserID", "You've entered an invalid email address."), this.getLocalizedString("Ok", "OK"));
            this.setPrimaryContactFocus();
        }
    }

    public void showHelp() {
        Object object;
        String string = null;
        if (this.localized == null) {
            object = this.localized.getString("Author", this.localized.getString("Manufacturer", "the manufacturer"));
            string = this.localized.getString("WrongLicenseEmail", (String)object);
        } else {
            string = this.wrongLicenseLabel;
        }
        object = new UserNotices();
        Vector<String> vector = new Vector<String>();
        vector.add(this.getLocalizedString("LicenseDetailsHelp", "Enter the email and PIN supplied to you when you obtained the license."));
        vector.add(string);
        object.note(vector, this.getLocalizedString("Ok", "OK"));
    }

    public void logMessage(String string) {
        if (log != null) {
            log.write(string);
        }
        this.debug(string);
    }

    public TransparentJPanel getHeaderPanel() {
        TransparentJPanel transparentJPanel = new TransparentJPanel();
        GridBagControl gridBagControl = new GridBagControl(transparentJPanel);
        GridBagConstraints gridBagConstraints = GridBagControl.getTextConstraints();
        this.header = new JLabel(this.headerLabel);
        gridBagControl.endRow(gridBagConstraints, this.header);
        this.logMessage("added header: " + this.headerLabel);
        gridBagControl.addBlankRow();
        if (this.subheadLabel != null) {
            this.subhead = new JLabel(this.subheadLabel.trim());
            gridBagControl.endRow(gridBagConstraints, this.subhead);
            this.logMessage("added subhead: " + this.subheadLabel);
        }
        if (this.wrongLicenseLabel != null) {
            String string = this.wrongLicenseLabel;
            String string2 = "";
            if (this.wrongLicenseLabel.length() > 40) {
                int n = this.wrongLicenseLabel.substring(40).indexOf(" ") + 40;
                string = this.wrongLicenseLabel.substring(0, n).trim();
                string2 = this.wrongLicenseLabel.substring(n).trim();
            }
            this.wrongLicenseEmail1 = new JLabel(string.trim());
            gridBagControl.endRow(gridBagConstraints, this.wrongLicenseEmail1);
            this.logMessage("added wrong license1: " + this.wrongLicenseEmail1.getText());
            this.wrongLicenseEmail2 = new JLabel(string2.trim());
            gridBagControl.endRow(gridBagConstraints, this.wrongLicenseEmail2);
            this.logMessage("added wrong license2: " + this.wrongLicenseEmail2.getText());
        }
        return transparentJPanel;
    }

    private boolean primaryContactOk() {
        String string = this.getPrimaryContact();
        return string.length() > 0 && string.indexOf("@") > 0;
    }

    private boolean idCodeOk() {
        String string = this.getIdCode();
        return string.length() >= 8;
    }

    private String getLocalizedString(String string, String string2) {
        String string3 = string2;
        string3 = this.localized == null ? string2 : this.localized.getString(string, string2);
        return string3;
    }

    private void debug(String string) {
    }
}
