/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.SwingRunner;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.UserNotices;
import java.awt.Color;
import java.awt.Component;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.filechooser.FileFilter;

public class FileSelectionDialog {
    private static final boolean debug = false;
    private static final Log fileLog = new Log("fileselection.log");
    private static File defaultDirectory;
    private static Color textColor;
    private static Color backgroundColor;
    private JFrame parent;
    private boolean dirsOnly;
    private boolean filesOnly;
    private boolean allowMultiSelection = false;
    private FileFilter filter;
    private String prompt;
    private String approveText;
    private JFileChooser filechooser;

    public FileSelectionDialog() {
        this(null);
    }

    public FileSelectionDialog(JFrame jFrame) {
        this.parent = UiLayoutUtilities.forceJFrameParent(jFrame);
    }

    public static File getDefaultDirectory() {
        return defaultDirectory;
    }

    public static void setDefaultDirectory(String string) {
        if (string != null) {
            FileSelectionDialog.setDefaultDirectory(new File(string));
        }
    }

    public static void setDefaultDirectory(File file) {
        defaultDirectory = file;
        fileLog.write("set default dir: " + defaultDirectory);
    }

    public static void setTextColor(Color color) {
        textColor = color;
    }

    public static void setBackgroundColor(Color color) {
        backgroundColor = color;
    }

    public static File askForFileOrDirectory() {
        FileSelectionDialog fileSelectionDialog = new FileSelectionDialog();
        fileSelectionDialog.setPrompt("Select file or directory");
        File file = fileSelectionDialog.getSelection();
        return FileSelectionDialog.fixDoubledDirBug(file);
    }

    public static File[] askForFilesOrDirectories() {
        FileSelectionDialog fileSelectionDialog = new FileSelectionDialog();
        fileSelectionDialog.setPrompt("Select files or directories");
        fileSelectionDialog.setMultiSelection(true);
        File[] arrfile = fileSelectionDialog.getSelections();
        return FileSelectionDialog.fixDoubledDirBug(arrfile);
    }

    public static File askForExistingFileOrDirectory() {
        File file = FileSelectionDialog.askForFileOrDirectory();
        if (!(file == null || file.exists())) {
            UserNotices userNotices = new UserNotices();
            userNotices.note(file.getPath() + " does not exist");
            file = null;
        }
        return file;
    }

    protected static File[] fixDoubledDirBug(File[] arrfile) {
        File[] arrfile2 = arrfile;
        if (arrfile2 != null) {
            int n = arrfile2.length;
            for (int i = 0; i < n; ++i) {
                File file = arrfile2[i];
                arrfile2[i] = FileSelectionDialog.fixDoubledDirBug(file);
            }
        }
        return arrfile2;
    }

    protected static File fixDoubledDirBug(File file) {
        String string;
        if (!(file == null || file.exists() || (string = file.getParent()) == null || string.length() <= 0)) {
            File file2 = new File(string);
            if (file.getName().equals(file2.getName())) {
                file = file2;
            }
        }
        return file;
    }

    public boolean getDirectoriesOnly() {
        return this.dirsOnly;
    }

    public void setDirectoriesOnly(boolean bl) {
        this.dirsOnly = bl;
    }

    public boolean getFilesOnly() {
        return this.filesOnly;
    }

    public void setFilesOnly(boolean bl) {
        this.filesOnly = bl;
    }

    public boolean getMultiSelection() {
        return this.allowMultiSelection;
    }

    public void setMultiSelection(boolean bl) {
        this.allowMultiSelection = bl;
    }

    public String getPrompt() {
        return this.prompt;
    }

    public void setPrompt(String string) {
        this.prompt = string;
    }

    public String getApproveButtonText() {
        return this.approveText;
    }

    public void setApproveButtonText(String string) {
        this.approveText = string;
    }

    public void setFileFilter(FileFilter fileFilter) {
        this.filter = fileFilter;
    }

    public FileFilter getFileFilter() {
        return this.filter;
    }

    public File[] getSelections() {
        File[] arrfile = null;
        try {
            SelectFiles selectFiles = new SelectFiles();
            SwingRunner.invokeAndWait(selectFiles);
            arrfile = selectFiles.getSelections();
        }
        catch (Exception var2_3) {
            fileLog.write(var2_3);
        }
        return arrfile;
    }

    public File getSelection() {
        File file = null;
        try {
            SelectFile selectFile = new SelectFile();
            SwingRunner.invokeAndWait(selectFile);
            file = selectFile.getSelection();
        }
        catch (Exception var2_3) {
            fileLog.write(var2_3);
        }
        return file;
    }

    private boolean setupFileChooser() {
        boolean bl = false;
        try {
            String string;
            Object var2_2 = null;
            if (defaultDirectory == null && (string = System.getProperty("user.dir")) != null) {
                FileSelectionDialog.setDefaultDirectory(string);
            }
            if (defaultDirectory != null) {
                fileLog.write("instantiating jfilechooser with default directory: " + defaultDirectory.getPath());
                this.filechooser = new JFileChooser(defaultDirectory.getPath());
            } else {
                fileLog.write("instantiating jfilechooser without default directory");
                this.filechooser = new JFileChooser();
            }
            if (this.prompt != null) {
                this.filechooser.setDialogTitle(this.prompt);
            }
            if (this.approveText != null) {
                this.filechooser.setApproveButtonText(this.approveText);
            }
            if (this.filter != null) {
                this.filechooser.setFileFilter(this.filter);
            }
            if (this.dirsOnly) {
                this.filechooser.setFileSelectionMode(1);
            } else if (this.filesOnly) {
                this.filechooser.setFileSelectionMode(0);
            } else {
                this.filechooser.setFileSelectionMode(2);
            }
            this.filechooser.setMultiSelectionEnabled(this.allowMultiSelection);
            UiLayoutUtilities.setColors(this.filechooser, textColor, backgroundColor);
            bl = this.getSelectionResult() == 0;
        }
        catch (Exception var2_3) {
            bl = false;
            fileLog.write(var2_3);
        }
        return bl;
    }

    protected int getSelectionResult() {
        int n = 1;
        try {
            n = this.getFilechooser().showOpenDialog(this.getParent());
        }
        catch (Exception var2_2) {
            fileLog.write(var2_2);
        }
        return n;
    }

    protected JFrame getParent() {
        return this.parent;
    }

    protected JFileChooser getFilechooser() {
        return this.filechooser;
    }

    private class SelectFiles
    implements Runnable {
        File[] selectedFiles;

        private SelectFiles() {
            this.selectedFiles = null;
        }

        public void run() {
            if (FileSelectionDialog.this.setupFileChooser()) {
                this.selectedFiles = FileSelectionDialog.this.filechooser.getSelectedFiles();
                defaultDirectory = FileSelectionDialog.this.filechooser.getCurrentDirectory();
                if (this.selectedFiles != null) {
                    // empty if block
                }
            }
        }

        public File[] getSelections() {
            return this.selectedFiles;
        }
    }

    private class SelectFile
    implements Runnable {
        File selection;

        private SelectFile() {
            this.selection = null;
        }

        public void run() {
            if (FileSelectionDialog.this.setupFileChooser()) {
                File file = FileSelectionDialog.this.filechooser.getSelectedFile();
                if (file != null) {
                    String string = file.getPath();
                    this.selection = new File(string);
                }
                if (this.selection != null) {
                    if (this.selection.isDirectory()) {
                        defaultDirectory = this.selection;
                    } else {
                        defaultDirectory = new File(this.selection.getParent());
                    }
                } else if (FileSelectionDialog.this.filechooser == null) {
                    fileLog.write("filechooser not instantiated");
                } else {
                    defaultDirectory = FileSelectionDialog.this.filechooser.getCurrentDirectory();
                    this.selection = defaultDirectory;
                }
            }
        }

        public File getSelection() {
            return this.selection;
        }
    }

}
