/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.GridBagControl;
import com.denova.ui.Swinger;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.UserNotices;
import com.denova.util.StringConversions;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.List;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;

public class ListEditor
extends JPanel
implements Runnable {
    protected PropertyChangeSupport propertyChanger;
    protected Vector items;
    protected JList list;
    private boolean editingItemsEnabled;
    private boolean viewingItemsEnabled;
    private JButton addButton;
    private JButton editButton;
    private JButton deleteButton;
    private JButton viewButton;
    private JLabel editorTitleLabel;
    private JLabel reminderLabel;
    private boolean addPending;
    private boolean editPending;
    private boolean deletePending;
    private boolean viewPending;
    private String editorTitle = "";
    private String reminder = "";
    private static final Log log = new Log("listeditor.log");
    private static boolean showIconsOnButtons = true;

    public ListEditor() {
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        buttonsIcons.setShowIcons(showIconsOnButtons);
        this.items = new Vector();
        this.list = new JList<Object>(this.items.toArray());
        this.editingItemsEnabled = false;
        this.viewingItemsEnabled = false;
        this.addPending = false;
        this.editPending = false;
        this.deletePending = false;
        this.viewPending = false;
        this.addButton = buttonsIcons.getIconTextButton("Add", "add-denova.png");
        this.editButton = buttonsIcons.getIconTextButton("Edit", "edit-denova.png");
        this.deleteButton = buttonsIcons.getIconTextButton("Delete", "del-denova.png");
        this.viewButton = buttonsIcons.getIconTextButton("View", "browse-denova.png");
        GridBagControl gridBagControl = new GridBagControl(this);
        this.editorTitleLabel = new JLabel(this.editorTitle);
        gridBagControl.addCentered(this.editorTitleLabel);
        JScrollPane jScrollPane = new JScrollPane();
        jScrollPane.setMinimumSize(new Dimension(187, 100));
        jScrollPane.getViewport().add(this.list);
        jScrollPane.setPreferredSize(new Dimension(375, 200));
        gridBagControl.endRow(jScrollPane);
        GridBagConstraints gridBagConstraints = gridBagControl.getConstraints();
        gridBagConstraints.gridheight = 1;
        gridBagConstraints.fill = 2;
        JPanel jPanel = new JPanel();
        GridBagControl gridBagControl2 = new GridBagControl(jPanel);
        this.addButton.setToolTipText("Add item");
        gridBagControl2.add(gridBagConstraints, this.addButton);
        this.editButton.setToolTipText("Edit selected item");
        gridBagControl2.add(gridBagConstraints, this.editButton);
        this.viewButton.setToolTipText("View details about all items");
        gridBagControl2.add(gridBagConstraints, this.viewButton);
        this.deleteButton.setToolTipText("Delete selected item");
        gridBagControl2.endRow(gridBagConstraints, this.deleteButton);
        this.editingItemsEnabled = this.isEditingItemsEnabled();
        if (!this.editingItemsEnabled) {
            this.editButton.setVisible(false);
        }
        this.viewingItemsEnabled = this.isViewingItemsEnabled();
        if (!this.viewingItemsEnabled) {
            this.viewButton.setVisible(false);
        }
        gridBagControl.addCentered(jPanel);
        this.reminderLabel = new JLabel(this.reminder);
        gridBagControl.addCentered(this.reminderLabel);
        gridBagControl.addBlankRow();
        Action action = new Action();
        this.addButton.addActionListener(action);
        this.editButton.addActionListener(action);
        this.deleteButton.addActionListener(action);
        this.viewButton.addActionListener(action);
        listMouseListener listMouseListener = new listMouseListener();
        this.list.addMouseListener(listMouseListener);
        this.propertyChanger = new PropertyChangeSupport(this);
    }

    public static void setShowIconsOnButtons(boolean bl) {
        showIconsOnButtons = bl;
    }

    public static boolean getShowIconsOnButtons() {
        return showIconsOnButtons;
    }

    public synchronized void setItems(Vector vector) {
        this.items = (Vector)vector.clone();
        UiLayoutUtilities.update((Component)this.list, (Object)this.items);
    }

    public synchronized Vector getItems() {
        Vector vector = this.items != null ? (Vector)this.items.clone() : new Vector();
        return vector;
    }

    public JList getList() {
        return this.list;
    }

    public JButton getAddButton() {
        return this.addButton;
    }

    public JButton getEditButton() {
        return this.editButton;
    }

    public JButton getDeleteButton() {
        return this.deleteButton;
    }

    public JButton getViewButton() {
        return this.viewButton;
    }

    public synchronized boolean isEditingItemsEnabled() {
        return this.editingItemsEnabled;
    }

    synchronized void setEditingItemsEnabled(boolean bl) {
        if (this.editingItemsEnabled != bl) {
            this.editingItemsEnabled = bl;
            this.editButton.setVisible(this.isEditingItemsEnabled());
        }
    }

    public synchronized boolean isViewingItemsEnabled() {
        return this.viewingItemsEnabled;
    }

    public synchronized void setViewingItemsEnabled(boolean bl) {
        if (this.viewingItemsEnabled != bl) {
            this.viewingItemsEnabled = bl;
            this.viewButton.setVisible(this.isViewingItemsEnabled());
        }
    }

    public String toString() {
        return StringConversions.fromVector(this.getItems());
    }

    public void fromString(String string) {
        this.items = StringConversions.toVector(string);
        UiLayoutUtilities.update((Component)this.list, (Object)this.items);
    }

    public void setEditorTitle(String string) {
        this.editorTitle = string;
        UiLayoutUtilities.update((Component)this.editorTitleLabel, (Object)this.editorTitle);
    }

    public void setReminder(String string) {
        this.reminder = string;
        UiLayoutUtilities.update((Component)this.reminderLabel, (Object)this.reminder);
    }

    public void addListener(PropertyChangeListener propertyChangeListener) {
        this.propertyChanger.addPropertyChangeListener(propertyChangeListener);
    }

    protected synchronized void addItems() {
        AddSwinger addSwinger = new AddSwinger();
        addSwinger.execute();
    }

    protected synchronized void editItem(int n) {
    }

    protected synchronized void viewItems(int[] arrn) {
    }

    protected synchronized boolean isItemDeletable(Object object) {
        return true;
    }

    protected synchronized void deleteItems(int[] arrn) {
        DeleteSwinger deleteSwinger = new DeleteSwinger(arrn);
        deleteSwinger.execute();
    }

    protected void addNewItems(List list) {
        if (list != null) {
            int n = list.size();
            for (int i = 0; i < n; ++i) {
                Object e = list.get(i);
                this.items.add(e);
            }
            this.list.setListData(this.items);
            log.write("finished adding items");
            this.postListUpdate();
        }
    }

    void edit() {
        this.editPending = true;
        new Thread(this).start();
    }

    void addButtonClicked(ActionEvent actionEvent) {
        this.addPending = true;
        new Thread(this).start();
    }

    void editButtonClicked(ActionEvent actionEvent) {
        this.edit();
    }

    void viewButtonClicked(ActionEvent actionEvent) {
        this.viewPending = true;
        log.write("view pending");
        new Thread(this).start();
    }

    void deleteButtonClicked(ActionEvent actionEvent) {
        this.deletePending = true;
        new Thread(this).start();
    }

    public void run() {
        UserNotices userNotices;
        if (this.addPending) {
            log.write("adding");
            this.addPending = false;
            this.addItems();
        }
        if (this.editPending) {
            log.write("editing");
            this.editPending = false;
            int n = this.list.getSelectedIndex();
            if (n >= 0) {
                this.editItem(n);
            } else {
                this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", false, true));
                userNotices = new UserNotices();
                userNotices.note("You must select an item before you edit it");
                this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", true, false));
            }
        }
        if (this.viewPending) {
            log.write("viewing");
            this.viewPending = false;
            int[] arrn = this.list.getSelectedIndices();
            if (arrn != null) {
                this.viewItems(arrn);
            } else {
                this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", false, true));
                userNotices = new UserNotices();
                userNotices.note("You must select an item before you view it");
                this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", true, false));
            }
        }
        if (this.deletePending) {
            log.write("deleting");
            this.deletePending = false;
            int[] arrn = this.list.getSelectedIndices();
            if (arrn != null) {
                this.deleteItems(arrn);
            } else {
                this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", false, true));
                userNotices = new UserNotices();
                userNotices.note("You must select an item before you delete it");
                this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", true, false));
            }
        }
    }

    public void showDialog() {
        this.showDialog(null);
    }

    public void showDialog(String string) {
        JDialog jDialog = new JDialog((Frame)new JFrame(), true);
        if (string != null) {
            jDialog.setTitle(string);
        }
        GridBagControl gridBagControl = new GridBagControl(jDialog.getContentPane());
        gridBagControl.addVerticalSpace();
        gridBagControl.add(this);
        gridBagControl.addVerticalSpace();
        gridBagControl.endRow();
        jDialog.setVisible(true);
    }

    protected void postListUpdate() {
        log.write("after list update");
    }

    private class DeleteSwinger
    extends Swinger {
        boolean deleted;
        int[] ints;

        public DeleteSwinger(int[] arrn) {
            this.deleted = false;
            this.ints = null;
            this.ints = arrn;
        }

        public void workInBackground() {
            for (int i = var1_1 = this.ints.length - 1; i >= 0; --i) {
                int n = this.ints[i];
                if (!ListEditor.this.isItemDeletable(ListEditor.this.items.get(n))) continue;
                ListEditor.this.items.remove(n);
                this.deleted = true;
            }
        }

        public void swingAfter() {
            if (this.deleted) {
                ListEditor.this.list.setListData(ListEditor.this.items);
                if (ListEditor.this.items.size() > 0) {
                    ListEditor.this.list.setSelectedIndex(0);
                    ListEditor.this.list.ensureIndexIsVisible(0);
                }
                log.write("finished deleting items");
                ListEditor.this.postListUpdate();
            }
        }
    }

    private class AddSwinger
    extends Swinger {
        private List newItems;

        private AddSwinger() {
            this.newItems = null;
        }

        public void swingBefore() {
            ListEditor.this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", false, true));
        }

        public void workInBackground() {
            String string = JOptionPane.showInputDialog("Please input a value");
            this.newItems = new Vector();
            this.newItems.add(string);
        }

        public void swingAfter() {
            ListEditor.this.addNewItems(this.newItems);
            ListEditor.this.propertyChanger.firePropertyChange(new PropertyChangeEvent(this, "active", true, false));
        }
    }

    private class listMouseListener
    extends MouseAdapter {
        private listMouseListener() {
        }

        public void mouseClicked(MouseEvent mouseEvent) {
            if (mouseEvent.getClickCount() == 2) {
                ListEditor.this.edit();
            }
        }
    }

    private class Action
    implements ActionListener {
        private Action() {
        }

        public void actionPerformed(ActionEvent actionEvent) {
            Object object = actionEvent.getSource();
            if (object == ListEditor.this.addButton) {
                ListEditor.this.addButtonClicked(actionEvent);
            } else if (object == ListEditor.this.editButton) {
                ListEditor.this.editButtonClicked(actionEvent);
            } else if (object == ListEditor.this.viewButton) {
                ListEditor.this.viewButtonClicked(actionEvent);
            } else if (object == ListEditor.this.deleteButton) {
                ListEditor.this.deleteButtonClicked(actionEvent);
            }
        }
    }

}
