/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.ui.ButtonsIcons;
import com.denova.ui.Fonts;
import com.denova.ui.Marquee;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JComponent;

private class Marquee.MainTextPanel
extends JComponent {
    private ImageIcon imageIcon;
    private int maxTextWidth;

    public Marquee.MainTextPanel() {
        this.maxTextWidth = 0;
        Marquee.this.logMessage("instantiating MainTextPanel");
        this.setup();
    }

    public void paintComponent(Graphics graphics) {
        graphics.setColor(Marquee.this.textColor);
        FontMetrics fontMetrics = graphics.getFontMetrics();
        if (this.imageIcon != null) {
            this.imageIcon.paintIcon(this, graphics, 1, 1);
        }
        if (Marquee.this.bottomText != null) {
            graphics.drawString(Marquee.this.bottomText, (this.getWidth() - fontMetrics.stringWidth(Marquee.this.bottomText)) / 2, this.getHeight() - 5);
        }
        if (Marquee.this.text != null && Marquee.this.text.size() > 0) {
            this.paintText(graphics, fontMetrics);
        }
        Marquee.this.logMessage("painted component");
    }

    public Dimension getPreferredSize() {
        Dimension dimension = null;
        dimension = this.imageIcon == null ? super.getPreferredSize() : new Dimension(1 + this.imageIcon.getIconWidth(), 1 + this.imageIcon.getIconHeight());
        return dimension;
    }

    private void paintText(Graphics graphics, FontMetrics fontMetrics) {
        try {
            int n = this.maxTextWidth + Marquee.this.leftMargin + Marquee.this.rightMargin;
            int n2 = this.getHeight() + Marquee.this.topMargin + Marquee.this.bottomMargin;
            int n3 = (this.getWidth() - n) / 2;
            int n4 = Marquee.this.topMargin;
            Marquee.this.logMessage("text area: x:" + n3 + " y:" + Marquee.this.topMargin + " w:" + n + " h:" + n2);
            Graphics graphics2 = graphics.create(n3, Marquee.this.topMargin, n, n2);
            int n5 = fontMetrics.getHeight();
            int n6 = Math.min(Marquee.this.text.size(), (this.getHeight() - Marquee.this.topMargin - Marquee.this.bottomMargin) / n5);
            int n7 = 0;
            String string = null;
            if (n7 < n6) {
                string = (String)Marquee.this.text.get(n7);
                int n8 = (n - (fontMetrics.stringWidth(string) + Marquee.this.leftMargin)) / 2;
                graphics2.drawString(string, n8, n4);
                n4+=fontMetrics.getHeight();
                ++n7;
            }
            while (n7 < n6) {
                string = (String)Marquee.this.text.get(n7);
                graphics2.drawString(string, Marquee.this.leftMargin, n4);
                n4+=fontMetrics.getHeight();
                ++n7;
            }
            Marquee.this.logMessage("painted " + n7 + " text lines");
        }
        catch (Exception var3_4) {
            Marquee.this.logException(var3_4);
        }
    }

    public void setup() {
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        this.imageIcon = buttonsIcons.getIcon(Marquee.this.backgroundFilename);
        boolean bl = this.imageIcon != null;
        Marquee.this.logMessage("got " + Marquee.this.backgroundFilename + ": " + bl);
        this.setFont(Fonts.Big);
        this.setForeground(Marquee.this.textColor);
        if (Marquee.this.text == null || Marquee.this.text.size() <= 0) {
            Marquee.this.logMessage("no main text to display");
        } else {
            this.calculateMaxWidth();
        }
    }

    private void calculateMaxWidth() {
        FontMetrics fontMetrics = this.getFontMetrics(this.getFont());
        this.maxTextWidth = 0;
        for (String string : Marquee.this.text) {
            this.maxTextWidth = Math.max(this.maxTextWidth, fontMetrics.stringWidth(string));
        }
    }
}
