/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.runtime.ThreadManager;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.Fonts;
import com.denova.ui.GridBagControl;
import com.denova.ui.JWordWrapLabel;
import com.denova.ui.SwingRunner;
import com.denova.ui.UiLayoutUtilities;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.util.Iterator;
import java.util.List;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.Border;

abstract class PopupDialog
extends JDialog {
    private String title = null;
    private String header = null;
    private List note = null;
    private String iconName = null;
    protected static final Log log = new Log("popup.log");
    protected Color foregroundColor = Color.black;
    protected Color backgroundColor = new Color(238, 238, 238);
    protected boolean showIcons = true;
    private boolean done = false;

    public PopupDialog(Frame frame) {
        super(frame, true);
        this.setDefaultCloseOperation(2);
    }

    public PopupDialog(Dialog dialog) {
        super(dialog, true);
        this.setDefaultCloseOperation(2);
    }

    public PopupDialog() {
        this.setModal(true);
        this.setDefaultCloseOperation(2);
    }

    public void setVisibleAndWait() {
        final PopupDialog popupDialog = this;
        SwingRunner.invokeAndWait(new Runnable(){

            public void run() {
                popupDialog.setVisible(true);
            }
        });
        while (!this.getDone()) {
            ThreadManager.sleep(100);
        }
    }

    public boolean getDone() {
        return this.done;
    }

    public void setColors(Color color, Color color2) {
        if (color != null && color2 != null) {
            this.foregroundColor = color;
            this.backgroundColor = color2;
            log.write("text color: " + this.foregroundColor.toString());
            log.write("background color: " + this.backgroundColor.toString());
        }
    }

    public void setShowIcons(boolean bl) {
        this.showIcons = bl;
        log.write("show icons: " + this.showIcons);
    }

    public void setTitle(String string) {
        this.title = string;
    }

    public void setHeader(String string) {
        this.header = string;
    }

    public void setNote(List list) {
        this.note = list;
    }

    public void setIconName(String string) {
        this.iconName = string;
    }

    protected JPanel getPanel(JPanel jPanel) {
        JPanel jPanel2 = new JPanel();
        jPanel2.setBorder(UiLayoutUtilities.getMarginBorder(15));
        GridBagControl gridBagControl = new GridBagControl(jPanel2);
        if (this.showIcons && this.iconName != null && this.iconName.length() > 0) {
            ButtonsIcons buttonsIcons = new ButtonsIcons();
            buttonsIcons.setShowIcons(this.showIcons);
            JLabel jLabel = new JLabel(buttonsIcons.getIcon(this.iconName));
            gridBagControl.add(GridBagControl.getLabelConstraints(), jLabel);
            gridBagControl.add(new JLabel("   "));
        }
        gridBagControl.endRow(this.getTextPanel());
        if (jPanel != null) {
            gridBagControl.addBlankRow();
            gridBagControl.addCentered(jPanel);
        }
        if (this.title != null && this.title.length() > 0) {
            super.setTitle(this.title);
        }
        return jPanel2;
    }

    protected void exit() {
        log.write("starting to exit");
        log.write("setting dialog invisible");
        this.setVisible(false);
        log.write("disposing of resources");
        this.dispose();
        log.write("finished exiting");
        this.done = true;
    }

    private JPanel getTextPanel() {
        JPanel jPanel = new JPanel();
        GridBagControl gridBagControl = new GridBagControl(jPanel);
        if (this.header != null && this.header.length() > 0) {
            gridBagControl.endRow(GridBagControl.getTextConstraints(), this.getHeaderPane());
        }
        if (this.note != null && this.note.size() > 0) {
            Iterator iterator = this.note.iterator();
            while (iterator.hasNext()) {
                gridBagControl.endRow(new JLabel(" "));
                String string = (String)iterator.next();
                if (string == null || string.length() <= 0) continue;
                JWordWrapLabel jWordWrapLabel = new JWordWrapLabel(string);
                jWordWrapLabel.setForeground(this.foregroundColor);
                jWordWrapLabel.setBackground(this.backgroundColor);
                gridBagControl.endRow(GridBagControl.getTextConstraints(), jWordWrapLabel);
            }
        }
        return jPanel;
    }

    private JScrollPane getHeaderPane() {
        JWordWrapLabel jWordWrapLabel = new JWordWrapLabel(this.header, Fonts.Big);
        jWordWrapLabel.setForeground(this.foregroundColor);
        jWordWrapLabel.setBackground(this.backgroundColor);
        return jWordWrapLabel;
    }

}
