/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.ui.NoteDialog;
import com.denova.ui.SwingRunner;
import com.denova.ui.YesNoDialog;
import com.denova.ui.awt.ErrorDialog;
import java.awt.Color;
import java.util.List;
import java.util.Vector;

public class UserNotices {
    private static final String InfoIcon = "info-denova.png";
    private static final String QuestionIcon = "question-denova.png";
    private static final String ErrorIcon = "error-denova.png";
    private static final Log log = new Log("notices");
    private static Color textColor = null;
    private static Color backgroundColor = null;
    private static boolean showIcons = true;
    private static YesNoDialog dialog = null;

    public static void setTextColor(Color color) {
        textColor = color;
        if (textColor != null) {
            log.write("text color: " + textColor.toString());
        }
    }

    public static void setBackgroundColor(Color color) {
        backgroundColor = color;
        if (backgroundColor != null) {
            log.write("background color: " + backgroundColor.toString());
        }
    }

    public static void setShowIcons(boolean bl) {
        showIcons = bl;
        log.write("show icons: " + showIcons);
    }

    public boolean ask(String string, String string2, String string3, String string4) {
        List list = null;
        return this.ask(string, string2, list, string3, string4);
    }

    public boolean ask(String string, String string2, List list, String string3, String string4) {
        String string5 = string3;
        return this.ask(string, string2, list, string3, string4, string5);
    }

    public boolean ask(String string, String string2, List list, String string3, String string4, String string5) {
        return this.ask(string, string2, list, string3, string4, string5, string5);
    }

    public boolean ask(String string, String string2, List list, String string3, String string4, String string5, String string6) {
        boolean bl = string6.equals(string3);
        try {
            dialog = new YesNoDialog();
            dialog.setTitle(string);
            dialog.setHeader(string2);
            dialog.setNote(list);
            dialog.setIconName("question-denova.png");
            dialog.setYesLabel(string3);
            dialog.setNoLabel(string4);
            dialog.setCloseOption(string6.equals(string3));
            dialog.setShowIcons(showIcons);
            if (string5.equals(string4)) {
                dialog.setNoToDefault();
                bl = false;
                log.write("set no to default answer");
            } else {
                dialog.setYesToDefault();
                bl = true;
                log.write("set yes to default answer");
            }
            if (textColor != null && backgroundColor != null) {
                dialog.setColors(textColor, backgroundColor);
            }
            dialog.createPanel();
            dialog.setVisibleAndWait();
            bl = dialog.yes();
            log.write("yes answer: " + bl);
        }
        catch (Exception var9_9) {
            log.write(var9_9);
        }
        log.write(string2.trim() + " " + bl);
        return bl;
    }

    public void note(String string) {
        Vector<String> vector = new Vector<String>();
        vector.add(string);
        this.note(vector, "OK");
    }

    public void note(String string, String string2) {
        Vector<String> vector = new Vector<String>();
        vector.add(string);
        this.note(vector, string2);
    }

    public void note(List list, String string) {
        String string2 = null;
        this.note(string2, list, string);
    }

    public void note(String string, List list, String string2) {
        this.note("", string, list, string2);
    }

    public void note(String string, String string2, List list, String string3) {
        this.note(string, string2, list, string3, "info-denova.png");
    }

    public void note(String string, String string2, List list, String string3, String string4) {
        this.showNote(string, string2, list, string3, "info-denova.png");
    }

    public void noteError(String string) {
        this.noteError(string, "OK");
    }

    public void noteError(String string, String string2) {
        String string3 = null;
        this.noteError(string3, string, string2);
    }

    public void noteError(String string, String string2, String string3) {
        String string4 = null;
        Vector<String> vector = new Vector<String>();
        vector.add(string2);
        this.noteError(string, string4, vector, string3);
    }

    public void noteError(String string, String string2, List list, String string3) {
        this.showNote(string, string2, list, string3, "error-denova.png");
    }

    public void awtNoteError(String string) {
        ErrorDialog.show("Error", string);
    }

    public void unexpectedStartupError() {
        this.awtNoteError("Unable to start application. It's possible that you are missing class files.");
    }

    private void showNote(final String string, final String string2, final List list, final String string3, final String string4) {
        SwingRunner.invokeAndWait(new Runnable(){

            public void run() {
                try {
                    NoteDialog noteDialog = new NoteDialog();
                    noteDialog.setTitle(string);
                    noteDialog.setHeader(string2);
                    noteDialog.setNote(list);
                    noteDialog.setIconName(string4);
                    noteDialog.setOkLabel(string3);
                    noteDialog.setShowIcons(showIcons);
                    if (textColor != null && backgroundColor != null) {
                        noteDialog.setColors(textColor, backgroundColor);
                    }
                    noteDialog.createPanel();
                    noteDialog.setVisible(true);
                }
                catch (Exception var1_2) {
                    log.write(var1_2);
                }
            }
        });
    }

}
