/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.runtime.ThreadManager;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.ImagePanel;
import com.denova.ui.SwingRunner;
import com.denova.ui.UiLayoutUtilities;
import com.denova.ui.WizardPanel;
import com.denova.util.MessageDelegate;
import com.denova.util.MessageListener;
import com.denova.util.MessageSender;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.ListIterator;
import java.util.Vector;
import javax.swing.Box;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;

public class Wizard
extends JPanel
implements ActionListener,
MessageSender {
    private static Log log = new Log("wizard");
    protected int panelIndex = 0;
    protected int mostRecentPanelIndex = 0;
    private List panels = new Vector();
    private WizardPanel panel = null;
    private boolean cancelled = false;
    private boolean aborted = false;
    private JPanel cardPanel;
    private String lastCard = "";
    private JPanel buttons;
    private boolean includeWizardButtons = true;
    private ButtonsIcons buttonsIcons = new ButtonsIcons();
    private JButton nextButton;
    private JButton previousButton;
    private JButton cancelButton;
    private Color backgroundColor = null;
    private Color textColor = null;
    private boolean backgroundOpaque = true;
    private boolean showIcons = true;
    private String cancelButtonLabel = "Cancel";
    private String previousButtonLabel = "Back";
    private String nextButtonLabel = "Next";
    private String finishedButtonLabel = "Finished";
    private String cancelButtonIconName = "cancel-jexpress.png";
    private String previousButtonIconName = "back-jexpress.png";
    private String nextButtonIconName = "forward-jexpress.png";
    private String finishedButtonIconName = "ok-jexpress.png";
    private String installButtonIconName = "install-jexpress.png";
    private String activePanel = "";
    private MessageDelegate messenger = new MessageDelegate();

    public synchronized void actionPerformed(ActionEvent actionEvent) {
        Object object = actionEvent.getSource();
        if (object == this.previousButton) {
            if (this.getCurrentPanel().isPreviousButtonEnabled()) {
                log.write("previous button clicked");
                this.showPrevious();
            } else {
                log.write("previous button clicked but ignored");
            }
        } else if (object == this.nextButton) {
            if (this.getCurrentPanel().isNextButtonEnabled()) {
                log.write("next button clicked");
                this.showNext();
            } else {
                log.write("next button clicked but ignored");
            }
        } else if (object == this.cancelButton) {
            if (this.getCurrentPanel().isCancelButtonEnabled()) {
                log.write("cancel button clicked");
                this.cancel();
            } else {
                log.write("previous button clicked but ignored");
            }
        }
    }

    public List getPanels() {
        return this.panels;
    }

    public synchronized void setEnabledNamedPanel(String string, boolean bl) {
        WizardPanel wizardPanel = this.getPanel(string);
        if (wizardPanel != null) {
            wizardPanel.setEnabled(bl);
            log.write(string + " enabled: " + bl);
        }
    }

    public synchronized void setBackgroundOpaque(boolean bl) {
        this.backgroundOpaque = bl;
        if (this.cardPanel != null) {
            this.cardPanel.setOpaque(this.backgroundOpaque);
        }
        for (int i = 0; i < this.panels.size(); ++i) {
            ImagePanel.setBackgroundTransparent(this.getPanel(i));
        }
        log.write("set wizard opaque: " + bl);
    }

    public synchronized void setBackgroundColor(Color color) {
        this.backgroundColor = color;
        if (this.cardPanel != null) {
            UiLayoutUtilities.setBackgroundColor(this.cardPanel, this.backgroundColor);
        }
        if (this.buttons != null) {
            UiLayoutUtilities.setBackgroundColor(this.buttons, this.backgroundColor);
        }
        if (this.panels != null) {
            for (int i = 0; i < this.panels.size(); ++i) {
                WizardPanel wizardPanel = this.getPanel(i);
                UiLayoutUtilities.setBackgroundColor(wizardPanel, this.backgroundColor);
            }
        }
    }

    public synchronized void setTextColor(Color color) {
        this.textColor = color;
        if (this.cardPanel != null) {
            UiLayoutUtilities.setTextColor(this.cardPanel, this.backgroundColor);
        }
        if (this.buttons != null) {
            UiLayoutUtilities.setTextColor(this.buttons, this.backgroundColor);
        }
        if (this.panels != null) {
            for (int i = 0; i < this.panels.size(); ++i) {
                WizardPanel wizardPanel = this.getPanel(i);
                UiLayoutUtilities.setTextColor(wizardPanel, this.backgroundColor);
            }
        }
    }

    public void setDefaultFinishedButtonLabel(String string) {
        this.finishedButtonLabel = string;
    }

    public void setDefaultFinishedButtonIconName(String string) {
        this.finishedButtonIconName = string;
    }

    public void setDefaultInstallButtonIconName(String string) {
        this.installButtonIconName = string;
    }

    public void setDefaultCancelButtonLabel(String string) {
        this.cancelButtonLabel = string;
        if (this.cancelButton != null) {
            this.cancelButton.setText(this.getDefaultCancelButtonLabel());
            this.checkButtonLabel(this.cancelButton, this.getDefaultCancelButtonLabel());
        }
    }

    public void setDefaultCancelButtonIconName(String string) {
        this.cancelButtonIconName = string;
    }

    public synchronized void setDefaultPreviousButtonLabel(String string) {
        this.previousButtonLabel = string;
        if (this.previousButton != null) {
            this.previousButton.setText(this.getDefaultPreviousButtonLabel());
            this.checkButtonLabel(this.previousButton, this.getDefaultPreviousButtonLabel());
        }
    }

    public void setDefaultPreviousButtonIconName(String string) {
        this.previousButtonIconName = string;
    }

    public synchronized void setDefaultNextButtonLabel(String string) {
        this.nextButtonLabel = string;
        if (this.nextButton != null) {
            this.nextButton.setText(this.getDefaultNextButtonLabel());
            this.checkButtonLabel(this.nextButton, this.getDefaultNextButtonLabel());
        }
    }

    public void setDefaultNextButtonIconName(String string) {
        this.nextButtonIconName = string;
    }

    public void setShowIcons(boolean bl) {
        this.showIcons = bl;
        this.buttonsIcons.setShowIcons(this.showIcons);
        log.write("show icons: " + this.showIcons);
    }

    private synchronized void enterPanel(WizardPanel wizardPanel) {
        if (!(this.activePanel.length() <= 0 || this.activePanel.equals(wizardPanel.getName()))) {
            log.write(this.activePanel + " is active. Waiting...");
            while (this.activePanel.length() > 0) {
                Thread.yield();
            }
        }
        List list = this.panels;
        synchronized (list) {
            class PanelEnterer
            implements Runnable {
                WizardPanel panel;

                public PanelEnterer(WizardPanel wizardPanel) {
                    this.panel = wizardPanel;
                }

                public void run() {
                    List list = Wizard.this.panels;
                    synchronized (list) {
                        Wizard.this.activePanel = this.panel.getName();
                        this.panel.enter();
                        Wizard.this.messenger.sendMessage(this.panel, "enter");
                    }
                }
            }
            SwingUtilities.invokeLater(new PanelEnterer(wizardPanel));
        }
    }

    private synchronized void leavePanel(WizardPanel wizardPanel) {
        if (!(this.activePanel.length() <= 0 || this.activePanel.equals(wizardPanel.getName()))) {
            log.write("WARNING: leaving " + wizardPanel.getName() + " while " + this.activePanel + " is active.");
        } else {
            log.write("leaving " + wizardPanel.getName());
        }
        List list = this.panels;
        synchronized (list) {
            class PanelLeaver
            implements Runnable {
                WizardPanel panel;

                public PanelLeaver(WizardPanel wizardPanel) {
                    this.panel = wizardPanel;
                }

                public void run() {
                    List list = Wizard.this.panels;
                    synchronized (list) {
                        this.panel.leave();
                        Wizard.this.messenger.sendMessage(this.panel, "leave");
                        Wizard.this.activePanel = "";
                    }
                }
            }
            SwingUtilities.invokeLater(new PanelLeaver(wizardPanel));
        }
    }

    public synchronized WizardPanel getPanel(String string) {
        WizardPanel wizardPanel = null;
        int n = this.getPanelIndex(string);
        if (n >= 0) {
            wizardPanel = this.getPanel(n);
        }
        return wizardPanel;
    }

    public synchronized int getPanelIndex(String string) {
        WizardPanel wizardPanel = null;
        boolean bl = false;
        int n = 0;
        while (!(n >= this.panels.size() || bl)) {
            wizardPanel = this.getPanel(n);
            String string2 = wizardPanel.getName();
            if (string2.equals(string)) {
                bl = true;
                continue;
            }
            ++n;
        }
        if (!bl) {
            n = -1;
        }
        return n;
    }

    public synchronized WizardPanel getCurrentPanel() {
        return this.getPanel(this.panelIndex);
    }

    public synchronized boolean isFirstPanel() {
        int n;
        for (n = this.panelIndex - 1; !(n < 0 || this.isPanelIndexEnabled(n)); --n) {
        }
        boolean bl = n < 0;
        log.write("is first active panel:" + bl);
        return bl;
    }

    public synchronized boolean isLastPanel() {
        int n;
        for (n = this.panelIndex + 1; !(n >= this.panels.size() || this.isPanelIndexEnabled(n)); ++n) {
        }
        boolean bl = n == this.panels.size();
        log.write("is last active panel: " + bl);
        return bl;
    }

    public synchronized int getLastActivePanel() {
        int n;
        for (n = this.panels.size() - 1; !(n < 0 || this.isPanelIndexEnabled(n)); --n) {
        }
        log.write("last active panel: " + n);
        return n;
    }

    public boolean isCancelled() {
        return this.cancelled;
    }

    public synchronized String getMostRecentPanelName() {
        WizardPanel wizardPanel;
        String string = "";
        if (this.mostRecentPanelIndex >= 0 && (wizardPanel = this.getPanel(this.mostRecentPanelIndex)) != null) {
            string = wizardPanel.getName();
        }
        return string;
    }

    public int getMostRecentPanelIndex() {
        return this.mostRecentPanelIndex;
    }

    public int getPanelIndex() {
        return this.panelIndex;
    }

    public JButton getNextButton() {
        return this.nextButton;
    }

    public JButton getPreviousButton() {
        return this.previousButton;
    }

    public JButton getCancelButton() {
        return this.cancelButton;
    }

    public Color getBackgroundColor() {
        return this.backgroundColor;
    }

    public String getDefaultFinishedButtonLabel() {
        return this.finishedButtonLabel;
    }

    public String getDefaultFinishedButtonIconName() {
        return this.finishedButtonIconName;
    }

    public String getDefaultInstallButtonIconName() {
        return this.installButtonIconName;
    }

    public String getDefaultCancelButtonLabel() {
        return this.cancelButtonLabel;
    }

    public String getDefaultCancelButtonIconName() {
        return this.cancelButtonIconName;
    }

    public String getDefaultPreviousButtonLabel() {
        return this.previousButtonLabel;
    }

    public String getDefaultPreviousButtonIconName() {
        return this.previousButtonIconName;
    }

    public String getDefaultNextButtonLabel() {
        return this.nextButtonLabel;
    }

    public String getDefaultNextButtonIconName() {
        return this.nextButtonIconName;
    }

    public synchronized WizardPanel getPanel(int n) {
        return (WizardPanel)this.panels.get(n);
    }

    public boolean isPanelIndexEnabled(int n) {
        return this.getPanel(n).isEnabled();
    }

    public String getButtonsPosition() {
        return "South";
    }

    public void createPanel() {
        SwingRunner.invokeAndWait(new Runnable(){

            public void run() {
                Box box;
                int n;
                EmptyBorder emptyBorder = new EmptyBorder(12, 12, 12, 12);
                Wizard.this.setLayout(new BorderLayout());
                Wizard.this.cardPanel = new JPanel();
                Wizard.this.cardPanel.setName("CardPanel");
                Wizard.this.cardPanel.setLayout(new CardLayout());
                Wizard.this.cardPanel.setOpaque(Wizard.this.backgroundOpaque);
                if (Wizard.this.backgroundColor != null) {
                    Wizard.this.cardPanel.setBackground(Wizard.this.backgroundColor);
                }
                Wizard.this.add((Component)Wizard.this.cardPanel, "Center");
                String string = Wizard.this.getButtonsPosition();
                if (string.equals("North") || string.equals("South")) {
                    box = Box.createHorizontalBox();
                    n = 350;
                } else {
                    box = Box.createVerticalBox();
                    n = 150;
                }
                box.setName("ButtonBox");
                box.add(Wizard.this.buttonGlue(string));
                Wizard.this.cancelButton = Wizard.this.buttonsIcons.getIconTextButton(Wizard.this.getDefaultCancelButtonLabel(), Wizard.this.getDefaultCancelButtonIconName());
                Wizard.this.cancelButton.setEnabled(false);
                Wizard.this.cancelButton.setHorizontalTextPosition(4);
                box.add(Wizard.this.cancelButton);
                box.add(Wizard.this.buttonGlue(string));
                Wizard.this.previousButton = Wizard.this.buttonsIcons.getIconTextButton(Wizard.this.getDefaultPreviousButtonLabel(), Wizard.this.getDefaultPreviousButtonIconName());
                Wizard.this.previousButton.setEnabled(false);
                Wizard.this.previousButton.setHorizontalTextPosition(4);
                box.add(Wizard.this.previousButton);
                box.add(Wizard.this.buttonGlue(string));
                String string2 = Wizard.this.getDefaultFinishedButtonLabel().length() > Wizard.this.getDefaultNextButtonLabel().length() ? Wizard.this.getDefaultFinishedButtonLabel() : Wizard.this.getDefaultNextButtonLabel();
                log.write("initial next button label: " + string2);
                Wizard.this.nextButton = Wizard.this.buttonsIcons.getIconTextButton(string2, Wizard.this.getDefaultNextButtonIconName());
                Wizard.this.nextButton.setEnabled(false);
                Wizard.this.nextButton.setHorizontalTextPosition(10);
                box.add(Wizard.this.nextButton);
                box.add(Wizard.this.buttonGlue(string));
                Wizard.this.buttons = new JPanel();
                Wizard.this.buttons.setName("ButtonsPanel");
                Wizard.this.buttons.setLayout(new BorderLayout());
                Wizard.this.buttons.setBorder(emptyBorder);
                if (Wizard.this.backgroundColor != null) {
                    Wizard.this.buttons.setBackground(Wizard.this.backgroundColor);
                }
                Wizard.this.buttons.add((Component)box, "Center");
                Wizard.this.buttons.add(Box.createHorizontalStrut(n), "North");
                if (Wizard.this.includeWizardButtons) {
                    Wizard.this.add((Component)Wizard.this.buttons, string);
                }
                Wizard.this.addActionListeners();
            }
        });
    }

    public Component buttonGlue(String string) {
        Component component = string.equals("North") || string.equals("South") ? Box.createHorizontalGlue() : Box.createVerticalGlue();
        return component;
    }

    public synchronized void addPanel(WizardPanel wizardPanel) {
        wizardPanel.setWizard(this);
        wizardPanel.setOpaque(this.backgroundOpaque);
        if (this.backgroundColor != null) {
            wizardPanel.setBackground(this.backgroundColor);
        }
        this.cardPanel.add((Component)wizardPanel, wizardPanel.getName());
        this.checkButtonSizes(wizardPanel);
        this.panels.add(wizardPanel);
        log.write("added " + wizardPanel.getName() + " as index: " + String.valueOf(this.panels.size() - 1));
    }

    public void startWizard() {
        this.logPanelNames();
        this.showPanel(this.panelIndex);
    }

    public void startWizard(String string) {
        this.logPanelNames();
        if (string == null) {
            this.showPanel(this.panelIndex);
        } else {
            this.showPanel(string);
        }
    }

    protected void logPanelNames() {
        ListIterator listIterator = this.panels.listIterator();
        while (listIterator.hasNext()) {
            WizardPanel wizardPanel = (WizardPanel)listIterator.next();
        }
    }

    public synchronized boolean resetPanel(String string) {
        boolean bl = false;
        WizardPanel wizardPanel = this.getPanel(string);
        if (wizardPanel != null) {
            wizardPanel.reset();
            bl = true;
        }
        return bl;
    }

    public synchronized void showPanel(String string) {
        int n = this.getPanelIndex(string);
        if (n >= 0) {
            this.showPanel(n);
        }
    }

    public synchronized void showPanel(int n) {
        if (n >= 0 && n < this.panels.size()) {
            if (this.isPanelIndexEnabled(n)) {
                log.write("starting to show " + this.getPanelID(n));
                this.setPanel(n, this.panelIndex);
            } else {
                log.write("unable to show disabled panel " + n);
            }
        } else {
            log.write("unable to show out of range panel " + n);
        }
    }

    public synchronized void showPrevious() {
        int n;
        for (n = this.panelIndex - 1; !(n < 0 || this.isPanelIndexEnabled(n)); --n) {
        }
        if (n >= 0) {
            this.showPanel(n);
        }
    }

    public synchronized void showNext() {
        if (this.getCurrentPanel().isOk()) {
            int n;
            for (n = this.panelIndex + 1; !(n >= this.panels.size() || this.isPanelIndexEnabled(n)); ++n) {
            }
            if (n < this.panels.size()) {
                log.write("showNext (): about to show next panel");
                this.showPanel(n);
            } else {
                log.write("showNext (): finish");
                this.runFinish();
            }
        } else {
            log.write("cannot move to next panel because current panel is not ok");
        }
    }

    public void cancel() {
        this.cancelled = true;
        this.cancelButton.setEnabled(false);
        this.previousButton.setEnabled(false);
        this.nextButton.setEnabled(false);
        for (int i = 0; i < this.panels.size(); ++i) {
            WizardPanel wizardPanel = this.getPanel(i);
            wizardPanel.userCanceled();
        }
    }

    public void abort() {
        this.aborted = true;
        this.cancel();
    }

    public void finish() {
    }

    public void addListener(MessageListener messageListener) {
        log.write("added listener for " + messageListener.getClass().getName());
        this.messenger.addListener(messageListener);
    }

    public void updateButtons() {
        SwingUtilities.invokeLater(new Runnable(){

            public void run() {
                String string = Wizard.this.panel.getPreviousButtonLabel();
                if (string == null) {
                    string = Wizard.this.getDefaultPreviousButtonLabel();
                }
                Wizard.this.previousButton.setText(string);
                log.write("previousButton: " + Wizard.this.previousButton.getText());
                String string2 = Wizard.this.panel.getPreviousButtonIconName();
                if (string2 == null) {
                    string2 = Wizard.this.getDefaultPreviousButtonIconName();
                }
                Wizard.this.setIcon(Wizard.this.previousButton, string2);
                log.write("previousIcon: " + string2);
                string = Wizard.this.panel.getNextButtonLabel();
                if (string == null) {
                    string = Wizard.this.getDefaultNextButtonLabel();
                }
                Wizard.this.nextButton.setText(string);
                log.write("nextButton: " + Wizard.this.nextButton.getText());
                string2 = Wizard.this.panel.getNextButtonIconName();
                if (string2 == null) {
                    string2 = Wizard.this.getDefaultNextButtonIconName();
                }
                Wizard.this.setIcon(Wizard.this.nextButton, string2);
                log.write("nextIcon: " + string2);
                string = Wizard.this.panel.getCancelButtonLabel();
                if (string == null) {
                    string = Wizard.this.getDefaultCancelButtonLabel();
                }
                Wizard.this.cancelButton.setText(string);
                log.write("cancelButton: " + Wizard.this.cancelButton.getText());
                string2 = Wizard.this.panel.getCancelButtonIconName();
                if (string2 == null) {
                    string2 = Wizard.this.getDefaultCancelButtonIconName();
                }
                Wizard.this.setIcon(Wizard.this.cancelButton, string2);
                log.write("cancelIcon: " + string2);
                if (Wizard.this.isFirstPanel()) {
                    Wizard.this.nextButton.setEnabled(Wizard.this.panel.isNextButtonEnabled());
                    Wizard.this.previousButton.setEnabled(false);
                    Wizard.this.cancelButton.setEnabled(Wizard.this.panel.isCancelButtonEnabled());
                } else if (Wizard.this.isLastPanel()) {
                    Wizard.this.nextButton.setText(Wizard.this.getDefaultFinishedButtonLabel());
                    Wizard.this.setIcon(Wizard.this.nextButton, Wizard.this.getDefaultFinishedButtonIconName());
                    Wizard.this.nextButton.setEnabled(Wizard.this.panel.isNextButtonEnabled());
                    Wizard.this.previousButton.setEnabled(Wizard.this.panel.isPreviousButtonEnabled());
                    Wizard.this.cancelButton.setEnabled(Wizard.this.panel.isCancelButtonEnabled());
                } else {
                    Wizard.this.nextButton.setEnabled(Wizard.this.panel.isNextButtonEnabled());
                    Wizard.this.previousButton.setEnabled(Wizard.this.panel.isPreviousButtonEnabled());
                    Wizard.this.cancelButton.setEnabled(Wizard.this.panel.isCancelButtonEnabled());
                }
                log.write("cancel button " + (Wizard.this.panel.isCancelButtonEnabled() ? "" : "not ") + "enabled");
                log.write("previous button " + (Wizard.this.panel.isPreviousButtonEnabled() ? "" : "not ") + "enabled");
                log.write("next button " + (Wizard.this.panel.isNextButtonEnabled() ? "" : "not ") + "enabled");
                JButton jButton = Wizard.this.panel.wizardGetDefaultButton();
                if (jButton == null) {
                    if (Wizard.this.nextButton.isEnabled()) {
                        jButton = Wizard.this.nextButton;
                        log.write("default button changed to " + jButton.getLabel());
                    } else if (Wizard.this.previousButton.isEnabled()) {
                        jButton = Wizard.this.previousButton;
                        log.write("default button changed to " + jButton.getLabel());
                    }
                }
                Wizard.this.setDefaultButton(jButton);
            }
        });
    }

    public void setIncludeButtons(boolean bl) {
        this.includeWizardButtons = bl;
    }

    protected void paintPanel(String string) {
        String string2 = this.lastCard;
        synchronized (string2) {
            if (!string.equals(this.lastCard)) {
                CardLayout cardLayout = (CardLayout)this.cardPanel.getLayout();
                cardLayout.show(this.cardPanel, string);
                UiLayoutUtilities.paintNow(this.cardPanel);
                this.lastCard = string;
            }
        }
    }

    private void addActionListeners() {
        this.previousButton.addActionListener(this);
        this.nextButton.addActionListener(this);
        this.cancelButton.addActionListener(this);
    }

    private synchronized void setPanel(int n, int n2) {
        if (n == this.panelIndex && n != 0) {
            log.write("tried to set panel to current panel " + this.getPanelID(this.panelIndex));
        } else {
            log.write("setting panel to " + this.getPanelID(n));
            if (n != 0 || n2 != 0) {
                this.leavePanel(this.getCurrentPanel());
            }
            this.mostRecentPanelIndex = n2;
            this.panelIndex = n;
            SwingRunner.invokeLater(new Runnable(){

                public void run() {
                    log.write("switching to panel " + Wizard.this.panelIndex);
                    Wizard.this.panel = Wizard.this.getPanel(Wizard.this.panelIndex);
                    log.write("new panel is " + Wizard.this.panel.getName());
                    Wizard.this.panel.prepareToEnter();
                    Wizard.this.paintPanel(Wizard.this.panel.getName());
                    Wizard.this.updateButtons();
                    log.write("finished showing (but not activating) panel " + Wizard.this.getPanelID(Wizard.this.panelIndex));
                    Wizard.this.enterPanel(Wizard.this.panel);
                }
            });
        }
    }

    private synchronized String getPanelID(int n) {
        WizardPanel wizardPanel = this.getPanel(n);
        return wizardPanel.getName() + " (panel " + n + ")";
    }

    private void setDefaultButton(JButton jButton) {
        this.getRootPane().setDefaultButton(jButton);
        if (jButton == null) {
            log.write("no default button");
        } else {
            jButton.requestFocusInWindow();
            log.write("default button " + jButton.getLabel());
        }
    }

    private void setIcon(JButton jButton, String string) {
        if (this.showIcons) {
            jButton.setIcon(this.buttonsIcons.getIcon(string));
        }
    }

    private void loadResources(WizardPanel wizardPanel) {
        this.buttonsIcons.getIcon(wizardPanel.getPreviousButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getNextButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getCancelButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getDefaultPreviousButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getDefaultNextButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getDefaultCancelButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getDefaultInstallButtonIconName());
        this.buttonsIcons.getIcon(wizardPanel.getDefaultFinishedButtonIconName());
    }

    private void checkButtonSizes(WizardPanel wizardPanel) {
        this.checkButtonLabel(this.previousButton, wizardPanel.getPreviousButtonLabel());
        this.checkButtonLabel(this.nextButton, wizardPanel.getNextButtonLabel());
        this.checkButtonLabel(this.cancelButton, wizardPanel.getCancelButtonLabel());
        this.checkButtonLabel(this.previousButton, this.getDefaultPreviousButtonLabel());
        this.checkButtonLabel(this.nextButton, this.getDefaultNextButtonLabel());
        this.checkButtonLabel(this.cancelButton, this.getDefaultCancelButtonLabel());
        this.checkButtonLabel(this.nextButton, this.getDefaultFinishedButtonLabel());
    }

    private void checkButtonLabel(JButton jButton, String string) {
        if (string != null && string.length() > jButton.getText().length()) {
            jButton.setText(string);
        }
    }

    public void restoreWizardDefaults() {
        this.previousButton.setText(this.getDefaultPreviousButtonLabel());
        this.nextButton.setText(this.getDefaultNextButtonLabel());
        this.cancelButton.setText(this.getDefaultCancelButtonLabel());
    }

    private void runFinish() {
        SwingUtilities.invokeLater(new Runnable(){

            public void run() {
                log.write("running finish, all other swing events should be done");
                log.write("All active stack traces:\n" + ThreadManager.allStackTracesToString());
                Wizard.this.finish();
            }
        });
    }

}
