/*
 * Decompiled with CFR 0_101.
 */
package com.denova.ui;

import com.denova.io.Log;
import com.denova.runtime.OS;
import com.denova.ui.ButtonsIcons;
import com.denova.ui.PopupDialog;
import com.denova.ui.UiLayoutUtilities;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JRootPane;

class YesNoDialog
extends PopupDialog {
    protected JButton yesButton;
    protected JButton noButton;
    private boolean defaultYes = true;
    private boolean answerYes = true;
    private boolean defaultClose = true;
    private String yesLabel = "Yes";
    private String noLabel = "No";

    public YesNoDialog(Frame frame) {
        super(frame);
    }

    public YesNoDialog(Dialog dialog) {
        super(dialog);
    }

    public YesNoDialog() {
    }

    public void setYesLabel(String string) {
        this.yesLabel = string;
        log.write("yes label: " + this.yesLabel);
    }

    public void setNoLabel(String string) {
        this.noLabel = string;
        log.write("no label: " + this.noLabel);
    }

    public void setYesToDefault() {
        this.defaultYes = true;
        log.write("default is yes");
    }

    public void setNoToDefault() {
        this.defaultYes = false;
        log.write("default is no");
    }

    public boolean yes() {
        log.write("answer yes: " + this.answerYes);
        return this.answerYes;
    }

    public boolean no() {
        log.write("answer no: " + !this.answerYes);
        return !this.answerYes;
    }

    public void setCloseOption(boolean bl) {
        this.defaultClose = bl;
        log.write("default close action: " + this.defaultClose);
    }

    public void createPanel() {
        JPanel jPanel = this.getPanel(this.getButtonsPanel());
        this.createListeners();
        this.getContentPane().add(jPanel);
        this.pack();
        UiLayoutUtilities.setColors(this.getContentPane(), this.foregroundColor, this.backgroundColor);
        if (this.defaultYes) {
            this.getRootPane().setDefaultButton(this.yesButton);
            UiLayoutUtilities.setFocus(this.yesButton);
        } else {
            this.getRootPane().setDefaultButton(this.noButton);
            UiLayoutUtilities.setFocus(this.noButton);
        }
        UiLayoutUtilities.centerComponent(this);
    }

    private JPanel getButtonsPanel() {
        ButtonsIcons buttonsIcons = new ButtonsIcons();
        buttonsIcons.setShowIcons(this.showIcons);
        JPanel jPanel = buttonsIcons.getOkCancelPanel(this.yesLabel, null, this.noLabel, null);
        this.yesButton = buttonsIcons.getOkButton();
        this.yesButton.setName("OkButton");
        this.noButton = buttonsIcons.getCancelButton();
        this.noButton.setName("CancelButton");
        return jPanel;
    }

    private JButton getFirstButton() {
        JButton jButton = this.yesButton;
        if (OS.isMacOsX()) {
            jButton = this.noButton;
        }
        return jButton;
    }

    private JButton getSecondButton() {
        JButton jButton = this.noButton;
        if (OS.isMacOsX()) {
            jButton = this.yesButton;
        }
        return jButton;
    }

    private void createListeners() {
        ButtonListener buttonListener = new ButtonListener();
        this.addActionListener(buttonListener);
        YesNoWindow yesNoWindow = new YesNoWindow();
        this.addWindowListener(yesNoWindow);
    }

    public void addActionListener(ActionListener actionListener) {
        this.yesButton.addActionListener(actionListener);
        this.noButton.addActionListener(actionListener);
    }

    private class ButtonListener
    implements ActionListener {
        private ButtonListener() {
        }

        public void actionPerformed(ActionEvent actionEvent) {
            Object object = actionEvent.getSource();
            if (object == YesNoDialog.this.yesButton) {
                PopupDialog.log.write("yes clicked");
                YesNoDialog.this.answerYes = true;
                YesNoDialog.this.exit();
            } else if (object == YesNoDialog.this.noButton) {
                PopupDialog.log.write("no clicked");
                YesNoDialog.this.answerYes = false;
                YesNoDialog.this.exit();
            }
        }
    }

    private class YesNoWindow
    extends WindowAdapter {
        private YesNoWindow() {
        }

        public void windowClosing(WindowEvent windowEvent) {
            Object object = windowEvent.getSource();
            if (object == YesNoDialog.this) {
                PopupDialog.log.write("close box pressed");
                YesNoDialog.this.answerYes = YesNoDialog.this.defaultClose;
                YesNoDialog.this.exit();
            }
        }
    }

}
