/*
 * Decompiled with CFR 0_101.
 */
package com.denova.util;

import com.denova.io.LineEndingInputFilter;
import com.denova.io.Log;
import com.denova.runtime.JRE;
import com.denova.ui.UserNotices;
import com.denova.util.DataFinder;
import com.denova.util.StringArray;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.PropertyResourceBundle;

public class LocaleTranslator {
    static final String Spanish = "es";
    static final String Polish = "pl";
    static final String Portuguese = "pt";
    static final String Dutch = "nl";
    public static final String EnglishResources = "english";
    public static final String SpanishResources = "spanish";
    public static final String GermanResources = "german";
    public static final String FrenchResources = "french";
    public static final String PolishResources = "polish";
    public static final String JapaneseResources = "japanese";
    public static final String PortugueseResources = "portuguese";
    public static final String ItalianResources = "italian";
    public static final String DutchResources = "dutch";
    public static final String ChineseResources = "chinese";
    public static final String SimplifiedChineseResources = "simplified-chinese";
    public static final String TraditionalChineseResources = "traditional-chinese";
    public static final String DefaultExtension = ".resources";
    public static final String LocaleLog = "locale";
    private static Log localeLog;
    private String resourceExtension = ".resources";
    private String defaultLanguage = "english";
    private LocaleTranslator localeTranslator;
    private PropertyResourceBundle localizedBundle;
    private PropertyResourceBundle defaultBundle;
    private boolean inited = false;
    private boolean autoDetectLanguage = true;
    private String activeLanguage = null;

    public LocaleTranslator(String string) {
        this.localeTranslator = this;
        this.resourceExtension = string;
        this.init();
        LocaleTranslator.log("LocaleTranslator instantiated with " + string);
        LocaleTranslator.log("resourceExtension is " + this.resourceExtension);
    }

    public void setAutoDetect(boolean bl) {
        this.autoDetectLanguage = bl;
        LocaleTranslator.log("auto detect language: " + this.autoDetectLanguage);
        this.setResourceBundle();
    }

    public void setLocale(String string, String string2) {
        Locale locale = new Locale(string, string2);
        Locale.setDefault(locale);
        LocaleTranslator.log("setLocale to " + string + " " + string2);
    }

    public String getLanguage() {
        LocaleTranslator.log("getLanguage " + Locale.getDefault().getLanguage());
        return Locale.getDefault().getLanguage();
    }

    public String getCountry() {
        LocaleTranslator.log("getCountry " + Locale.getDefault().getCountry());
        return Locale.getDefault().getCountry();
    }

    public void setDefaultLanguage(String string) {
        this.defaultLanguage = string.toLowerCase().replace((CharSequence)" ", (CharSequence)"-");
        LocaleTranslator.log("setDefaultLanguage to " + this.defaultLanguage);
        this.setResourceBundle();
    }

    public String getDefaultLanguage() {
        return this.defaultLanguage;
    }

    public String getActiveLanguage() {
        int n;
        String string = this.activeLanguage;
        if (string == null) {
            string = this.defaultLanguage;
            LocaleTranslator.log("using default language: " + string);
        }
        if ((n = string.indexOf(this.resourceExtension)) != -1) {
            string = string.substring(0, n);
        }
        LocaleTranslator.log("activeLanguage " + string);
        return string;
    }

    public void setLanguageExtension(String string) {
        LocaleTranslator.log("setLanguageExtension from " + this.resourceExtension + " to " + string);
        this.resourceExtension = string;
    }

    public String getLanguageExtension() {
        LocaleTranslator.log("getLanguageExtension " + this.resourceExtension);
        return this.resourceExtension;
    }

    public String getString(String string) {
        return this.getString(string, " ");
    }

    public String getString(String string, String string2) {
        String[] arrstring = new String[]{string2};
        return this.getString(string, arrstring);
    }

    public String getString(String string, String[] arrstring) {
        String string2 = this.getRawString(string);
        if (string2 != null && arrstring != null) {
            StringArray stringArray = new StringArray();
            stringArray.setStrings(arrstring);
            int n = 0;
            int n2 = stringArray.getCount();
            int n3 = string2.indexOf("%VARIABLE%");
            while (n3 != -1) {
                String string3 = stringArray.getItem(n);
                if (string3 == null) {
                    string3 = " ";
                }
                string2 = string2.substring(0, n3) + string3 + string2.substring(n3 + "%VARIABLE%".length());
                LocaleTranslator.log("   new value /" + string2 + "/");
                n3 = string2.indexOf("%VARIABLE%");
                if (n >= n2 - 1) continue;
                ++n;
            }
        }
        LocaleTranslator.log("value /" + string2 + "/");
        return string2;
    }

    private String getRawString(String string) {
        String string2 = null;
        boolean bl = true;
        LocaleTranslator.log("getString for " + string);
        if (!this.inited) {
            LocaleTranslator.log("! inited");
            this.init();
        }
        try {
            string2 = this.localizedBundle.getString(string);
        }
        catch (MissingResourceException var4_4) {
            bl = false;
            LocaleTranslator.log("value missing in locale file");
        }
        if (!bl) {
            try {
                if (this.defaultBundle != null) {
                    string2 = this.defaultBundle.getString(string);
                    bl = true;
                }
            }
            catch (MissingResourceException var4_5) {
                bl = false;
                LocaleTranslator.log("value missing in default file");
            }
            if (!(bl && string2 != null && string2.length() != 0)) {
                string2 = " ";
                LocaleTranslator.log("value set to blank");
            }
        }
        LocaleTranslator.log("raw value /" + string2 + "/");
        return string2;
    }

    private void setResourceBundle() {
        Object object;
        LocaleTranslator.log("setting resource bundle");
        InputStream inputStream = null;
        String string = this.getResourceExtenion();
        if (this.autoDetectLanguage) {
            InputStream inputStream2;
            object = Locale.getDefault().getLanguage();
            LocaleTranslator.log("user's native language " + (String)object);
            if (object.equals(Locale.ENGLISH.getLanguage())) {
                inputStream = this.findResources("english" + string);
            }
            if (inputStream == null && object.equals("es")) {
                inputStream = this.findResources("spanish" + string);
            }
            if (inputStream == null && object.equals(Locale.GERMAN.getLanguage())) {
                inputStream = this.findResources("german" + string);
            }
            if (inputStream == null && object.equals(Locale.FRENCH.getLanguage())) {
                inputStream = this.findResources("french" + string);
            }
            if (inputStream == null && object.equals("pl")) {
                inputStream = this.findResources("polish" + string);
            }
            if (inputStream == null && object.equals(Locale.ITALIAN.getLanguage())) {
                inputStream = this.findResources("italian" + string);
            }
            if (inputStream == null && object.equals("pt")) {
                inputStream = this.findResources("portuguese" + string);
            }
            if (inputStream == null && object.equals("nl")) {
                inputStream = this.findResources("dutch" + string);
            }
            if (inputStream == null && object.equals(Locale.JAPANESE.getLanguage()) && (inputStream2 = this.findResources("japanese" + string)) != null && this.fontFileExists(Locale.JAPANESE.getLanguage())) {
                inputStream = inputStream2;
            }
            if (inputStream == null && object.equals(Locale.SIMPLIFIED_CHINESE.getLanguage())) {
                inputStream = this.findResources("simplified-chinese" + string);
            }
            if (inputStream == null && object.equals(Locale.CHINESE.getLanguage())) {
                inputStream = this.findResources("chinese" + string);
            }
            if (inputStream == null && object.equals(Locale.TRADITIONAL_CHINESE.getLanguage())) {
                inputStream = this.findResources("traditional-chinese" + string);
            }
        } else {
            LocaleTranslator.log("using default language: " + this.defaultLanguage);
        }
        if (inputStream == null) {
            LocaleTranslator.log("looking for " + this.defaultLanguage + " resources");
            inputStream = this.findResources(this.defaultLanguage + string);
        }
        if (inputStream == null) {
            LocaleTranslator.log("looking for english resources");
            inputStream = this.findResources("english" + string);
            this.setLocale("en", "US");
        }
        if (inputStream != null) {
            this.loadResources(inputStream);
        } else {
            LocaleTranslator.log("Unable to find any resources with extension: " + string);
            object = new UserNotices();
            object.noteError("Unable to find any resources with " + string + " resources");
            System.exit(-1);
        }
    }

    private boolean fontFileExists(String string) {
        File file = new File(JRE.getActiveJavaHome() + "lib", "font.properties." + string);
        boolean bl = file.exists();
        LocaleTranslator.log(file.getName() + " exists: " + bl);
        return bl;
    }

    private InputStream findResources(String string) {
        InputStream inputStream = null;
        LocaleTranslator.log("looking for resource filename " + string);
        InputStream inputStream2 = this.getResourceAsStream(string);
        if (inputStream2 != null) {
            this.activeLanguage = string;
            inputStream = inputStream2;
            LocaleTranslator.log("found resources " + this.activeLanguage);
        }
        return inputStream;
    }

    private void loadResources(InputStream inputStream) {
        LineEndingInputFilter lineEndingInputFilter = null;
        InputStream inputStream2 = null;
        try {
            try {
                lineEndingInputFilter = new LineEndingInputFilter(inputStream);
                lineEndingInputFilter.setIsText(true);
                this.localizedBundle = new PropertyResourceBundle(lineEndingInputFilter);
                LocaleTranslator.log("returned from PropertyResourceBunde instantiation");
            }
            catch (Exception var5_4) {
                LocaleTranslator.log("Exception getting local resources");
                UserNotices userNotices = new UserNotices();
                userNotices.noteError("Exception getting local resources: " + var5_4);
                System.exit(-1);
            }
            if (lineEndingInputFilter != null) {
                lineEndingInputFilter.close();
                lineEndingInputFilter = null;
            }
            try {
                String string = "english" + this.resourceExtension;
                if (!(this.activeLanguage != null && this.activeLanguage.equals(string) || (inputStream2 = this.getResourceAsStream(string)) == null)) {
                    lineEndingInputFilter = new LineEndingInputFilter(inputStream2);
                    lineEndingInputFilter.setIsText(true);
                    this.defaultBundle = new PropertyResourceBundle(lineEndingInputFilter);
                    LocaleTranslator.log("found default resources " + string);
                }
            }
            catch (Exception var5_5) {
                String string = "english" + this.resourceExtension;
                LocaleTranslator.log("Exception getting default resources " + string);
            }
            if (lineEndingInputFilter != null) {
                lineEndingInputFilter.close();
                lineEndingInputFilter = null;
            }
            if (inputStream2 != null) {
                inputStream2.close();
                inputStream2 = null;
            }
            inputStream.close();
        }
        catch (IOException var5_6) {
            LocaleTranslator.log(var5_6);
        }
    }

    private String getResourceExtenion() {
        if (this.resourceExtension == null) {
            this.resourceExtension = ".resources";
            LocaleTranslator.log("using default resources");
        }
        if (!this.resourceExtension.startsWith(".")) {
            String string = this.resourceExtension;
            this.resourceExtension = "." + string;
            LocaleTranslator.log("added . to resourceExtension " + this.resourceExtension);
        }
        String string = this.resourceExtension;
        return string;
    }

    private InputStream getResourceAsStream(String string) {
        InputStream inputStream;
        block15 : {
            inputStream = null;
            try {
                inputStream = DataFinder.getStream(string);
            }
            catch (RuntimeException var3_3) {
                LocaleTranslator.log(var3_3);
            }
            Class class_ = null;
            if (this.localeTranslator != null) {
                class_ = this.localeTranslator.getClass();
            }
            if (class_ != null && inputStream == null) {
                try {
                    inputStream = class_.getResourceAsStream(string);
                }
                catch (Exception var4_5) {
                    LocaleTranslator.log(var4_5);
                }
            }
            if (class_ != null && inputStream == null) {
                try {
                    URL uRL = class_.getResource(string);
                    if (uRL != null) {
                        inputStream = uRL.openStream();
                        break block15;
                    }
                    LocaleTranslator.log("unable to get url for " + string);
                }
                catch (Exception var4_7) {
                    LocaleTranslator.log(var4_7);
                }
            } else if (class_ == null) {
                LocaleTranslator.log("unable to getClass");
            } else if (inputStream != null) {
                LocaleTranslator.log("got stream, but still unable to get resource");
            } else {
                LocaleTranslator.log("unknown error while getting resource as stream");
            }
        }
        return inputStream;
    }

    private static void log(String string) {
        LocaleTranslator.startLog();
        localeLog.write(string);
    }

    private static void log(Exception exception) {
        LocaleTranslator.startLog();
        localeLog.write(exception);
    }

    private static void startLog() {
        if (localeLog == null) {
            localeLog = new Log("locale");
        }
    }

    private void init() {
        this.setResourceBundle();
        this.inited = true;
        LocaleTranslator.log("inited LocaleTranslator");
    }
}
