/*
 * Decompiled with CFR 0_101.
 */
package com.denova.util;

import com.denova.io.LineEndingInputFilter;
import com.denova.io.Log;
import com.denova.lang.FieldAccess;
import com.denova.ui.UiLayoutUtilities;
import com.denova.util.StringArrayString;
import java.awt.Checkbox;
import java.awt.Component;
import java.awt.Container;
import java.awt.List;
import java.awt.TextArea;
import java.awt.TextField;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Properties;
import java.util.Vector;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

public class PropertyList
extends Properties
implements Runnable {
    private static final String Blank = "";
    private static final boolean debugging = false;
    private static Log propLog;
    private Exception lastError;
    private FieldAccess setContainerFieldAccess;
    private boolean setContainerOk;
    private String title = "Property List";

    public PropertyList(Properties properties) {
        super(properties);
    }

    public PropertyList() {
    }

    private static void log(String string) {
        PropertyList.startLog();
        propLog.write(string);
    }

    private static void log(Exception exception) {
        PropertyList.startLog();
        propLog.write(exception);
    }

    private static void startLog() {
        if (propLog == null) {
            propLog = new Log("properties");
        }
    }

    public static void main(String[] arrstring) {
        PropertyList propertyList = new PropertyList();
        propertyList.setProperty("test", "test value");
        System.out.println(propertyList.getProperty("test"));
    }

    public synchronized boolean load(String string) {
        return this.load(new File(string));
    }

    public synchronized boolean load(File file) {
        boolean bl;
        FileInputStream fileInputStream = null;
        try {
            fileInputStream = new FileInputStream(file);
            LineEndingInputFilter lineEndingInputFilter = new LineEndingInputFilter(file.getName(), fileInputStream);
            this.load(lineEndingInputFilter);
            bl = true;
            PropertyList.log("loaded properties from " + file.getPath());
        }
        catch (Exception var4_4) {
            PropertyList.log(var4_4);
            this.lastError = var4_4;
            bl = false;
            PropertyList.log("unable to load properties from " + file.getPath());
        }
        if (fileInputStream != null) {
            try {
                fileInputStream.close();
            }
            catch (IOException var4_5) {
                // empty catch block
            }
        }
        return bl;
    }

    public synchronized void load(InputStream inputStream) throws IOException {
        try {
            PropertyList.log("removing old properties");
            Enumeration enumeration = this.propertyNames();
            while (enumeration.hasMoreElements()) {
                String string = (String)enumeration.nextElement();
                this.remove(string);
            }
            PropertyList.log("loading new properties");
            super.load(inputStream);
            PropertyList.log("properties loaded");
        }
        catch (Exception var2_3) {
            this.lastError = var2_3;
            PropertyList.log(var2_3);
        }
    }

    public synchronized boolean save(String string) {
        return this.save(new File(string));
    }

    public synchronized boolean save(File file) {
        boolean bl;
        try {
            PropertyList.log("Saving properties to " + file.getPath());
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            this.save(fileOutputStream, this.title);
            fileOutputStream.close();
            bl = true;
        }
        catch (Exception var3_3) {
            PropertyList.log(var3_3);
            this.lastError = var3_3;
            bl = false;
        }
        return bl;
    }

    public synchronized void save(OutputStream outputStream, String string) {
        try {
            PropertyList.log("saving properties");
            String string2 = System.getProperty("java.version");
            if (string2 != null && string2.startsWith("1.1")) {
                super.save(outputStream, string);
            } else {
                super.store(outputStream, string);
            }
            PropertyList.log("saved properties");
        }
        catch (Exception var3_4) {
            PropertyList.log(var3_4);
            this.lastError = var3_4;
        }
    }

    public synchronized void setTitle(String string) {
        this.title = string;
    }

    public synchronized Object setProperty(String string, String string2) {
        PropertyList.log(" set: " + string + " = " + string2);
        return this.put(string, string2);
    }

    public Object setProperty(String string, Properties properties) {
        PropertyList.log(" set: " + string + " to a new properties");
        PropertyList propertyList = new PropertyList(properties);
        return this.put(string, propertyList.toString());
    }

    public Object setProperty(String string, Component component) {
        PropertyList.log("setProperty for ");
        Object object = null;
        String string2 = this.getValueAsString(component);
        PropertyList.log(" named: " + string);
        PropertyList.log(" value: " + string2);
        if (string2 != null) {
            object = this.setProperty(string, string2);
        }
        return object;
    }

    public Object setProperty(String string, int n) {
        return this.setProperty(string, new Integer(n).toString());
    }

    public Object setProperty(String string, long l) {
        return this.setProperty(string, new Long(l).toString());
    }

    public void setBooleanProperty(String string, boolean bl) {
        this.setProperty(string, this.getBooleanString(bl));
    }

    public void setIntProperty(String string, int n) {
        this.setProperty(string, new Integer(n).toString());
    }

    public void setLongProperty(String string, long l) {
        this.setProperty(string, new Long(l).toString());
    }

    public int getIntProperty(String string) {
        int n;
        try {
            n = new Integer(this.getProperty(string, "0"));
        }
        catch (Exception var3_3) {
            n = -1;
        }
        return n;
    }

    public int getIntProperty(String string, int n) {
        int n2;
        try {
            n2 = new Integer(this.getProperty(string, String.valueOf(n)));
        }
        catch (Exception var4_4) {
            n2 = n;
        }
        return n2;
    }

    public long getLongProperty(String string) {
        long l;
        try {
            l = new Long(this.getProperty(string, "0"));
        }
        catch (Exception var4_3) {
            l = -1;
        }
        return l;
    }

    public boolean getBooleanProperty(String string) {
        return this.getBooleanProperty(string, false);
    }

    public boolean getBooleanProperty(String string, boolean bl) {
        String string2 = this.getBooleanString(bl);
        return this.getBoolean(this.getProperty(string, string2));
    }

    public PropertyList getPropertyListProperty(String string) {
        return this.getPropertyListProperty(string, new PropertyList());
    }

    public PropertyList getPropertyListProperty(String string, PropertyList propertyList) {
        PropertyList propertyList2;
        String string2 = this.getProperty(string);
        if (string2 == null) {
            propertyList2 = propertyList;
        } else {
            propertyList2 = new PropertyList();
            propertyList2.fromString(string2);
        }
        return propertyList2;
    }

    public void setPropertyListProperty(String string, PropertyList propertyList) {
        this.setProperty(string, propertyList.toString());
    }

    public Object removeProperty(String string) {
        return this.remove(string);
    }

    public synchronized void clear() {
        Enumeration enumeration = this.propertyNames();
        while (enumeration.hasMoreElements()) {
            String string = (String)enumeration.nextElement();
            this.removeProperty(string);
        }
    }

    public void setPropertyList(PropertyList propertyList) {
        this.setProperties(propertyList);
    }

    public void setProperties(Properties properties) {
        this.clear();
        this.addProperties(properties);
    }

    public boolean setProperties(Container container, FieldAccess fieldAccess) {
        boolean bl;
        this.clear();
        try {
            Class class_ = container.getClass();
            PropertyList.log("class name is " + class_.getName());
            Field[] arrfield = fieldAccess.getDeclaredFields();
            int n = arrfield.length;
            PropertyList.log("# of fields is " + n);
            for (int i = 0; i < n; ++i) {
                Field field = arrfield[i];
                Object object = fieldAccess.getFieldObject(field);
                if (!(object instanceof Component)) continue;
                PropertyList.log("  field " + field.getName());
                this.setProperty(field.getName(), (Component)object);
                Thread.yield();
            }
            bl = true;
        }
        catch (Exception var4_4) {
            PropertyList.log(var4_4);
            this.lastError = var4_4;
            bl = false;
        }
        return bl;
    }

    public boolean setContainer(FieldAccess fieldAccess) {
        this.setContainerFieldAccess = fieldAccess;
        if (SwingUtilities.isEventDispatchThread()) {
            this.run();
        } else {
            try {
                SwingUtilities.invokeAndWait(this);
            }
            catch (Exception var2_2) {
                PropertyList.log(var2_2);
            }
        }
        return this.setContainerOk;
    }

    public void addPropertyList(PropertyList propertyList) {
        this.addProperties(propertyList);
    }

    public void addProperties(Properties properties) {
        Enumeration enumeration = properties.propertyNames();
        while (enumeration.hasMoreElements()) {
            String string = (String)enumeration.nextElement();
            String string2 = properties.getProperty(string);
            this.setProperty(string, string2);
            Thread.yield();
        }
    }

    public Properties getPropertyList() {
        return this;
    }

    public Properties getProperties() {
        return this;
    }

    public void run() {
        boolean bl;
        try {
            Enumeration enumeration = this.getProperties().propertyNames();
            while (enumeration.hasMoreElements()) {
                String string = (String)enumeration.nextElement();
                PropertyList.log("getting value for " + string);
                try {
                    StringArrayString stringArrayString;
                    Field field = this.setContainerFieldAccess.getDeclaredField(string);
                    Object object = this.setContainerFieldAccess.getFieldObject(field);
                    if (object instanceof TextField) {
                        ((TextField)object).setText(this.getProperty(string, ""));
                    } else if (object instanceof JTextField) {
                        UiLayoutUtilities.update((Component)((JTextField)object), (Object)this.getProperty(string, ""));
                    } else if (object instanceof TextArea) {
                        ((TextArea)object).setText(this.getProperty(string, ""));
                    } else if (object instanceof JTextArea) {
                        UiLayoutUtilities.update((Component)((JTextArea)object), (Object)this.getProperty(string, ""));
                    } else if (object instanceof Checkbox) {
                        ((Checkbox)object).setState(this.getBooleanProperty(string));
                    } else if (object instanceof JCheckBox) {
                        UiLayoutUtilities.update((Component)((JCheckBox)object), this.getBooleanProperty(string));
                    } else if (object instanceof List) {
                        stringArrayString = new StringArrayString();
                        stringArrayString.fromString(this.getProperty(string, ""));
                        stringArrayString.showList((List)object);
                    } else if (object instanceof JList) {
                        stringArrayString = new StringArrayString();
                        stringArrayString.fromString(this.getProperty(string, ""));
                        stringArrayString.showList((JList)object);
                    } else if (object instanceof JRadioButton) {
                        UiLayoutUtilities.update((Component)((JRadioButton)object), this.getBooleanProperty(string));
                    } else if (object instanceof JComboBox) {
                        ((JComboBox)object).setSelectedItem(this.getProperty(string, ""));
                    }
                }
                catch (NoSuchFieldException var4_5) {
                    PropertyList.log("No such field found for " + string);
                    PropertyList.log(var4_5);
                }
                Thread.yield();
            }
            bl = true;
        }
        catch (Exception var2_2) {
            PropertyList.log(var2_2);
            this.lastError = var2_2;
            bl = false;
        }
        this.setContainerOk = bl;
    }

    public synchronized String toString() {
        StringArrayString stringArrayString = new StringArrayString();
        Enumeration enumeration = this.propertyNames();
        while (enumeration.hasMoreElements()) {
            String string = (String)enumeration.nextElement();
            String string2 = this.getProperty(string);
            String string3 = string + "=" + string2;
            stringArrayString.addItem(string3);
        }
        return stringArrayString.toString();
    }

    public boolean fromString(String string) {
        boolean bl = true;
        StringArrayString stringArrayString = new StringArrayString();
        this.clear();
        stringArrayString.fromString(string);
        for (int i = 0; i < stringArrayString.getCount() && bl; ++i) {
            String string2 = stringArrayString.getItem(i);
            int n = string2.indexOf("=");
            if (n > 0) {
                String string3 = string2.substring(0, n);
                String string4 = string2.substring(n + 1, string2.length());
                this.setProperty(string3, string4);
                Thread.yield();
                continue;
            }
            bl = false;
        }
        return bl;
    }

    public Exception getLastError() {
        return this.lastError;
    }

    public void clearLastError() {
        Object var1_1;
        this.lastError = var1_1 = null;
    }

    private String getValueAsString(Component component) {
        Object object;
        String string = null;
        if (component instanceof TextField) {
            string = ((TextField)component).getText();
        } else if (component instanceof JTextField) {
            string = ((JTextField)component).getText();
            PropertyList.log(" a JTextField");
        } else if (component instanceof TextArea) {
            string = ((TextArea)component).getText();
        } else if (component instanceof JTextArea) {
            string = ((JTextArea)component).getText();
            PropertyList.log(" a JTextArea");
        } else if (component instanceof Checkbox) {
            boolean bl = ((Checkbox)component).getState();
            string = this.getBooleanString(bl);
        } else if (component instanceof JCheckBox) {
            boolean bl = ((JCheckBox)component).isSelected();
            string = this.getBooleanString(bl);
        } else if (component instanceof List) {
            StringArrayString stringArrayString = new StringArrayString();
            stringArrayString.setItems((List)component);
            string = stringArrayString.toString();
        } else if (component instanceof JList) {
            StringArrayString stringArrayString = new StringArrayString();
            stringArrayString.setItems((JList)component);
            string = stringArrayString.toString();
        } else if (component instanceof JRadioButton) {
            boolean bl = ((JRadioButton)component).isSelected();
            string = this.getBooleanString(bl);
        } else if (component instanceof JComboBox && (object = ((JComboBox)component).getSelectedItem()) != null && object instanceof String) {
            string = (String)object;
        }
        return string;
    }

    private boolean getBoolean(String string) {
        boolean bl;
        block2 : {
            bl = false;
            try {
                Boolean bl2 = Boolean.valueOf(string);
                bl = bl2;
            }
            catch (Exception var3_4) {
                if (!string.equalsIgnoreCase("true")) break block2;
                bl = true;
            }
        }
        return bl;
    }

    private String getBooleanString(boolean bl) {
        String string;
        block2 : {
            string = "false";
            try {
                string = Boolean.valueOf(bl).toString();
            }
            catch (Exception var3_3) {
                if (!bl) break block2;
                string = "true";
            }
        }
        return string;
    }

    public Vector propertyNamesList() {
        Vector<String> vector = new Vector<String>();
        Enumeration enumeration = this.propertyNames();
        while (enumeration.hasMoreElements()) {
            vector.add(enumeration.nextElement().toString());
        }
        return (Vector)vector.clone();
    }
}
