/*
 * Decompiled with CFR 0_101.
 */
package com.denova.util;

import com.denova.io.Log;
import com.denova.runtime.OS;
import com.denova.runtime.WindowsCommands;
import com.denova.runtime.WindowsDirs;
import com.denova.runtime.WindowsRegistry;
import com.denova.util.PropertyList;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Vector;

public class PropertyStore
extends PropertyList {
    private static final String DeNovaDataStoreSubdir = "denova";
    private static final String UnixStoreDir = "/var/local/";
    private static final String MacStoreDir = "/Library/Application Support/";
    private static final String PrimaryWindowsKey = "HKEY_LOCAL_MACHINE\\SOFTWARE";
    private static final Log log = new Log("propstore.log");
    private static final long serialVersionUID = -1;
    private static String dataStoreSubdir = "denova";

    public PropertyStore(Properties properties) {
        super(properties);
    }

    public PropertyStore() {
    }

    public static void main(String[] arrstring) {
        Log.setLogDir(System.getProperty("user.dir"));
        PropertyStore propertyStore = new PropertyStore();
        propertyStore.setProperty("test", "testvalue");
        propertyStore.store("test store");
        PropertyStore propertyStore2 = new PropertyStore();
        propertyStore2.load("test store");
        String string = propertyStore2.getProperty("test");
        if ("testvalue".equals(string)) {
            System.out.println("passed");
        } else {
            System.out.println("stored testvalue, loaded " + string);
        }
    }

    public synchronized boolean load(String string) {
        boolean bl = OS.isWindows() ? this.loadWindows(string) : (OS.isMac() ? this.loadMac(string) : (OS.isUnix() ? this.loadUnix(string) : false));
        return bl;
    }

    public synchronized boolean store(String string) {
        boolean bl = OS.isWindows() ? this.storeWindows(string) : (OS.isMac() ? this.storeMac(string) : (OS.isUnix() ? this.storeUnix(string) : false));
        return bl;
    }

    public synchronized boolean remove(String string) {
        boolean bl = OS.isWindows() ? this.removeWindows(string) : (OS.isMac() ? this.removeMac(string) : (OS.isUnix() ? this.removeUnix(string) : false));
        return bl;
    }

    public synchronized void setDataStoreSubdir(String string) {
        dataStoreSubdir = string;
        dataStoreSubdir = OS.isWindows() || OS.isMac() ? string : string.toLowerCase();
    }

    private synchronized boolean loadWindows(String string) {
        boolean bl = true;
        String string2 = this.getWindowsStoreKey(string);
        bl = WindowsRegistry.exists(string2);
        if (bl) {
            List list = WindowsRegistry.enumerate(this.getWindowsStoreParentKey(), string);
            if (list == null || list.isEmpty()) {
                log.write("no attributes in " + string2);
            } else {
                for (String string3 : list) {
                    String string4 = WindowsRegistry.getStringData(string2, string3);
                    this.setProperty(string3, string4);
                    log.write(string3 + "=" + string4);
                }
                log.write("saved properties from " + string2);
            }
        }
        return bl;
    }

    private synchronized boolean loadMac(String string) {
        return this.loadFromFile(this.getMacStoreDir(), string);
    }

    private synchronized boolean loadUnix(String string) {
        return this.loadFromFile("/var/local/", string);
    }

    private synchronized boolean loadFromFile(String string, String string2) {
        File file = new File(new File(string, dataStoreSubdir), string2);
        boolean bl = super.load(file);
        return bl;
    }

    private synchronized boolean storeWindows(String string) {
        boolean bl = true;
        Iterator iterator = this.propertyNamesList().iterator();
        if (iterator != null) {
            this.addWindowsStoreKey(string);
            String string2 = this.getWindowsStoreKey(string);
            while (iterator.hasNext()) {
                String string3 = (String)iterator.next();
                String string4 = this.getProperty(string3, "");
                WindowsRegistry.replaceData(string2, string3, string4);
                log.write("set " + string3 + "= " + string4);
            }
            log.write("saved properties in " + string2);
        }
        return bl;
    }

    private synchronized boolean storeMac(String string) {
        return this.storeToFile(this.getMacStoreDir(), string);
    }

    private synchronized boolean storeUnix(String string) {
        return this.storeToFile("/var/local/", string);
    }

    private synchronized boolean storeToFile(String string, String string2) {
        return this.storeToFile(new File(string, dataStoreSubdir), string2);
    }

    private synchronized boolean storeToFile(File file, String string) {
        boolean bl;
        try {
            if (!file.exists()) {
                file.mkdirs();
            }
            File file2 = new File(file, string);
            FileOutputStream fileOutputStream = new FileOutputStream(file2);
            super.store(fileOutputStream, string);
            fileOutputStream.close();
            this.hideFile(file2.getPath());
            bl = true;
        }
        catch (Exception var4_4) {
            bl = false;
        }
        return bl;
    }

    private synchronized boolean removeWindows(String string) {
        int n;
        List list = WindowsRegistry.enumerate(this.getWindowsStoreParentKey(), string);
        if (list != null) {
            for (n = 0; n < list.size(); n+=1) {
                String string2 = (String)list.get(n);
                WindowsRegistry.deleteAttribute(this.getWindowsStoreKey(string), string2);
                log.write("deleted " + string2);
            }
        }
        n = WindowsRegistry.deleteKey(this.getWindowsStoreParentKey(), string);
        log.write("deleted " + this.getWindowsStoreKey(string));
        log.write("remove ok " + (boolean)n);
        list = WindowsRegistry.enumerate("HKEY_LOCAL_MACHINE\\SOFTWARE", dataStoreSubdir);
        if (list == null || list.isEmpty()) {
            WindowsRegistry.deleteKey("HKEY_LOCAL_MACHINE\\SOFTWARE", dataStoreSubdir);
            log.write("deleted " + this.getWindowsStoreParentKey());
        }
        return n;
    }

    private synchronized boolean removeMac(String string) {
        return this.removeStoreFile(this.getMacStoreDir(), string);
    }

    private synchronized boolean removeUnix(String string) {
        return this.removeStoreFile("/var/local/", string);
    }

    private synchronized boolean removeStoreFile(String string, String string2) {
        File file = new File(string, dataStoreSubdir);
        File file2 = new File(file, string2);
        boolean bl = file2.delete();
        String[] arrstring = file.list();
        if (arrstring == null || arrstring.length <= 0) {
            file.delete();
        }
        return bl;
    }

    private synchronized String getMacStoreDir() {
        String string = System.getProperty("user.home", "");
        String string2 = string + "/Library/Application Support/";
        String string3 = null;
        File file = new File("/Library/Application Support/");
        if (file.exists() && this.isDirWritable(file)) {
            string3 = "/Library/Application Support/";
        } else {
            file = new File(string2);
            if (file.exists() && this.isDirWritable(file)) {
                string3 = string2;
            }
        }
        if (string3 == null) {
            try {
                file = new File("/Library/Application Support/");
                file.mkdirs();
                string3 = "/Library/Application Support/";
            }
            catch (Exception var6_5) {
                try {
                    file = new File(string2);
                    file.mkdirs();
                    string3 = string2;
                }
                catch (Exception var7_6) {
                    string3 = string;
                    file = new File(string3, dataStoreSubdir);
                    file.mkdirs();
                }
            }
        }
        log.write("mac storage dir: " + string3);
        return string3;
    }

    private synchronized String getWinStoreDir() {
        String string = System.getProperty("user.home", "");
        String string2 = null;
        File file = null;
        String string3 = WindowsDirs.getDocumentsDirectory("allUsers");
        if (string3 != null && (file = new File(string3, dataStoreSubdir)).exists() && this.isDirWritable(file)) {
            string2 = string3;
            this.hideFile(string2);
        }
        if (string2 == null) {
            try {
                file = new File(string3, dataStoreSubdir);
                file.mkdirs();
                string2 = string3;
                this.hideFile(string2);
            }
            catch (Exception var5_5) {
                try {
                    string3 = WindowsDirs.getDocumentsDirectory("currentUser");
                    file = new File(string3, dataStoreSubdir);
                    file.mkdirs();
                    string2 = string3;
                    this.hideFile(string2);
                }
                catch (Exception var6_6) {
                    string2 = string;
                    file = new File(string2, dataStoreSubdir);
                    file.mkdirs();
                }
            }
        }
        log.write("win storage dir: " + string2);
        return string2;
    }

    private void hideFile(String string) {
        try {
            if (OS.isWindows()) {
                WindowsCommands.hideFile(string);
            }
        }
        catch (Exception var2_2) {
            log.write(var2_2);
        }
    }

    private synchronized String getWindowsStoreParentKey() {
        return "HKEY_LOCAL_MACHINE\\SOFTWARE\\" + dataStoreSubdir;
    }

    private synchronized String getWindowsStoreKey(String string) {
        return this.getWindowsStoreParentKey() + "\\" + string;
    }

    private synchronized boolean addWindowsStoreKey(String string) {
        if (!WindowsRegistry.exists(this.getWindowsStoreKey(string))) {
            if (!WindowsRegistry.exists(this.getWindowsStoreParentKey())) {
                WindowsRegistry.addKey("HKEY_LOCAL_MACHINE\\SOFTWARE", dataStoreSubdir);
            }
            WindowsRegistry.addKey(this.getWindowsStoreParentKey(), string);
        }
        return WindowsRegistry.exists(this.getWindowsStoreKey(string));
    }

    private synchronized boolean isDirWritable(File file) {
        String string = "__delete_me_test__.properties";
        boolean bl = this.storeToFile(file, string);
        if (bl) {
            File file2 = new File(file, string);
            file2.delete();
        }
        return bl;
    }
}
