/*
 * Decompiled with CFR 0_101.
 */
package org.apache.http.impl.auth;

import java.io.UnsupportedEncodingException;
import org.apache.http.impl.auth.NTLMEngineException;
import org.apache.http.impl.auth.NTLMEngineImpl;

static class NTLMEngineImpl.Type3Message
extends NTLMEngineImpl.NTLMMessage {
    protected int type2Flags;
    protected byte[] domainBytes;
    protected byte[] hostBytes;
    protected byte[] userBytes;
    protected byte[] lmResp;
    protected byte[] ntResp;

    NTLMEngineImpl.Type3Message(String domain, String host, String user, String password, byte[] nonce, int type2Flags, String target, byte[] targetInformation) throws NTLMEngineException {
        this.type2Flags = type2Flags;
        host = NTLMEngineImpl.convertHost(host);
        domain = NTLMEngineImpl.convertDomain(domain);
        try {
            byte[] clientChallenge;
            if (targetInformation != null && target != null) {
                clientChallenge = NTLMEngineImpl.makeRandomChallenge();
                this.ntResp = NTLMEngineImpl.getNTLMv2Response(target, user, password, nonce, clientChallenge, targetInformation);
                this.lmResp = NTLMEngineImpl.getLMv2Response(target, user, password, nonce, clientChallenge);
            } else if ((type2Flags & 524288) != 0) {
                clientChallenge = NTLMEngineImpl.makeNTLM2RandomChallenge();
                this.ntResp = NTLMEngineImpl.getNTLM2SessionResponse(password, nonce, clientChallenge);
                this.lmResp = clientChallenge;
            } else {
                this.ntResp = NTLMEngineImpl.getNTLMResponse(password, nonce);
                this.lmResp = NTLMEngineImpl.getLMResponse(password, nonce);
            }
        }
        catch (NTLMEngineException e) {
            this.ntResp = new byte[0];
            this.lmResp = NTLMEngineImpl.getLMResponse(password, nonce);
        }
        try {
            this.domainBytes = domain.toUpperCase().getBytes("UnicodeLittleUnmarked");
            this.hostBytes = host.getBytes("UnicodeLittleUnmarked");
            this.userBytes = user.getBytes("UnicodeLittleUnmarked");
        }
        catch (UnsupportedEncodingException e) {
            throw new NTLMEngineException("Unicode not supported: " + e.getMessage(), e);
        }
    }

    String getResponse() {
        int ntRespLen = this.ntResp.length;
        int lmRespLen = this.lmResp.length;
        int domainLen = this.domainBytes.length;
        int hostLen = this.hostBytes.length;
        int userLen = this.userBytes.length;
        int lmRespOffset = 64;
        int ntRespOffset = lmRespOffset + lmRespLen;
        int domainOffset = ntRespOffset + ntRespLen;
        int userOffset = domainOffset + domainLen;
        int hostOffset = userOffset + userLen;
        int sessionKeyOffset = hostOffset + hostLen;
        int finalLength = sessionKeyOffset + 0;
        this.prepareResponse(finalLength, 3);
        this.addUShort(lmRespLen);
        this.addUShort(lmRespLen);
        this.addULong(lmRespOffset);
        this.addUShort(ntRespLen);
        this.addUShort(ntRespLen);
        this.addULong(ntRespOffset);
        this.addUShort(domainLen);
        this.addUShort(domainLen);
        this.addULong(domainOffset);
        this.addUShort(userLen);
        this.addUShort(userLen);
        this.addULong(userOffset);
        this.addUShort(hostLen);
        this.addUShort(hostLen);
        this.addULong(hostOffset);
        this.addULong(0);
        this.addULong(finalLength);
        this.addULong(536871429 | this.type2Flags & 524288 | this.type2Flags & 16 | this.type2Flags & 32 | this.type2Flags & 1073741824 | this.type2Flags & 32768);
        this.addBytes(this.lmResp);
        this.addBytes(this.ntResp);
        this.addBytes(this.domainBytes);
        this.addBytes(this.userBytes);
        this.addBytes(this.hostBytes);
        return super.getResponse();
    }
}
