/*
 * Decompiled with CFR 0_101.
 */
package org.jdesktop.swingx.plaf.nimbus;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.DataBuffer;
import java.awt.image.DataBufferByte;
import java.awt.image.DataBufferInt;
import java.awt.image.Kernel;
import java.awt.image.WritableRaster;
import java.io.PrintStream;
import java.net.URL;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import javax.imageio.ImageIO;
import javax.swing.plaf.synth.SynthContext;
import javax.swing.plaf.synth.SynthGraphicsUtils;

public class NimbusGraphicsUtils
extends SynthGraphicsUtils {
    private RenderingHints desktopHints = new RenderingHints(null);
    static /* synthetic */ Class class$0;

    public static RenderingHints getRenderingHints(Graphics2D graphics2D, RenderingHints renderingHints, RenderingHints renderingHints2) {
        if (renderingHints2 == null) {
            renderingHints2 = new RenderingHints(null);
        } else {
            renderingHints2.clear();
        }
        if (renderingHints.size() == 0) {
            return renderingHints2;
        }
        Iterator<Object> iterator = renderingHints.keySet().iterator();
        while (iterator.hasNext()) {
            RenderingHints.Key key = (RenderingHints.Key)iterator.next();
            Object object = graphics2D.getRenderingHint(key);
            renderingHints2.put(key, object);
        }
        return renderingHints2;
    }

    public void paintText(SynthContext synthContext, Graphics graphics, String string, int n, int n2, int n3) {
        Object object;
        Graphics2D graphics2D = (Graphics2D)graphics;
        if (this.desktopHints == null) {
            object = Toolkit.getDefaultToolkit();
            this.desktopHints = (RenderingHints)object.getDesktopProperty("awt.font.desktophints");
        }
        object = null;
        RenderingHints renderingHints = null;
        if (this.desktopHints != null) {
            renderingHints = NimbusGraphicsUtils.getRenderingHints(graphics2D, this.desktopHints, null);
            graphics2D.addRenderingHints(this.desktopHints);
        } else {
            object = graphics2D.getRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING);
            graphics2D.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        }
        super.paintText(synthContext, graphics, string, n, n2, n3);
        if (renderingHints != null) {
            graphics2D.addRenderingHints(renderingHints);
        } else if (object != null) {
            graphics2D.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, object);
        }
    }

    public static BufferedImage loadImage(String string) {
        try {
            Class class_;
            class_ = class$0;
            if (class_ == null) {
                try {
                    class_ = NimbusGraphicsUtils.class$0 = Class.forName("org.jdesktop.swingx.plaf.nimbus.NimbusGraphicsUtils");
                }
                catch (ClassNotFoundException v1) {
                    throw new NoClassDefFoundError(v1.getMessage());
                }
            }
            return ImageIO.read(class_.getClassLoader().getResource("org/jdesktop/swingx/plaf/nimbus/images/" + string));
        }
        catch (Exception var1_1) {
            System.err.println("Error loading image \"org/jdesktop/swingx/plaf/nimbus/images/" + string + "\"");
            var1_1.printStackTrace();
            return null;
        }
    }

    public static Color getWebColor(String string) {
        if (string.startsWith("#")) {
            string = string.substring(1);
        }
        return new Color(Integer.parseInt(string.substring(0, 2), 16), Integer.parseInt(string.substring(2, 4), 16), Integer.parseInt(string.substring(4, 6), 16));
    }

    public static Color getMidWebColor(String string, String string2) {
        if (string.startsWith("#")) {
            string = string.substring(1);
        }
        if (string2.startsWith("#")) {
            string2 = string2.substring(1);
        }
        int n = Integer.parseInt(string.substring(0, 2), 16);
        int n2 = Integer.parseInt(string.substring(2, 4), 16);
        int n3 = Integer.parseInt(string.substring(4, 6), 16);
        int n4 = Integer.parseInt(string2.substring(0, 2), 16);
        int n5 = Integer.parseInt(string2.substring(2, 4), 16);
        int n6 = Integer.parseInt(string2.substring(4, 6), 16);
        int n7 = n + (n4 - n) / 2;
        int n8 = n2 + (n5 - n2) / 2;
        int n9 = n3 + (n6 - n3) / 2;
        return new Color(n7, n8, n9);
    }

    public static BufferedImage createCompatibleTranslucentImage(int n, int n2) {
        return GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration().createCompatibleImage(n, n2, 3);
    }

    public static BufferedImage getAlphaMask(BufferedImage bufferedImage, int n, int n2) {
        int n3 = (n - bufferedImage.getWidth()) / 2;
        int n4 = (n2 - bufferedImage.getHeight()) / 2;
        BufferedImage bufferedImage2 = new BufferedImage(n, n2, 10);
        int[] arrn = new int[bufferedImage.getWidth() * bufferedImage.getHeight()];
        WritableRaster writableRaster = bufferedImage.getAlphaRaster();
        writableRaster.getPixels(0, 0, bufferedImage.getWidth(), bufferedImage.getHeight(), arrn);
        bufferedImage2.getRaster().setPixels(n3, n4, bufferedImage.getWidth(), bufferedImage.getHeight(), arrn);
        return bufferedImage2;
    }

    public static BufferedImage createColorMaskImage(BufferedImage bufferedImage, Color color) {
        int n = color.getRed() << 16 | color.getGreen() << 8 | color.getBlue();
        int n2 = bufferedImage.getWidth();
        int n3 = bufferedImage.getHeight();
        BufferedImage bufferedImage2 = NimbusGraphicsUtils.createCompatibleTranslucentImage(n2, n3);
        byte[] arrby = ((DataBufferByte)bufferedImage.getRaster().getDataBuffer()).getData();
        int[] arrn = ((DataBufferInt)bufferedImage2.getRaster().getDataBuffer()).getData();
        for (int i = 0; i < arrn.length; ++i) {
            arrn[i] = arrby[i] << 24 | n;
        }
        return bufferedImage2;
    }

    public static Kernel[] getSeparateGaussianKernel(int n) {
        int n2;
        float[] arrf = new float[n * 2 + 1];
        double d = 0.0;
        int n3 = 2 * n + 1;
        double d2 = (double)n / 3.0;
        double d3 = 2.0 * Math.pow(d2, 2.0);
        double d4 = 3.141592653589793 * d3;
        double d5 = Math.sqrt(d4);
        for (n2 = 0; n2 < n3; ++n2) {
            arrf[n2] = (float)(Math.pow(2.718281828459045, (double)(- (n2 - n) * (n2 - n)) / d3) / d5);
            d+=(double)arrf[n2];
        }
        n2 = 0;
        while (n2 < n3) {
            float[] arrf2 = arrf;
            int n4 = n2++;
            arrf2[n4] = (float)((double)arrf2[n4] / d);
        }
        Kernel kernel = new Kernel(n3, 1, arrf);
        Kernel kernel2 = new Kernel(1, n3, arrf);
        return new Kernel[]{kernel, kernel2};
    }
}
